Here is an annotated, abbreviated, directory structure for the 
directory ~ftp/pub/netflow, available on Internet node dimacs@rutgers.edu.   

In general, file names are omitted the list below: check the readme
files in each directory for further information.  With few
exceptions, all instances, instance generators, and problem solvers
are compatible with the DIMACS standard input/output format. 
Caveat: DIMACS does not ensure that these implementations are correct, but
we will pass along bug reports and fixes that we hear about. 

This directory listing was prepared in March 1993. 

benchmarks/   	{ Instances and codes for comparison across architectures }
     	      	{   and compilers.} 
biblio/ 	{ Bibliographies and pointers to literature.}
directory.notes {This file (old name) } 
general-info/	{ DIMACS documents describing Challenge, standard} 
                {   input formats, benchmark experiments, etc. }
generators/     { Instance generators.}
instances/	{ Instances from real problems.} 
matching/	{ Solvers for matching problems.} 
maxflow/ 	{ Solvers for maxflow problems.}
mincost/	{ Solvers for mincost flow problems.} 
program_tools/  { Awk programs, tools, C procedures and packages to }
		{   support program development.} 
readme          { This file } 
recursive.ls	{ A regularly-updated recursive ls of directory.} 
submit/		{ Publically-writable directory for submissions. }
		{   If you submit something, send a note to }
		{   netflow@dimacs.rutgers.edu. } 
tar.notes 	{ Instructions for obtaining this directory as a tar file}

-----------
benchmarks:  
c/           	{ Files for testing C compilers (unix/notunix).} 
fortran/	{ Files for testing Fortraon compilers (unix/notunix).}

-----------
generators/matching: 
		 { Contains many generators in .edge and .geom format, }
  		 { plus Awk files for converting formats.  } 

generators/net-simple:
                  {Network generators too simple to be interesting; use only } 
                  { to test format compatibility. } 

generators/network:
                { Many generator codes in .min, .max, and .asn format,     }
		{    plus Awk files for converting from one problem        }
		{    format to another (e.g. assignment to min-cost flow). } 
capt/		{ CAPT generator by Bland and Jensen (min-cost flow). } 
ccd/            { Generates all the early DIMACS test files,     }
                { now slightly obsolete. } 
genrmf/		{ RMFGEN generator by Goldfarb and Grigoriadis, implemented }  
		{    by T. Badics (max flow). } 
grid-on-torus/  { Grid-on-torus generator by A. Goldberg (min-cost flow). }
gridgen/        { Grig generator by Y. Lee and J. Orlin.                  } 
gridgraph/      { Grid-network generator by M. G. C. Resende.             } 
mesh/	        { Mesh generator by A. Goldberg (min-cost circulation).   } 
netgen/		{ NETGEN.  The Fortran version and a C version.           } 
waissi/         { Many max-flow generators by G. Waissi. Also Turbo Pascal.} 
washington/     { Several max-flow generators by students of R. Anderson . } 

----------
instances:      
matching/       { Real-world instances for matching problems. }
mincost/	{ Real instances for mincost-flow problems.  } 

--------
matching/cardinality:
solver-1/	{  Gabows n^3 algorithm, implemented by E. Rothberg.} 
solver-2/	{  Micali-Vazirani, by S. Crocker. } 
solver-3/       {  Micali-Vazirano, by B. Mattingly and N. Ritchey  }

matching/weighted:
solver-1/	{ Gabows n^3 algorithm, implemented by E. Rothberg. } 

--------
maxflow:   	{  Solvers for maximum flow problems. } 
solver-1/	{  Goldberg's '86 agorithm, by E. Rothberg.} 
solver-2/	{  By G.  Waissi } 
solver-3/	{  3 solvers (Goldberg1, Goldberg2, and Dinic) by  }
		{  R. Anderson and J. Setubal. } 
solver-4/	{  The PLED algorithm by T. Badics} 
solver-5/	{  The GOLD algorithm by T. Badics} 

--------
mincost:	{ Solvers for minimum-cost flow problems.}
solver-1/  	{  Netflo by Helgason and Kennington. } 

--------------
program_tools:
dynamic_trees/   { C package for implementing Dynamic Trees, by T. Badics. } 
universal.c      { Bentley's RNG which is robust across architectures. } 

This directory contains programs that generate networks and graphs.
Most are in the DIMACS format. 

This Directory Contains:

universal.c  : A very portable random number generator, as C-language
               function calls.  Read the in-line code. 

matching/  : A directory of generators for matching problems. 
           
net-simple/  : A directory containing some very simple-minded generators,
                for checking compatiblity with DIMACS format.  These
                generators are not much good for testing code. 

network/   : A directory containing generators for network problems. 

            

Each subdirectory contains contributed codes for solving maxflow problems.

solver-1  Goldberg's (STOC 86) algorithm implemented by E. Rothberg
solver-2  Author's algorithm (in TurboPascal) implemented by G. R. Waissi
solver-3  Several programs (Goldberg variations, Dinics) implemented by 
                 J. Setubal
solver-4  The PLED algorithm implemented by T. Badics
solver-5  The GOLD algorithm implemented by T. Badics

This directory is publically-writable and contains files 
submitted for the DIMACS network flows / matching project.
Files placed here eventually get moved to an
appropriate place in the netflow subdirectory.  

For more information send mail to netflow@dimacs.rutgers.edu

This directory contains bibliographic references to problems
on network flows and matching.  

netflow.bib:  A file containing Veldhorst's ``Bibliography on network
   flow problems,'' as published in Algorithms Review.  Certain 
   copywrite restrictions apply--see the file header.  This file is
   in the Latex .bib format. 

biblio.tex: This is a simple .tex file for getting a formatted bibliography
   from netflow.bib.
   The way to compile:
		latex biblio
		bibtex biblio
		latex biblio
		latex biblio
   Finally there is a biblio.dvi file with the bibliography.
		
For other surveys and large  bibliographies, see also:

R. K. Ahuja, T. L. Magnanti, and J. B. Orlin, ``Network Flows,''  
   Sloan Working Paper No. 2059-88, August 1988, Sloan School 
   of Management,  MIT.  For a copy of the biblography list 
   only, (hard copy only), send a request to netflow@dimacs.rutgers.edu

A. V. Goldberg, E. Tardos, and R. E. Tarjan,  ``Network Flow Algorithms,''
   Technical Report CS-TR-216-89, March  1989, Dept. of Computer 
   Science,  Princeton University, Princeton, NJ  07974

M. Veldhorst, A bibliography on network flow problems, Algorithms
   Review (the newsletter of Project ALCOM). Address:  ALCOM,
   Department of Computer Science, Utrecht University,  P.O. Box 80.089
   35008  TB Utrecht, the Netherlands.  

This directory contains Latex files relating to the DIMACS 
Implementation Challenge.  Files with suffix .bbl are bibliography
files.  

call.tex  : One-page call for participation

directory.notes : An annotated listing of the directory structure here. 
                  This file is in plain ASCII

info.tex  
info.bbl  : The General Information document.  

specs.tex : Problem definitions and I/O specifications.
specs.bbl :  the bibliography file

core.tex  :  Describes the workshop and the core experiments 

The ftp directory  pub/netflow/benchmarks contains two subdirectories 
for benchmark tests of your local computing environment. 

fortran/   Contains programs and inputs for a test of a Fortran program. 
           In that directory, see either  readme.unix  or  readme.notunix 
           depending upon whether your system can support Unix tools 
           such as pipes, awk, and shell programs.

c/         Contains programs and inputs for a test of a C program. 
           In that directory, see either  readme.unix  or readme.notunix
           depending upon whether your system can support Unix tools. 

If you can, run both the Fortran and C tests on your local system.  The 
goal is to gather timing information for a wide variety of architectures.

Given the variety of architectures that participants are using, it is
difficult to anticipate what will be possible and interesting.  Send a
note to  netflow@dimacs.rutgers.edu  if one of the following occurs:

1) Some input files are too large to be transferred to your system.
2) Some input files are too small to give interesting runtimes. 
3) Some other problem prevents you from performing the tests. 

Enjoy!
Cathy McGeoch
Challenge Coordiinator
mcgeoch@dimacs.rutgers.edu

The subdirectories contain solvers for cardinality matching

solver-1  Gabow's algorithm, implemented by E. Rothberg
solver-2  Micali-Vazirani, implemented by S. Crocker
solver-3  Micali-Vazirano, implemented by R. B. Mattingly and N. P. Ritchey

This directory contains a files for a C language benchmark test. 
For instructions,  see either  readme.unix  or   readme.notunix 
depending on whether your local system can support Unix tools 
such as shell programs, awk, and pipes.

This is a preliminary information on how to compile
, and use the PLED maxflow solver. 

The package contains the PLED Maxflow Algorithm developed by
Cheriyan & Hagerup. For details look:
CH2806-8/89/0000/0118/$01.00(c)1989IEEE

   Implemented by
   Tamas Badics, 1991,
   Rutgers University, RUTCOR
   P.O.Box 5062
   New Brunswick, NJ, 08903
   e-mail: badics@rutcor.rutgers.edu

Copyright:
	This program was written by Tamas Badics,
	and may be used and modified for not-for-profit use.
	This notice must be remained.	

Files:
    dyn_tree_maxflow.c   maxflow_init.c
    dyn_tree_maxflow.h   maxflow_typedef.h
    fib_heap_maxflow.c   netio.c
    _dyn_tree_maxflow.h  netio.h
    _fib_heap_maxflow.h  macros.h             permute.c
    _maxflow.h           main.c               queue.c   
    big_relabel.c        makefile             queue.h
    debug.c              math_to_gcc.h        
    debug.h              maxflow.c           
    dyn_splay_maxflow.c  maxflow.h

Sample instance:
    ww.max

Compilation:
    Simple type "make" in the directory where the files are.
    This command uses the file makefile, and build the executable
    named PLED.
    If you want to use the debug routines, compile with -DDEBUG.
    (See the makefile)

Usage:
    PLED [-in input_file] [-out out_file]
         [-pf print_freq] [-sf stall_freq]
         [-rf relabel_freq] [-cf cut_freq]
         [-rep s|p|t|v|e|a (report_controll)]
         [-nogap] [-perm] [-quiet] [-h] [-help]

    For short help use the -h or -help option. (You will get 
    the same help as written above here.)
    By default some information is printed while the algorithm 
    is running.
    
    Options:
        Options can be used in arbitrary order.
        The program will use stdin, stdout and stderr for 
        I/O functions so everything can be redirected.
        (Unless the user specifies another, using -in -out )

        -in inputfile : The program will use inputfile - which must be
                        in DIMACS .max format - to read a maxflow 
                        problem. Try with ww.max, which is a 
                        small example.

        -out out_file : Only in the case of '-rep s' this file will
                        contain the solution, in the format which is
                        required by DIMACS.
                        (This should be changed by default, but
                        until experimental phase is not finished
                        I leave it in this form. )

        -rep s|p|t|v|e|a: Report options. v, e, a can only be used 
                        after compiled with DEBUG.
                        These letters can form any string, they will
                        be interpreted sequentially. (Eg. -rep tavta)
                        s - Standard DIMACS format output.
						p - Parameter settings
                        t - Problem parameters. (title)
                        v - vertex list
                        e - edge list
                        a - adjacency lists for each vertex

        -quiet        : Shut every report, only '-rep s' has impact.
    
        -pf  freq     : Iteration report frequency. 
                        Default is 0.
                        (freq is any integer number)
        
        -perm         : Use the permute_rnd function after each relabel
                        Without this option - by default - there will 
                        be no permutations.
                        (This option should be extended with 
                        Noga Alon's deterministic permutation.)

        -rf  freq     
        -sf  freq
        -cf  freq     : These options controll the heuristic calling 
                        frequency of big_relabel procedure.
                        I just use them for experiments.

                        rf - call it after this many macro_push
                             Default: vertex_num

                        sf - call it after this many stalling of 
                             source->excess (= actual flow value)
                             (Reason: Amount of maxflow can be sent
                              relatively soon, big_relabel will detect
                              this. So stalling of the flow value can
                              indicate this event. )
                             Default: 0 

                        cf - This is a new option, it can be useless.
                             Call big_relabel after this many real cut
                             in the dynamic tree. Real cut means that
                             there is no next_current after a cut of a
                             vertex.
                             Default: vertex_num / 2

		-nogap		  : This option will switch off the checking
						of a gap among the distance labels.
						By default if this check found a gap, then
						it calls a big_relabel 
-----------------------------------------------------------------------

	Please send all comments (bug reports) to:
	    badics@rutcor.rutgers.edu

 Dynamic tree data structure operations

   Based on Sleator, Tarjan : Self-Adjusting Binary Search Trees
   JACM Vol. 32., No. 3, July 1985 pp.652-686 
   
   Slight difference: The Real roots have only middle children,
   so that infinite value on the root can be handled.

   Implemented by 
   Tamas Badics, 1991, 
   Rutgers University, RUTCOR
   P.O.Box 5062
   New Brunswick, NJ, 08901
 
  e-mail: badics@rutcor.rutgers.edu

/**********************************************************
  Usage of the dynamic tree routines:

  The main purpose of using this data structure is to deal with
  trees of any type of objects with a value associated with them. 
  See the literature! (linking-cutting trees)
  
  The user need only the dyn_tree.h header file and the object
  files which can be created with the enclosed makefile.
  All the other sourcefiles could be referred to as a black box.

  So the first step is to make the objects with gcc.
  (type make dyn_tree)
  
  After this you can use the functions described in dyn_tree.h
***********************************************************  

  If you find this program useful and worth to work with,
  or if you have any questions, suggestions or bugs found,
  please write it to me and I am happy to answer.
  
  Tamas Badics, 1991

This directory contains programs that generate networks and graphs.
Most are in the DIMACS format. For the others, format translators 
are or will soon be available.  Generators suitable for multiple 
problems are in this directory---problem-specific generators appear
in subdirectories.  

This Directory Contains:

ac.c      : Generates a fully dense acyclic network in .max format. 
             A C version of waissi/ac.pas.  Submitted by J. Setubal

asnmin.a  : Awk language converter from DIMACS assignment format to 
            DIMACS min-cost flow format

assign.c  : Generates a random bipartite graph in .asn format. 
assign.old.c:  Aan early version with fewer features. 

capt/     : A directory containing files for the CAPT network generator
            of Bland and Jensen.  Networks are  in .min format. 

ccd/      : A directory containing a shell script for generating all 
              maxflow instances for the DIMACS Core Experiments.  

genrmf/   : A directory containing files for the RMFGEN network generator.
             Networks are in .max format. 

geomasn.a : Awk language converter from DIMACS .geom format to a bipartite
            network in .asn format.  Read the file for more information. 

gridgen/  : Contains a c program for generating the grid-network
              of Lee and Orlin.

grid-on-torus/ : A direcotry of files to generate capacitated transporation
             instances laid out on a grid-on-torus.  Files are in .min format.

gridgraph/ : A directory of files to generate min-cost problems on a grid. 
             files are in .min format. 

maxmin.a  : Awk language converter from DIMACS max-flow format to 
            DIMACS min-cost flow format.

mesh/     : Files for a generator of max-flow problems on a mesh. 
            Instances are in .max format. 

netgen/    : A directory containing a well-known NETGEN program.
              Also contains a C-version which produces 
	      instances in DIMACS .min format. 

tr.c       :  Generates at transportation network. A C version of 
               waissi/tr.pas.  Contributed by J. Setubal.  

twocost.a  :  An awk langague program.  Takes  networks in .asn
              format: arc costs > 50 are converted to 10^8, and
              arc costs <=5 are converted to 10^2. 

waissi/    : A directory containing several  generators for max-flow
               problems.  Pascal and Turbo-Pascal versions available.

washington/ : A directory containing code for several max-flow generators.  

This directory contains problem instances for the matching problem, from
real applications problems. 

r442.geom  A 422-node geometric matching problem.  Contributed by 
           Bill Cook.

r1002.geom  A 1002-node geometric matching problem. Contributed by 
            Bill Cook

r2392.geom  A 2392-node geometric matching problem. Contributed by 
            Bill Cook

r20726.geom A big geometric matching problem from a line plotter. Bill
            again.

tsp.instances  An anonymous ftp site where you can find travelling 
	    salesman and related problems. (TSPLIB)

This directory contains the source code and executables for the
maximum-flow problem developed by Richard Anderson and Joao Setubal,
University of Washington, Seattle (e-mail: anderson@cs.washington.edu
and setubal@cs.washington.edu).

The code is not commented for the most part, and it contains several
variants of maximum-flow algorithms. The 3 executables that the
makefile generates are the following:

gold_q: goldberg's algorithm using a queue to select active vertices.
It corresponds to procedure Goldberg1 in file goldberg.c.

gold_hlf: goldberg's algorithm using highest label first criterion.
It corresponds to procedure Goldberg2 in file goldberg.c.

dinic: dinic's algorithm. Relevant code in procedure AugmentFlow in
main_dinic.c and in file dinic.c (look for option DINIC_NEW in the code).

Usage is: <program> <input file> [<output file>].

Input must be in DIMACS format. Maximum size allowed is 20,000 nodes
(determined by constant MAX_N in file ghead.h).

The programs report flow value, cpu time to compute max-flow (input
and output time not reported) and some combinatorial quantities.

The executable `flow' contains all 3 programs, plus some others, that
are selected according to parameter fct (usage: flow <fct> <input file>
[<output file>] ). File netflow.h describes (cryptically) which fct
values can be chosen and what do they mean.

This file written by J. Setubal on October, 15, 1991.

-------------------------------------------------------------------------
The NETFLOW_F.shell file contains programs and files relating to the NETFLO
program written by R. V. Helgason and J. L. Kennington in 1976.  
-------------------------------------------------------------------------

For more information see pages 244-256 in ``Algorithms for Network
Programming'' by Kennington and Helgason, John Wiley, 1980.


REQUIRED FILES:
        readme input.form output.form NETFLO.INP NETFLO.OUT NETFLO.FOR
		netflo.f min_to_flo flo_to_std format.a trans.a 
                flo_to_std.a del_dup.a

TO GET THESE FILES:
        Run the "NETFLOW_F.shell" file in the /bin/sh shell. 
		(It will unwrap itself.)
		Or copy the files themselves.

ANOTHER FILE: 
        netrans.tar.Z:  contains C source code for programs to convert
                 between DIMACS and netflow.f formats.  These programs
                 are more efficient than the awk programs provided
                 in the above shell script, and should be used for large
                 instances.  Use the Unix ``tar'' command to unbundle
                 these files.  Contributed by Geraldo Viega
                    ilan34@violet.berkeley.edu

FILE DESCRIPTIONS: 
		input.form:  A description of the NETFLO input format, taken from the
		               user guide. Usage of the input format converter. 

		output.form:   A description of the NETFLO output format, from the user
		               guide. Usage of the output format converter.

		NETFLO.INP:    The required name of the input file. Contains a sample
		               input file.  

		NETFLO.OUT:    The output file. This file will be created (and overwritten)
		               by the program at each invocation. 
		
		NETFLO.FOR:    The original NENETFLO.FORTFLO code, compatible with IBM PC running
		               under Microsoft FORTRAN Optimizing Compiler.  The output
		               appears in file 6. 

		netflo.f  :    Code modified for compatibility with Unix. See program 
		               header.  To compile:   f77 netflo.f -o netflo


/ This README file was written at DIMACS, and based on experiments with the
code. /
 

This directory contains files for a Fortran benchmark test.
For instructions, see either  readme.unix   or  readme.notunix
depending on whether your local system can support Unix tools
such as shell programs, awk, and pipes.  

This directory contains a Maximum-flow solver written in TURBO-PASCAL 5.5.

(*     Algorithms and program by      *)
(*          Gary R. Waissi            *)
(*       School of Management         *)
(*   Department of Decision Science   *)
(*      Information Systems and       *)
(*      Operations Management         *)
(*  University of Michigan - Dearborn *)


It uses the standard DIMACS input files.

This directory contains instance generators for matching problems.

asnmat.a    : Awk program to convert DIMACS .asn format to
              .edge format.

clusters.c  : Generates points within a circle which are clustered 
		according to some input parameters.  Documentation is
		in code.  To compile: cc clusters.c -lm 

dcube.c    : Generates points uniform within a d-dimensional cube. 
             Documentation is in the code.  

hardcard.f  : Generates (nongeometric) graphs which Gabow has shown 
		will be hard for Edmond's cardinality matching algorithm.
 		Provided by R. B. Mattingly.  This is a Fortran program. 
                To compile:  f77 hardcard.f

neighbor.c  : Takes a graph in .geom format and a command line argument
              k.  Produces a graph in .edge format.  Vertex i is has an
              edge to vertices [i-k, i-1].  See the code for more 
              documentation. 
              NOTE:  a version which includes the p line and which is 
                 slightly more robust was installed July 26. 
              
random.c    : Generates a random undirected graph with m edges.  Edge
              weights are uniformly distributed within a specified range.
              See the code for further documentation. 
              NOTE: the original version contains a bug.  The fixed 
              version was installed July 22. 

t.f        :  Generates a sequence of K one-connected triangles 
              in  .edge format. 
              Written in Fortran.  These graphs tend to generate 
               a lot of blossoms.
              Contributed by N. Ritchey and B. Mattingly

tt.f       :  Generates a sequence of K tri-connected triangles
              in .edge format.
              Written in Fortran.
              Contributed by N. Ritchey and B. Mattingly

fractals/   : Subdirectory containing generators of fractal-like instances,
               in .geom format.

-------------------------------------------------------------------------
The Goldberg_C.shell file contains two programs, written in C, 
for finding MAXIMUM-FLOW in UNDIRECTED graphs.  
-------------------------------------------------------------------------

These programs were written by Ed Rothberg to implement Goldberg's
``new max-flow algorithm'' (STOC 86). There are two main programs, for two  
types of input formats. 

MAIN PROGRAMS:
        - flow
        - matflow

REQUIRED FILES:
        README input.form output.form makefile main.c flow.c
        glib.c matfl.c graphtypes.h matrix.h matmain.c test.mat test.in

TO GET THESE FILES:
        Run the "goldberg_c.shell" file in the /bin/sh shell. 
		(It will unwrap itself.)
		Or copy the files themselves.

FILE DESCRIPTIONS: 
        input.form:  Describes the input formats for flow and matflow. 
        output.form: Describes output formats for flow and matflow
					Note: The DIMACS standard for maxflow needs a 
							directed graph so it cannot be converted 
							into this format.

        test.in:  A sample input for flow
        test.mat: A sample input for mat

        The others are source code files written in C language.

HOW TO MAKE THE PROBLEM-SOLVERS:

		flow:  Solves max-flow for undirected graphs presented in an 
				adjacency-list format. 
  
       			Requires: flow.c, main.c, glib.c, graphtypes.h, makefile. 

       			To invoke: 		$make flow
                  				$flow filename.in

      	If no filename is given, flow uses standard input. It always  
      	writes to standard out.  

		matflow: Solves max-flow for complete undirected graphs presented in a
       			distance-matrix format.  

		       	Requires: 		matfl.c, flow.c, matmain.c, glib.c
								graphtypes.h, matrix.h, makefile.  

       			To invoke: 		$make matflow
        				        $matflow filename.in

		If no filename is given, matflow uses standard input. It 
       	always writes to standard out. 

/ This README file was written by DIMACS, and based on experiments with the
codes. /
       

This directory contains very simple generators for network problems. 
Also contains translators from .asn and .max files to .min files.  
THESE GENERATORS PRODUCED INSTANCES WHICH ARE SYNTACTICALLY CORRECT
(FOR DIMACS CHALLENGE FORMAT) BUT WHICH ARE PRETTY MUCH UNINTERESTING 
OTHERWISE. 

genasn.c   Generate an instance for assignment.  See comments in 
	   program for command format.  C source. 

genmin.c   Generate an instance for min-cost flow.  See comments in 
	   code for instructions.  C source. 

genmax.c   Generate an instance for max flow.  See comments in 
	   code for instructions. C source. 

makefile   The make file. 

test.*     Sample input files.  The suffix .min .max .asn denotes
           inputs for min-cost flow, max flow, and assignment.  

asnmin.a   An awk program to convert assignment instances, in
	   .asn format, to min-cost flow instances  in .min format.  

maxmin.a   An awk program toconver max-flow instances, in .max format,
	   to min-cost flow instances in .min format. 

To compile the generator "capt" on SUN machines, type
	f77 -O capt.f -lc -o capt

The current source file gives rise to some warning messages;
these are given in the file "compiler_warnings".
Carry on regardless; these warnings are harmless.

To run the generator, the input parameters have to be given in the file "fort.8";
these parameters are documented at the start of the source file "capt.f".
The output (ASCII in DIMACS format) will be written to file "fort.11".
An example "fort.8" is given below.

To execute the generator, simply type
	capt

"capt" is somewhat slower than generators like NETGEN because its
internal algorithm uses order statistics (i.e., sorting).

When "capt" finishes, three output files "fort.9", "fort.10" and "fort.11"
will be produced. Only file "fort.11" is useful for the DIMACS experiments.
The contents of these files are:
	fort.9		the network in unformatted FORTRAN form (NOT ASCII !)
	fort.10		diagnostic output
	fort.11		the network in DIMACS format (ASCII)

=======================================================
=======================================================

Here is a sample input file for the generator;
only the first line is read by the generator, the other
lines are for documentation.
CCCCCCCCCCCCCCCCCCC file: fort.8 CCCCCCCCCCCCCCCCCCCCCC

0.123456785 500   500   3162 1      1      1000   14   0.5   5     0.0632455532
seed        nsrce nsink flow ipsrce ipsink intlen cost  D  distrbn density
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

For this network, here are the first 5 lines from "fort.11"
c 0.123456785NS -       500 ND -       500
c FLOW -      3162 IPSRCE - 1 IPSINK - 1
c INTLEN - 1000 COST -   14 D - 0.50 IDIST -    5
c Density - 0.06
p min            1002     16312

The value of the min cost flow in this network is:
         Minimum cost flow value= 2059212544

Some statistics about the network:
Number of vertices   : 1002          Number of edges      : 16312     
Maximum vertex degree: 501           Minimum vertex degree: 1         
Maximum edge cost    : 16383         Minimum edge cost    : 0         
Maximum edge capacity: 1573118       Minimum edge capacity: 0

=======================================================
=======================================================

The maximum number of nodes and arcs that can be handled by "capt"
are given in the file "NETPARM". This file is "included" into "capt.f"
during compilation, so it must be present in the directory where "capt.f"
is compiled.

CCCCCCCCCCCCCCCCCCC file: NETPARM CCCCCCCCCCCCCCCCCCCCCC
      PARAMETER (NARCS =  131072, NODES = 16384)
      PARAMETER (Nedges = narcs)

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

Please note that if you CHANGE the parameter "Nedges" in the file "NETPARM",
then the source file "capt.f" would need the following modification:

The variable "ihprime" in subroutine "CAPTRN" (in file "capt.f")
would have to be set to a prime number slightly less than "Nedges".
The lines from subroutine "CAPTRN" in file "capt.f" where variable
"ihprime" is introduced are reproduced below:

CCCCCCCCCCCCCCCCCCC extracted from file: capt.f CCCCCCCCCCCCCCCCCCCCCC
C	set "hashing prime" ihprime to a prime number less than nedges
C	here is a table of useful primes
C	nedges = 1024 2048 4096 8192 16,384 32,768 65,536 131,072
C	ihprime= 1021 2039 4093 8191 16,381 32,749 65,521 131,071
C
C	nedges = 262,144 524,288 550,000 1,048,576 1,200,000
C	ihprime= 262,139 524,287 549,979 1,048,573 1,199,999
		ihprime= 131071
		ihpretry= 0
		if (ihprime .ge. nedges)
     c	WRITE(0,*)'	ERROR: nedges = ',nedges,' too small'
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

For further documentation, see the starting part of "capt.f".

For further clarifications contact
Dave Jensen at djensen@ibm.com (Phone: (914) 945-2471),
or Bob Bland at bland@orie.cornell.edu (Phone: (607) 255-9144).

This directory contains a number of files of the form gte_bad.XXXXXX

These files are instances of a minimum-cost flow problem on a
particular 49 node graph.  The instances differ in the choice of
capacities and demands.  We ran these problems using the RELAXT-III
code of Bertsekas and Tseng.  The interesting thing that happened was
the running times varied greatly.  A file with the name gte_bad.XXXX
represents a graph which took XXXX milliseconds.  These seems to be
bad examples for the RELAXT-III code, it would be interesting to see
how other minimum-cost flow code performed on these problems.

These problems came about as subproblems in the multicommodity flow
code of Leong, Shor, and Stein.

--Cliff Stein (cliff@theory.lcs.mit.edu)

This program produces a capacitated transportation problem in .min
format, laid out on a grid-on-torus.  Contributed by A. Goldberg
     ango@Theory.Stanford.EDU 

goto.c should be compiled with the math library, e.g.
"cc -O goto.c -lm" in UNIX.

The GOTO generator expects 5 (integer) inputs. The inputs are as follows.

No. |	DESCRIPTION			| RESTRICTIONS
-----------------------------------------------------------------------------
 1  | number of nodes, N		| N >= 15
 2  | number of arcs, M			| 6*N <= M <= N^(5/3)
 3  | max. capacity, MAXCAP		| MAXCAP >= 8
 4  | max. arc cost, MAXCOST		| MAXCOST >= 8
 5  | seed (for random number generator)|
 ----------------------------------------------------------------------------

-------------------------------------------------------------------
The Match_C.shell file contains a program, written in C, for finding 
MAXIMUM-WEIGHT MATCHING for UNDIRECTED graphs.  
-------------------------------------------------------------------

This program was written by Ed Rothberg to implement H. Gabow's N-cubed 
weighted matching algorithm, as described in his Ph.D. thesis 
"Implementation of Algorithms for Maximum Matching on Nonbipartite Graphs" 
Stanford University, 1973.  


MAIN PROGRAMS:
		- wmatch

REQUIRED FILES:
		README input.form output.form makefile graphtypes.h glib.c pairs.c
		term.c pointer.c readgraph.c unpairs.c match.defs wmatch.c main.c

TO GET THESE FILES:
        Run the "Match_C.shell" file in the /bin/sh shell. 
		(It will unwrap itself.)

FILE DESCRIPTIONS: 
		input.form:  Describes the input formats for match.
		output.form: Describes output formats for match.
						***Format converters will be available soon to
						translate input and output files from and to the
						DIMACS Challenge format. Contributions are welcome. 
		
		test.in:  A sample input for wmatch
		
        The others are source code files written in C language.

HOW TO MAKE THE PROBLEM-SOLVERS:

		wmatch:  Solves maximum matching for undirected graphs presented in an 
		       adjacency-list format. 

		       Requires:graphtypes.h glib.c pairs.c term.c pointer.c 
						readgraph.c unpairs.c match.defs wmatch.c main.c makefile 
 
		
		       To compile: $make
		       To invoke: $wmatch input_file
		
		      If no filename is given, a small help message appears. It always  
		      writes to standard out.  

/ This README file was written by DIMACS, and based on experiments with the
codes. /

netgen.shell:  NETGEN is described in Klingman, Napier, and Stutz, 
             ``NETGEN: A program for generating large scale capacitated
              assignment, transportation, and minimum-cost flow network
              problems,'' Management Science 20, 814-820 (1974).

               This is a Unix shell containing a version of NETGEN written
               in C.  Contributed by Norbert Schlenker.  Some copywrite
               restrictions apply---read the in-file comments.  

               To use, you just need to obtain and execute netgen.shell 
               (using /bin/sh (not csh)).  This  will create a Makefile 
               and other necessary files.  The compiler switches are 
               set for the DIMACS input/output format. 

fortran/  NETGEN in fortran. 

netgen-bcjl/  Contains the netgen.shell stuff, plus a README file explaining
   some fixes to well-known NETGEN bugs when trying to generate large networks.

eight.problems Input commands for 8 of the 40 NETGEN benchmark problems. 
(problems.8)

problems      Input commands for the 40 NETGEN benchmark problems. 
(problems.40)

The ccd shell file generates the test instances for the DIMACS 
standard tests.  It is slightly obsolete---directory structure
has changed a little bit, and a new set of standard tests has been
adopted. 

washington.c : A C language program to generate ten types of 
             networks/graphs. Contributed by seminar students working with 
             Richard Anderson. Compatible with the DIMACS format. 
    
             To use:  cc washington.c -o gengraph
                      gengraph function arg1 arg2 arg3 

             Command line arguments have the following meanings: 
 
                      function:           index of desired graph type
                      arg1, arg2, arg3:   meanings depend on graph type
                                          (briefly listed below: see code 
                                           comments for more info) 

		 Mesh Graph:          1 rows  cols  maxcapacity 
	 	 Random Level Graph:  2 rows  cols  maxcapacity 
		 Random 2-Level Graph:3 rows  cols  maxcapacity
		 Matching Graph:      4 vertices  degree 
		 Square Mesh:         5 side  degree  maxcapacity 
		 Basic Line:          6 rows  cols  degree 
                 Exponential Line:    7 rows  cols  degree 
                 Double Exponential   8 rows  cols  degree
  		 DinicBadCase:        9 vertices 
                      (causes n augmentation phases)                 
		 GoldBadCase         10 vertices 
		 Cheryian            11 dim1 dim2  range 
                      (last 2 are bad for goldberg's algorithm) 

GENRMF -- Maxflow generator in DIMACS format.

This generator produces the RMFGEN networks developed by 
 Goldfarb and Grigoriadis (see ``A computational comparison of the Dinic
  and Network Simplex methods for maximum flow,'' Annals of Operations 
  Research 13 (1988), pp 83--123. 

Contributed by Tamas Badics. 

Files: genio.c genrmf.c genmain.c  genio.h 
	   gen_maxflow_typedef.h  math_to_gcc.h
	   makefile

Compilation: Get all the files. Type make.

Usage: genrmf [-out out_file]
              -a frame_size -b depth
              -c1 cap_range1 -c2 cap_range2

	       Here without the -out option the generator will
		write to stdout.

		The generated network is as follows:
			It has b pieces of frames of size (a x a).
			(So alltogether the number of vertices is a*a*b)
			
			In each frame all the vertices are connected with 
			their neighbours. (forth and back)
			In addition the vertices of a frame are connected
			one to one with the vertices of next frame using 
			a random permutation of those vertices.

			The source is the lower left vertex of the first frame,
			the sink is the upper right vertex of the b'th frame. 
               
			The capacities are randomly chosen integers
			from the range of (c1, c2) in the case of 
                        interconnecting edges, and c2 * a * a for 
                        the in-frame edges.

-----------------------------------------------------------
NETWORK PROBLEM GENERATORS

          readme_next describes five network generators which generate
          networks for maximum-flow problems in the DIMACS standard format:
		
           ac-max.p(as)    Acyclic network generator
           bi-max.p(as)    Bipartite network generator
           tr1-max.p(as)   Transit grid network generator, one-way
           tr2-max.p(as)   Transit grid network generator, two-way
           ra-max.p(as)    Random network generator

         (C) Gary R. Waissi, University of Michigan-Dearborn
         School of Management, Room 113FOB, Dearborn, MI 48128
         Tel: (313) 593-5012
         E-mail: gary_waissi@um.cc.umich.edu

-----------------------------------------------------------
DIMACS NOTE: 
     1) All file names in the directory are  in lower-case.
     2) Files with the suffix .pas will compile under Standard Pascal
     3) Files with the suffix .p   have been modified to compile
              under Sun Pascal.  You must use the -L option
              when compiling:  for example  pc -L random.p
     4) Files in the tp55 directory will compile under Turbo-Pascal 5.5	

Gary R. Waissi, University of Michigan-Dearborn
School of Management, Room 113FOB, Dearborn, MI 48128
Tel: (313) 593-5012
E-mail: gary_waissi@um.cc.umich.edu
-----------------------------------------------------------
Table of Contents:
1. NETWORK PROBLEM GENERATORS FOR MAX-FLOW;
   Standard Pascal Versions
2. DESCRIPTION OF NETWORK GENERATORS
3. EXAMPLE OUTPUT DATA FILES
-----------------------------------------------------------
Programs:  
Copyright (C) Gary R. Waissi (1990,1991)

Algorithms:
Copyright (C) Gary R. Waissi (1988,1989,1990,1991)

(updated November, 1990, December 1990, January 1991)
-----------------------------------------------------------
1. NETWORK PROBLEM GENERATORS FOR MAX-FLOW;
   Standard Pascal Versions
-----------------------------------------------------------

The Max-Flow Problem
--------------------
In a maximum flow problem the total flow from a specified
source node to a specified sink is maximized, while 
satisfying flow feasibility and flow conservation 
constraints, as follows:
        
    MAX  SUM f(i,j) over all arcs (i,j) in A

    where f(i,j) = flow on arc (i,j)
          A      = set of arcs in the network

The Network Generators
----------------------
The programs generate max-flow networks in five network
categories; acyclic, bipartite, one-way transit grid, 
two-way transit grid, and random.

Standard Pascal Source Files
----------------------------
  ac-max.pas    Acyclic network generator
  bi-max.pas    Bipartite network generator
  tr1-max.pas   Transit grid network generator, one-way
  tr2-max.pas   Transit grid network generator, two-way
  ra-max.pas    Random network generator

These source programs have been given to public domain
through The Center for Discrete Mathematics and Theoretical
Computer Science (DIMACS), Rutgers University. The programs
are designed for maximum flow applications. All programs
are written in standard Pascal for portability.

Data file formats correspond to DIMACS data file
specifications described in "The First DIMACS International
Algorithm Implementation Challenge: Problem Definitions and
Specifications". Please contact via e-mail:
netflow@dimacs.rutgers.edu

Data File Format
----------------
All the MAX-FLOW networks are given as lists of lines using
the same format. There are four types of lines: comment 
lines c, problem line p, node lines n, arc lines a, as 
follows:

      c This is a comment line. The "p" line gives the 
      c problem type, here MAX (maximization), number of
      c nodes, and number of arcs. There are exactly two
      c "n" lines. The first "n" line lists the source node
      c number, and a lower case letter s designating the
      c source. The second "n" line lists the sink node
      c number, and a lower case c letter t designating
      c the sink. All user input must be in integers.
      c The "a" lines list the arcs, one line per arc with
      c three numbers: Arc tail node, arc head node, arc
      c flow capacity.
      c For example like this:
      p max NODES ARCS
      n NODE WHICH
      a FROM TO CAP
      c where
      c      max   = specifies the max-flow data file
      c      NODES = number of nodes
      c      ARCS  = number of arcs
      c      NODE  = source of sink node number
      c      WHICH = s for a source node, t for a sink node
      c      FROM  = arc tail node number
      c      TO    = arc head node number
      c      CAP   = arc flow capacity

For simplicity the only supply node s is always numbered
with 1, and the only demand node t is assigned the largest
node number. In all cases, where the user is asked for 
a flow capacity bound, the program will generate random
arc flow capacities. All arc flow lower bounds are set 
equal to zero.

The data files are ASCII files, and can be accessed with
a common editor. 


2. DESCRIPTION OF NETWORK GENERATORS

Acyclic Network Generator for Max-Flow
--------------------------------------
Source Files:
ac-max.pas   Standard Pascal Version
Copyright (C) Gary R. Waissi (1990,1991)

The program generates an ACYCLIC MAX-FLOW network into
a user file. An acyclic network is such that for each
arc (i,j), where i is the arc tail node number, and j is 
the arc head node number, i<j.

The program can generate three types of acyclic networks:

    - Fully dense networks with random capacities
    - Fully dense networks with special capacities
    - Special sparse networks with special capacities.

The two key procedures are:

 PROCEDURE AcyclicNet1;
 PROCEDURE AcyclicNet2;

For the FULLY DENSE acyclic networks the user has two
options for arc flow capacities: random or special
capacities. Special arcs capacities are calculated using
the concept of Glover et al. (published in "A Comprehensive
Computer Evaluation and Enhancement of Maximum Flow
Algorithms", Appl. of MS, Vol 3, 1983) as follows:

     1. For all arcs, say (i,j), where j=i+1 the capacity
        CAP(i,j) of the arc (i,j) is

            CAP(i,j) = 1 + (i - n/2)^2
            where n is the number of nodes

     2. For all arcs, say (i,j), where j>i+1 the capacity

            CAP(i,j) = 1.

The networks were called "hard networks" in the study,
because such networks were found to cause max-flow 
algorithms to their worst case performance.

If random capacities are selected for fully dense networks,
then the program wil generate random arc flow capacities
from a range of values between zero and a user specified
value. All non-integer values are truncated to integer 
values to conform with DIMACS specifications.

The special SPARSE acyclic networks are such that each node
is connected by an arc to the next node and to the sink 
node, i.e. there exist two types of arcs: 

     1. (i,j) where j=i+1 for all i and j\t with capacity n

     2. (i,t) for all i\t with capacity 1.

These simple networks cause the Dinic Layered Network
Algorithm (Dinic, E.A., Algorithm for Solution of a Problem
of Maximum Flow in a Network with Power Estimation, Soviet
Math. Dokl. Vol. 11, No. 5, pp. 1277-1280, 1970), to it's
worst case performance. That is, an acyclic network of n
nodes requires always the generation of (n-1) Dinic 
networks for maximum value flow, regardless of the maximal
flow algorithm applied to the Dinic networks. Many max-flow
algorithms use the Dinic Algorithm to generate auxiliary 
acyclic networks from an original network, and find the 
maximal flow in such an acyclic network. These sparse 
acyclic networks were presented in the dissertation of
Gary R. Waissi, "Acyclic Network Generation and Maximal
Flow Algorithms for Single Commodity Flow", University 
of Michigan, 1985.

This program is robust. A generated arc is written to the
disk file, and not stored in the memory. Disk full causes
a run-time error (101).


Bipartite Network Generator for Max-Flow
----------------------------------------
Source File:
bi-max.pas   Standard Pascal Version
Copyright (C) Gary R. Waissi (1990,1991)

The program generates a BIPARTITE MAX-FLOW NETWORK to 
a user specified file. The set of nodes N can be 
partitioned into two sets N1 and N2, such that all arcs
are directed from N1 to N2.

The program generates two types of networks:

    - Bipartite networks with unit capacities on bipartite
      arcs, and random capacities on arcs from the
      SUPER SOURCE and into the SUPER SINK.

    - Bipartite networks with random capacities.

The key procedure is:

PROCEDURE BipartiteNet;

The user selects the number of nodes on the source side
and sink side of the network respectively. The bipartite
network is appended with two nodes, a common source
SUPER SOURCE, and a common sink SUPER SINK. The SUPER
SOURCE is connected by arcs to all nodes in the SOURCE SET,
N1. The nodes in the SINK SET, N2, are connected by arcs
to the SUPER SINK. The SUPER SOURCE is always numbered with
number one, and the SUPER SINK is numbered with the largest
node number.

The user has two options for the arc capacities: either
random capacities or unit capacities. In the case of random
capacities all arcs capacities are random integers between
zero and a user selected upper bound. In the case of unit
capacities all arc capacities connecting the nodes in the
SOURCE SET, N1, to the nodes in the SINK SET, N2, are unit
capacities, i.e the bipartite arcs. However, the arc 
capacities of arcs from the SUPER SOURCE to N1, as well
as, the arc capacities of arcs from N2 to the SUPER SINK,
are random.

This program is robust. A generated arc is written to the
disk file, and not stored in the memory. Disk full causes
a run-time error (101).


Transit Grid Network Generator for Max-Flow/One-Way System
----------------------------------------------------------
Source File:
tr1-max.pas   Standard Pascal Version

Copyright (C) Gary R. Waissi (1990,1991)

This program generates a ONE-WAY TRANSIT GRID NETWORK for
the MAX-FLOW problem into a user specified file with at
most one arc between any pair of nodes.

The program generates one type of networks:
    
   - One-Way Transit-Grid networks with a SUPER SOURCE
     and a SUPER SINK, random arc flow capacities.

The key procedure is:

PROCEDURE TransitOneNet;

The network resembles a one-way city street network. The
direction of each arc, except those connected to the common
source and common sink respectively, is randomly assigned.
The arc flow capacities are randomly assigned from a range
between zero and a user selected value. All arc capacities
are random integers.

Two nodes a SUPER SOURCE and a SUPER SINK are added to the
network automatically. The SUPER SOURCE is connected by 
arcs to nodes on one side of the grid. The nodes on the 
opposite side of the grid are connected to the SUPER SINK. 

The user is suggested to select a number of nodes in the
network, that creates a complete square grid. The program
works, however, for any n>=4.

For example:

      4 nodes in a 2 x 2 network  (smallest)
      9 nodes in a 3 x 3 network
     16 nodes in a 4 x 4 network
     25 nodes in a 5 x 5 network
          ...
   1600 nodes in a 40 x 40 network
          ...
  10000 nodes in a 100 x 100 network.
          ...

This program is robust. A generated arc is written to the
disk file, and not stored in the memory. Disk full causes
a run-time error (101).

Transit Grid Network Generator for Max-Flow/Two-Way System
----------------------------------------------------------
Source File:
tr2-max.pas   Standard Pascal Version

Copyright (C) Gary R. Waissi  (1990,1991)

This program generates a TWO-WAY TRANSIT GRID NETWORK for
the MAX-FLOW problem into a user specified file with two
arcs between any pair of nodes forming the grid.

The program generates one type of networks:
    
   - Two-Way Transit-Grid networks with a SUPER SOURCE
     and a SUPER SINK, random arc flow capacities.

The key procedure is:

PROCEDURE TransitTwoNet;

The network resembles a two-way city street network. There
are two arcs, one in each direction, between the nodes 
forming the grid. The arc flow capacities are randomly 
assigned from a range between zero and a user selected 
value. 

Two nodes a SUPER SOURCE and a SUPER SINK are added to
the network automatically. The SUPER SOURCE is connected
by two arcs, one in each direction, to nodes on one side of
the grid. The nodes on the opposite side of the grid are
connected by two arcs, one in each direction, to the SUPER
SINK. 

The user is suggested to select a number of nodes in the
network, that creates a complete square grid. The program
works, however, for any n>=4.

For example:

      4 nodes in a 2 x 2 network  (smallest)
      9 nodes in a 3 x 3 network
     16 nodes in a 4 x 4 network
     25 nodes in a 5 x 5 network
          ...
   1600 nodes in a 40 x 40 network
          ...
  10000 nodes in a 100 x 100 network.
          ...

This program is robust. A generated arc is written to the
disk file, and not stored in the memory. Disk full causes
a run-time error (101).


RANDOM NETWORK GENERATOR FOR MAX-FLOW
Source File: 
ra-max.pas   Standard Pascal Version
Copyright (C) Gary R. Waissi (1990,1991)

This program generates a RANDOM MAX-FLOW network into
a user file. The network is generated by randomly pairing
a given number of nodes using a given number of arcs.

The program generates one type of networks:

    - Random networks with random arc flow capacities.

The key procedure is:

PROCEDURE RandomNet;

The maximum number of arcs in a fully dense network cannot
exceed n^2-n. Duplicate arcs and self-loops are not allowed.

This program generates initially a BALANCED ARC TREE to 
store network arcs. This arc tree is temporarily maintained
and manipulated in the RAM. The size of the tree is 
determined by the number of arcs in the random network
selected by the user. The program then generates a pair
of random numbers, say (i,j). This pair of numbers 
represents an arc (i,j) with node i as the arc origin and
node j as the arc destination. The balanced tree is then 
searched to determine, if this arc (i,j) is already 
included in the tree (network). If the pair of numbers
is found, another pair is generated and the search is 
repeated. The process is repeated until the tree (network)
is complete, i.e. the required number of arcs is generated.
The resulting network may be a connected or disconnected
network.

When the network is completed, i.e. the arc tree is filled
with arcs (random pairs of numbers), the network is written
to a file.

Two types of run-time errors may occur:

   101 Disk write error, if the disk becomes full.
   203 Heap overflow error. Each dynamic variable 
       is stored in the heap by stacking them on the
       top of each other.
       
3. EXAMPLE OUTPUT DATA FILES

EXAMPLE: A Fully Dense Acyclic Network
with Random Arc Capacities

c Fully Dense Acyclic Network
c for Max-Flow
c Arcs with random capacities
p max         5        10
n             1  s
n             5  t
a         1         2         7
a         1         3         3
a         1         4         6
a         1         5         5
a         2         3         5
a         2         4         8
a         2         5         2
a         3         4         7
a         3         5         4
a         4         5         2


EXAMPLE: A Fully Dense Acyclic Network
with Special Arc Capacities; (Glover et al
"Hard Network", but with rounded capacities)

c Fully Dense Acyclic Network
c for Max-Flow
c Arcs with special capacities
p max         5        10
n             1  s
n             5  t
a         1         2         3
a         1         3         1
a         1         4         1
a         1         5         1
a         2         3         1
a         2         4         1
a         2         5         1
a         3         4         1
a         3         5         1
a         4         5         3


EXAMPLE: A Sparse Acyclic Network with Special
Arc Capacities; (Dinic Worst Case Network)

c Sparse Acyclic Network
c for Max-Flow
c Arcs with special capacities
p max         5         7
n             1  s
n             5  t
a         1         2         5
a         1         5         1
a         2         3         5
a         2         5         1
a         3         4         5
a         3         5         1
a         4         5         1


EXAMPLE: A Bipartite Network with Unit Capacities

c Bipartite Network for Max-Flow
c with UNIT capacities on bipartite arcs
p max         8        15
n             1  s
n             8  t
a         1         2        11
a         1         3        25
a         1         4         7
a         2         5         1
a         2         6         1
a         2         7         1
a         3         5         1
a         3         6         1
a         3         7         1
a         4         5         1
a         4         6         1
a         4         7         1
a         5         8        10
a         6         8        15
a         7         8        30


EXAMPLE: A Bipartite Network with Random Capacities

c Bipartite Network for Max-Flow
c with RANDOM capacities
p max         8        15
n             1  s
n             8  t
a         1         2        11
a         1         3        30
a         1         4        22
a         2         5         7
a         2         6         8
a         2         7         4
a         3         5         2
a         3         6        10
a         3         7         2
a         4         5        23
a         4         6        27
a         4         7        27
a         5         8        23
a         6         8        18
a         7         8        19


EXAMPLE: One-Way Transit Grid Network
         Random Arc Capacities

c One-Way Transit Grid Network
c for Max-Flow
p max         6         8
n             1  s
n             6  t
a         1         2         8
a         1         3         5
a         2         3         1
a         2         4         8
a         3         5         9
a         5         4         6
a         4         6        10
a         5         6         5


EXAMPLE: Two-Way Transit Grid Network
         Random Arc Capacities

c Two-Way Transit Grid Network
c for Max-Flow
p max         6        16
n             1  s
n             6  t
a         1         2        10
a         2         1         3
a         1         3         7
a         3         1         1
a         2         3        10
a         3         2         9
a         2         4         7
a         4         2         6
a         3         5         5
a         5         3         3
a         4         5         9
a         5         4         2
a         4         6         5
a         6         4         6
a         5         6         6
a         6         5        10


EXAMPLE: Random Network
         Random Arc Capacities

c Random Network
c for Max-Flow
p max         5        10
n             1  s
n             5  t
a         5         3        30
a         4         2        23
a         3         5        16
a         1         3         7
a         2         4         6
a         4         3         6
a         2         1        25
a         1         4        30
a         4         1        23
a         2         5        18

FRACTALS --- This directory contains programs and examples for producing
      random point sets which converge to fractal images. 

fractals.c:  The generation program. It accepts an input file on standard
      in and writes to standard out.  Read code comments for more info. 
      The max coordinate value is 1000000, but the max seen in output
      will depend on the input file.  

*.in      :  Sample input files.  

This directory contains a generator of grid-like graphs written by 
Mauricio Resende. 


ggraph.bnd  is a Unix bundle containing a collection of related files.
            See the front of the file for instructions

ggraph1.f   is a Fortran file which is a modified version of ggraph.f
            in the bundle.  This version generates networks with 
            capacities and costs in [1, MAXCAP].  (The original version
            generates capacities in [0, MAXCAP] -- the netflo solver
            doesn't work with zero capacities.) 

 

-------------------------------------------------------------------
The Match_C.shell file contains a program, written in C, for finding 
MAXIMUM-WEIGHT MATCHING for UNDIRECTED graphs.  
-------------------------------------------------------------------

This program was written by Ed Rothberg to implement H. Gabow's N-cubed 
weighted matching algorithm, as described in his Ph.D. thesis 
"Implementation of Algorithms for Maximum Matching on Nonbipartite Graphs" 
Stanford University, 1973.  


MAIN PROGRAMS:
		- wmatch

REQUIRED FILES:
		README input.form output.form makefile graphtypes.h glib.c pairs.c
		term.c pointer.c readgraph.c unpairs.c match.defs wmatch.c main.c

TO GET THESE FILES:
        Run the "match_c.shell" file in the /bin/sh shell. 
		(It will unwrap itself.)
		Or copy the files themselves.

HOW TO MAKE THE PROBLEM-SOLVERS:

		wmatch:  Solves maximum matching for undirected graphs 
			presented in an adjacency-list format. 

		  Requires:graphtypes.h glib.c pairs.c term.c pointer.c 
		   readgraph.c unpairs.c match.defs wmatch.c main.c makefile 
 		
		       To compile: $make
		       To invoke: $wmatch input_file >output_file
		
		      If no filename is given, a small help message 
                      appears. It always  writes to standard out.  

FILE DESCRIPTIONS: 
		input.form:  Describes the input formats for match.
		output.form: Describes output formats for match.
		test.in:  A sample input for wmatch
	
                edge_to_wm:  A shell file which converts files in DIMACS 
                      .edge format to one compatible with wmatch.  It
                      uses the following awk files. 
                                  double.a
                                  strip.a 

                       Usage:  $edge_to_wm  input.edge output.wm 
      		
               The others are source code files written in C language.

-------------------------------------------------------------------------
1. The file addzer.f  converts DIMACS format to Rothberg's format so that 
   vertices of degree zero can be input.  
-------------------------------------------------------------------------

-------------------------------------------------------------------------
2. The Match_C.shell file contains a program, written in C, for finding 
  MAXIMUM-CARDINALITY MATCHING in UNDIRECTED graphs.  
-------------------------------------------------------------------------

This program was written by Ed Rothberg to implement H. Gabow's N-cubed 
non-weighted matching algorithm. For an explanation of the algorithm 
see JACM 23, pp221-34 .

MAIN PROGRAMS:
		- match

REQUIRED FILES:
		readme input.form output.form makefile graphtypes.h 
                glib.c main.c match.c

TO GET THESE FILES:
        Run the "match_c.shell" file in the /bin/sh shell. 
		(It will unwrap itself.)
		Or copy the files themselves.

FILE DESCRIPTIONS: 
		input.form:  Describes the input formats for match.
		output.form: Describes output formats for match. 
		test.in:  A sample input for match

                edge_to_wm: A shell file for converting input files in
                   DIMACS .edge format to inputs suitable for match.
                   It uses the following awk files: double.a strip.a 
		 
                   Usage:  edge_to_wm  input.edge output.match

                The others are source code files written in C language.

HOW TO MAKE THE PROBLEM-SOLVERS:

		match:  Solves maximum matching for undirected graphs presented in an 
		       adjacency-list format. 

		       Requires: graphtypes.h glib.c main.c match.c makefile
		
		       To compile: $make
		       To invoke: $match input_file
		
		      If no filename is given, a small help message appears. It always  
		      writes to standard out.  

/ This readme file was written by DIMACS, and based on experiments with the
codes. /
  
       

[SUBMITTED BY ANDREW GOLDBERG  ango@stanford.edu]

The generator produces instances of the minimum-cost circulation
problem in the DIMACS format. The graphs are based on grids embedded
on the torus. Each node is connected to nodes in X and Y directions,
up to a specified distance (that determines graph density).
The expected capacities of "longer" (with respect to the mesh) arcs
are smaller then those of the shorter arcs. The costs are random.

To use the generator, compile, run, and answer a few questions it
asks.

mesh.c   The c-code generator
mesh1.c  Modified by Li Liu.  This version does not produce nodes
         named ``0''

(*** See the end of this file for a description of some fixes to standard 
  NETGEN bugs in c and in Fortran versions)

netgen.shell:  NETGEN is described in Klingman, Napier, and Stutz, 
             ``NETGEN: A program for generating large scale capacitated
              assignment, transportation, and minimum-cost flow network
              problems,'' Management Science 20, 814-820 (1974).

               This is a Unix shell containing a version of NETGEN written
               in C.  Contributed by Norbert Schlenker.  Some copywrite
               restrictions apply---read the in-file comments.  

               To use, you just need to obtain and execute netgen.shell 
               (using /bin/sh (not csh)).  This  will create a Makefile 
               and other necessary files.  The compiler switches are 
               set for the DIMACS input/output format. 

problems      Input commands for the 40 NETGEN benchmark problems. 



netgen: example format of input data
1	seed>0
1	problem > 0
400	nodes
200	sources
200	sinks
5000	density
-1000	mincost
+1000	maxcost
100000	supply
150	tsources
150	tsinks
20	hicost%
100	capacitated%
-1000	mincap
+1000	maxcap

Date: Fri, 13 Mar 92 18:44:59 PST
From: Michael Kharitonov <misha@Jinn.Stanford.EDU>
To: cheriyan@cs.cornell.edu
Subject: Netgen problems
Status: RO

Hi. I was wondering if you managed to generate instances with
netgen that have 2^17 nodes or more. Even after I changed the
corresponding parameters, both C and Fortran versions of 
netgen do not terminate or produce any output when given the
following input:

13502460 17161 131072 8192 8192 1048576 0 4096 67108864 0 0 100 100 1 16384 

I would really appreciate any light you can shed on this problem.

Thanks,
Michael


From cheriyan Wed Mar 18 16:00:21 1992
To: misha@Jinn.Stanford.EDU
Subject: Re:  Netgen problems
Cc: cheriyan
Status: R

Michael,

The "bug" in the C version of NETGEN is as follows:
At some statements, the program multiplies two values that
may be as big as n, the no. of nodes. So, if you have
n > 2^{15} there is danger of overflow, assuming 32-bit integers.
In the instance you sent, there is indeed an integer overflow,
causing the program to loop endlessly.

Here is a quick fix.

In line 265 of the "netgen.c" file (in procedure "netgen")
replace
sinks_per_source = 2*sort_count*SINKS/(NODES-SOURCES-SINKS);

by
sinks_per_source = ((double) 2*sort_count*SINKS) / ((double) NODES-SOURCES-SINKS);


and also in line 433 in the same file (in procedure "pick_head")
replace

     } while (nodes_left * (non_sources - 1) < remaining_arcs - limit);
by

     } while ( ((double) nodes_left * (non_sources - 1)) < ((double) remaining_arcs - limit));


This fix makes your instance go through NETGEN (C version).
Without the fix, there is overflow at line 433,
and the program gets stuck forever in a "while" loop
in procedure "pick_head".
Here is the timing data for the revised NETGEN on a sparc-2:

time gnetgen < misha >! misha.min

192.8u 15.2s 10:00 34% 0+10704k 3+3413io 2844pf+0w

Probably, this fix will work fine for all your networks.
Unfortunately, the fact is that NETGEN was not intended for such big instances.
In order to guarantee that the program will always
work fine for "big instances", the only way seems to be
to go carefully through the entire program,
and mark all potential overflows and then rectify them,
eg., by using (double).

Also, the FORTRAN version has exactly the same "bugs" --
so it won't work unless a similar fix is used.


Best wishes,
-Joseph

netgen.f    :  NETGEN is described in Klingman, Napier, and Stutz, 
             ``NETGEN: A program for generating large scale capacitated
              assignment, transportation, and minimum-cost flow network
              problems,'' Management Science 20, 814-820 (1974).

              This the NETGEN program, written in Fortran.  The input 
              and output formats are standard NETGEN, not the DIMACS 
              format.  Contributed by Mike Grigoriadis
    
              To compile on Sun Unix, type 
                   f77  netgen.f 


net.in	      : Sample input and output files.  
net.out

CCCCCCCCCCCCCCCCCCC file: capt.f CCCCCCCCCCCCCCCCCCCCCC
C
      INTEGER*4 ITITLE(20),ISYSI,ISYSO,ISYSP,IDIMACS

      INCLUDE "NETPARM"

C-----------------------------------------------------------------------
C  For a detailed description of this generator see:
C    "A report on the computational behavior of a polynomial time
C       network flow algorithm.", Cornell School of OR/IE Technical
C       Report No. 661 (1985).
C-----------------------------------------------------------------------
C  The generator reads parameters from unit 8 in free format.
C  The record should contain the following fields:
C-----------------------------------------------------------------------
C  Real seed
C      a floating point number between 0 and 1.
C  Number of sources
C      integer
C  Number of sinks
C      integer
C  Flow
C     the (integer) average amount of flow through each source
C  Perturb sources
C     1 implies that source generated flows should be perturbed.
C  Perturb sinks
C     1 implies that sink generated flows should be perturbed.
C  Interval Length
C     the (integer) size of the interval from which flow perturbations a
C     chosen.
C  Cost Bits
C     the number of significant bits in the edge costs.
C  Density of cost bits
C     the (real) probability of setting a particular cost bit to 1.
C  Distribution
C     1-5 specifies the distribution used to generate initialize
C     feasible solutions.
C     Distribution 5 is a sparse version of distribution 1 as reported
C     in the Tech. Rep. referenced above.
C  Density of edges
C     the (real) number of edges generated is density*(Number of sources
C     (Number of sinks). This only is significant for distribution
C     number 5, however the parameter must be included for the
C     other distributions.
C
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      REAL*8 EDGES(NEDGES),SUPPLY(NODES),DEMAND(NODES)
      COMMON /A1/EDGES
      COMMON /ITITLE/ITITLE
      COMMON /IO/ISYSP,ISYSI,ISYSO,IDIMACS
      COMMON /NETWORK/FROM,TO,CST,UPPER,LOWER,RHS
      INTEGER*4 FROM(NEDGES),TO(NEDGES),CST(NEDGES),UPPER(NEDGES),
     C LOWER(NEDGES),RHS(NODES)
      COMMON /PARMS/ISEED,
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,IDIST,
     C SEED,PERLEN,PERCNT,DENS
      INTEGER*4 TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,NSRCE,NSINK,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,ITOT,ISEED,IDIST
      REAL*4
     C SEED,PERLEN,PERCNT,DENS
      COMMON /STATS/RTOT1,RTOT2,RTOT3,RTOT4
      REAL*8 RTOT1,RTOT2,RTOT3,RTOT4
      REAL*8 RSEED
      integer*4 ceil,dceil,floor,dfloor
C  DCL RAND ENTRY(FIXED BINARY(31),FLOAT BINARY(21));
C  DCL 1 ITITLE STATIC EXTERNAL,
C      2 TITLE CHAR(80);

      ISYSI = 8
      ISYSO = 9
      ISYSP = 10
      IDIMACS = 11
      READ(ISYSI,*)RSEED,NSRCE,NSINK,CAPRAN,IPSRCE,IPSINK,
     C               INTLEN,COST,PERCNT,IDIST,
     C               DENS
      WRITE(ISYSP,01)RSEED,NSRCE,NSINK,CAPRAN,IPSRCE,
     C         IPSINK,INTLEN,COST,PERCNT,IDIST
01    FORMAT(F11.9,'NS - ',I9,' ND - ',I9,
     C ' FLOW - ',I9,' IPSRCE - ',I1,' IPSINK - ',I1,/,' INTLEN - ',I4,
     C ' COST - ',I4,
     C ' D - ',F4.2,' IDIST - ',I4)
      WRITE(IDIMACS,02)RSEED,NSRCE,NSINK,CAPRAN,IPSRCE,
     C         IPSINK,INTLEN,COST,PERCNT,IDIST,DENS
02    FORMAT('c ',F11.9,'NS - ',I9,' ND - ',I9,/,
     C 'c FLOW - ',I9,' IPSRCE - ',I1,' IPSINK - ',I1,/,
     C 'c INTLEN - ',I4,
     C ' COST - ',I4,
     C ' D - ',F4.2,' IDIST - ',I4,/,
     C 'c Density - ',F4.2)
      SEED = RSEED
      ISEED = 2**15
      ISEED = 2*(ISEED*ISEED - 1) + 1
      ISEED = ISEED * RSEED
C  PUT STRING(TITLE) EDIT(RSEED,'NS - ',NSRCE,'ND - ',
C      NSINK,'FLOW - ',CAPRAN,'I - ',INTLEN,'C - ',COST,
C      'D - ',PERCNT)
C    (F(11,9),X(1),2(A,F(4),X(1)),A,F(9),X(1),2(A,F(4),X(1)),A,F(4,2));
      NEDGE = NSRCE * NSINK
      ICIRC=0
      INODE=MAX(NSRCE,NSINK)
      CALL       CAPTRN(NSRCE,NSINK,INODE,SUPPLY,DEMAND,ICIRC)
      RETURN
      END

      SUBROUTINE CAPTRN(NSRCE,NSINK,INODE,SUPPLY,DEMAND,ICIRC)

      INCLUDE "NETPARM"

C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------

      COMMON /A1/EDGES(NEDGES)
      REAL*8 EDGES
      COMMON /ITITLE/ITITLE
      INTEGER*4 ITITLE(20)
      COMMON /IO/ISYSP,ISYSI,ISYSO,IDIMACS
      INTEGER*4 ISYSI,ISYSO,ISYSP,IDIMACS
      COMMON /NETWORK/FROM,TO,CST,UPPER,LOWER,RHS
      INTEGER*4 FROM(NEDGES),TO(NEDGES),CST(NEDGES),UPPER(NEDGES),
     C LOWER(NEDGES),RHS(NODES)
C     PARAMETERS COMMON
      COMMON /PARMS/ISEED,
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,IDIST,
     C SEED,PERLEN,PERCNT,DENS
      INTEGER*4
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,
     C NEDGE,ARCCLS,HIGH,LOW,IPSRCE,IPSINK,ITOT,ISEED,IDIST
      REAL*4
     C SEED,PERLEN,PERCNT,DENS
C     STATS COMMON
      COMMON /STATS/RTOT1,RTOT2,RTOT3,RTOT4
      REAL*8 RTOT1,RTOT2,RTOT3,RTOT4
C     LOCAL VARIABLES
      INTEGER*4 NSRCE,NSINK,INODE,
     C SPPLYP,SSRCE,SSINK,
     C PT,IRT,MXIT,IPROB,ICIRC
      REAL*8
     C FRQ,P0,PBAR,dsrce,dsink,dedge,
     C SUPPLY(INODE),
     C DEMAND(NSINK)
C     FUNCTIONS
      integer*4 ceil,dceil,floor,dfloor
      REAL*4 RHOLD
      SSRCE = NSINK + NSRCE + 1
      SSINK = SSRCE + 1
      IPROB = 0
      PT = 0
      IRT = 0
      MXIT = 100000
      FRQ = 8.0
      P0 = 1.0
      PBAR = 1.
      I=NSRCE+NSINK+NSRCE*NSINK+1
C     CALL TITL(SSINK,I)
      DO 01 J = 1,NSINK
          DEMAND(J) = 0
01        CONTINUE
      DO I = 1,NODES
          RHS(I) = 0
      ENDDO
      TOTSUP = 0
      TOTDEM = 0
      RTOT1=0.0
      RTOT2=0.0
      RTOT3=0.0
      RTOT4=0.0
      ITOT=0
      IF (IDIST .EQ. 2) THEN
      DO 101 ISINK = 1 ,  NSINK
          CALL RANDOM(ISEED,SEED)
          SPPLYP = FLOOR(CAPRAN * SEED)
          ITOT=ITOT+SPPLYP
          CALL CREATU(SPPLYP,NSRCE,SUPPLY)
          II = ISINK
          CALL LOAD1(NSRCE,II,NSINK,SUPPLY(1))
101           CONTINUE
      ELSE IF (IDIST .EQ. 3) THEN
          CALL ORDER1(NSRCE,NSINK,SUPPLY)
      ELSE IF (IDIST .EQ. 4) THEN
      ITOT=0
      DO 1041 ISRCE = 1 , NSRCE
          CALL RANDOM(ISEED,SEED)
          SPPLYP = FLOOR(CAPRAN * SEED)
          ITOT=ITOT+SPPLYP
          CALL CREATU(SPPLYP,NSINK,SUPPLY)
          II=(ISRCE-1)*NSINK+1
          CALL LOAD1(NSINK,II,1,SUPPLY(1))
1041          CONTINUE
      DO 1042 ISINK = 1,NSINK
          CALL RANDOM(ISEED,SEED)
          SPPLYP = FLOOR(CAPRAN * SEED)
          ITOT=ITOT+SPPLYP
          CALL CREATU(SPPLYP,NSRCE,SUPPLY)
          II = ISINK
          CALL LOAD1(NSRCE,II,NSINK,SUPPLY(1))
1042          CONTINUE
      ELSE IF (IDIST .EQ. 5) THEN
C         if(1.eq.0) then
C             NEDGE = DENS * NEDGE
C             dsrce = dfloat(nsrce)
C             dsink = dfloat(nsink)
C             do i=1,nedge
C                 call random(iseed,seed)
C                 from(i) = dceil(seed*dsrce)
C                 call random(iseed,seed)
C                 to(i) = dceil(seed*dsink) + nsrce
C             enddo
C         endif
C	oct 1 jc -- handling case of nedge (=nsrce*nsink) >= nedges
 	if (nedge .lt. nedges) then
              do i=1,nedge
                   edges(i)=i
              enddo
              dsrce = dfloat(nsrce)
              dsink = dfloat(nsink)
              dedge = dfloat(nedge)
              KEDGE = DENS * NEDGE
              do i=0,kedge-1
                  call random(iseed,seed)
                  iedge = dceil(seed*dedge)
                  iedge=edges(i+iedge)
C	oct 1 jc -- changing edges(i+iedge) to edges(iedge)
                  edges(iedge)=edges(i+1)
                  edges(i+1)=iedge
                  from(i+1)=1+(iedge-1)/nsink
                  to(i+1)=nsrce+iedge-(from(i+1)-1)*nsink
                  dedge=dedge-1
              enddo
		WRITE(ISYSP,*)'	NO hashing, nedge = ', nedge
              nedge=kedge
	else
C	oct 1 jc -- if nedge too big, use linear hashing to detect duplicates
C			simple, but not too efficient,
C			specially for no. requested arcs > 1/2 nedges
C	set "hashing prime" ihprime to a prime number less than nedges
C	here is a table of useful primes
C	nedges = 1024 2048 4096 8192 16,384 32,768 65,536 131,072
C	ihprime= 1021 2039 4093 8191 16,381 32,749 65,521 131,071
C
C	nedges = 262,144 524,288 550,000 1,048,576 1,200,000
C	ihprime= 262,139 524,287 549,979 1,048,573 1,199,999
		ihprime= 131071
		ihpretry= 0
		if (ihprime .ge. nedges)
     c	WRITE(0,*)'	ERROR: nedges = ',nedges,' too small'
              do i=1,nedges
                   edges(i)=0
              enddo
              dsrce = dfloat(nsrce)
              dsink = dfloat(nsink)
              dedge = dfloat(nedge)
              KEDGE = DENS * NEDGE
              do i=0,kedge-1
520              call random(iseed,seed)
                 iedge = dceil(seed*dedge)
		ihpindex = mod(iedge, ihprime) + 1
530		if ( idnint(edges(ihpindex)) .ne. 0) then
			ihpretry= ihpretry + 1
		if ( idnint(edges(ihpindex)) .eq. iedge ) goto 520
			ihpindex = ihpindex + 1
			if (ihpindex .gt. nedges) ihpindex = 1
			goto 530
		endif
		edges(ihpindex) = dfloat(iedge)
C
                  from(i+1)=1+(iedge-1)/nsink
                  to(i+1)=nsrce+iedge-(from(i+1)-1)*nsink
                  dedge=dedge-1
              enddo
              nedge=kedge
		WRITE(ISYSP,*)'	no. collisions = ', ihpretry
        endif
C
      CALL ORDER5
              do i=1,nedge
          ii = idint(edges(I) * dfloat( nsrce * capran ) )
          IF (INTLEN .NE. 0) THEN
              CALL RANDOM(ISEED,SEED)
              HIGH = ii
     c                 + CEIL(SEED * INTLEN )
          ELSE
              HIGH = ii
          END IF
                      supply(from(i)) = supply(from(i)) +  ii
                      demand(to(i)-nsrce) = demand(to(i)-nsrce) +  ii
          CALL PUTARC(0,HIGH,from(i),to(i),1,1)
      enddo
      END IF
      DO 105 ISRCE = 1 , NSRCE
      IF (IDIST .EQ. 1 .OR. IDIST .EQ. 0) THEN
          CALL RANDOM(ISEED,SEED)
          SPPLYP = FLOOR(CAPRAN * SEED)
          ITOT=ITOT+SPPLYP
          RTOT1=RTOT1+SPPLYP
          RTOT2=RTOT2+FLOAT(SPPLYP)*FLOAT(SPPLYP)
      END IF
      IF ( IDIST .EQ. 4 ) THEN
          CALL CREATY(SPPLYP,SUPPLY,NSINK,ITOT)
      ELSE IF ( IDIST .EQ. 3) THEN
          CALL CREATW(SPPLYP,SUPPLY,NSRCE,NSINK,CAPRAN)
      ELSE IF ( IDIST .EQ.  2) THEN
          CALL CREATY(SPPLYP,SUPPLY,NSINK,ITOT)
      ELSE IF ( IDIST .EQ.  1) THEN
          CALL CREATU(SPPLYP,NSINK,SUPPLY)
      ELSE
                      spplyp = supply(isrce)
      END IF
              if(idist.ne.5) then
      DO 106 ISINK = 1 , NSINK
          IF (INTLEN .NE. 0) THEN
              CALL RANDOM(ISEED,SEED)
              HIGH = SUPPLY(ISINK) + CEIL(SEED * INTLEN )
          ELSE
              HIGH = SUPPLY(ISINK)
          END IF
          CALL PUTARC(0,HIGH,ISRCE,NSRCE+ISINK,1,1)
106           CONTINUE
      DO 150 J =1,NSINK
          DEMAND(J) = DEMAND(J) + SUPPLY(J)
150           CONTINUE
      endif
      TOTSUP = TOTSUP + SPPLYP
      HIGH = SPPLYP
      RTOT3 = RTOT3 + SPPLYP
      RTOT4=RTOT4+FLOAT(SPPLYP)*FLOAT(SPPLYP)
      IF ( IPSRCE .EQ. 1) THEN
          CALL RANDOM(ISEED,SEED)
          IF ( INTLEN .NE. 0) THEN
              HIGH = SPPLYP + CEIL(SEED * INTLEN)
          ELSE
              HIGH = SPPLYP
          END IF
      END IF
      CALL PUTARC(0,HIGH,SSRCE,ISRCE,0,2)
105       CONTINUE
      DO 200 ISINK = 1 , NSINK
      LOW = DEMAND(ISINK)
      IF ( IPSRCE .EQ.  1 .AND. INTLEN .EQ. 0 ) THEN
          IPSINK = 1
      END IF
      IF ( IPSINK .EQ. 1 ) THEN
          CALL RANDOM(ISEED,SEED)
          IF ( INTLEN .NE. 0) THEN
              LOW = MAX0(0,LOW - NINT(INTLEN * SEED))
          END IF
      END IF
      IF ( ICIRC .EQ. 1 ) THEN
          CALL PUTARC(LOW,TOTSUP,NSRCE+ISINK,SSINK,0,3)
      ELSE
          CALL PUTARC(LOW,LOW,NSRCE+ISINK,SSINK,0,3)
      END IF
      TOTDEM = TOTDEM + LOW
200       CONTINUE
      CALL PUTARC(0,TOTSUP,SSINK,SSRCE,0,4)
      IF ( IDIST .EQ. 1 .OR.  IDIST .EQ. 0 ) THEN
      RTOT1 = RTOT1/ITOT
      RTOT2 = RTOT2/ITOT
      RTOT2 = RTOT2/ITOT
      END IF
      RTOT3 = RTOT3/TOTSUP
      RTOT4 = RTOT4/TOTSUP
      RTOT4 = RTOT4/TOTSUP
      RTOT1=RTOT1/NSRCE
      RTOT2=(RTOT2-NSRCE*RTOT1*RTOT1)/(NSRCE-1)
      RTOT2=SQRT(RTOT2)
      RTOT3=RTOT3/NSRCE
      RTOT4=(RTOT4-NSRCE*RTOT1*RTOT1)/(NSRCE-1)
      RTOT4=SQRT(RTOT4)
      WRITE(ISYSP,*) NSRCE,RTOT1,RTOT2
      WRITE(ISYSP,*) NSRCE,RTOT3,RTOT4
      RTOT1=0.0
      RTOT2=0.0
      DO 300 ISINK = 1 , NSINK
         RTOT1=RTOT1+DEMAND(ISINK)/TOTSUP
         RTOT2=RTOT2+(DEMAND(ISINK)/TOTSUP)**2
300      CONTINUE
      RTOT1=RTOT1/NSINK
      RTOT2=(RTOT2-NSINK*RTOT1*RTOT1)/(NSINK-1)
      RTOT2=SQRT(RTOT2)
      WRITE(ISYSP,*) NSINK,RTOT1,RTOT2
      CALL PUTA(2+NSRCE+NSINK,0,NSRCE,NSINK,0,0,1)
      RETURN
      END

      SUBROUTINE CREATW(IR,RARRAY,NN,N,CAPRAN)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      COMMON /STATS/RTOT1,RTOT2,RTOT3,RTOT4
      REAL*8 RTOT1,RTOT2,RTOT3,RTOT4
      REAL*8 RARRAY(NN),R
      INTEGER*4 IR,N,J,CAPRAN
      IR=0
      R=0.0
      CALL DUMP1(N,RARRAY(1))
      DO 100 II=1 , N
      R=R+RARRAY(II)
      RARRAY(II)=DINT(RARRAY(II)*NN*CAPRAN)
      IR=IR+RARRAY(II)
100       CONTINUE
      RTOT1=RTOT1+R
      RTOT2=RTOT2+R*R
      RETURN
      END

      SUBROUTINE CREATY(IR,RARRAY,N,ITOT)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      COMMON /STATS/RTOT1,RTOT2,RTOT3,RTOT4
      REAL*8 RTOT1,RTOT2,RTOT3,RTOT4
      REAL*8 RARRAY(N),R
      INTEGER*4 IR,N,J,ITOT
      IR=0
      R=0.0
      CALL DUMP1(N,RARRAY(1))
      DO 100 II=1 , N
      R=R+RARRAY(II)
      IR=IR+RARRAY(II)
100       CONTINUE
      R=R/ITOT
      RTOT1=RTOT1+R
      RTOT2=RTOT2+R*R
      RETURN
      END

      SUBROUTINE CREATU(TOT1,N,SUPPLY)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      COMMON /PARMS/ISEED,
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,IDIST,
     C SEED,PERLEN,PERCNT
      INTEGER*4
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,NSRCE,NSINK,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,ITOT,ISEED,IDIST
      REAL*4
     C SEED,PERLEN,PERCNT
      REAL*8 SUPPLY(N)
      INTEGER*4 TOT1,N,SUBTOT,J,CEIL
      REAL*8 VL,VH
      REAL*4 TSEED
      SUBTOT = 0
      TSEED = 0.0
      CALL RANDOM(ISEED,SEED)
      J =  CEIL(SEED*N)
      DO 10 I = 1,N
      CALL RANDOM(ISEED,SEED)
      SUPPLY(I) = SEED
      TSEED = TSEED + SEED
10        CONTINUE
      I=1
      NM1 = N - 1
      CALL SORT(I,NM1,N,SUPPLY)
      VL=SUPPLY(1)
      SUPPLY(N)=1.0
      DO 100 I=1 ,  NM1
      VH=SUPPLY(I+1)-SUPPLY(I)
      SUPPLY(I)=VL
      VL=VH
100       CONTINUE
      SUPPLY(N)=VH
      II = 1
      DO 200 I = 1 , NM1
      IF (II .EQ. J) THEN
          II = II + 1
      END IF
      SUPPLY(II) =  DINT(SUPPLY(II) * TOT1)
      SUBTOT = SUBTOT + SUPPLY(II)
      II = II + 1
200       CONTINUE
      SUPPLY(J) = TOT1 - SUBTOT
      RETURN
      END


      SUBROUTINE ORDER1(NSRCE,NSINK,SUPPLY)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------


      INCLUDE "NETPARM"

      COMMON /A1/EDGES(NEDGES)
      REAL*8 EDGES
      COMMON /PARMS/ISEED,
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,IDIST,
     C SEED,PERLEN,PERCNT
      INTEGER*4
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,NSRCE,NSINK,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,ITOT,ISEED,IDIST
      REAL*4
     C SEED,PERLEN,PERCNT
      REAL*8 SUPPLY(NSINK)
      INTEGER*4 NN,NNN,II
      DO 100 ISRCE = 1,NSRCE
      DO 200 ISINK = 1,NSINK
          CALL RANDOM(ISEED,SEED)
          SUPPLY(ISINK)=SEED
200           CONTINUE
      II=(ISRCE-1)*NSINK+1
      CALL LOAD1(NSINK,II,1,SUPPLY(1))
100       CONTINUE
      NN=NEDGE-1
      NNN=1
      CALL SORT(NNN,NN,NN,EDGES)
      CALL ORDER2(NEDGE)
      RETURN
      END

      SUBROUTINE ORDER5


      INCLUDE "NETPARM"

C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      COMMON /A1/EDGES(NEDGES)
      REAL*8 EDGES
      COMMON /PARMS/ISEED,
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,IDIST,
     C SEED,PERLEN,PERCNT
      INTEGER*4
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,NSRCE,NSINK,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,ITOT,ISEED,IDIST
      REAL*4
     C SEED,PERLEN,PERCNT
      INTEGER*4 NN,NNN,II
      DO 100 I = 1,NEDGE
      CALL RANDOM(ISEED,SEED)
      EDGES(I)=SEED
100       CONTINUE
      NN=NEDGE-1
      NNN=1
      CALL SORT(NNN,NN,NN,EDGES)
      CALL ORDER2(NEDGE)
      RETURN
      END


      SUBROUTINE PUTARC(LOW,HIGH,I,II,COSTSW,IARC)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      INTEGER*4 I,II,CST,LOW,HIGH,IARC,COSTSW,ARCCTR,PP
      COMMON /PARMS/ISEED,
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,IDIST,
     C SEED,PERLEN,PERCNT
      INTEGER*4
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,NSRCE,NSINK,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,ITOT,ISEED,IDIST
      ARCCTR = ARCCTR + 1
      IF ( COSTSW .NE. 0) THEN
      PP=1
      CST=0
      DO 10 J=1,COST
          CALL RANDOM(ISEED,SEED)
          CST=CST+PP*(SIGN(1.0,PERCNT-SEED)+1)/2
          PP=2*PP
10            CONTINUE
      ELSE
      CST = 0
      END IF
      CALL PUTA(I,II,CST,HIGH,LOW,IARC,0)
      RETURN
      END

      SUBROUTINE CREATV(TOT1,N,V)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      COMMON /PARMS/ISEED,
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,IDIST,
     C SEED,PERLEN,PERCNT
      INTEGER*4
     C TOTSUP,TOTDEM,COST,CAPRAN,INTLEN,NSRCE,NSINK,
     C NEDGE,ARCCLS,IPSRCE,IPSINK,ITOT,ISEED,IDIST
      REAL*4
     C SEED,PERLEN,PERCNT
      INTEGER*4 TOT1,N,SUBTOT,NM1,CEIL,J
      REAL*8 V(N)
      REAL*4 TSEED
      SUBTOT = 0
      TSEED = 0.0
      CALL RANDOM(ISEED,SEED)
      J =  CEIL(SEED*N)
      DO 100 I = 1 , N
      CALL RANDOM(ISEED,SEED)
      V(I) = SEED
      TSEED = TSEED + SEED
100       CONTINUE
      DO 110 I = 1 ,N
      V(I) = V(I)/TSEED
110       CONTINUE
      II = 1
      DO 200 I = 1 , NM1
      IF (II .EQ. J) THEN
          II = II + 1
      END IF
      V(II) =  DINT(V(II) * TOT1)
      SUBTOT = SUBTOT + V(II)
      II = II + 1
200       CONTINUE
      V(J) = TOT1 - SUBTOT
      RETURN
      END

      SUBROUTINE TITL(I,II)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      COMMON /IO/ISYSP,ISYSI,ISYSO,IDIMACS
      INTEGER*4  ISYSP,ISYSI,ISYSO,IDIMACS

      INCLUDE "NETPARM"


      COMMON /A1/EDGES(NEDGES)
      REAL*8 EDGES
      COMMON /ITITLE/TITLE
      INTEGER TITLE(20)
C     WRITE(ISYSO,10)TITLE
C     WRITE(ISYSO)TITLE
10    FORMAT(20A4)
      IPROB = 0
      PT = 0
      IRT = 0
      MXIT = 100000
      FRQ = 8.0
      P0 = 1.0
      PBAR = 1.5
      III=0
C     WRITE(ISYSO,20)I,III,II,IPROB,PT,IRT,MXIT,FRQ,P0,PBAR
      WRITE(ISYSO)I,III,II,IPROB,PT,IRT,MXIT,FRQ,P0,PBAR
      WRITE(IDIMACS,21)I,III,II,IPROB,PT,IRT,MXIT,FRQ,P0,PBAR
20    FORMAT(3I5,4I8,3F8.1)
21    FORMAT('c',3I5,4I8,3F8.1)
      RETURN
      END

      SUBROUTINE PUTA(IFROM,ITO,ICOST,IHIGH,ILOW,ITYPE,IDUMP)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------


      INCLUDE "NETPARM"

      COMMON /NETWORK/FROM,TO,CST,UPPER,LOWER,RHS
      INTEGER*4 FROM(NEDGES),TO(NEDGES),CST(NEDGES),UPPER(NEDGES),
     C LOWER(NEDGES),RHS(NODES)
      COMMON /IO/ISYSP,ISYSI,ISYSO,IDIMACS
      INTEGER*4  ISYSP,ISYSI,ISYSO,IDIMACS

      INTEGER*4  IFROM,ITO,ICOST,IHIGH,ILOW,ITYPE,IDUMP
      INTEGER*4 IARC,iarcs
      DATA IARC/0/,iarcs/0/
      IF(IDUMP.EQ.1)GOTO01
      IARC = IARC + 1
      FROM(IARC) = IFROM
      TO(IARC)   = ITO
      CST(IARC) = ICOST
      UPPER(IARC) = IHIGH - ILOW
      LOWER(IARC)  = 0
      RHS(IFROM) = RHS(IFROM) - ILOW
      RHS(ITO) = RHS(ITO) + ILOW
      if(ihigh.ne.ilow) then
          iarcs = iarcs+1
      else
          iarcs=iarcs
      endif
      RETURN
01    CONTINUE
10    FORMAT(6X,2I6,2X,3I10)
C-jc	oct 1 jc -- changing I6 to I10
11    FORMAT('p min',6X,2I10)
12    FORMAT('a',6X,2I10,2X,3I10)
C
C     UNFORMATTED WRITE
C
C     WRITE(ISYSO)IFROM,IARC,ICOST,IHIGH
C     WRITE(ISYSO)(FROM(I),I=1,IARC)
C     WRITE(ISYSO)(TO(I),I=1,IARC)
C     WRITE(ISYSO)(COST(I),I=1,IARC)
C     WRITE(ISYSO)(HIGH(I),I=1,IARC)
C     WRITE(ISYSO)(LOW(I),I=1,IARC)
C
C     FORMATTED WRITE
C
C     WRITE(ISYSO,20)IFROM,IARC,ICOST,IHIGH
C     WRITE(ISYSO,20)(FROM(I),I=1,IARC)
C     WRITE(ISYSO,20)(TO(I),I=1,IARC)
C     WRITE(ISYSO,20)(COST(I),I=1,IARC)
C     WRITE(ISYSO,20)(HIGH(I),I=1,IARC)
C     WRITE(ISYSO,20)(LOW(I),I=1,IARC)
20    FORMAT(8(1X,I9))
C     WRITE(ISYSO,10)IFROM,ITO,ICOST,IHIGH
      IPROB = 0
      PT = 0
      IRT = 0
      MXIT = 100000
      FRQ = 8.0
      P0 = 1.0
      PBAR = 1.5
      WRITE(ISYSO)IFROM,0,IARC,ICOST,IHIGH
      WRITE(IDIMACS,11)IFROM,IARCs
      DO I = 1, IFROM
          IF(RHS(I).NE.0) then
              write(IDIMACS,'(''n '',I10,2X,I10)')I,RHS(I)
              if(i.ne.ifrom) then
                  if(rhs(i).gt.0) then
                      WRITE(ISYSO)IFROM,I,0,RHS(I),RHS(I)
                  else
                      WRITE(ISYSO)I,IFROM,0,-RHS(I),-RHS(I)
                  endif
              endif
          endif
      enddo
      DO 100 I=1,IARC
          IF(UPPER(I).GT.0) THEN
C         WRITE(ISYSO,10)FROM(I),TO(I),CST(I),UPPER(I),LOWER(I)
          WRITE(IDIMACS,12)FROM(I),TO(I),LOWER(I),UPPER(I),CST(I)
          WRITE(ISYSO)FROM(I),TO(I),CST(I),UPPER(I),LOWER(I)
          ENDIF
100       CONTINUE
      RETURN
      END
      SUBROUTINE SORT(I,L,N,EDGES)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------


      INCLUDE "NETPARM"

      REAL*8 EDGES(N)
      INTEGER I,L,IRD
      INTEGER II(100),MM(100),LL(100),ICALL(100)
      REAL*8 WORK(NEDGES)
      INTEGER I1,I2,L1,L2,J
C     WRITE(6,*)(EDGES(IV),IV=I,L)
      IRD=1
      ICALL(IRD)=1
      II(IRD)=I
      MM(IRD)=I+(L-I)/2
      LL(IRD)=L
10    CONTINUE
      IC=ICALL(IRD)
      GOTO(100,200,300),IC
100   CONTINUE
      I=II(IRD)
      L=MM(IRD)
      IF(I.EQ.L)GOTO150
      IRD=IRD+1
      ICALL(IRD)=1
      II(IRD)=I
      LL(IRD)=L
      MM(IRD)=I+(L-I)/2
      GOTO10
150   CONTINUE
      ICALL(IRD)=2
200   CONTINUE
      I=MM(IRD)+1
      L=LL(IRD)
      IF(I.EQ.L)GOTO300
      IRD=IRD+1
      ICALL(IRD)=1
      II(IRD)=I
      LL(IRD)=L
      MM(IRD)=I+(L-I)/2
      GOTO10
300   CONTINUE
      I1=II(IRD)
      I2=MM(IRD)
      I3=I2+1
      I4=LL(IRD)
      I5=I1
350   CONTINUE
      IF(I5.GT.I4)GOTO500
      IF(I3.GT.I4)GOTO400
      IF(I1.GT.I2)GOTO360
      IF(EDGES(I1).LT.EDGES(I3))GOTO400
360   CONTINUE
      WORK(I5)=EDGES(I3)
      I3=I3+1
      I5=I5+1
      GOTO350
400   CONTINUE
      WORK(I5)=EDGES(I1)
      I1=I1+1
      I5=I5+1
      GOTO350
500   CONTINUE
      I1=II(IRD)
      I4=LL(IRD)
      DO 510 I5=I1,I4
      EDGES(I5)=WORK(I5)
510       CONTINUE
      IRD=IRD-1
      IF(IRD.EQ.0)RETURN
      ICALL(IRD)=ICALL(IRD)+1
      GOTO10
      END
      SUBROUTINE LOAD1(N,II,IS,SUPPLY)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------

      INCLUDE "NETPARM"


      COMMON /A1/EDGES(NEDGES)
      REAL*8 EDGES
      REAL*8 SUPPLY(N)
      INTEGER IX
      DATA IX/0/
      IF(IX.NE.0)GOTO9
      DO 5 I=1,NEDGES
      EDGES(I)=0.0
5         CONTINUE
       IX = 1
9      CONTINUE
       DO 10 I=1,N
       EDGES(II)=EDGES(II)+SUPPLY(I)
      II=II+IS
C         WRITE(6,*)EDGES(I)
10        CONTINUE
      RETURN
      END
      SUBROUTINE DUMP1(N,SUPPLY)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------

      INCLUDE "NETPARM"


      COMMON /A1/EDGES(NEDGES)
      REAL*8 EDGES
      REAL*8 SUPPLY(N)
      INTEGER I
      DATA I/0/
      DO 10 II=1,N
C         WRITE(6,*)I,N,SUPPLY
      I=I+1
      SUPPLY(II)=EDGES(I)
10        CONTINUE
      RETURN
      END
      SUBROUTINE ORDER2(N)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------

      INCLUDE "NETPARM"


      COMMON /A1/EDGES(NEDGES)
      REAL*8 EDGES
      EDGES(N)=1.0
      II=N-1
      DO 10 I=1,II
      EDGES(N-I+1)=EDGES(N-I+1)-EDGES(N-I)
10        CONTINUE
      RETURN
      END

      SUBROUTINE RANDOM(ISEED,SEED)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      INTEGER*4 ISEED
      REAL*4 SEED
      REAL*8 RSEED
      CALL RAND_LOCAL(ISEED,RSEED)
      SEED = RSEED
C     WRITE(15,90)ISEED,SEED
90    FORMAT('RANDOM NUMBER -',I12,1X,F12.10)
      RETURN
      END

      INTEGER FUNCTION FLOOR*4(RNUM)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      REAL*4 RUM
      FLOOR = INT(AINT(RNUM))
      RETURN
      END

      INTEGER FUNCTION DFLOOR*4(RNUM)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      REAL*8 RNUM
      DFLOOR = DINT(RNUM)
      RETURN
      END

      INTEGER FUNCTION DCEIL*4(RNUM)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      REAL*8 RNUM,RR
      RR = DFLOAT(IDINT(RNUM))
      IF(RNUM.EQ.DFLOAT(IDINT(RNUM))) THEN
      DCEIL = IDINT(RNUM)
      ELSE
      DCEIL = 1 + IDINT(RNUM)
      END IF
      RETURN
      END

      INTEGER FUNCTION CEIL*4(RNUM)
C-----------------------------------------------------------------------
C     c 1991 copyright Robert G. Bland and David L. Jensen
C                      Ithaca, New York
C            All rights reserved
C-----------------------------------------------------------------------
      REAL*4 RNUM
      IF(RNUM.EQ.AINT(RNUM)) THEN
      CEIL = INT(AINT(RNUM))
      ELSE
      CEIL = 1 + INT(AINT(RNUM))
      END IF
      RETURN
      END
       subroutine rand_local(iseed,seed)
       integer*4 iseed
       real*8 seed
       iseed = iabs(iseed * 16807)
       seed = dfloat(iseed) / dfloat(2*(2**30-1) +1)
       return
       end

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

C*********************************************************************
      PROGRAM CARDMP
C
C     SOLVES THE CARDINALITY MATCHING PROBLEM USING AN
C     IMPLEMENTATION OF THE MICALI-VAZIRANI ALGORITHM
C
C     LANGUAGE:   FORTRAN 77
C
C     PARAMETERS:
C             N = maximum number of nodes allowed
C             M = maximum number of edges allowed
C
C             These parameters are used to determine the amount of
C             memory to be allocated.  Identical parameter statements
C             are included in each of the following modules:
C                 PROGRAM CARDMP  (main program)
C                 SUBROUTINE SEARCH
C                 SUBROUTINE BLSAUG
C                 SUBROUTINE FNDPTH
C
C     INPUT:  Input is read from UNIT 5.
C           * Comment lines begin with 'c' and are ignored.
C             WARNING: This program deviates slightly from DIMACS format.
C             Comments may occur before or after the 'p' line, but
C             no comment may occur after the first 'e' line.
C           * The 'p' line contains the string 'edge' followed by
C             two integers NI and MI.  NI = number of vertices input.
C             MI = number of edges input.  
C           * 'e' lines contain 3 integers representing the two vertices
C             making up an edge, along with the edge weight.  (This 
C             program ignores the edge weights).    
C
C     Warning:  Some versions of FORTRAN may require formatted input.
C               Alternative input statements are provided as comments
C               beginning with 'CI'
C
C     OUTPUT: Output is written to UNIT 6.
C           * Line 1 begins with 's' (solution line) and contains a
C             single integer representing the cardinality of an
C             optimal matching.
C           * Lines 2-NI+1 begin with 'm' (matching line) followed by
C             two integers:  U and MATCH(U).
C             U is a vertex and MATCH(U) is the vertex adjacent
C             to U in the optimal matching or 0 if U is unmatched.
C
C     The main program, Step -1 of SEARCH and subroutine SSORT are
C     based on code written by U. Derigs and G. Kazakidis published in
C
C             R. E. Burkard and U. Derigs.  Assignment and Matching
C             Problems:  Solution Methods and FORTRAN-Programs.  Lecture
C             Notes in Economics and mathematical Systems, Vol. 184,
C             Springer-Verlag, Berlin, 1980.
C
C     Subroutines SEARCH, BLSAUG and FNDPTH are based on an algorithm
C     published in:
C
C             Micali, S. and Vazirani, V. V.,"An O(square root of V * E)
C             Algorithm for Finding Maximum Matching in General Graphs",
C             Proc. 21st Annual Symposium on Foundation of Computer
C             Science, IEEE, 1980, pp. 17-27.
C
C     Programmers:
C              R. Bruce Mattingly  (FR132601@ysub.ysu.edu)
C              Nathan P. Ritchey   (nate@macs.ysu.edu)
C              Department of Mathematical and Computer Sciences
C              Youngstown State University
C              Youngstown, OH  44555
C
C     Version 1.11
C     Last modification:  02/14/92
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
      INTEGER N, M, NP1, MT2
      PARAMETER (N=8192, M=32768)
      PARAMETER (MT2=M*2, NP1=N+1)
C
      CHARACTER CH*1, JUNK*5
      INTEGER I, J, P, U, V, B
      INTEGER DEGREE(N), NBRLL(MT2, 2), PTR(N)
C
      INTEGER NI, MI, MATCH(N), CARD, NINDEX(NP1), NGHBR(MT2)
      COMMON NI, MI, MATCH, CARD, NINDEX, NGHBR
C-----------------------------------------------------------------------
C
C     READ AND CHECK PROBLEM DIMENSIONS
C  
      CH = 'c'
    1 IF (CH .NE. 'p') THEN
         READ(5,*) CH
CI       READ(5, 501) CH
CI501    FORMAT(A1, A5, 2I10)
         GOTO 1
      ENDIF
      BACKSPACE(5)
      READ(5,*) CH, JUNK, NI, MI
CI    READ(5, 501) CH, JUNK, NI, MI
C
      IF (N .LT. NI) THEN
         WRITE(6, 2) 'N', N, NI
    2    FORMAT(1X, 'MAIN:  PARAMETER ', A1,' =',I10,
     +          ' IS TOO SMALL - INPUT VALUE =',I10)
         STOP
      ELSE IF (M .LT. MI) THEN
         WRITE(6, 2) 'M', M, MI
         STOP
      ENDIF
C
    3 IF (CH .NE. 'e') THEN
         READ(5,*) CH
CI       READ(5,501) CH
         GOTO 3
      ENDIF
      BACKSPACE(5)
C
C   INPUT EDGES, STORE ADJACENCY LISTS IN NBRLL (NEIGHBOR LINKED LISTS)
C
      DO 8 I = 1, NI
         DEGREE(I) = 0
         PTR(I) = 0
    8 CONTINUE
      P = 0
      DO 10 I = 1, MI
         READ(5, *) CH, U, V
CI       READ(5,502) CH, U, V
CI502    FORMAT(A1,1X,2I10)
         P = P+1
         NBRLL(P,1) = V
         NBRLL(P,2) = PTR(U)
         PTR(U) = P
         DEGREE(U) = DEGREE(U) + 1
         P = P + 1
         NBRLL(P,1) = U
         NBRLL(P,2) = PTR(V)
         PTR(V) = P
         DEGREE(V) = DEGREE(V) + 1
   10 CONTINUE
C
C     NOW STORE ADJACENCY LISTS SEQUENTIALLY
C
      NINDEX(1) = 1
      DO 12 I = 1, NI
         NINDEX(I+1) = NINDEX(I) + DEGREE(I)
   12 CONTINUE
      DO 16 I = 1, NI
         P = PTR(I)
         DO 14 J = NINDEX(I), NINDEX(I+1)-1
            NGHBR(J) = NBRLL(P,1)
            P = NBRLL(P,2)
   14    CONTINUE
   16 CONTINUE
C
C     CALL SEARCH TO FIND OPTIMAL MATCHING AND CARDINALITY
C
      CALL SEARCH(DEGREE)
C
C     DIMACS OUTPUT
C
      WRITE(6,60)  CARD
   60 FORMAT('s  ', I10)
C
      DO 68 J = 1 , NI
      WRITE(6,66)  J, MATCH(J)
   66 FORMAT('m  ', 2I10)
   68 CONTINUE
C
  100 STOP
      END
C***********************************************************************
      SUBROUTINE SEARCH(DEGREE)
C
C     PERFORMS BREADTH-FIRST SEARCHES FROM FREE (UNMATCHED) VERTICES.
C     IDENTIFIES BRIDGES (EDGES JOINING ALTERNATING PATHS FROM 
C     FREE VERTICES)
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
C
C     PARAMETERS
C
      INTEGER N, M, NP1, MT2, INFTY, UNDEF, ND2
      PARAMETER (N=8192, M=32768)
      PARAMETER (NP1=N+1, MT2=M*2, INFTY=NP1, UNDEF=0, ND2=N/2)
C
C     ARGUMENTS
C
      INTEGER  DEGREE(*)
C
C     LOCAL VARIABLES
C
      INTEGER B, U, V, E, I, UU, VV, TEMP, NEXT, NLEVI, LEVELI(N), CODE
      INTEGER VP1, MEM(N)
      LOGICAL DIDAUG
C
C     COMMON STORAGE
C
      INTEGER NI, MI, MATCH(N), CARD, NINDEX(NP1), NGHBR(MT2)
      COMMON NI, MI, MATCH, CARD, NINDEX, NGHBR
C
      CHARACTER*1 MARK(N)
      COMMON /BLK0/ MARK
C
      INTEGER EVLEV(N), ODLEV(N), BLOSS(N)
      COMMON /BLK1/ EVLEV, ODLEV, BLOSS
C
      INTEGER ANOM(2,N), AINDEX(N), AFREE
      COMMON /BLK2/ ANOM, AINDEX, AFREE
C
      LOGICAL VISITD(N)
      COMMON /BLK3/ VISITD
C
      INTEGER BASE(ND2), BSTAR(ND2), PEAKL(ND2), PEAKR(ND2),
     +        F(N), PATH(N)
      COMMON /BLK4/ BASE, BSTAR, PEAKL, PEAKR, F, PATH
C
      INTEGER BRIDGE(3,M), BINDEX(ND2), BFREE
      COMMON /BLK5/ BRIDGE, BINDEX, BFREE
C
      INTEGER PRED(2,M), PINDEX(N), PFREE, DERP(2,M), DINDEX(N), DFREE,
     +        PRDCTR(N)
      COMMON /BLK6/ PRED, PINDEX, PFREE, DERP, DINDEX, DFREE, PRDCTR
C
      INTEGER EDGE(MT2)
      COMMON /BLK7/ EDGE
C
      INTEGER LR(N), CALLS
      COMMON /BLK9/ LR, CALLS
C-----------------------------------------------------------------------
      IF (N .LT. NI) THEN
         WRITE(6, 4) 'N', N, NI
    4    FORMAT(1X, 'SEARCH:  PARAMETER ', A1,' =',I10,
     +          ' IS TOO SMALL - INPUT VALUE =',I10)
         STOP
      ELSE IF (M .LT. MI) THEN
         WRITE(6, 4) 'M', M, MI
         STOP
      ENDIF
C 
C  *** STEP -1 ***  Compute initial matching 
C
C     INITIALIZE MATCH ARRAY
C
      DO 20 V = 1, NI
         MATCH(V) = 0
         MEM(V) = V
   20 CONTINUE
      CARD = 0
C
      CALL SSORT(DEGREE, MEM, NI)
      DO 55 VV = 1, NI
         V = MEM(VV)
         IF (MATCH(V) .EQ. 0) THEN
            DO 53 UU = NINDEX(V), NINDEX(V+1)-1
               U = NGHBR(UU)
               IF (MATCH(U) .EQ. 0) THEN
                  MATCH(U) = V
                  MATCH(V) = U
                  CARD = CARD + 1
                  GOTO 55
               ENDIF
   53       CONTINUE
         ENDIF
   55 CONTINUE
      IF (CARD .EQ. NI/2) RETURN
C
C *** STEP 0 *** Initialization
C
    5 DO 10 V = 1, NI
         EVLEV(V) = INFTY
         ODLEV(V) = INFTY
         BLOSS(V) = UNDEF
         PINDEX(V) = 0
         DINDEX(V) = 0
         AINDEX(V) = 0
         VISITD(V)   = .FALSE.
         LR(V) = 0
         MARK(V) = ' '
         F(V) = 0
         PRDCTR(V) = 0
   10 CONTINUE
      PFREE = 1
      DFREE = 1
      AFREE = 1
C
      DO 12 E = 1, MI*2
   12    EDGE(E) = 0
C
      DO 14 V = 0, NI/2
   14    BINDEX(V) = 0
      BFREE = 1
C
      DO 16 V = 1, MI-1
         VP1 = V + 1
         PRED(1,V) = VP1
         DERP(1,V) = VP1
   16 CONTINUE
      PRED(1, MI) = 0
      DERP(1, MI) = 0
      DO 17 V = 1, NI - 1
         VP1 = V + 1
         ANOM(1,V) = VP1
   17 CONTINUE
      ANOM(1, NI) = 0
C
      DO 18 V = 1, MI-1
            BRIDGE(1,V) = V+1
   18 CONTINUE
      BRIDGE(1,MI) = 0
C
      I = -1
      DIDAUG = .FALSE.
      CALLS = 0
      B = 0
C
C *** STEP 1 ***  Check for free vertices
C
      DO 101 V = 1, NI
         IF (MATCH(V) .EQ. 0) EVLEV(V) = 0
  101 CONTINUE
C
C *** STEP 2 ***  Proceed to next level (I) of search
C
  200 I = I + 1
      IF (I .GT. N/2) THEN
          PRINT *, 'SEARCH:  SEARCH LEVEL LIMIT EXCEEDED'
          STOP
      ENDIF
      NLEVI = 0
C
C     Loop 210 searches for vertices with level=I
C
      DO 210 V = 1, NI
         IF ((EVLEV(V) .EQ. I) .OR. (ODLEV(V) .EQ. I)) THEN
C        IF (MIN(EVLEV(V), ODLEV(V)) .EQ. I) THEN
            NLEVI = NLEVI + 1
            LEVELI(NLEVI) = V
         ENDIF
  210 CONTINUE
C
C     If no more vertices have level I then HALT (return to main)
C
      IF (NLEVI .EQ. 0)  RETURN
C
C     Is search level I even or odd?
C
      IF (MOD(I,2) .EQ. 0) THEN
C
C *** STEP 3 ***  For even search levels
C
         DO 310 VV = 1, NLEVI
            V = LEVELI(VV)
            IF ((I .EQ. 0) .AND. (MATCH(V) .NE. 0)) GOTO 310
C
C           Loop 320 processes all neighbors of current V
C
            DO 320 UU = NINDEX(V), NINDEX(V+1)-1
               U = NGHBR(UU)
C
C              EDGE UV IS UNUSED IF CODE IS EVEN
C
               CALL STATUS(U, V, EDGE, CODE, 'R', NINDEX, NGHBR)
               IF ((MATCH(U) .NE. V) .AND. (MOD(CODE,2) .EQ. 0)) THEN
                  IF (EVLEV(U) .NE. INFTY) THEN
                     TEMP = (EVLEV(U) + I) / 2
                     IF ((EVLEV(U) .NE. I) .OR. (U .LT. V)) THEN
                        CALL ADDBRG(U, V, TEMP, BRIDGE, BINDEX, BFREE)
                     ENDIF
                  ELSE
                     IF (ODLEV(U) .EQ. INFTY) ODLEV(U) = I + 1
                     IF (ODLEV(U) .EQ. I + 1) THEN
                        CALL ADDSTK(PRED, PINDEX, PFREE, U, V)
                        CALL ADDSTK(DERP, DINDEX, DFREE, V, U)
                        PRDCTR(U) = PRDCTR(U) + 1
                     ELSE IF (ODLEV(U) .LT. I) THEN
                        CALL ADDSTK(ANOM, AINDEX, AFREE, U, V)
                     ENDIF
                  ENDIF
               ENDIF
  320       CONTINUE
  310    CONTINUE
C
      ELSE
C
C *** STEP 4 ***  For odd search levels
C
         DO 410 VV = 1, NLEVI
            V = LEVELI(VV)
            IF (BLOSS(V) .EQ. UNDEF) THEN
               U = MATCH(V)
               IF (ODLEV(U) .EQ. I) THEN
                  IF (U .LT. V) THEN
                     CALL ADDBRG(U, V, I, BRIDGE, BINDEX, BFREE)
                  ENDIF
               ELSE IF (ODLEV(U) .EQ. INFTY) THEN
C
C                   MAKE V THE ONLY PREDECESSOR OF U
C
                    EVLEV(U) = I + 1
                    NEXT = PINDEX(U)
C
C                   CHECK FOR ERROR CONDITION
C
                    IF (NEXT .NE. 0) PRINT *, 'WARNING FROM SEARCH: ',
     +              U, ' SHOULD NOT HAVE ANY PREDECESSORS'
  408               IF (NEXT .NE. 0) THEN
                       PINDEX(U) = PRED(1, NEXT)
                       PRED(1, NEXT) = PFREE
                       PFREE = NEXT
                       NEXT = PINDEX(U)
                       GOTO 408
                    ENDIF
C
                    CALL ADDSTK(PRED, PINDEX, PFREE, U, V)
                    CALL ADDSTK(DERP, DINDEX, DFREE, V, U)
                    PRDCTR(U) = PRDCTR(U) + 1
               ENDIF
            ENDIF
  410    CONTINUE
      ENDIF
C
C *** STEP 5 ***
C
      NEXT = BINDEX(I)
  510 IF (NEXT .NE. 0) THEN
         U = BRIDGE(2, NEXT)
         V = BRIDGE(3, NEXT)
         NEXT = BRIDGE(1, NEXT)
         IF ((MARK(U) .EQ. 'E') .OR. (MARK(V) .EQ. 'E')) GOTO 510
         IF ((BLOSS(U) .NE. UNDEF) .AND. (BLOSS(V) .EQ. BLOSS(U)))
     +      GOTO 510
         CALL BLSAUG(U, V, DIDAUG, B, I)
         IF (CARD .EQ. NI/2) RETURN
         GOTO 510
      ENDIF
      IF (DIDAUG) THEN
         GOTO 5
      ELSE
         GOTO 200
      ENDIF
C
      END
C***********************************************************************
      SUBROUTINE BLSAUG(W1, W2, DIDAUG, B, I)
C
C     FINDS AN AUGMENTING PATH CONTAINING BRIDGE W1-W2 OR CREATES A NEW
C     BLOSSOM.  THE COMMON VARIABLE CALLS IS INCREMENTED EACH TIME THIS
C     ROUTINE IS CALLED.  I IS THE SEARCH LEVEL.  B COUNTS BLOSSOMS.
C
C     DEPTH-FIRST SEARCHES ARE CONDUCTED SIMULTANEOUSLY FROM W1 AND W2.
C     THE LEFT SEARCH STARTS AT W1 AND THE RIGHT SEARCH STARTS AT W2.
C     LR(N) = +CALLS IF VERTEX N IS VISITED BY THE LEFT SEARCH.
C     LR(N) = -CALLS IF VERTEX N IS VISITED BY THE RIGHT SEARCH.
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
C
C     PARAMETERS
C
      INTEGER N, M, NP1, MT2, UNDEF, ND2
      PARAMETER (N=8192, M=32768)
      PARAMETER (NP1=N+1, MT2=M*2, UNDEF=0, ND2=N/2)
C
C     ARGUMENTS
C
      INTEGER W1, W2, B, I
      LOGICAL DIDAUG
C
C     LOCAL VARIABLES
C
      INTEGER VL, VR, DCV, BARIER, P1, P2, U, V, TEMP, NEXT, 
     +        INDEX, MEMBER(N), NMEM, UU, LINDEX, RINDEX,
     +        ESTK(N), ETOP, LJUMP, RJUMP
C
C     COMMON STORAGE
C
      INTEGER NI, MI, MATCH(N), CARD, NINDEX(NP1), NGHBR(MT2)
      COMMON NI, MI, MATCH, CARD, NINDEX, NGHBR
C
      CHARACTER*1 MARK(N)
      COMMON /BLK0/ MARK
C
      INTEGER EVLEV(N), ODLEV(N), BLOSS(N)
      COMMON /BLK1/ EVLEV, ODLEV, BLOSS
C
      INTEGER ANOM(2,N), AINDEX(N), AFREE
      COMMON /BLK2/ ANOM, AINDEX, AFREE
C
      INTEGER BASE(ND2), BSTAR(ND2), PEAKL(ND2), PEAKR(ND2),
     +        F(N), PATH(N)
      COMMON /BLK4/ BASE, BSTAR, PEAKL, PEAKR, F, PATH
C
      INTEGER BRIDGE(3,M), BINDEX(ND2), BFREE
      COMMON /BLK5/ BRIDGE, BINDEX, BFREE
C
      INTEGER PRED(2,M), PINDEX(N), PFREE, DERP(2,M), DINDEX(N), DFREE,
     +        PRDCTR(N)
      COMMON /BLK6/ PRED, PINDEX, PFREE, DERP, DINDEX, DFREE, PRDCTR
C
      INTEGER EDGE(MT2)
      COMMON /BLK7/ EDGE
C
      INTEGER LR(N), CALLS
      COMMON /BLK9/ LR, CALLS
C-----------------------------------------------------------------------
      CALLS = CALLS + 1
      IF (N .LT. NI) THEN
         WRITE(6, 4) 'N', N, NI
    4    FORMAT(1X, 'BLSAUG:  PARAMETER ', A1,' =',I10,
     +          ' IS TOO SMALL - INPUT VALUE =',I10)
         STOP
      ELSE IF (M .LT. MI) THEN
         WRITE(6, 4) 'M', M, MI
         STOP
      ENDIF
C
C *** STEP 0 ***
C
      VL = W1
      LJUMP=0
      IF ( BLOSS(W1) .NE. UNDEF) THEN
         CALL BASTAR(0, VL, BSTAR, F, BLOSS)
      ENDIF
C
      VR = W2
      RJUMP=0
      IF (BLOSS(W2) .NE. UNDEF) THEN
         CALL BASTAR(0, VR, BSTAR, F, BLOSS)
      ENDIF
C
C     QUIT IF AN EMPTY BLOSSOM IS DETECTED
C
      IF (VL .EQ. VR) GOTO 500
C
      LINDEX = PINDEX(VL)
      RINDEX = PINDEX(VR)
      LR(VL) = CALLS
      LR(VR) = -CALLS
      MEMBER(1) = VL
      MEMBER(2) = VR
      NMEM = 2
      F(W1) = UNDEF
      DCV = UNDEF
C     IN ORIGINAL ALGORITHM W2 IS REPLACED BY VR BELOW
      BARIER = W2
C
C *** STEP 1.1 ***  If VL and VR are both free vertices
C
  100 IF ((MATCH(VL) .EQ. 0) .AND. (MATCH(VR) .EQ. 0) ) THEN
         CALL FNDPTH(W1, VL, UNDEF, -1)
         CALL FNDPTH(W2, VR, UNDEF, 1)
C
C        Concatenate paths
C
         PATH(W1) = W2
C
C        AUGMENT MATCHING 
C
         P1 = VL
  111    P2 = PATH(P1)
         MATCH(P1) = P2
         MATCH(P2) = P1
         ETOP = ETOP + 1
         ESTK(ETOP) = P1
         ETOP = ETOP + 1
         ESTK(ETOP) = P2
         P1 = PATH(P2)
         IF (P2 .NE. VR) GOTO 111
         CARD = CARD + 1
         DIDAUG = .TRUE.
C
C        PERFORM TOPOLOGICAL ERASE AND RETURN
C
  122    IF (ETOP .GT. 0) THEN
            P1 =  ESTK(ETOP)
            ETOP = ETOP - 1
            IF (MARK(P1) .NE. 'E') THEN
               MARK(P1) = 'E'
               NEXT = DINDEX(P1)
  127          IF (NEXT .NE. 0) THEN
                  P2 = DERP(2, NEXT)
                  NEXT = DERP(1, NEXT)
                  PRDCTR(P2) = PRDCTR(P2) - 1
                  IF (PRDCTR(P2) .EQ. 0) THEN
                     ETOP = ETOP + 1
                     ESTK(ETOP) = P2
                  ENDIF
                  GOTO 127
               ENDIF
            ENDIF
            GOTO 122
         ENDIF
         GOTO 500
C
C *** STEP 1.2 ***  If VL and VR are not both free
C
      ELSE
         IF (MIN(EVLEV(VL),ODLEV(VL)).GE.MIN(EVLEV(VR),ODLEV(VR))) THEN
            GOTO 200
         ELSE
            GOTO 300
         ENDIF
      ENDIF
C
C Does VL have unused ancestor edges?
C
  200 IF (LINDEX .EQ. 0) THEN
         U = 0
      ELSE
         CALL ANCEST(VL, 1, U, LINDEX, PRED, EDGE, MARK, NINDEX, NGHBR)
      ENDIF
      IF (U .EQ. 0) THEN
C
C *** STEP 2.1 ***  VL has no more unused ancestors
C
         IF (F(VL) .EQ. UNDEF) THEN
            IF (DCV .NE. UNDEF) THEN
               GOTO 400
            ELSE
               PRINT *, 'WARNING - BLSAUG(',W1,',',W2,') QUITTING ', 
     +                  'BECAUSE DCV UNDEFINED AT STEP 2.1'
               GOTO 500
            ENDIF
         ELSE
            VL = F(VL)
            LINDEX = PINDEX(VL)
            GOTO 100
         ENDIF
      ELSE
C
C ***  STEP 2.2 *** VL has some unused ancestors
C
C        MARK VL-U 'USED'
C
         CALL STATUS(VL, U, EDGE, 1, 'W', NINDEX, NGHBR)
         LJUMP = VL
         IF (BLOSS(U) .NE. UNDEF) THEN
            CALL BASTAR(VL, U, BSTAR, F, BLOSS)
            LINDEX = PINDEX(VL)
         ENDIF
C
C    *** Is U marked? ***
C
         IF (ABS(LR(U)) .NE. CALLS) THEN
C
C        *** STEP 2.2 (a) ***   U is unmarked
C
            LR(U) = CALLS
            CALL ADDMEM(MEMBER, NMEM, U)
            F(U) = VL
            VL = U
            LINDEX = PINDEX(VL)
            GOTO 100
         ELSE
C
C        *** STEP 2.2 (b) ***   U is marked
C
            IF ((U .EQ. BARIER) .OR. (U .NE. VR)) THEN
               GOTO 100
            ELSE
               LR(U) = CALLS
               CALL ADDMEM(MEMBER, NMEM, U)
               VR = F(VR)
               IF (RJUMP .NE. 0) VR = RJUMP
               RINDEX = PINDEX(VR)
               F(U) = VL
               VL = U
               LINDEX = PINDEX(VL)
               DCV = U
               GOTO 100
            ENDIF
         ENDIF
      ENDIF
C
C Does VR have unused ancestor edges?
C
  300 IF (RINDEX .EQ. 0) THEN
         U = 0
      ELSE
         CALL ANCEST(VR, 1, U, RINDEX, PRED, EDGE, MARK, NINDEX, NGHBR)
      ENDIF
      IF (U .EQ. 0) THEN
C
C    *** STEP 3.1 ***  VR has no more unused ancestors
C
         IF (VR .EQ. BARIER) THEN
            IF (DCV .EQ. 0) THEN 
            PRINT *, 'WARNING - BLSAUG(',W1,',',W2,') QUITTING ', 
     +               'BECAUSE DCV UNDEFINED AT STEP 3.1'
               GOTO 500
            endif
            VR = DCV
            RINDEX = PINDEX(VR)
            BARIER = DCV
            LR(VR) = -CALLS
            CALL ADDMEM(MEMBER, NMEM, VR)
            IF (F(VL) .EQ. UNDEF) THEN
                GOTO 400
            ELSE
               VL = F(VL)
               IF (LJUMP .NE. 0) VL = LJUMP
               LINDEX = PINDEX(VL)
            ENDIF
         ELSE
            VR = F(VR)
            RINDEX = PINDEX(VR)
         ENDIF
         GOTO 100
      ELSE
C
C     *** STEP 3.2 ***  VR has some unused ancestors
C
C        MARK VR-U 'USED'
C
         CALL STATUS(VR, U, EDGE, 1, 'W', NINDEX, NGHBR)
         RJUMP = VR
         IF (BLOSS(U) .NE. UNDEF) THEN
            CALL BASTAR(VR, U, BSTAR, F, BLOSS)
            RINDEX = PINDEX(VR)
         ENDIF
C
C    *** Is U unmarked? ***
C
         IF (ABS(LR(U)) .NE. CALLS) THEN
C
C        *** STEP 3.2 (a) ***
C
            LR(U) = -CALLS
            CALL ADDMEM(MEMBER, NMEM, U)
            F(U) = VR
            VR = U
            RINDEX = PINDEX(VR)
            GOTO 100
         ELSE
C
C        *** STEP 3.2 (b) ***
C
            IF (U .EQ. VL) THEN
               DCV = U
            ENDIF
            GOTO 100
         ENDIF
      ENDIF
C
C *** STEP 4 ***  
C
  400 LR(DCV) = 0
C
C     create new blossom using all vertices marked L or R during call
C
      B = B + 1
      IF (B .GT. ND2) THEN  
         PRINT *,'BLSAUG: OUT OF STORAGE FOR BASE, BSTAR, PEAKL, PEAKR' 
         STOP
      ENDIF
      DO 425 UU = 1, NMEM
         U = MEMBER(UU)
         IF (U .EQ. DCV) GOTO 425
         IF (BLOSS(U) .EQ. UNDEF) THEN
            BLOSS(U) = B
            IF (EVLEV(U) .LT. ODLEV(U)) THEN
               ODLEV(U) = 2 * I + 1 - EVLEV(U)
            ELSE
               EVLEV(U) = 2 * I + 1 - ODLEV(U)
               INDEX = AINDEX(U)
  421          IF (INDEX .NE. 0) THEN
                  V = ANOM(2, INDEX)
                  INDEX = ANOM(1, INDEX)
                  TEMP = (EVLEV(U) + EVLEV(V))/2
                  CALL ADDBRG(U, V, TEMP, BRIDGE, BINDEX, BFREE)
C
C                 MARK U-V 'USED'
C
                  CALL STATUS(U, V, EDGE, 1, 'W', NINDEX, NGHBR)
                  GOTO 421
               ENDIF
            ENDIF
         ENDIF
  425 CONTINUE
C
      PEAKL(B) = W1
      PEAKR(B) = W2
      BASE(B)  = DCV
      BSTAR(B) = DCV
C
C *** STEP 5 ***  Return to SEARCH
C
  500 RETURN
      END
C***********************************************************************
      SUBROUTINE ADDMEM(MEMBER, NMEM, U)
C
C     KEEPS TRACK OF VERTICES MARKED L OR R DURING A CALL TO BLSAUG
C     IN CASE A NEW BLOSSOM IS FORMED
C
C-----------------------------------------------------------------------
      INTEGER MEMBER(1), NMEM, U
C-----------------------------------------------------------------------
      NMEM = NMEM + 1
      MEMBER(NMEM) = U
      RETURN
      END
C***********************************************************************
      SUBROUTINE FNDPTH(HIGH, LOW, B, JOB)
C
C     JOB .NE. -1:  RETURNS A LINKED LIST FROM HIGH TO LOW
C     JOB .EQ. -1:  RETURNS A LINKED LIST FROM LOW TO HIGH
C     JOB .EQ.  2:  ALLOWS TRANSFERS BETWEEN LEFT AND RIGHT SEARCHTREES
C                   (OCCURS ONLY WHEN OPENING A BLOSSOM)
C
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
C
C     PARAMETERS
C
      INTEGER N, M, NP1, ND8, MT2, ND2
      PARAMETER (N=8192, M=32768)
      PARAMETER (NP1=N+1, ND8=N/8, MT2=M*2, ND2=N/2)
C
C     ARGUMENTS 
C
      INTEGER HIGH, LOW, B, JOB
C
C     LOCAL VARIABLES 
C
      INTEGER ENTRNC, BASS, LB, RETADD
      INTEGER STACK(8, ND8), U, V, PREE, PNTR, SUCC, VINDEX
C
C     COMMON STORAGE
C
      INTEGER NI, MI, MATCH(N), CARD, NINDEX(NP1), NGHBR(MT2)
      COMMON NI, MI, MATCH, CARD, NINDEX, NGHBR
C
      CHARACTER*1 MARK(N)
      COMMON /BLK0/ MARK
C
      INTEGER EVLEV(N), ODLEV(N), BLOSS(N)
      COMMON /BLK1/ EVLEV, ODLEV, BLOSS
C
      LOGICAL VISITD(N)
      COMMON /BLK3/ VISITD
C
      INTEGER BASE(ND2), BSTAR(ND2), PEAKL(ND2), PEAKR(ND2),
     +        F(N), PATH(N)
      COMMON /BLK4/ BASE, BSTAR, PEAKL, PEAKR, F, PATH
C
      INTEGER PRED(2,M), PINDEX(N), PFREE, DERP(2,M), DINDEX(N), DFREE,
     +        PRDCTR(N)
      COMMON /BLK6/ PRED, PINDEX, PFREE, DERP, DINDEX, DFREE, PRDCTR
C
      INTEGER EDGE(MT2)
      COMMON /BLK7/ EDGE
C
      INTEGER STKLIM, STKTOP
      COMMON /BLK8/ STKLIM, STKTOP
C
      INTEGER LR(N), CALLS
      COMMON /BLK9/ LR, CALLS
C-----------------------------------------------------------------------
      IF (N .LT. NI) THEN
         WRITE(6, 4) 'N', N, NI
    4    FORMAT(1X, 'FNDPTH:  PARAMETER ', A1,' =',I10,
     +          ' IS TOO SMALL - INPUT VALUE =',I10)
         STOP
      ELSE IF (M .LT. MI) THEN
         WRITE(6, 4) 'M', M, MI
         STOP
      ENDIF
      STKLIM = ND8
      STKTOP = 0
C
C *** STEP 0 ***
C
   10 IF (HIGH .EQ. LOW) THEN
C
C        WHOLE PATH IS JUST "high"
C
         GOTO 820
      ENDIF
C
      V = HIGH
      VINDEX = PINDEX(V)
C
C *** STEP 1 ***
C
  100 IF (VINDEX .EQ. 0) THEN
         U = 0
      ELSE
         CALL ANCEST(V, 2, U, VINDEX, PRED, EDGE, MARK, NINDEX, NGHBR)
      ENDIF
      IF (U .EQ. 0) THEN
         IF (F(V) .EQ. 0) THEN
            PRINT *, 'ERROR --  FNDPTH CANNOT FIND PATH'
            STOP
         ELSE 
            V = F(V)
         ENDIF
         VINDEX = PINDEX(V)
         GOTO 100
      ENDIF
C
C *** STEP 2 ***
C
      IF (BLOSS(V) .EQ.  B) THEN
C
C        MARK U-V 'VISITED'
C
         CALL STATUS(U, V, EDGE, 2, 'W', NINDEX, NGHBR)
      ELSE
         U = BASE(BLOSS(V))
      ENDIF
C
C *** STEP 3 ***
C
      IF (U .EQ. LOW) GOTO 600
C
C *** STEP 4 ***  
C
      IF  (VISITD(U)) GOTO 100
      IF ( MIN(EVLEV(U),ODLEV(U)) .LE. MIN(EVLEV(LOW),ODLEV(LOW)) ) 
     +   GOTO 100
      IF (JOB .EQ. 2) GOTO 501
      IF ((BLOSS(U) .EQ. B) .AND. (LR(U) .EQ. -LR(HIGH))) GOTO 100 
C *** STEP 5 ***
C
  501 VISITD(U) = .TRUE.
      F(U) = V
      V = U
      VINDEX = PINDEX(V)
      GOTO 100
C
C *** STEP 6 ***
C
  600 PATH(V) = LOW
  620 IF (V .NE. HIGH) THEN
         U = V
         V = F(V)
         PATH(V) = U
         GOTO 620
      ENDIF
C
C *** STEP 7 ***
C
      ENTRNC = HIGH
  710 IF (ENTRNC .NE. LOW) THEN
         BASS = PATH(ENTRNC)
         IF (BLOSS(ENTRNC) .NE. B) THEN
C
C            SIMULATE CALL TO OPEN(ENTRNC, BASS)
C
             GOTO 900
C
         ENDIF
  777    ENTRNC = BASS
         GOTO 710
      ENDIF
C
C *** STEP 8 ***
C
  800 IF (JOB .EQ. -1) THEN
C
C     INVERT PATH IF NECESSARY
C
      PREE = 0
      PNTR = HIGH
      SUCC = PATH(HIGH)
  810 IF (PNTR .NE. LOW) THEN
         PATH(PNTR) = PREE
         PREE = PNTR
         PNTR = SUCC
         SUCC = PATH(PNTR)
         GOTO 810
      ENDIF
      PATH(PNTR) = PREE
      ENDIF
C
C     CHECK STACK BEFORE RETURNING
C
  820 IF (STKTOP .NE. 0) THEN
         HIGH   = STACK(1, STKTOP)
         LOW    = STACK(2, STKTOP)
         B      = STACK(3, STKTOP)
         JOB    = STACK(4, STKTOP)
         ENTRNC = STACK(5, STKTOP)
         BASS   = STACK(6, STKTOP)
         LB     = STACK(7, STKTOP)
         RETADD = STACK(8, STKTOP)
         STKTOP = STKTOP - 1
      ELSE
         RETURN
      ENDIF
C
      IF (RETADD .EQ. 777) THEN
         GOTO 777
      ELSE IF (RETADD .EQ. 902) THEN
         GOTO 902
      ELSE
         GOTO 904
      ENDIF
C
C***********************************************************************
C
C     FUNCTION OPEN STARTS AT LINE 900
C     EMBEDDED INSIDE FNDPTH TO REMOVE RECURSION
C
  900 LB = BLOSS(ENTRNC)
      IF (EVLEV(ENTRNC) .LE. ODLEV(ENTRNC) ) THEN
         CALL PUSH(HIGH, LOW, B, JOB, ENTRNC, BASS, LB, 777, STACK)
         HIGH = ENTRNC
         LOW = BASS
         JOB = 2
         B = LB
         GOTO 10
      ELSE
         IF (LR(ENTRNC) .GT. 0) THEN
            CALL PUSH(HIGH, LOW, B, JOB, ENTRNC, BASS, LB, 902, STACK)
            HIGH = PEAKL(LB)
            LOW = ENTRNC
            JOB = -1
            B = LB
            GOTO 10
  902    PATH(PEAKL(LB)) = PEAKR(LB)
            CALL PUSH(HIGH, LOW, B, JOB, ENTRNC, BASS, LB, 777, STACK)
            HIGH= PEAKR(LB)
            LOW = BASS
            JOB = 1
            B = LB
            GOTO 10
         ELSE
            CALL PUSH(HIGH, LOW, B, JOB, ENTRNC, BASS, LB, 904, STACK)
            HIGH = PEAKR(LB)
            LOW = ENTRNC
            JOB = -1
            B = LB
            GOTO 10
  904    PATH(PEAKR(LB)) = PEAKL(LB)
            CALL PUSH(HIGH, LOW, B, JOB, ENTRNC, BASS, LB, 777, STACK)
            HIGH = PEAKL(LB)
            LOW = BASS
            JOB = 1
            B = LB
            GOTO 10
         ENDIF
      ENDIF
      END
C***********************************************************************
      SUBROUTINE ANCEST(V, JOB, U, INDEX, PRED, EDGE, MARK,NINDEX,NGHBR)
C
C     SEARCHES PREDECESSOR LIST OF V
C         JOB = 1:  CHECK FOR UNUSED EDGES
C         JOB = 2:  CHECK FOR UNVISITED EDGES
C
C         U .EQ. 0:  NO SUITABLE EDGE WAS FOUND
C         U .NE. 0:  U-V IS A SUITABLE EDGE
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
C
      INTEGER V, JOB, U, INDEX, PRED(2,*), EDGE(*), NINDEX(*), NGHBR(*)
      CHARACTER*1 MARK(*)
C
      INTEGER W, CODE, K
C-----------------------------------------------------------------------
      U = 0
  201 IF ((INDEX .NE. 0) .AND. (U .EQ. 0)) THEN
         W = PRED(2, INDEX)
         INDEX = PRED(1, INDEX)
         IF (MARK(W) .NE. 'E') THEN
            CALL STATUS(W, V, EDGE, CODE, 'R', NINDEX, NGHBR)
            IF (JOB .EQ. 1) THEN
               IF (MOD(CODE, 2) .EQ. 0) U = W
            ELSE
               IF (CODE .LT. 2) U = W
            ENDIF
         ENDIF
         GOTO 201
      ENDIF
      RETURN
      END
C***********************************************************************
      SUBROUTINE STATUS(U, V, EDGE, CODE, JOB, NINDEX, NGHBR)
C
C     JOB .EQ. 'W' (WRITE):, ADD CODE TO STATUS(U,V)
C     JOB .EQ. 'R' (READ) :  SETS CODE =  STATUS(U,V)
C     STATUS(U,V) IS SYMMETRIC SO UPPER TRIANGLE IS STORED IN EDGE
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
C
      INTEGER U, V, EDGE(*), CODE, NINDEX(*), NGHBR(*)
      CHARACTER JOB
C
      INTEGER I, J, K, INDEX
C-----------------------------------------------------------------------
      IF (U.LT.V) THEN
          I = U
          J = V
      ELSE
          I = V
          J = U
      ENDIF
      INDEX = 0
      DO 10 K=NINDEX(I), NINDEX(I+1)-1
         IF (NGHBR(K) .EQ. J) INDEX = K
   10 CONTINUE
      IF (INDEX .EQ. 0) THEN
         PRINT *, 'STATUS:  CANNOT FIND EDGE ', I, J
         STOP
      ENDIF
      IF (JOB .EQ. 'W') THEN
         EDGE(INDEX) = EDGE(INDEX) + CODE
      ELSE
         CODE = EDGE(INDEX)
      ENDIF
      RETURN
      END
C***********************************************************************
      SUBROUTINE ADDBRG(U, V, BR, BRIDGE, BINDEX, BFREE)
C
C     ADDS EDGE (U,V) TO BRIDGE(BR)
C
C     U, V   -  INTEGER VERTICIES
C     BR     -  INTEGER BRIDGE LEVEL NUMBER
C     BRIDGE -  ARRAY OF SIZE 3 x M  HOLDING ALL BRIDGES
C     BINDEX -  ARRAY OF SIZE N/2 HOLDING POINTERS TO EACH LEVEL
C     BFREE  -  INTEGER POINTING TO FIRST FREE LOCATION IN BRIDGE
C     NEXT   -  INTEGER POINTER
C
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
C
      INTEGER U, V, BR, BRIDGE(3,*), BINDEX(*), BFREE
      INTEGER NEXT
C-----------------------------------------------------------------------
      IF (BFREE .EQ. 0) THEN
         WRITE(6,20) BR, U, V
   20    FORMAT(1X, 'ADDBRG:  STACK OVERFLOW ERROR',
     +          5X, 'BR, U, V:',3I10)
         STOP
      ELSE
         NEXT = BFREE
         BFREE = BRIDGE(1, NEXT)
         BRIDGE(2, NEXT) = U
         BRIDGE(3, NEXT) = V
         BRIDGE(1, NEXT) = BINDEX(BR)
         BINDEX(BR)       = NEXT
      ENDIF
      RETURN
      END
C***********************************************************************
      SUBROUTINE ADDSTK(STACK, INDEX, FREE, U, V)
C
C     ADDS ELEMENT V TO SUBSTACK U
C
C     STACK  -  ARRAY OF SIZE 2 x M  HOLDING ALL SUBSTACKS
C     INDEX  -  ARRAY OF SIZE N HOLDING POINTERS TO EACH SUBSTACK
C     FREE   -  INTEGER POINTING TO FIRST FREE LOCATION IN STACK
C     U      -  INTEGER VERTEX
C     V      -  INTEGER VERTEX
C     NEXT   -  INTEGER POINTER
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
C
      INTEGER STACK(2,*), INDEX(*), FREE, U, V
      INTEGER NEXT
C-----------------------------------------------------------------------
      IF (FREE .EQ. 0) THEN
         WRITE(6,20) U, V
   20    FORMAT(1X, 'ADDSTK:  STACK OVERFLOW ERROR',
     +          5X, 'U, V:',2I10)
         STOP
      ELSE
         NEXT = FREE
         FREE = STACK(1, NEXT)
         STACK(2, NEXT) = V
         STACK(1, NEXT) = INDEX(U)
         INDEX(U)       = NEXT
      ENDIF
      RETURN
      END
C***********************************************************************
      SUBROUTINE PUSH(HI, LO, B, JOB, ENT, BAS, LB, RA, STACK)
C
C     ADDS ELEMENTS TO STACK USED TO SIMULATE RECURSIVE CALLS
C     BETWEEN FNDPTH AND OPEN
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
C
      INTEGER HI, LO, B, JOB, ENT, BAS, LB, RA, STACK(8,*)
C
      INTEGER STKLIM, STKTOP
      COMMON /BLK8/ STKLIM, STKTOP
C-----------------------------------------------------------------------
      IF (STKTOP .LT. STKLIM) THEN
          STKTOP = STKTOP + 1
          STACK(1, STKTOP) = HI
          STACK(2, STKTOP) = LO
          STACK(3, STKTOP) = B
          STACK(4, STKTOP) = JOB
          STACK(5, STKTOP) = ENT
          STACK(6, STKTOP) = BAS
          STACK(7, STKTOP) = LB
          STACK(8, STKTOP) = RA
      ELSE
         WRITE(6, 9) HI, LO, B, JOB, RA
    9    FORMAT(1X, 'PUSH:  STACK OVERFLOW ERROR',
     +          5X, 'HI, LO, B, JOB, RA =', 5I10)
         STOP
      ENDIF
      RETURN
      END
C***********************************************************************
      SUBROUTINE BASTAR(V, U, BSTAR, F, BLOSS)
C
C     SETS U = BASE*(U) AND PRESERVES PATH BACK TO OLDV
C-----------------------------------------------------------------------
      IMPLICIT CHARACTER (A-Z)
      INTEGER V, U, BSTAR(*), F(*), BLOSS(*)
      INTEGER OLDV, W
C-----------------------------------------------------------------------
      OLDV = V
   10 F(U) = V
      V = U
      U = BSTAR(BLOSS(U))
      IF (BLOSS(U) .NE. 0) GOTO 10
C
      W = F(V)
      IF (OLDV .EQ. 0) THEN
         F(U) = V
         V = 0
      ENDIF
C
C     PATH COMPRESSION
C
   20 IF (W .NE. OLDV) THEN
         BSTAR(BLOSS(W)) = U
         W = F(W)
         GOTO 20
      ENDIF
      RETURN
      END
C***********************************************************************
      SUBROUTINE SSORT(A,B,L)
C
C     *      SORTING OF THE VECTOR A(I) IN INCREASING ORDER BY THE     *
C     *      SHELL-ALGORITHM.                                          *
C     *                                                                *
C     *      PARAMETERS:                                               *
C     *      INPUT:                                                    *
C     *         L        DIMENSION OF THE VECTOR                       *
C     *         A(I)     VECTOR TO SORT (INTEGER)                      *
C     *         B(I)     = I    (INTEGER)  I=1,...,N                   *
C     *      OUTPUT:                                                   *
C     *         A(I)     THE SORTED VECTOR                             *
C     *         B(I)     PERMUTATION VECTOR OF THE SORTED VECTOR       *
C     *                                                                *
C *** ******************************************************************
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      IMPLICIT INTEGER (A-Z)
      DIMENSION A(1), B(1)
C - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      F = 1
      IF (L.LE.F) RETURN
      N2 = (L - F+1)/2
      S = 1023
      DO 100 T = 1, 10
      IF (S.GT.N2) GOTO 90
      LS = L - S
      DO 20 I = F, LS
      IS = I + S
      AH = A(IS)
      BH = B(IS)
      J = I
      JS = IS
    5 IF (AH.GE.A(J)) GOTO 10
      A(JS) = A(J)
      B(JS) = B(J)
      JS = J
      J = J - S
      IF (J.GE.F) GOTO 5
   10 A(JS) = AH
      B(JS) = BH
   20 CONTINUE
   90 S = S/2
  100 CONTINUE
      RETURN
      END

C  THIS VERSION OF NETFLO WAS MODIFIED FOR COMPATIBILITY WITH SUN UNIX. 
C  THE ONLY CHANGE WAS TO REPLACE FUNCTION CALLS TO  IEOR  WITH CALLS TO 
C   XOR  .  BOTH ARE BITWISE EXCLUSIVE OR FUNCTIONS.  C. MCGEOCH 1/91
C
C  THIS VERSION OF NETFLO WAS PREPARED FOR THE IBM 3081 D.              JOY00010
C                                                                       JOY00030
C  SEE PAGES 244-256  IN ALGORITHMS FOR NETWORK PROGRAMMING, BY
C  KENNINGTON AND HELGASON, JOHN WILEY, 1980 FOR ADDITIONAL INFORMATION
C
C  NOTE:  FOR THIS VERSION IF INPUT HAS UPPER BOUND = 0 OR BLANK, THEN
C         NETFLO INTERPRETS THIS AS AN UNBOUNDED ARC.
C                          IF INPUT HAS UPPER BOUND = -1, THEN
C         NETFLO INTERPRETS THIS AS AN ARC WITH UPPER BOUND = 0.
C                                                                       JOY00050
C         IF THE DATA IN CARD SET 3 PAGE 252 IS INCORRECT, THEN
C         NETFLO WILL DISCOVER THE ERROR AND MAKE THE NECESSARY
C         CHANGES.  IT WILL PRODUCE THE CORRECT ANSWER EVEN IF THIS
C         FILE IS WRONG.  THIS INFORMATION IS SIMPLY USED TO REORDER
C         THE ARCS IN BACKWARD STAR FORMAT.  IT THE DATA IS INCORRECT
C         THE REORDERING PROCESS WILL TAKE LONGER.
C                                                                       JOY00050
C         NETFLO USES THE BIG-M METHOD WHICH CAN CAUSE DIFFICULTIES     JOY00050
C         ON SOME MACHINES.  OUR APPROXIMATION FOR INFINITY IS 10000000.JOY00050
C         IF THE ARC COSTS ARE TOO LARGE, THEN THIS VALUE CAN BE TOO    JOY00050
C         SMALL.  IF YOU INCREASE THIS VALUE, THEN YOU MAY EXCEED THE   JOY00050
C         INTEGER PRECISION OF YOUR HARDWARE.                           JOY00050
C         USE CAUTION AND HAVE FUN!                                     JOY00050
C                                                                       JOY00050
C----------------------------------------------------------             JOY00040
C                                                                       JOY00050
C     NETFLO WAS WRITTEN BY R. V. HELGASON AND J. L. KENNINGTON         JOY00060
C                           OPERATIONS RESEARCH DEPT.                   JOY00070
C                           SOUTHERN METHODIST UNIVERSITY               JOY00080
C                           DALLAS, TEXAS 75275                         JOY00090
C                           (214)-692-3072                              JOY00100
C-----------------------------------------------------------            JOY00110
C                                                                       JOY00120
C     LAST REVISED -- FEB 1988                                          JOY00130
C                                                                       JOY00140
C-----------------------------------------------------------            JOY00150
C                                                                       JOY00160
      INTEGER AAAA,NNNN                                                 JOY00170
      PARAMETER (AAAA=12400,NNNN=1230)                                  JOY00180
C                                                                       JOY00190
      INTEGER   LNODE,MNODE
      INTEGER   DOWN(NNNN),NEXT(NNNN),LEVEL(NNNN)
      INTEGER   ARCID(NNNN),FLOW(NNNN),DUAL(NNNN),CAT(NNNN)
      EQUIVALENCE (DUAL(1),CAT(1))                                      JOY00300
C                                                                       JOY00310
C                                                                       JOY00320
C     NODE FORMAT                                                       JOY00330
C                                                                       JOY00340
C                                                                       JOY00350
C     1 - PREDECESSOR OR DOWN POINTER                                   JOY00360
C     2 - THREAD OR NEXT POINTER                                        JOY00370
C     3 - LEVEL NUMBER                                                  JOY00380
C     4 - ASSOCIATED ARC IDENTIFIER                                     JOY00390
C     (+=ORIENTATION OPPOSITE TO DOWN POINTER)                          JOY00400
C     (-=ORIENTATION SAME AS DOWN POINTER)                              JOY00410
C     5 - FLOW ON ARC                                                   JOY00420
C     6 - DUAL VARIABLE VALUE                                           JOY00430
C                                                                       JOY00440
      INTEGER   LARC,MARC                                               JOY00460
      INTEGER   FROM(AAAA),COST(AAAA),CAPAC(AAAA)
      INTEGER   FLOOR(AAAA),NAME(AAAA)
      INTEGER   ARCNAM
C                                                                       JOY00530
C     ARC FORMAT                                                        JOY00540
C                                                                       JOY00550
C     1 - FROM NODE                                                     JOY00560
C     2 - COST                                                          JOY00570
C     3 - CAPACITY(-,IF AT UB)                                          JOY00580
C     4 - LOWER BOUND                                                   JOY00590
C     5 - NAME                                                          JOY00600
C                                                                       JOY00610
C     ARC(ARTY) IS GENERAL REFERENCE FOR ARTIFICIAL ARCS                JOY00620
C                                                                       JOY00630
      INTEGER   TO                                                      JOY00640
      INTEGER   SLACK,ARTIF,DUMMY,XCESS
      INTEGER   PRICE0,TOO                                              JOY00660
      INTEGER   TRY,PRICE                                               JOY00670
      INTEGER   NEWARC,NEWPR                                            JOY00680
      INTEGER   NEWFRM,NEWTO                                            JOY00690
      INTEGER   ARTY,BIG,ARTYP1                                         JOY00700
      INTEGER   THD                                                     JOY00710
      INTEGER   DW(2),CH(2),DWN,CHG                                     JOY00720
      INTEGER   THETA,JTHETA,KTHETA,POSS,JPOSS                          JOY00730
      INTEGER   FRM,LVJ                                                 JOY00740
      INTEGER   FM,LST                                                  JOY00750
      INTEGER   DWE                                                     JOY00760
      INTEGER   FLW,AID                                                 JOY00770
      INTEGER   Q1,Q2                                                   JOY00780
      INTEGER   DIR,REF                                                 JOY00790
      INTEGER   U1,U2,U3,U4                                             JOY00800
      LOGICAL   INFEAS                                                  JOY00850
      LOGICAL   OPTIM                                                   JOY00860
      LOGICAL   DMP                                                     JOY00870
      LOGICAL   PPR                                                     JOY00880
      LOGICAL   PRES                                                    JOY00890
C                                                                       JOY00900
      DATA ITDOPT/ 1 /                                                  JOY00910
      DATA ARTY/ 1 /                                                    JOY00940
      DATA BIG/  10000000 /                                             JOY00950
      DATA U1,U2,U3,U4/5,5,5,5/                                         JOY00980
C                                                                       JOY00990
      DATA SLACK/  66666/                                               JOY01000
      DATA ARTIF/  99999/                                               JOY01010
      DATA DUMMY/  77777/                                               JOY01020
      DATA XCESS/  88888/                                               JOY01030
C                                                                       JOY01040
 1000 FORMAT(8I10)                                                      JOY01050
 1001 FORMAT(1X,8I10)                                                   JOY01060
 1002 FORMAT(2X,I8,5I10)                                                JOY01070
 1003 FORMAT(1X,I10,5I10)                                               JOY01080
 1004 FORMAT(F10.0)                                                     JOY01090
 1005 FORMAT(1X,F10.5)                                                  JOY01100
 2001 FORMAT(1X,I5,1H,,4I15,1X,A10)                                     JOY01110
 2002 FORMAT(1X,I5,1H,,6I15)                                            JOY01120
 8910 FORMAT(8H0PROBLEM,I5)                                             JOY01230
C                                                                       JOY01250
C     NSTOP - EXIT CONDITION                                            JOY01260
C     MNODE - NUMBER OF NODES                                           JOY01270
C     NET -TOTAL BALANCE IN NETWORK                                     JOY01280
C     MSORC - NUMBER OF SOURCES                                         JOY01290
C     MSINK - NUMBER OF SINKS                                           JOY01300
C     MARC - NUMBER OF ARCS                                             JOY01310
C     MTREE - NUMBER OF BRANCHES ON TREE(EXCLUDING ROOT)                JOY01320
C     THD - POINTER MOVING ALONG THREAD                                 JOY01330
C     TRY - VARIABLE ENCOUNTERED DURING SETUP OR PRICING                JOY01340
C     PRICE - REDUCED  COST FOR TRY                                     JOY01350
C     NEWARC  - BEST VARIABLE TO ENTER                                  JOY01360
C     NEWPR - PRICE FOR NEWARC                                          JOY01370
C     DW - DOWN PTRS FOR RATIO TEST(FROM STEM,TO STEM)                  JOY01380
C     CH - PATH CONDITIONS FOR RATIO TEST (FROM STEM,TO STEM)           JOY01390
C     DWN - POINTER MOVING ALONG DOWN PATH                              JOY01400
C     CHG - PATH CONDITION                                              JOY01410
C     THETA - MINIMUM RATIO IN RATIO TEST                               JOY01420
C     JTHETA - UB (-) OR LB(+1) CONDITION FOR MIN THETA                 JOY01430
C     KTHETA - MIN THETA OCCURS ON FROM STEM(1) OR TO STEM (2)          JOY01440
C     POSS - CANDIDATE FOR MIN THETA                                    JOY01450
C     JPOSS - UB (-1) OR LB(+1) CONDITION FOR CANDIDATE FOR MIN THETA   JOY01460
C     DWE - ROOT OF CYCLE                                               JOY01470
C                                                                       JOY01480
      OPEN(5,FILE='NETFLO.INP')
      OPEN(6,FILE='NETFLO.OUT')
      ARTYP1 = ARTY+1
      LNODE = NNNN-2
      LARC =  AAAA-2
      LARCP1 = LARC+1                                                   JOY01740
C     UNUSED NODE NUMBER                                                JOY01750
      LNODP1 = LNODE+1                                                  JOY01760
      NPROB = 0                                                         JOY01800
      KARD = 0                                                          JOY01810
    5 CONTINUE                                                          JOY01830
      PPR = .TRUE.                                                      JOY01840
      PRES = .FALSE.                                                    JOY01850
      NPROB = NPROB+1                                                   JOY01860
C     INPUT NUMBER OF REGULAR NODES                                     JOY02060
      NSTOP = 2                                                         JOY02100
      READ(U1,1000,END=999) I                                           JOY02110
C                                                                       JOY02120
C     NUMBER OF NODES(I10)                                              JOY02130
C                                                                       JOY02140
      KARD = KARD+1                                                     JOY02150
      IF(PPR) WRITE(6,8910) NPROB                                       JOY02160
      WRITE(6,1001) I                                                   JOY02170
      NSTOP = 3                                                         JOY02190
      IF(I.LE.0) GO TO 999                                              JOY02200
      MNODE = I                                                         JOY02210
      MNODP1 = MNODE+1                                                  JOY02220
      MNODP2 = MNODE+2                                                  JOY02230
      NSTOP = 4                                                         JOY02240
      IF(MNODP1.GT.LNODE) GO TO 999                                     JOY02250
      DUAL(MNODP1) = 0                                                  JOY02260
C     INITIALIZE NODE ARRAY                                             JOY02270
      DO 10 J10=1,MNODP1                                                JOY02280
      DOWN(J10) = 0
      NEXT(J10) = 0
      LEVEL(J10) = 0
      ARCID(J10) = 0
      FLOW(J10) = 0
   10 CONTINUE
C     INITIALIZE ARTIFICIAL                                             JOY02310
      FROM(ARTY) = MNODP1                                               JOY02320
      COST(ARTY) = BIG                                                  JOY02330
      CAPAC(ARTY) = 0                                                   JOY02340
      FLOOR(ARTY) = 0                                                   JOY02350
      NAME(ARTY) = ARTIF                                                JOY02360
C                                                                       JOY02370
C     DURING SETUP WE USE THE ABSENCE OF THE UPPER BOUND FLAG           JOY02380
C     ON AN ARC TO INDICATE THAT THE ARC IS ELIGIBLE TO BECOME          JOY02390
C     PART OF THE STARTING BASIS, OTHERWISE IT IS NOT.                  JOY02400
C                                                                       JOY02410
      NET = 0                                                           JOY02420
      MSORC = 0                                                         JOY02430
      MARC = 0                                                          JOY02440
C     INITIALIZE SUPPLY AND DEMAND LISTS WITH SELF-POINTER              JOY02450
      NEXT(MNODP1) = MNODP1                                             JOY02460
      DOWN(MNODP1) = MNODP1                                             JOY02470
C     INPUT NON-ZERO NODAL BALANCES                                     JOY02480
   15 CONTINUE                                                          JOY02490
      NSTOP = 5                                                         JOY02510
      READ(U2,1000,END=999) I,J                                         JOY02520
C                                                                       JOY02530
C     NODE NUMBER(I10),BALANCE(I10)/BLANK= ESCAPE                       JOY02540
C                                                                       JOY02550
      KARD = KARD+1                                                     JOY02560
      WRITE(6,1001) I,J                                                 JOY02570
      NSTOP = 6                                                         JOY02590
      IF(I) 999,60,20                                                   JOY02600
   20 CONTINUE                                                          JOY02610
      IF(I.GT.MNODE) GO TO 999                                          JOY02620
      NSTOP = 7                                                         JOY02630
      IF(FLOW(I).NE.0) GO TO 999                                        JOY02640
      FLOW(I) = J                                                       JOY02650
      NET = NET+J                                                       JOY02660
      IF(J.LE.0) GO TO 15                                               JOY02670
      MSORC = MSORC+1                                                   JOY02680
C     SAVE ORIGINAL SUPPLY IN LEVEL                                     JOY02690
      LEVEL(I) = J                                                      JOY02700
      NEXT(I) = NEXT(MNODP1)                                            JOY02710
      NEXT(MNODP1) = I                                                  JOY02720
      GO TO 15                                                          JOY02730
   60 CONTINUE                                                          JOY02740
C     TEST FOR FEASIBILITY                                              JOY02750
      NSTOP = 8                                                         JOY02760
      IF(NET.LT.0) GO TO 999                                            JOY02770
C     INPUT NUMBER OF ARCS TO EACH NODE(IN NUMERIC ORDER)               JOY02780
      NSTOP = 9                                                         JOY02800
      READ(U3,1000,END=999) (CAT(I),I=1,MNODE)                          JOY02810
C                                                                       JOY02820
C     NUMBER OF ARCS TO EACH NODE (8I10)                                JOY02830
C                                                                       JOY02840
      KARD = KARD+1                                                     JOY02850
      WRITE(6,1001) (CAT(I),I=1,MNODE)                                  JOY02860
C                                                                       JOY02880
C     RESERVE LOCATIONS FOR INPUT ARCS BY FILLING WITH DUMMIES          JOY02890
C      CAT(N) WILL POINT TO THE NEXT OPEN LOCATION FOR STORING          JOY02900
C      ARCS WHOSE TERMINAL NODE IS N.                                   JOY02910
C                                                                       JOY02920
      NSTOP = 10                                                        JOY02930
      I = 1                                                             JOY02940
      J = ARTY                                                          JOY02950
      DO 80 J80 = 1,MNODE                                               JOY02960
      I = -I                                                            JOY02970
      K70 = MAX0(1,CAT(J80))
      IF(J+K70.GT.LARC) GO TO 999                                       JOY02990
      CAT(J80) = ISIGN(J+1,I)                                           JOY03000
      DO 70 I70=1,K70                                                   JOY03010
      J = J+1                                                           JOY03020
C     NOTE THAT DUMMY ARCS HAVE SAME INITIAL AND TERMINAL NODE          JOY03030
      FROM(J) = ISIGN(J80,I)                                            JOY03040
      COST(J) = 0                                                       JOY03050
      CAPAC(J) = -BIG                                                   JOY03060
      FLOOR(J) = 0
      NAME(J) = DUMMY
   70 CONTINUE                                                          JOY03090
   80 CONTINUE                                                          JOY03100
      MARC = J+1                                                        JOY03110
      IF(MARC.GT.LARC) GO TO 999                                        JOY03120
      FROM(MARC) = ISIGN(MNODP1,-I)                                     JOY03130
C     INPUT REGULAR ARCS                                                JOY03140
      KOST0 = 0                                                         JOY03150
   90 CONTINUE                                                          JOY03160
      NSTOP = 11                                                        JOY03180
      READ(U4,1002,END=999)    ARCNAM,I,J,K,L,M                         JOY03190
C                                                                       JOY03200
C     NAME,FROM NODE,TO NODE,COST,CAPACITY,LOWER BOUND                  JOY03210
C      (I10) , (I10) , (I10),(I10), (I10) ,    (I10)                    JOY03220
C     /BLANK = ESCAPE                                                   JOY03230
C                                                                       JOY03240
      KARD = KARD+1                                                     JOY03250
      WRITE(6,1003)    ARCNAM,I,J,K,L,M                                 JOY03260
      NSTOP = 12                                                        JOY03280
      IF(I) 999,150,100                                                 JOY03290
  100 CONTINUE                                                          JOY03300
      IF(I.GT.MNODE) GO TO 999                                          JOY03310
      IF(J.GT.MNODE) GO TO 999                                          JOY03320
      IF(J.LE.0) GO TO 999                                              JOY03330
      NSTOP = 13                                                        JOY03340
      IF(L.GE.BIG) GO TO 999                                            JOY03350
      IF(L.EQ.0) L = BIG                                                JOY03360
      IF(L.LT.0) L = 0                                                  JOY03370
      IF(M.GE.BIG) GO TO 999                                            JOY03380
      IF(M.LT.0) GO TO 999                                              JOY03390
      IF(M.GT.L) GO TO 999                                              JOY03400
      II = CAT(J)                                                       JOY03410
      JJ = IABS(II)                                                     JOY03420
C     TEST TO SEE IF CATEGORY IS FULL                                   JOY03430
      KK = ISIGN(LNODP1,II)                                             JOY03440
      IF( XOR(KK,FROM(JJ)).GT.0) GO TO 140                              JOY03450
C     MOVE REST OF ARCS DOWN TO ACCOMODATE                              JOY03460
      NSTOP = 14                                                        JOY03470
      IF(MARC.EQ.LARC) GO TO 999                                        JOY03480
      MARC = MARC+1                                                     JOY03490
      K120 = MARC-JJ                                                    JOY03500
      M120 = MARC                                                       JOY03510
      DO 120 J120=1,K120                                                JOY03520
      L120 = M120-1                                                     JOY03530
      FROM(M120)  = FROM(L120)
      COST(M120)  = COST(L120)
      CAPAC(M120) = CAPAC(L120)
      FLOOR(M120) = FLOOR(L120)
      NAME(M120)  = NAME(L120)
      M120 = L120                                                       JOY03570
  120 CONTINUE                                                          JOY03580
      DO 130 J130=J,MNODE                                               JOY03590
  130 CAT(J130) = CAT(J130)+ISIGN(1,CAT(J130))                          JOY03600
C     INSERT NEW ARC                                                    JOY03610
  140 CONTINUE                                                          JOY03620
      FROM(JJ) = ISIGN(I,II)                                            JOY03630
      COST(JJ) = K                                                      JOY03640
      KOST0 = KOST0+K*M                                                 JOY03650
      CAPAC(JJ) = L-M                                                   JOY03660
      FLOOR(JJ) = M                                                     JOY03670
      FLOW(I) = FLOW(I)-M                                               JOY03680
      FLOW(J) = FLOW(J)+M                                               JOY03690
      NAME(JJ) = ARCNAM                                                 JOY03700
      CAT(J) = ISIGN(JJ+1,II)                                           JOY03710
C     MARK FROM NODE WITH ARC RUNNING FROM IT FLAG                      JOY03720
      ARCID(I) = -1                                                     JOY03730
      GO TO 90                                                          JOY03740
  150 CONTINUE                                                          JOY03750
C                                                                       JOY03760
C     ELIMINATE NON-ESSENTIAL DUMMY ARCS                                JOY03770
C     CAT(N) WILL POINT TO LOCATION OF FIRST ARC TERMINAL AT NODE N     JOY03780
C                                                                       JOY03790
      I = LNODP1                                                        JOY03800
      K = ARTY                                                          JOY03810
      L = 0                                                             JOY03820
      MARC = MARC-1                                                     JOY03830
      DO 190 J190=ARTYP1,MARC                                           JOY03840
      J = FROM(J190)                                                    JOY03850
      IF( XOR(I,J).GT.0) GO TO 160                                      JOY03860
      I = -I                                                            JOY03870
      L = L+1                                                           JOY03880
      CAT(L) = K+1                                                      JOY03890
      GO TO 170                                                         JOY03900
  160 IF(IABS(J).EQ.L) GO TO 190                                        JOY03910
  170 K = K+1                                                           JOY03920
      IF(K.EQ.J190) GO TO 190                                           JOY03930
      FROM(K)  = FROM(J190)
      COST(K)  = COST(J190)
      CAPAC(K) = CAPAC(J190)
      FLOOR(K) = FLOOR(J190)
      NAME(K)  = NAME(J190)
  190 CONTINUE                                                          JOY03970
      MARC = K                                                          JOY03980
      MREG = K                                                          JOY03990
      NSTOP = 15                                                        JOY04000
      IF(MARC+MAX0(1,MSORC)+1.GT.LARC) GO TO 999                        JOY04010
C                                                                       JOY04020
C     ADD REGULAR SLACKS                                                JOY04030
C                                                                       JOY04040
      I = -FROM(MARC)                                                   JOY04050
      THD = NEXT(MNODP1)                                                JOY04060
      NEXT(MNODP1) = MNODP1                                             JOY04070
      IF(THD.NE.MNODP1) GO TO 192                                       JOY04080
C     NO REGULAR SLACKS, ADD DUMMY                                      JOY04090
      MARC = MARC+1                                                     JOY04100
      FROM(MARC) = ISIGN(MNODP1,I)                                      JOY04110
      COST(MARC) = 0                                                    JOY04120
      CAPAC(MARC) = -BIG                                                JOY04130
      FLOOR(MARC) = 0                                                   JOY04140
      NAME(MARC) = DUMMY                                                JOY04150
      GO TO 194                                                         JOY04160
C     FOLLOW LIST                                                       JOY04170
  192 CONTINUE                                                          JOY04180
      MARC = MARC+1                                                     JOY04190
      NAME(MARC) = SLACK                                                JOY04200
      FROM(MARC) = ISIGN(THD,I)                                         JOY04210
      COST(MARC) = 0                                                    JOY04220
      CAPAC(MARC) = LEVEL(THD)                                          JOY04230
      LEVEL(THD) = 0                                                    JOY04240
      FLOOR(MARC) = 0                                                   JOY04250
      NXT = NEXT(THD)                                                   JOY04260
      NEXT(THD) = 0                                                     JOY04270
      THD = NXT                                                         JOY04280
      IF(THD.NE.MNODP1) GO TO 192                                       JOY04290
  194 CONTINUE                                                          JOY04300
      MSLK = MARC                                                       JOY04310
C     ADD EXCESS ARC AT END OF REGULAR SLACKS                           JOY04320
      MARC = MARC+1                                                     JOY04330
      FROM(MARC) = ISIGN(MNODP2,-I)                                     JOY04340
      COST(MARC) = BIG                                                  JOY04350
      CAPAC(MARC) = 0                                                   JOY04360
      FLOOR(MARC) = 0                                                   JOY04370
      NAME(MARC) = XCESS                                                JOY04380
C                                                                       JOY04390
C     LOCATE SOURCES AND SINKS FOR PROBLEM                              JOY04400
C     ADJUSTED FOR LOWER BOUNDS                                         JOY04410
C                                                                       JOY04420
      NET = 0                                                           JOY04430
      MTREE = 0                                                         JOY04440
      THD = MNODP1                                                      JOY04450
      DO 200 I200 = 1,MNODE                                             JOY04460
      J = FLOW(I200)                                                    JOY04470
      NET = NET+J                                                       JOY04480
      IF(J) 30,200,50                                                   JOY04490
C     SINK                                                              JOY04500
   30 CONTINUE                                                          JOY04510
      FLOW(I200) = -J                                                   JOY04520
C     LINK DEMANDS IN DECREASING SIZE ORDER                             JOY04530
      DWN = MNODP1                                                      JOY04540
   35 CONTINUE                                                          JOY04550
      NXT = DOWN(DWN)                                                   JOY04560
      IF(FLOW(NXT)+J.LE.0) GO TO 40                                     JOY04570
      DWN = NXT                                                         JOY04580
      GO TO 35                                                          JOY04590
   40 CONTINUE                                                          JOY04600
      DOWN(DWN) = I200                                                  JOY04610
      DOWN(I200) = NXT                                                  JOY04620
      LEVEL(I200) = -1                                                  JOY04630
      GO TO 200                                                         JOY04640
C     SOURCE                                                            JOY04650
   50 CONTINUE                                                          JOY04660
      MTREE = MTREE+1                                                   JOY04670
      ARCID(I200) = -MARC                                               JOY04680
      FLOW(I200) = J                                                    JOY04690
      NEXT(THD) = I200                                                  JOY04700
      DOWN(I200) = MNODP1                                               JOY04710
      NEXT(I200) = MNODP1                                               JOY04720
      LEVEL(I200) = 1                                                   JOY04730
      DUAL(I200) = BIG                                                  JOY04740
      THD = I200                                                        JOY04750
  200 CONTINUE                                                          JOY04760
C     CHECK FOR FEASIBILITY                                             JOY04770
      NSTOP = 16                                                        JOY04780
      IF(NET.LT.0) GO TO 999                                            JOY04790
 2331 FORMAT(1X,I5,1H,,4I5,1X,A6)                                       JOY04800
 2332 FORMAT(1X,I5,1H,,5I8,I15)                                         JOY04810
 8339 FORMAT(10H ITERATION,I10)                                         JOY04820
 8704 FORMAT(   '**** DUMP ENABLED AT',I7)                              JOY04830
C                                                                       JOY04840
C     ADVANCED START                                                    JOY04850
C                                                                       JOY04860
C     SELECT HIGHEST RANK DEMAND ON LIST                                JOY04900
 1010 CONTINUE                                                          JOY04910
      TO = DOWN(MNODP1)                                                 JOY04920
C     IS LIST EXHAUSTED                                                 JOY04930
      IF(TO.EQ.MNODP1) GO TO 210                                        JOY04940
 1020 CONTINUE                                                          JOY04950
C     SET TO LINK TO ARTIFICIAL                                         JOY04960
      NEWARC = ARTY                                                     JOY04970
      NEWPR = BIG                                                       JOY04980
C     ANY DEMAND LEFT                                                   JOY04990
      IF(FLOW(TO).EQ.0) GO TO 1110                                      JOY05000
C                                                                       JOY05010
C     LOOK FOR SOURCES FIRST                                            JOY05020
C                                                                       JOY05030
      TRY = CAT(TO)                                                     JOY05040
      FRM = FROM(TRY)                                                   JOY05050
      LST = ISIGN(LNODP1,FRM)                                           JOY05060
 1030 CONTINUE                                                          JOY05070
C     IS IT UNAVAILABLE                                                 JOY05080
      IF(CAPAC(TRY).LE.0) GO TO 1050                                    JOY05090
      FM = IABS(FRM)                                                    JOY05100
C     IS IT FROM A NON-SOURCE                                           JOY05110
      IF(LEVEL(FM).NE.1) GO TO 1050                                     JOY05120
      IF(ARCID(FM).EQ.ARTY) GO TO 1050                                  JOY05130
      PRICE = COST(TRY)                                                 JOY05140
C     IS COST WORSE                                                     JOY05150
      IF(PRICE.GE.NEWPR) GO TO 1050                                     JOY05160
C     DOES CAPACITY EXCEED DEMAND                                       JOY05170
      IF(CAPAC(TRY).GT.FLOW(TO)) GO TO 1040                             JOY05180
C     IS THERE NOT ENOUGH SUPPLY FOR CAPACITY                           JOY05190
      IF(FLOW(FM).LT.CAPAC(TRY)) GO TO 1050                             JOY05200
      NEWARC = -TRY                                                     JOY05210
      NEWPR = PRICE                                                     JOY05220
      IF(NEWPR.EQ.0) GO TO 1055                                         JOY05230
      GO TO 1050                                                        JOY05240
 1040 CONTINUE                                                          JOY05250
C     IS THERE NOT ENOUGH SUPPLY FOR DEMAND                             JOY05260
      IF(FLOW(FM).LT.FLOW(TO)) GO TO 1050                               JOY05270
      NEWARC = TRY                                                      JOY05280
      NEWPR = PRICE                                                     JOY05290
      IF(NEWPR.EQ.0) GO TO 1055                                         JOY05300
 1050 CONTINUE                                                          JOY05310
      TRY = TRY+1                                                       JOY05320
      FRM = FROM(TRY)                                                   JOY05330
      IF( XOR(FRM,LST).GT.0) GO TO 1030                                 JOY05340
      IF(NEWARC.EQ.ARTY) GO TO 1070                                     JOY05350
 1055 CONTINUE                                                          JOY05360
C     ARE WE SENDING DEMAND                                             JOY05370
      IF(NEWARC.GT.0) GO TO 1060                                        JOY05380
C     SEND CAPACITY                                                     JOY05390
      NEWARC = -NEWARC                                                  JOY05400
      FM = IABS(FROM(NEWARC))                                           JOY05410
C     GET CAPACITY                                                      JOY05420
      FLW = CAPAC(NEWARC)                                               JOY05430
C     MARK UNAVAILABLE                                                  JOY05460
      CAPAC(NEWARC) = -FLW                                              JOY05470
C     ADJUST FLOWS                                                      JOY05480
      FLOW(FM) = FLOW(FM)-FLW                                           JOY05490
      FLOW(TO) = FLOW(TO)-FLW                                           JOY05500
      GO TO 1020                                                        JOY05510
C     SEND DEMAND                                                       JOY05520
 1060 CONTINUE                                                          JOY05530
C     MARK UNAVAILABLE                                                  JOY05540
      CAPAC(NEWARC) = -CAPAC(NEWARC)                                    JOY05550
C     ADJUST FLOWS                                                      JOY05560
      FM = IABS(FROM(NEWARC))                                           JOY05570
      FLOW(FM) = FLOW(FM)-FLOW(TO)                                      JOY05580
      K = BIG                                                           JOY05600
      GO TO 1115                                                        JOY05610
C                                                                       JOY05620
C     LOOK FOR TRANSSHIPMENT POINTS                                     JOY05630
C                                                                       JOY05640
 1070 CONTINUE                                                          JOY05650
      TRY = CAT(TO)                                                     JOY05660
      FRM = FROM(TRY)                                                   JOY05670
 1080 CONTINUE                                                          JOY05680
C     IS IT UNAVAILABLE                                                 JOY05690
      IF(CAPAC(TRY).LE.0) GO TO 1090                                    JOY05700
      FM = IABS(FRM)                                                    JOY05710
C     IS IT ALREADY LINKED                                              JOY05720
      IF(LEVEL(FM).NE.0) GO TO 1090                                     JOY05730
      PRICE = COST(TRY)                                                 JOY05740
C     IS COST WORSE                                                     JOY05750
      IF(PRICE.GE.NEWPR) GO TO 1090                                     JOY05760
      NEWARC = TRY                                                      JOY05770
      NEWPR = PRICE                                                     JOY05780
      IF(NEWPR.EQ.0) GO TO 1095                                         JOY05790
 1090 CONTINUE                                                          JOY05800
      TRY = TRY+1                                                       JOY05810
      FRM = FROM(TRY)                                                   JOY05820
      IF( XOR(FRM,LST).GT.0) GO TO 1080                                 JOY05830
      IF(NEWARC.EQ.ARTY) GO TO 1110                                     JOY05840
 1095 CONTINUE                                                          JOY05850
      FM = IABS(FROM(NEWARC))                                           JOY05860
C     DOES CAPACITY EXCEED DEMAND                                       JOY05870
      IF(CAPAC(NEWARC).GT.FLOW(TO)) GO TO 1100                          JOY05880
C     GET CAPACITY                                                      JOY05890
      FLW = CAPAC(NEWARC)                                               JOY05900
C     MARK UNAVAILABLE                                                  JOY05910
      CAPAC(NEWARC) = -FLW                                              JOY05920
C     ADJUST FLOWS                                                      JOY05930
      FLOW(FM) = FLW                                                    JOY05940
      FLOW(TO) = FLOW(TO)-FLW                                           JOY05950
C     LINK IN TO DEMAND LIST                                            JOY05960
      DOWN(FM) = TO                                                     JOY05970
      DOWN(MNODP1) = FM                                                 JOY05980
C     START NEW CHAIN                                                   JOY05990
      LEVEL(FM) = -1                                                    JOY06000
      GO TO 1010                                                        JOY06010
 1100 CONTINUE                                                          JOY06020
C     MARK UNAVAILABLE                                                  JOY06030
      CAPAC(NEWARC) = -CAPAC(NEWARC)                                    JOY06040
C     PASS ALONG FLOW DEMAND                                            JOY06050
      FLOW(FM) = FLOW(TO)                                               JOY06060
C     LINK IN NEW DEMAND NODE                                           JOY06070
      DOWN(FM) = DOWN(TO)                                               JOY06080
      DOWN(TO) = FM                                                     JOY06090
      DOWN(MNODP1) = FM                                                 JOY06100
      NEXT(FM) = TO                                                     JOY06110
      ARCID(TO) = NEWARC                                                JOY06120
      LEVEL(FM) = LEVEL(TO)-1                                           JOY06130
      DUAL(TO) = NEWPR                                                  JOY06140
      MTREE = MTREE+1                                                   JOY06150
      GO TO 1010                                                        JOY06160
C     ADD CHAIN TO TREE                                                 JOY06170
 1110 CONTINUE                                                          JOY06180
      K = 0                                                             JOY06200
 1115 CONTINUE                                                          JOY06210
C     REMOVE FROM DEMAND LIST                                           JOY06230
      DOWN(MNODP1) = DOWN(TO)                                           JOY06240
C     LINK IN AS LEFTMOST BRANCH                                        JOY06250
      FM = IABS(FROM(NEWARC))                                           JOY06260
      ARCID(TO) = NEWARC                                                JOY06270
      DUAL(TO) = NEWPR                                                  JOY06280
      DOWN(TO) = FM                                                     JOY06290
      I = NEXT(FM)                                                      JOY06300
      NEXT(FM) = TO                                                     JOY06310
      J = LEVEL(FM)-LEVEL(TO)+1                                         JOY06320
      THD = FM                                                          JOY06330
 1120 CONTINUE                                                          JOY06340
C     MOVE ALONG CHAIN                                                  JOY06350
      THD = NEXT(THD)                                                   JOY06360
C     ADJUST LEVEL AND DUAL VARIABLES                                   JOY06370
      L = LEVEL(THD)                                                    JOY06380
      LEVEL(THD) = L+J                                                  JOY06390
      K = K-DUAL(THD)                                                   JOY06400
      DUAL(THD) = K                                                     JOY06410
      IF(L.NE.-1) GO TO 1120                                            JOY06420
      NEXT(THD) = I                                                     JOY06430
      MTREE = MTREE+1                                                   JOY06440
      GO TO 1010                                                        JOY06450
  210 CONTINUE                                                          JOY06460
C     SET UP TO EXPAND TREE                                             JOY06540
      TO = 1                                                            JOY06550
      TRY = ARTYP1                                                      JOY06560
      FRM = FROM(TRY)                                                   JOY06570
  220 CONTINUE                                                          JOY06580
C     DO WE NEED TO EXPAND TREE TO REACH ALL NODES                      JOY06590
      IF(MTREE.EQ.MNODE) GO TO 285                                      JOY06600
      TOO = TO                                                          JOY06610
      NEWPR = BIG                                                       JOY06620
C     SEARCH FOR LEAST COST CONNECTABLE ARC IN CURRENT TO-GROUP         JOY06630
  230 CONTINUE                                                          JOY06640
      LVJ = LEVEL(TO)                                                   JOY06650
      LST = ISIGN(LNODP1,FRM)                                           JOY06660
  235 CONTINUE                                                          JOY06670
      IF(CAPAC(TRY).LE.0) GO TO 260                                     JOY06680
      M = COST(TRY)                                                     JOY06690
      IF(NEWPR.LT.M) GO TO 260                                          JOY06700
      FM = IABS(FRM)                                                    JOY06710
      IF(LEVEL(FM).EQ.0) GO TO 240                                      JOY06720
      IF(LVJ.NE.0) GO TO 260                                            JOY06730
C     TO END IS CONNECTABLE                                             JOY06740
      I = FM                                                            JOY06750
      J = TO                                                            JOY06760
      K = M                                                             JOY06770
      L = TRY                                                           JOY06780
      GO TO 250                                                         JOY06790
  240 CONTINUE                                                          JOY06800
      IF(LVJ.EQ.0) GO TO 260                                            JOY06810
C     FROM END IS CONNECTABLE                                           JOY06820
      I = TO                                                            JOY06830
      J = FM                                                            JOY06840
      K = -M                                                            JOY06850
      L = -TRY                                                          JOY06860
  250 CONTINUE                                                          JOY06870
      NEWPR = M                                                         JOY06880
  260 CONTINUE                                                          JOY06890
      TRY = TRY+1                                                       JOY06900
      FRM = FROM(TRY)                                                   JOY06910
C     IS TO-GROUP EXHAUSTED                                             JOY06920
      IF( XOR(FRM,LST).GT.0) GO TO 235                                  JOY06930
C     PREPARE FOR NEXT TO-GROUP                                         JOY06940
      TO = TO+1                                                         JOY06950
      IF(TO.NE.MNODP1) GO TO 270                                        JOY06960
      TO = 1                                                            JOY06970
      TRY = ARTYP1                                                      JOY06980
      FRM = FROM(TRY)                                                   JOY06990
  270 CONTINUE                                                          JOY07000
      IF(NEWPR.NE.BIG) GO TO 280                                        JOY07010
      IF(TO.NE.TOO) GO TO 230                                           JOY07020
C     NOT ALL NODES CONNECTABLE - CHECK FOR ISOLATED POINTS             JOY07030
      DO 275 I275=1,MNODE                                               JOY07040
      IF(LEVEL(I275).NE.0) GO TO 275                                    JOY07050
C     TEST FOR ARCS RUNNING FROM IT                                     JOY07060
      IF(ARCID(I275).EQ.-1) GO TO 274                                   JOY07070
C     CHECK FOR DUMMY - NO ARCS RUNNING TO IT                           JOY07080
      J275 = CAT(I275)                                                  JOY07090
      IF(IABS(FROM(J275)).NE.I275) GO TO 274                            JOY07100
      WRITE(6,8021) I275                                                JOY07110
 8021 FORMAT(6H NODE ,I10,12H IS ISOLATED)                              JOY07120
C     ADD ARTIFICIAL                                                    JOY07130
  274 CONTINUE                                                          JOY07140
      ARCID(I275) = ARTY                                                JOY07150
      FLOW(I275) = 0                                                    JOY07160
      NEXT(I275) = NEXT(MNODP1)                                         JOY07170
      NEXT(MNODP1) = I275                                               JOY07180
      DOWN(I275) = MNODP1                                               JOY07190
      LEVEL(I275) = 1                                                   JOY07200
      DUAL(I275) = -BIG                                                 JOY07210
  275 CONTINUE                                                          JOY07220
      GO TO 285                                                         JOY07230
  280 CONTINUE                                                          JOY07240
      ARCID(J) = L                                                      JOY07250
      DOWN(J) = I                                                       JOY07260
      NEXT(J) = NEXT(I)                                                 JOY07270
      NEXT(I) = J                                                       JOY07280
      LEVEL(J) = LEVEL(I)+1                                             JOY07290
      DUAL(J) = DUAL(I)-K                                               JOY07300
      NEWARC = IABS(L)                                                  JOY07310
      CAPAC(NEWARC) = -CAPAC(NEWARC)                                    JOY07320
      MTREE = MTREE+1                                                   JOY07330
      GO TO 220                                                         JOY07340
  285 CONTINUE                                                          JOY07350
C     CLEAR UPPER BOUND FLAGS ON BASIC ARCS                             JOY07360
      DO 290 I290=1,MNODE                                               JOY07370
      J290 = IABS(ARCID(I290))                                          JOY07380
      CAPAC(J290) = -CAPAC(J290)                                        JOY07390
  290 CONTINUE                                                          JOY07400
C     CLEAR OUT UPPER BOUND FLAGS ON DUMMY ARCS                         JOY07410
      DO 295 I295=1,MARC                                                JOY07420
      IF(CAPAC(I295)+BIG.EQ.0)                                          JOY07430
     *CAPAC(I295) = 0                                                   JOY07440
  295 CONTINUE                                                          JOY07450
C     SET UPPER BOUND FOR ARTIFICIAL AND EXCESS                         JOY07460
      CAPAC(ARTY) = BIG                                                 JOY07470
      CAPAC(MARC) = BIG                                                 JOY07480
C                                                                       JOY07680
C     INITIALIZE PRICING                                                JOY07690
C                                                                       JOY07740
      TO = 1                                                            JOY07750
      TRY = ARTYP1                                                      JOY07760
      FRM = FROM(TRY)                                                   JOY07770
      ITER = 0                                                          JOY07780
      OPTIM = .FALSE.                                                   JOY07790
      DMP = .TRUE.                                                      JOY07800
C                                                                       JOY07840
C     NEW ITERATION                                                     JOY07850
C                                                                       JOY07860
  300 CONTINUE                                                          JOY07880
      ITER = ITER+1                                                     JOY07900
  305 CONTINUE                                                          JOY08140
C                                                                       JOY08150
C     PRICING                                                           JOY08160
C                                                                       JOY08170
C     NOTE THAT WE ARE PRICING OUT BASIC ARCS                           JOY08180
      TOO = TO                                                          JOY08210
      NEWPR = 0                                                         JOY08220
  310 CONTINUE                                                          JOY08230
      PRICE0 = -DUAL(TO)                                                JOY08240
      LST = ISIGN(LNODP1,FRM)                                           JOY08250
  320 CONTINUE                                                          JOY08260
      FM = IABS(FRM)                                                    JOY08270
      PRICE = DUAL(FM)+PRICE0-COST(TRY)                                 JOY08280
      IF(CAPAC(TRY)) 325,330,326                                        JOY08290
  325 CONTINUE                                                          JOY08300
      PRICE = -PRICE                                                    JOY08310
  326 CONTINUE                                                          JOY08320
      IF(PRICE.LE.NEWPR) GO TO 330                                      JOY08330
      NEWARC = TRY                                                      JOY08340
      NEWPR = PRICE                                                     JOY08350
      NEWTO = TO                                                        JOY08360
  330 CONTINUE                                                          JOY08370
      TRY = TRY+1                                                       JOY08380
      FRM = FROM(TRY)                                                   JOY08390
      IF( XOR(FRM,LST).GT.0) GO TO 320                                  JOY08400
      TO = TO+1                                                         JOY08410
      IF(TO.NE.MNODP2) GO TO 350                                        JOY08420
      TO = 1                                                            JOY08430
      TRY = ARTYP1                                                      JOY08440
      FRM = FROM(TRY)                                                   JOY08450
  350 CONTINUE                                                          JOY08460
      IF(NEWPR.NE.0) GO TO 360                                          JOY08470
      IF(TO.NE.TOO) GO TO 310                                           JOY08480
C                                                                       JOY08490
C     OPTIMAL INDICATION                                                JOY08500
C                                                                       JOY08510
      IF(ITDOPT.NE.0) DMP = .TRUE.                                      JOY08570
      OPTIM = .TRUE.                                                    JOY08580
      GO TO 795                                                         JOY08590
  360 CONTINUE                                                          JOY08600
      NEWFRM = IABS(FROM(NEWARC))                                       JOY08610
C                                                                       JOY08620
C     RATIO TEST                                                        JOY08630
C                                                                       JOY08640
      THETA = IABS(CAPAC(NEWARC))                                       JOY08680
      JTHETA = 0                                                        JOY08690
C     SET FOR CYCLE SEARCH                                              JOY08700
      CH(2) = ISIGN(LARCP1,CAPAC(NEWARC))                               JOY08710
      CH(1) = -CH(2)                                                    JOY08720
      DW(1) = NEWFRM                                                    JOY08730
      DW(2) = NEWTO                                                     JOY08740
      LDIFF = LEVEL(NEWFRM)-LEVEL(NEWTO)                                JOY08750
      KTHETA = 1                                                        JOY08760
      IF(LDIFF) 380,450,390                                             JOY08770
  380 KTHETA = 2                                                        JOY08780
  390 CONTINUE                                                          JOY08790
      DWN = DW(KTHETA)                                                  JOY08800
      CHG = CH(KTHETA)                                                  JOY08810
      K440 = IABS(LDIFF)                                                JOY08820
      DO 440 I440=1,K440                                                JOY08830
      IF( XOR(CHG,ARCID(DWN)).GT.0) GO TO 410                           JOY08840
C     INCREASING FLOW                                                   JOY08850
      I = IABS(ARCID(DWN))                                              JOY08860
      POSS = CAPAC(I)-FLOW(DWN)                                         JOY08870
      JPOSS = -DWN                                                      JOY08880
      GO TO 420                                                         JOY08890
C     DECREASING FLOW                                                   JOY08900
  410 POSS = FLOW(DWN)                                                  JOY08910
      JPOSS = DWN                                                       JOY08920
C     FIND MIN                                                          JOY08930
  420 CONTINUE                                                          JOY08940
      IF(THETA.LE.POSS) GO TO 430                                       JOY08950
      THETA = POSS                                                      JOY08960
      JTHETA = JPOSS                                                    JOY08970
      IF(THETA.EQ.0) GO TO 530                                          JOY08980
  430 CONTINUE                                                          JOY08990
      DWN = DOWN(DWN)                                                   JOY09000
  440 CONTINUE                                                          JOY09010
      DW(KTHETA) = DWN                                                  JOY09020
C     AT COMMON LEVEL                                                   JOY09030
  450 CONTINUE                                                          JOY09040
C     SEARCH FOR CYCLE END                                              JOY09050
  460 CONTINUE                                                          JOY09060
      IF(DW(1).EQ.DW(2)) GO TO 520                                      JOY09070
      DO 510 L510=1,2                                                   JOY09080
      DWN = DW(L510)                                                    JOY09090
      IF( XOR(CH(L510),ARCID(DWN)).GT.0) GO TO 480                      JOY09100
C     INCREASING FLOW                                                   JOY09110
      I = IABS(ARCID(DWN))                                              JOY09120
      POSS = CAPAC(I)-FLOW(DWN)                                         JOY09130
      JPOSS = -DWN                                                      JOY09140
      GO TO 490                                                         JOY09150
C     DECREASING FLOW                                                   JOY09160
  480 POSS = FLOW(DWN)                                                  JOY09170
      JPOSS = DWN                                                       JOY09180
C     FIND MIN                                                          JOY09190
  490 CONTINUE                                                          JOY09200
      IF(THETA.LE.POSS) GO TO 500                                       JOY09210
      THETA = POSS                                                      JOY09220
      JTHETA = JPOSS                                                    JOY09230
      KTHETA = L510                                                     JOY09240
      IF(THETA.EQ.0) GO TO 530                                          JOY09250
  500 CONTINUE                                                          JOY09260
      DW(L510) = DOWN(DWN)                                              JOY09270
  510 CONTINUE                                                          JOY09280
      GO TO 460                                                         JOY09290
  520 DWE = DW(1)                                                       JOY09300
C     RATIO TEST COMPLETE                                               JOY09310
  530 CONTINUE                                                          JOY09320
      IF(THETA.EQ.0) GO TO 560                                          JOY09460
C     UPDATE FLOWS ON INTACT PORTION OF CYCLE                           JOY09490
      DW(1) = NEWFRM                                                    JOY09500
      DW(2) = NEWTO                                                     JOY09510
      IF(JTHETA.NE.0)                                                   JOY09520
     *DW(KTHETA) = IABS(JTHETA)                                         JOY09530
      DO 550 I550=1,2                                                   JOY09540
      DWN = DW(I550)                                                    JOY09550
      CHG = ISIGN(THETA,CH(I550))                                       JOY09560
  540 CONTINUE                                                          JOY09570
      IF(DWN.EQ.DWE) GO TO 550                                          JOY09580
      FLOW(DWN) = FLOW(DWN)-CHG*ISIGN(1,ARCID(DWN))                     JOY09590
      DWN = DOWN(DWN)                                                   JOY09600
      GO TO 540                                                         JOY09610
  550 CONTINUE                                                          JOY09620
  560 CONTINUE                                                          JOY09630
      IF(JTHETA.NE.0) GO TO 570                                         JOY09640
C     CHANGE OF BOUNDS ONLY                                             JOY09650
      CAPAC(NEWARC) = -CAPAC(NEWARC)                                    JOY09660
      GO TO 300                                                         JOY09690
  570 CONTINUE                                                          JOY09700
      ITHETA = IABS(JTHETA)                                             JOY09710
      IF(JTHETA.GT.0) GO TO 590                                         JOY09720
      J = IABS(ARCID(ITHETA))                                           JOY09730
C     SET OLD ARC TO UPPER BOUND                                        JOY09740
      CAPAC(J) = -CAPAC(J)                                              JOY09750
  590 CONTINUE                                                          JOY09780
C     FLOW ON NEWARC                                                    JOY09790
      FLW = THETA                                                       JOY09800
      IF(CAPAC(NEWARC).GT.0) GO TO 600                                  JOY09810
      CAPAC(NEWARC) = -CAPAC(NEWARC)                                    JOY09820
      FLW = CAPAC(NEWARC)-FLW                                           JOY09830
      NEWPR = -NEWPR                                                    JOY09840
  600 CONTINUE                                                          JOY09850
      IF(KTHETA.EQ.2) GO TO 610                                         JOY09860
      Q1 = NEWFRM                                                       JOY09870
      Q2 = NEWTO                                                        JOY09880
      AID = -NEWARC                                                     JOY09890
      NEWPR = -NEWPR                                                    JOY09900
      GO TO 620                                                         JOY09910
  610 CONTINUE                                                          JOY09920
      Q1 = NEWTO                                                        JOY09930
      Q2 = NEWFRM                                                       JOY09940
      AID = NEWARC                                                      JOY09950
  620 CONTINUE                                                          JOY09960
C                                                                       JOY09970
C     UPDATE TREE                                                       JOY09980
C                                                                       JOY09990
      I = Q1                                                            JOY10000
      J = DOWN(I)                                                       JOY10010
      LSTAR = LEVEL(Q2)+1                                               JOY10020
      IF(THETA.EQ.0) GO TO 730                                          JOY10030
C     FLOWS NEED TO BE UPDATED                                          JOY10040
      CHG = ISIGN(THETA,CH(KTHETA))                                     JOY10050
  680 CONTINUE                                                          JOY10060
C     UPDATE DUAL VARIABLE ON STEM                                      JOY10070
      DUAL(I) = DUAL(I)+NEWPR                                           JOY10080
C     UPDATE FLOW ON STEM                                               JOY10090
      N = FLOW(I)                                                       JOY10100
      FLOW(I) = FLW                                                     JOY10110
C     UPDATE ARC ID ON STEM                                             JOY10120
      DIR = ISIGN(1,ARCID(I))                                           JOY10130
      REF = IABS(ARCID(I))                                              JOY10140
      ARCID(I) = AID                                                    JOY10150
C     PREPARE FOR LEVEL UPDATES                                         JOY10160
      LSAVE = LEVEL(I)                                                  JOY10170
      LDIFF = LSTAR-LSAVE                                               JOY10180
      LEVEL(I) = LSTAR                                                  JOY10190
      THD = I                                                           JOY10200
  690 CONTINUE                                                          JOY10210
      NXT = NEXT(THD)                                                   JOY10220
      IF(LEVEL(NXT).LE.LSAVE) GO TO 700                                 JOY10230
C     UPDATE LEVEL                                                      JOY10240
      LEVEL(NXT) = LEVEL(NXT)+LDIFF                                     JOY10250
C     UPDATE DUAL VARIABLE                                              JOY10260
      DUAL(NXT) = DUAL(NXT)+NEWPR                                       JOY10270
      THD = NXT                                                         JOY10280
      GO TO 690                                                         JOY10290
  700 CONTINUE                                                          JOY10300
      K = J                                                             JOY10310
  710 CONTINUE                                                          JOY10320
      L = NEXT(K)                                                       JOY10330
      IF(L.EQ.I) GO TO 720                                              JOY10340
      K = L                                                             JOY10350
      GO TO 710                                                         JOY10360
  720 CONTINUE                                                          JOY10370
C     TEST FOR LEAVING ARC                                              JOY10380
      IF(I.EQ.ITHETA) GO TO 790                                         JOY10390
C     PREPARE FOR NEXT UPDATE ON STEM                                   JOY10400
      FLW = N-CHG*DIR                                                   JOY10410
      AID = -ISIGN(REF,DIR)                                             JOY10420
C     MOVE DOWN STEM                                                    JOY10430
      NEXT(K) = NXT                                                     JOY10440
      NEXT(THD) = J                                                     JOY10450
      K = I                                                             JOY10460
      I = J                                                             JOY10470
      J = DOWN(J)                                                       JOY10480
      DOWN(I) = K                                                       JOY10490
      LSTAR = LSTAR+1                                                   JOY10500
      GO TO 680                                                         JOY10510
  730 CONTINUE                                                          JOY10520
C     ONLY FLOW ON NEW ARC CHANGES                                      JOY10530
  740 CONTINUE                                                          JOY10540
C     UPDATE DUAL VARIABLE ON STEM                                      JOY10550
      DUAL(I) = DUAL(I)+NEWPR                                           JOY10560
C     UPDATE FLOW ON STEM                                               JOY10570
      N = FLOW(I)                                                       JOY10580
      FLOW(I) = FLW                                                     JOY10590
C     UPDATE ARC ID ON STEM                                             JOY10600
      DIR = ISIGN(1,ARCID(I))                                           JOY10610
      REF = IABS(ARCID(I))                                              JOY10620
      ARCID(I) = AID                                                    JOY10630
C     PREPARE FOR LEVEL UPDATES                                         JOY10640
      LSAVE = LEVEL(I)                                                  JOY10650
      LDIFF = LSTAR-LSAVE                                               JOY10660
      LEVEL(I) = LSTAR                                                  JOY10670
      THD = I                                                           JOY10680
  750 CONTINUE                                                          JOY10690
      NXT = NEXT(THD)                                                   JOY10700
      IF(LEVEL(NXT).LE.LSAVE) GO TO 760                                 JOY10710
C     UPDATE LEVEL                                                      JOY10720
      LEVEL(NXT) = LEVEL(NXT)+LDIFF                                     JOY10730
C     UPDATE DUAL VARIABLE                                              JOY10740
      DUAL(NXT) = DUAL(NXT)+NEWPR                                       JOY10750
      THD = NXT                                                         JOY10760
      GO TO 750                                                         JOY10770
  760 CONTINUE                                                          JOY10780
      K = J                                                             JOY10790
  770 CONTINUE                                                          JOY10800
      L = NEXT(K)                                                       JOY10810
      IF(L.EQ.I) GO TO 780                                              JOY10820
      K = L                                                             JOY10830
      GO TO 770                                                         JOY10840
  780 CONTINUE                                                          JOY10850
C     TEST FOR LEAVING ARC                                              JOY10860
      IF(I.EQ.ITHETA) GO TO 790                                         JOY10870
C     PREPARE FOR NEXT UPDATE ON STEM                                   JOY10880
      FLW = N                                                           JOY10890
      AID = -ISIGN(REF,DIR)                                             JOY10900
C     MOVE DOWN STEM                                                    JOY10910
      NEXT(K) = NXT                                                     JOY10920
      NEXT(THD) = J                                                     JOY10930
      K = I                                                             JOY10940
      I = J                                                             JOY10950
      J = DOWN(J)                                                       JOY10960
      DOWN(I) = K                                                       JOY10970
      LSTAR = LSTAR+1                                                   JOY10980
      GO TO 740                                                         JOY10990
  790 CONTINUE                                                          JOY11000
      NEXT(K) = NXT                                                     JOY11010
      NEXT(THD) = NEXT(Q2)                                              JOY11020
      NEXT(Q2) = Q1                                                     JOY11030
      DOWN(Q1) = Q2                                                     JOY11040
      GO TO 300                                                         JOY11050
C                                                                       JOY11060
C     SUMMARY                                                           JOY11070
C                                                                       JOY11080
  795 CONTINUE                                                          JOY11090
      INFEAS = .FALSE.                                                  JOY11140
      KOST = KOST0                                                      JOY11150
      DO 830 I830=1,MNODE                                               JOY11160
      I = IABS(ARCID(I830))                                             JOY11170
      IF((FLOW(I830).NE.0).AND.(COST(I).EQ.BIG)) INFEAS = .TRUE.        JOY11240
      KOST = KOST+COST(I)*FLOW(I830)                                    JOY11250
  830 CONTINUE                                                          JOY11260
      DO 840 I840=1,MSLK                                                JOY11270
      IF(CAPAC(I840).GE.0) GO TO 840                                    JOY11280
      J840 = -CAPAC(I840)                                               JOY11290
      KOST = KOST+COST(I840)*J840                                       JOY11300
  840 CONTINUE                                                          JOY11360
      IF(OPTIM) WRITE(6,8009) ITER                                      JOY11380
      IF(INFEAS) GO TO 850                                              JOY11390
      IF(OPTIM) WRITE(6,8005) KOST                                      JOY11400
 8005 FORMAT(1H+,21X,4HCOST,I16)                                        JOY11420
      GO TO 860                                                         JOY11430
  850 CONTINUE                                                          JOY11440
      IF(OPTIM) WRITE(6,8008)                                           JOY11450
 8008 FORMAT(1H+,21X,10HINFEASIBLE)                                     JOY11470
  860 CONTINUE                                                          JOY11480
      IF(.NOT.OPTIM) GO TO 305                                          JOY11530
CCCC  IF(INFEAS) GO TO 892                                              JOY11540
      WRITE(6,8009) ITER                                                JOY11560
 8009 FORMAT(10H ITERATION,I10)                                         JOY11570
      WRITE(6,8000)                                                     JOY11580
 8000 FORMAT(1H+,20X,19H OPTIMAL INDICATION)                            JOY11590
C                                                                       JOY11600
      PRES = .TRUE.                                                     JOY11780
      IF(.NOT.PRES) GO TO 885                                           JOY11790
C     MOVE BASIC FLOWS TO CAPACITY CELLS FOR BASIC ARCS                 JOY11800
      DO 884 I884=1,MNODE                                               JOY11810
      J884 = IABS(ARCID(I884))                                          JOY11820
      CAPAC(J884) = -FLOW(I884)                                         JOY11830
  884 CONTINUE                                                          JOY11840
  885 CONTINUE                                                          JOY11850
      WRITE(6,8023)                                                     JOY12230
 8023 FORMAT(10H0ARC FLOWS/                                             JOY12240
     *52H0ARC         FROM   TO           FLOW           COST   )       JOY12250
      TO = 1                                                            JOY12260
      TRY = ARTYP1                                                      JOY12270
      FRM = FROM(TRY)                                                   JOY12280
 8886 CONTINUE                                                          JOY12290
      LST = ISIGN(LNODP1,FRM)                                           JOY12300
 8888 CONTINUE                                                          JOY12310
      FLW = MAX0(0,-CAPAC(TRY))+FLOOR(TRY)                              JOY12320
      IF(FLW.EQ.0) GO TO 8889                                           JOY12330
      FM = IABS(FRM)                                                    JOY12340
      WRITE(6,8024) NAME(TRY),FM,TO,FLW,COST(TRY)                       JOY12350
 8024 FORMAT(1X,I10,1X,2I5,2I15)
*     IF(NAME(TRY).LT.20000) WRITE(7,8025) NAME(TRY)
 8025 FORMAT(I6)
 8889 CONTINUE                                                          JOY12370
      TRY = TRY+1                                                       JOY12380
      FRM = FROM(TRY)                                                   JOY12390
      IF( XOR(FRM,LST).GT.0) GO TO 8888                                 JOY12400
      TO = TO+1                                                         JOY12410
      IF(TO.NE.MNODP1) GO TO 8886                                       JOY12420
      CLOSE(5)
      CLOSE(6)
      STOP 12345                                                        JOY12430
  892 CONTINUE                                                          JOY12450
C                                                                       JOY12460
C     END OF PROBLEM                                                    JOY12470
C                                                                       JOY12480
      GO TO 5                                                           JOY12870
C                                                                       JOY12880
C     EXIT                                                              JOY12890
C                                                                       JOY12900
  999 CONTINUE                                                          JOY12910
      WRITE(6,1999) NSTOP,KARD                                          JOY12920
 1999 FORMAT(5H STOP,I5/1X,I10,16H DATA CARDS READ)                     JOY12930
      STOP 77777
      END

C  Note: field sizes increased for DIMACS challenge (C. McGeoch, 7/91) 
C     PROGRAM GABOW
C
C
C     REFERENCE:   H. N. GABOW, "AN EFFICIENT IMPLEMENTATION OF EDMONDS'
C                  ALGORITHM FOR MAXIMUM MATCHING ON GRAPHS", JACM 23
C                  (1976), PP. 221-234.
C
C     INPUT:       NONE.  SET THE VALUE OF K IN THE PARAMETER STATEMENT.
C
C     OUTPUT:      NUMBER OF VERTICES = N = 6*K
C                  NUMBER OF EDGES    = M = 8*K*K
C                  LIST OF EDGES (ALL EDGE COSTS ARE SET TO 1)
C
C                  THE GRAPH IS CONSTRUCTED SO THAT VERTICES 1-4K FORM A
C                  COMPLETE SUBGRAPH.  FOR I = 1 TO 2K, VERTEX (2I-1) IS
C                  JOINED TO VERTEX 4K+1.
C
C     PROGRAMMER:  R. BRUCE MATTINGLY
C     LANGUAGE:    FORTRAN 77
C     DATE:        FEBRUARY 28, 1991
C
      PARAMETER (K= 3, N=6*K, M=8*K*K, K4=4*K, K4P = K4+1, K4M = K4-1)
C
      WRITE(6, 7)
    7 FORMAT('c This problem belongs to the class of worst-case graphs',
     + /,'c described by Gabow (JACM 23, pp.221-234)',
     + /,'c Submitted by R. B. Mattingly')
      WRITE(6,11) N, M
   11 FORMAT('p edge', I8, I9)
c  11 FORMAT('p edge',I4,I6)
      DO 20 I = 1, K4M
         DO 30 J = I+1, K4
            WRITE(6, 31) I, J
  31       FORMAT('e',2I8,'   1')
c 31       FORMAT('e',2I4,'   1')
   30    CONTINUE
         IF (MOD(I,2) .EQ. 1) THEN
            J = K4 + (I+1)/2
            WRITE(6, 31) I, J
         ENDIF
   20 CONTINUE
      STOP
      END

      program addzer
c
c     This program is intended to be used on the output of the
c     shell file edge_to_cm to create a suitable input file for 
c     Rothberg's cardinality matching code match.c
c     
c     Input to edge_to_cm is a file in DIMACS input format.
c     The output file should contain a line for each vertex,
c     followed by its adjacency list.  Unfortunately, lines
c     with degree 0 are not included.
c
c     This program reads the output from edge_to_cm and inserts
c     additional lines of the form '0 v 0 0' whenever v is a 
c     vertex of degree 0.
c
c     To use this program:
c        edge_to_cm data.edge temp 
c        f77 addzer.f
c        a.out < temp > data.match
c     
      integer n,m,i,deg,v,j,u,k
c
c     read the problem line (n=number of vertices, m=2*number of edges)
      read *, n,m 
      print *,n,m,' U'
      i = 1
c     
c     read the i-th vertex line
c
    7 read(*,*,end=9) deg, v
c
c        if the i-th vertex line does not contain vertex i,
c        then add any missing vertices
c
    8    if (v .gt. i) then
            print *, '0 ',i,' 0 0'
            i = i+1
            goto 8
         endif
c        
c        copy line for vertex v to output file
         print *, deg, v, ' 0 0'
c
c        now copy the adjacency list
c
         do 3 j=1,deg
            read *, u,k
            print *,u,k
    3    continue
         i = i+1
         goto 7
c
c     check for missing vertices at eof
c
    9 if (i .le. n) then
         do 13 j=i,n
   13       print *, '0 ',j, '0 0'
      endif
      end

      PROGRAM TT
C     GENERATES A CHAIN OF TRIANGLES CONNECTED AT ALL VERTICES
C     EXAMPLE:
C      1--------4-------7-------10--------13
C      º \      º \     º \     º \       º  \
C      º   3----+---6---+---9---+---12----+----15
C      º /      º /     º /     º /       º  /
C      2--------5-------8-------11--------14
C
C     DATE:         7-1-91
C     LANGUAGE:     FORTRAN 77
C     PROGRAMMERS:  N. RITCHEY
C                   B. MATTINGLY
C                   YOUNGSTOWN STATE UNIVERSITY
C
C     INPUT:  K = NUMBER OF TRIANGLES
C
C     OUTPUT:  NUMBER OF VERTICES = N = 3*K
C              NUMBER OF EDGES    = M = 6*K - 3
C              LIST OF EDGES   (EDGE COSTS ARE SET = 1)
C
      READ(5, *) K
      N = 3 * K
      M = 6 * K - 3
C
      WRITE(6,11)N,M
11    FORMAT('p edge ', 2I10)
      L = 1
5     I1 = 3*(L-1) + 1
      I2 = I1 + 1
C
      DO 20 I = I1,I2
         WRITE(6,21)I,I+1
   21    FORMAT('e ',2I10,'     1')
         IF(I.LT.I2) WRITE(6,21)I,I+2
20    CONTINUE
C
      IF(L.LT.K)THEN
        L = L + 1
        GO TO 5
      ENDIF
      DO 25 I = 1,N-3
         WRITE(6,21)I,I+3
25    CONTINUE
      STOP
      END

      PROGRAM T
C     GENERATES A CHAIN OF TRIANGLES CONNECTED AT ONE VERTEX
C     EXAMPLE:
C      1--------4       7       10--------13
C      º \      º \     º \     º \       º  \
C      º   3    º   6   º   9---+---12    º    15
C      º /      º /     º /     º /       º  /
C      2        5-------8       11        14
C
C     DATE:         7-1-91
C     LANGUAGE:     FORTRAN 77
C     PROGRAMMERS:  N. RITCHEY
C                   B. MATTINGLY
C                   YOUNGSTOWN STATE UNIVERSITY
C
C     INPUT:  K = NUMBER OF TRIANGLES
C
C      OUTPUT:  NUMBER OF VERTICES =N= 3*K
C               NUMBER OF EDGES    =M= 4*K-1
C               LIST OF EDGES  (EDGE COSTS ARE SET = 1)
C
      READ(5,*) K
      N = 3*K
      M = 4*K - 1
C
      WRITE(6,11) N,M
11     FORMAT('p edge', 2I10)
       L = 1
5      I1 = 3*(L-1) + 1
       I2 = I1 + 1
C
       DO 20 I = I1,I2
         WRITE(6,21)I,I+1
   21    FORMAT('e ',2I10,'    1')
         IF(I.LT.I2) WRITE(6,21)I,I+2
20     CONTINUE
C
       IF(L.LT.K)THEN
        L = L + 1
        GO TO 5
       ENDIF
      I=0
      M=0
      DO 100 L = 1, K-1
         M = MOD(M+1, 3)
         IF (M .EQ. 1) THEN
             I = I+1
         ELSE
            I = I + 4
         ENDIF
         WRITE(6,21) I, I+3
  100 CONTINUE
      STOP
      END

c
c let's keep this line here so that we know what's the netgen that
c this file represents.
c                               MDG  9/6/90


      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      character*24 inpfn,outfn
      integer int13(13)

      NPROB=0
      write(*,*)' enter netgen input data filename'
      read(5,12121)inpfn
12121 format(a24)
      write(*,*)' enter output filename'
      read(5,12121)outfn
      open(1,file=inpfn,status='old')
      open(6,file=outfn,status='new')
c      open(7,file='netgen.stats',status='old')
c------------------------------------------------------
c new problem
 50   read(1,*)iISEED
      IF(iISEED.EQ.0)stop
       read(1,10100)(INT13(kk),kk=1,13)
c       read(1,10100)NODES,NSORC,NSINK,DENS,MINCST,MAXCST,ITSUP,NTSORC,
c     1NTSINK,IPHIC,IPCAP,MINCAP,MAXCAP
10100 FORMAT(6I5,I10,4I5,2I10)
      call netgen(iiseed,int13,nodes,narcs)
      NPROB=NPROB+1
      write(0,*)' problem',nprob, '; nodes and arcs=',nodes,narcs
c
c
      write(6,*)nodes,narcs
      do 300 i=1,narcs
 300     write(6,*)from(i),to(i),c(i),u(i)
         do 400 i=1,nodes
 400        if(b(i).ne.0)write(6,*)i,b(i)
c
c
            goto50
c
 9000       stop
            end
c
c     PROGRAM NETGEN(INPUT,OUTPUT,TAPE5=INPUT,TAPE7=OUTPUT,TAPE3)
      subroutine netgen(iiseed,int13,nnodes,nnarcs)
      integer int13(13)

C***********************************************************************
C***********************************************************************
C
C        NETGEN IS A GENERAL PURPOSE CODE FOR THE GENERATION OF NETWORK
C        PROBLEMS. THE CODE CAN CREATE CAPACITATED AND UNCAPACITATED
C        MINIMUM COST FLOW PURE NETWORKS AND TRANSPORTATION PROBLEMS
C        AS WELL AS ASSIGNMENT PROBLEMS.
C
C             ///////////////////////////////////////////////////
C
C        THE FOLLOWING ARE THE INPUT REQUIREMENTS FOR EACH PROBLEM
C
C       COLUMNS                  CONTENTS                       VARIABLE
C       -------                  -------                        --------
C
C   CARD 1.
C         1-8      8 DIGIT POSITIVE INTEGER TO INITIALIZE        ISEED
C                  THE RANDOM NUMBER GENERATOR. (MUST HAVE
C                  AT LEAST ONE NON-ZERO DIGIT IN COLUMNS
C                  1-8
 
C   CARD 2.
C
C         1-5      TOTAL NUMBER OF NODES....................    NODES
C         6-10     TOTAL NUMBER OF SOURCE NODES (INCLUDING
C                  TRANSHIPMENT SOURCES)....................    NSORC
C        11-15     TOTAL NUMBER OF SINK NODES (INCLUDING
C                  TRANSHIPMENT SINKS)......................    NSINK
C        16-20     NUMBER OF ARCS...........................    DENS
C        21-25     MINIMUM COST FOR ARCS....................    MINCST
C        26-30     MAXIMUM COST FOR ARCS....................    MAXCST
C        31-40     TOTAL SUPPLY.............................    ITSUP
C        41-45     NUMBER OF TRANSHIPMENT SOURCE NODES......    NTSORC
C        46-50     NUMBER OF TRANSHIPMENT SINK NODES........    NTSINK
C        51-55     PERCENTAGE OF SKELETON ARCS TO BE GIVEN
C                  THE MAXIMUM COST.........................    IPHIC
C        56-60     PERCENTAGE OF ARCS TO BE CAPACITATED.....    IPCAP
C        61-70     MINIMUM UPPER BOUND FOR CAPACITATED ARCS.    MINCAP
C        71-80     MAXIMUM UPPER BOUND FOR CAPACITATED ARCS.    MAXCAP
C
C        ALL INPUT VALUES ON CARD 2 ARE INTEGER AND MUST BE RIGHT-
C        JUSTIFIED IN THEIR FIELD.
C
C        THE DATA (INPUT) DECK MUST CONTAIN 2 CARDS (PUNCHED ACCORDING
C        TO THE ABOVE FORMAT) FOR EACH PROBLEM DESIRED. THE PROGRAM
C        WILL GENERATE A SEPARATE NETWORK PROBLEM FOR EACH PAIR OF
C        CARDS IN THE DATA DECK.
C
C ***IMPORTANT***IMPORTANT***IMPORTANT***IMPORTANT***IMPORTANT***
C        THE LAST CARD IN THE DATA DECK MUST BE A BLANK CARD.
C       THAT IS, ALL PROBLEM DEFINITION CARDS ARE FOLLOWED BY
C       A BLANK TRAILER CARD.
C
C             //////////////////////////////////////////////////
C
C            THE PROGRAM WILL GENERATE A TRANSPORTATION PROBLEM IF
C                            NSORC+NSINK=NODES
C                                     AND
C                            NTSORC=NTSINK=0
C
C
C        THE PROGRAM WILL GENERATE AN ASSIGNMENT PROBLEM IF THE
C        REQUIREMENTS FOR A TRANSPORTATION PROBLEM ARE MET AND IN
C        ADDITION
C                               NSORC=NSINK
C                                   AND
C                                ITSUP=NSORC
C
C             ///////////////////////////////////////////////////
C
C        THE FOLLOWING ARRAYS AND VARIBLES SHOULD BE ADJUSTED, AS
C        INDICATED, ACCORDING TO THE LARGEST PROBLEM IT IS DESIRED TO
C        GENERATE IN A GIVEN RUN.
C
C                  ARRAY                   SIZE
C                  -----                   ----
C                  IPRED          TOTAL NUMBER OF NODES
C                  IHEAD          TOTAL NUMBER OF NODES
C                  ITAIL          TOTAL NUMBER OF NODES
C                  IFLAG          TOTAL NUMBER OF NODES
C                  ISUP           TOTAL NUMBER OF SOURCES
C                  LSINKS         TOTAL NUMBER OF SINKS
C
C
C                 VARIABLE                 VALUE
C                 --------                 -----
C                  MXNODE         TOTAL NUMBER OF NODES
C                  MXSORC         TOTAL NUMBER OF SOURCES
C                  MXSINK         TOTAL NUMBER OF SINKS
C
C        NOTE...... IT IS ONLY NECESSARY TO CHANGE THE SIZE OF THE
C        ARRAYS IN THE DIMENSION STATEMENT OF THE MAIN SUBPROGRAM
C        (NETGEN).  THE 3 VARIABLES TO BE CHANGED ARE ALSO SET IN THE
C        MAIN SUBPROGRAM (THEY ARE THE FIRST 3 EXECUTABLE STATEMENTS)
C
C             ///////////////////////////////////////////////////
C
C        THE PROGRAM USES THE FOLLOWING 3 EXTERNAL FILES.
C                  (1)  THE INPUT FILE (FILE 5), WHICH CONTAINS THE
C                       DATA DECK (NORMALLY PUNCH CARDS)
C                  (2)  THE OUTPUT FILE (FILE 7), WHERE A SUMMARY OF
C                       THE INPUT SPECIFICATIONS, THE NUMBER OF ARCS
C                       CREATED, AND ANY ERROR MESSAGES ARE OUTPUT FOR
C                       EACH PROBLEM (NORMALLY ASSIGNED TO THE PRINTER)
C                  (3)  THE PROBLEM FILE (FILE 3), WHERE THE ACTUAL
C                       NETWORK PROBLEMS ARE WRITTEN IN SHARE INPUT
C                       FORMAT (NORMALLY MAGNETIC TAPE OR DISK FOR
C                       FUTURE INPUT TO A NETWORK CODE)
C
C***********************************************************************
C***********************************************************************
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
      COMMON/ARRAY1/IST,IPRED
      COMMON/ARRAY2/IHEAD
      COMMON/ARRAY3/ITAIL
      COMMON/ARRAY4/ISEED
      COMMON/ARRAY5/IFLAG
      COMMON/ARRAY6/ISUP
      COMMON/ARRAY7/LSINKS
      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS
C   *****
C   THE FOLLOWING DIMENSION STATEMENT IS THE ONLY ONE IN THE PROGRAM TAH
C   BE CHANGED IN ORDER TO CHANGE THE MAXIMUM SIZE PROBLEM THAT CAN BE G
C   IT IS SET AS DETAILED ABOVE
C   *****
C                  IPRED          TOTAL NUMBER OF NODES
C                  IHEAD          TOTAL NUMBER OF NODES
C                  ITAIL          TOTAL NUMBER OF NODES
C                  IFLAG          TOTAL NUMBER OF NODES
C                  ISUP           TOTAL NUMBER OF SOURCES
C                  LSINKS         TOTAL NUMBER OF SINKS
      DIMENSION IPRED(8500),IHEAD(8500),ITAIL(8500),IFLAG(8500),
     1ISUP(8500),LSINKS(8500)
C   *****
C   THE FOLLOWING 3 VARIABLES DETERMINE THE MAXIMUM PROBLEM AND ARE SET
C   DETAILED ABOVE.
C   *****
      MXNODE=8500
      MXSORC=1100
      MXSINK=1100
C   *****
C   READ THE INPUT CARDS FOR THE NEXT PROBLEM AND INITIALIZE THE RANDOM
C   GENERATOR.
C   *****
       nacnt=0
       iseed=iiseed
       NODES=int13(1)
       NSORC=int13(2)
       NSINK=int13(3)
       DENS=int13(4)
       MINCST=int13(5)
       MAXCST=int13(6)
       ITSUP=int13(7)
       NTSORC=int13(8)
       NTSINK=int13(9)
       IPHIC=int13(10)
       IPCAP=int13(11)
       MINCAP=int13(12)
       MAXCAP=int13(13)
   50 continue
c      read(1,10000,end=9000)ISEED
10000 FORMAT(I8)
c      IF(ISEED.EQ.0)GO TO 9000
       IF(ISEED.EQ.0)STOP 9000
75     continue
c75 IF(NPROB-NPROB/3*3.EQ.0)WRITE(7,10010)
10010 FORMAT(1H1)
c      NPROB=NPROB+1
      CALL SETRAN(ISEED)
c      read(1,*)NODES,NSORC,NSINK,DENS,MINCST,MAXCST,ITSUP,NTSORC,
c      read(1,10100)NODES,NSORC,NSINK,DENS,MINCST,MAXCST,ITSUP,NTSORC,
c     1NTSINK,IPHIC,IPCAP,MINCAP,MAXCAP
c10100 FORMAT(6I5,I10,4I5,2I10)

C    ******
C   SET VARIOUS CONSTANTS USED IN THE PROGRAM
C    ******
      NARCS=0
      NSKEL=0
      NLTR=NODES-NSINK
      LTSINK=NLTR+NTSINK
      NTRANS=NLTR-NSORC
      NFSINK=NLTR+1
      ISSORC=NODES+1
      ISSINK=NODES+2
      NONSOR=NODES-NSORC+NTSORC
      NPSINK=NSINK-NTSINK
      NODLFT=NODES-NSINK+NTSINK
      NFTR=NSORC+1
      NFTSOR=NSORC-NTSORC+1
      NPSORC=NSORC-NTSORC
C   *****
C   WRITE OUT THE INPUT SPECIFICATIONS ON THE OUTPUT (PRINT) FILE
C   *****
c      WRITE(7,10150)NPROB,NODES,NSORC,NSINK,DENS,MINCST,MAXCST,ITSUP,
c     1NTSORC,NTSINK,IPHIC,IPCAP,MINCAP,MAXCAP,ISEED
10150 FORMAT(/////52X,8HPROBLEM ,I3,5X,14HSPECIFICATIONS//1X,124(1H*)
     1/ 2H *         ,5X,1H*,7X,1H*,2(5X,1H*),23HCOST RANGE *  TOTAL   *
     2,2(13HTRANSHIPMENT*),48HPERCENT*PERCENT*  UPPER BOUND RANGE  *RAND
     3OM NO*/     1X,124H*NODES*SOURCES*SINKS* ARCS* MIN * MAX *  SUPPLY
     4  *  SOURCES   *   SINKS    *HI COST* CAPAC.*   MIN    *   MAX
     5*  SEED   */1X,124(1H*)/     1X,1H*,5X,1H*,7X,1H*,4(5X,1H*),10X,
     61H*,2(12X,1H*),2(7X,1H*),2(10X,1H*),9X,1H*/2H *          ,I5,2H* ,
     7I5,2H *,4(I5,1H*),I10,1H*,2(1X,I10,2H *),2(I7,1H*),2(I10,1H*),
     81X,I8,1H*/     1X,1H*,5X,1H*,7X,1H*,4(5X,1H*),10X,1H*,2(12X,1H*
     9),2(7X,1H*),2(10X,1H*),9X,1H*/1X,124(1H*)/)
      IF(NODES.LE.MXNODE.AND.NSORC.LE.MXSORC.AND.NSINK.LE.MXSINK)GOTO150
  100 continue
c      WRITE(7,10170)
10170 FORMAT(1X,30(1H/),70H THE NUMBER OF NODES, SOURCES, OR SINKS EXCEE
     1DS CURRENT ARRAY CAPACITY  ,33(1H/))
      GO TO 50
C    ******
C   RANDOMLY DISTRIBUTE THE SUPPLY AMONG THE SOURCE NODES
C    ******
  150 IF(NPSORC+NPSINK.NE.NODES)GO TO 25
      IF(NPSORC.NE.NPSINK) GO TO 25
      IF(ITSUP.NE.NSORC) GO TO 25
      CALL ASSIGN
      NSKEL=NSORC
      GO TO 1450
25    CALL CRESUP
C    ******
C   WRITE OUT THE HEADER AND THE ARCS FROM THE SUPER SOURCE TO THE SOURC
C    ******
      CALL WHEAD
C    ******
C    MAKE THE SOURCES POINT TO THEMSELVES IN IPRED ARRAY
C   *****
      DO 200 I=1,NSORC
  200 IPRED(I)=I
      IF(NTRANS.EQ.0)GO TO 600
C    ******
C   CHAIN THE TRANSHIPMENT NODES TOGETHER IN THE IPRED ARRAY
C   *****
250   IST=NFTR
      IPRED(NLTR)=0
      K=NLTR-1
      DO 300 I=NFTR,K
  300 IPRED(I)=I+1
C    ******
C    FORM EVEN LENGTH CHAINS FOR 60 PERCENT OF THE TRANSHIPMENTS
C    ******
      NTRAVL=6*NTRANS/10
      NTRREM=NTRANS-NTRAVL
  340 LSORC=1
  350 IF(NTRAVL.EQ.0)GO TO 500
      LPICK=IRAN(1,NTRAVL+NTRREM)
      NTRAVL=NTRAVL-1
      CALL CHAIN(LPICK,LSORC)
      IF(LSORC.EQ.NSORC)GO TO 340
      LSORC=LSORC+1
      GO TO 350
C    ******
C    ADD THE REMAINING TRANSHIPMENTS TO THE CHAINS
C    ******
  500 IF(NTRREM.EQ.0)GO TO 600
      LPICK=IRAN(1,NTRREM)
      NTRREM=NTRREM-1
      LSORC=IRAN(1,NSORC)
      CALL CHAIN(LPICK,LSORC)
      GO TO 500
C    ******
C    SET ALL DEMANDS EQUAL TO ZERO
C    ******
600   DO 700 I=NFSINK,NODES
  700 IPRED(I)=0
C   *****
C   THE FOLLOWING DO LOOP (TO STATEMENT 3000) TAKES ONE CHAIN AT A TIME
C   THROUGH THE USE OF CODE CONTAINED IN THE LOOP AND CALLS TO OTHER SUB
C   COMPLETES THE NETWORK
C   *****
      DO 3000 LSORC=1,NSORC
      CALL CHNARC(LSORC)
      DO 705 I=NFSINK,NODES
  705 IFLAG(I)=0
C   *****
C   CHOOSE THE NUMBER OF SINKS TO BE HOOKED UP TO THE CURRENT CHAIN (NSK
C   *****
      IF(NTRANS.EQ.0) GO TO 711
      NSKSR=(NSORT*2*NSINK)/NTRANS
      GO TO 710
711   NSKSR=NSINK/NSORC+1
710   IF(NSKSR.LT.2) NSKSR=2
      IF(NSKSR.GT.NSINK)NSKSR=NSINK
      NSRCHN=NSORT
C    ******
C    RANDOMLY PICK NSKSR SINKS AND PUT THEIR NAMES IN LSINKS
C    ******
      KTL=NSINK
      DO 800 J=1,NSKSR
      ITEM=IRAN(1,KTL)
      KTL=KTL-1
      DO 750 L=NFSINK,NODES
      IF(IFLAG(L).EQ.1)GO TO 750
      ITEM=ITEM-1
      IF(ITEM.EQ.0)GO TO 775
  750 CONTINUE
      GO TO 825
  775 LSINKS(J)=L
      IFLAG(L)=1
  800 CONTINUE
C    ******
C    IF LAST SOURCE CHAIN, ADD ALL SINKS WITH ZERO DEMAND TO LSINKS LIST
C    ******
  825 IF(LSORC.NE.NSORC)GO TO 850
      DO 910 J=NFSINK,NODES
      IF(IPRED(J).NE.0)GO TO 910
      IF(IFLAG(J).EQ.1)GO TO 910
  905 NSKSR=NSKSR+1
      LSINKS(NSKSR)=J
      IFLAG(J)=1
  910 CONTINUE
C    ******
C    CREATE DEMANDS FOR GROUP OF SINKS IN LSINKS
C    ******
  850 KS=ISUP(LSORC)/NSKSR
  925 K=IPRED(LSORC)
      DO 1000 I=1,NSKSR
      NSORT=NSORT+1
      KSP=IRAN(1,KS)
      J=IRAN(1,NSKSR)
      ITAIL(NSORT)=K
      LI=LSINKS(I)
      IHEAD(NSORT)=LI
      IPRED(LI)=IPRED(LI)+KSP
      LI=LSINKS(J)
      IPRED(LI)=IPRED(LI)+KS-KSP
      N=IRAN(1,NSRCHN)
      K=LSORC
      DO 950 II=1,N
  950 K=IPRED(K)
 1000 CONTINUE
      LI=LSINKS(1)
      IPRED(LI)=IPRED(LI)+ISUP(LSORC)-(KS*NSKSR)
      NSKEL=NSKEL+NSORT
C    ******
c    sort the arcs in the chain from source lsorc using itail as sort ke
c    ******
      call srt
c    ******
c    write out this part of skeleton and create density arcs for these n
c    ******
       i=1
       itail(nsort+1)=0
 1050  do 1100 j=nftsor,nodes
 1100  iflag(j)=0
       ktl=nonsor-1
 1125  it=itail(i)
       iflag(it)=1
 1150  ih=ihead(i)
       iflag(ih)=1
       narcs=narcs+1
       ktl=ktl-1
c    ******
c    determine if this skeleton arc should be capacitated
c    ******
       icap=itsup
      JCAP=IRAN(1,100)
      IF(JCAP.GT.IPCAP) GO TO 1160
      ICAP=ISUP(LSORC)
      IF(MINCAP.GT.ICAP)ICAP=MINCAP
C    ******
C    DETERMINE IF THIS SKELETON ARC SHOULD HAVE THE MAXIMUM COST
C    ******
 1160 ICOST=MAXCST
      JCOST=IRAN(1,100)
      IF(JCOST.LE.IPHIC) GO TO 1175
      ICOST=IRAN(MINCST,MAXCST)
 1175 continue
c      write(6,10300)IT,IH,ICOST,ICAP
                                 call putarc(IT,IH,ICOST,ICAP)
10300 FORMAT(6X,2I6,2X,2I10)
      I=I+1
      IF(ITAIL(I).EQ.IT)GO TO 1150
      CALL PKHD(IT)
      IF(I.LE.NSORT)GO TO 1050
 3000 CONTINUE
C    ******
C    CREATE ARCS FROM THE TRANSHIPMENT SINKS
C    ******
      IF(NTSINK.EQ.0)GO TO 1450
      NZ=0
      DO 1400 I=NFSINK,LTSINK
c      write(6,10300)I,ISSINK,NZ,IPRED(I)
                                 call putarc(I,issink,nz,ipred(i))
      DO 1350 J=NFTSOR,NODES
 1350 IFLAG(J)=0
      KTL=NONSOR-1
      IFLAG(I)=1
      CALL PKHD(I)
 1400 CONTINUE
C    ******
C   PRINT THE NUMBER OF ARCS IN THE SKELETON ON THE OUTPUT FILE
C    ******
 1450 NODESC=NODES+2
      NARSCS=NARCS+NSORC+NSINK+1
c      WRITE(7,10400)NARCS,NODESC,NARSCS
10400 FORMAT(20X,21HTHE NETWORK CONTAINS ,I5,5H ARCS,26H  (CIRCULATION N
     1ETWORK HAS ,I5,11H NODES AND ,I5,6H ARCS))
C    ******
C    WRITE OUT THE ARCS FROM THE SINKS TO THE SUPER SINK WITH DEMANDS,
C   AND PUT OUT THE END MESSAGES FOR SHARE FORMAT
C    ******
      CALL WEND
                                 nnodes=nodes
                                 nnarcs=narcs
c      GO TO 50
                                 return
 9000 continue
c     write(6,10500)
10500 FORMAT(4HQUIT)
c      ENDFILE 3
c      REWIND 3
      END
      subroutine putarc(i1,i2,i3,i4)
      integer from(1),to(1),c(1),u(1),b(1)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
                             nacnt=nacnt+1
                             from(nacnt)=i1
                             to(nacnt)=i2
                             c(nacnt)=i3
                             u(nacnt)=i4
                             return
                             end

      SUBROUTINE WHEAD
C***********************************************************************
C        WHEAD WRITES OUT THE HEADER CARDS FOR SHARE FORMAT ON THE
C        PROBLEM FILE.  THIS CONSISTS OF THE BEGIN, TITLE, AND ARCS
C        CARDS. THIS SUBROUTINE ALSO WRITES OUT THE ARCS FROM THE
C        SUPER SOURCE TO THE SOURCE NODES ON THE PROBLEM FILE.
C***********************************************************************
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
      COMMON/ARRAY1/IST,IPRED
      COMMON/ARRAY2/IHEAD
      COMMON/ARRAY3/ITAIL
      COMMON/ARRAY4/ISEED
      COMMON/ARRAY5/IFLAG
      COMMON/ARRAY6/ISUP
      COMMON/ARRAY7/LSINKS
      DIMENSION IPRED(1),IHEAD(1),ITAIL(1),IFLAG(1),ISUP(1),LSINKS(1)
      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS
c
cc      write(6,10000)ISEED,IPHIC
10000 FORMAT(5HBEGIN,5X,29HRANDOM NUMBER GENERATOR SEED=,I8,   16H,PERCE
     1NT HI CST=,I5)
cc      write(6,10100)NODES,NSORC,NSINK,DENS,MINCST,MAXCST,ITSUP
10100 FORMAT(1X,6HNODES=,I5,7H,SORCE=,I5,6H,SINK=,I5,6H,ARCS=,I5,6H,COST
     1=,I5,1H-,I5,7H,SUPLY=,I10)
cc      write(6,10200)NTSORC,NTSINK,MINCAP,MAXCAP,IPCAP
10200 FORMAT(4HARCS,6X,7HTSORCE=,I5,7H,TSINK=,I5,5H,CAP=,I10,1H-,I10,
     113H,PERCENT CAP=,I5)
      do 10202 i=1,nodes
10202    b(i)=0
c         write(6,*)nodes,dens
      NZ=0
      DO 100 I=1,NSORC
c         write(6,10300) ISSORC,I,NZ,ISUP(I)
         b(i)=isup(i)
100   continue
10300 FORMAT(6X,2I6,2X,2I10)
      RETURN
      END
      SUBROUTINE CRESUP
C***********************************************************************
C        CRESUP DISTRIBUTES THE TOTAL SUPPLY AMONG THE SOURCE  NODES
C***********************************************************************
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
      COMMON/ARRAY1/IST,IPRED
      COMMON/ARRAY2/IHEAD
      COMMON/ARRAY3/ITAIL
      COMMON/ARRAY4/ISEED
      COMMON/ARRAY5/IFLAG
      COMMON/ARRAY6/ISUP
      COMMON/ARRAY7/LSINKS
      DIMENSION IPRED(1),IHEAD(1),ITAIL(1),IFLAG(1),ISUP(1),LSINKS(1)
      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS

      IF(ITSUP.LE.NSORC)STOP 66
      KS=ITSUP/NSORC
      DO 100 I=1,NSORC
  100 ISUP(I)=0
      DO 500 I=1,NSORC
      KSP=IRAN(1,KS)
      J=IRAN(1,NSORC)
      ISUP(I)=ISUP(I)+KSP
  500 ISUP(J)=ISUP(J)+KS-KSP
      J=IRAN(1,NSORC)
      ISUP(J)=ISUP(J)+ITSUP-(KS*NSORC)
      RETURN
      END
      SUBROUTINE CHAIN(LPICK,LSORC)
C***********************************************************************
C        CHAIN HAS 2 INPUT PARAMETERS (LPICK AND LSORC). THE SUBROUTINE
C        ADDS NODE LPICK TO THE END OF THE CHAIN WITH SOURCE NODE LSORC
C***********************************************************************
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
      COMMON/ARRAY1/IST,IPRED
      COMMON/ARRAY2/IHEAD
      COMMON/ARRAY3/ITAIL
      COMMON/ARRAY4/ISEED
      COMMON/ARRAY5/IFLAG
      COMMON/ARRAY6/ISUP
      COMMON/ARRAY7/LSINKS
      DIMENSION IPRED(1),IHEAD(1),ITAIL(1),IFLAG(1),ISUP(1),LSINKS(1)
      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS

      K=0
      M=IST
      DO 100 I=1,LPICK
      L=K
      K=M
  100 M=IPRED(K)
      IPRED(L)=M
      J=IPRED(LSORC)
      IPRED(K)=J
      IPRED(LSORC)=K
      RETURN
      END
      SUBROUTINE CHNARC(LSORC)
C***********************************************************************
C    THIS ROUTINE PUTS THE ARCS IN THE CHAIN FROM SOURCE LSORC, IN
C    IHEAD AND ITAIL FOR SORTING
C***********************************************************************
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
      COMMON/ARRAY1/IST,IPRED
      COMMON/ARRAY2/IHEAD
      COMMON/ARRAY3/ITAIL
      COMMON/ARRAY4/ISEED
      COMMON/ARRAY5/IFLAG
      COMMON/ARRAY6/ISUP
      COMMON/ARRAY7/LSINKS
      DIMENSION IPRED(1),IHEAD(1),ITAIL(1),IFLAG(1),ISUP(1),LSINKS(1)
      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS

      NSORT=0
      ITO=IPRED(LSORC)
      GO TO 150
  100 NSORT=NSORT+1
      IFROM=IPRED(ITO)
      IHEAD(NSORT)=ITO
      ITAIL(NSORT)=IFROM
      ITO=IFROM
150   IF(ITO.NE.LSORC) GO TO 100
      RETURN
      END
      SUBROUTINE SRT
C***********************************************************************
C        SRT SORTS THE ARCS IN ITAIL AND IHEAD USING ITAIL AS THE
C        SORT KEY.  VARIABLE NSORT INDICATES HOW MANY ARCS ARE TO BE
C        SORTED.
C***********************************************************************
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
      COMMON/ARRAY1/IST,IPRED
      COMMON/ARRAY2/IHEAD
      COMMON/ARRAY3/ITAIL
      COMMON/ARRAY4/ISEED
      COMMON/ARRAY5/IFLAG
      COMMON/ARRAY6/ISUP
      COMMON/ARRAY7/LSINKS
      DIMENSION IPRED(1),IHEAD(1),ITAIL(1),IFLAG(1),ISUP(1),LSINKS(1)
      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS

   10 N=NSORT
      M=N
   20 M=M/2
      IF(M)30,65,30
   30 K=N-M
      J=1
   41 I=J
   49 L=I+M
      IF(ITAIL(I)-ITAIL(L))60,60,50
   50 IT=ITAIL(I)
      ITAIL(I)=ITAIL(L)
      ITAIL(L)=IT
      IT=IHEAD(I)
      IHEAD(I)=IHEAD(L)
      IHEAD(L)=IT
      I=I-M
      IF(I-1)60,49,49
   60 J=J+1
      IF(J-K)41,41,20
   65 CONTINUE
      RETURN
      END
      SUBROUTINE WEND
C***********************************************************************
C        WEND WRITES OUT THE ARCS FROM THE SINKS TO THE SUPER SINK,
C        THE ARC FROM THE SUPER SINK TO THE SUPER SOURCE, AND THE
C        END CARDS FOR SHARE FORMAT.  THESE ARE ALL WRITTEN ON THE
C        PROBLEM FILE.
C***********************************************************************
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
      COMMON/ARRAY1/IST,IPRED
      COMMON/ARRAY2/IHEAD
      COMMON/ARRAY3/ITAIL
      COMMON/ARRAY4/ISEED
      COMMON/ARRAY5/IFLAG
      COMMON/ARRAY6/ISUP
      COMMON/ARRAY7/LSINKS
      DIMENSION IPRED(1),IHEAD(1),ITAIL(1),IFLAG(1),ISUP(1),LSINKS(1)
      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS

      NZ=0
      NFPSNK=LTSINK+1
      IF(NFPSNK.GT.NODES)GO TO 150
      DO 100 I=NFPSNK,NODES
c         write(6,10100) I,ISSINK,NZ,IPRED(I)
         kkkk=-ipred(i)
c         write(6,*)i,kkkk,'    at 100ENDSOLVE'
         b(i)=kkkk
 100     continue
c         do 101 i=1,nodes
c 101        if(b(i).ne.0)write(6,*)i,b(i)
10100 FORMAT(6X,2I6,2X,3I10)
 150  continue
c  150 write(6,10100) ISSINK,ISSORC,NZ,ITSUP,ITSUP
c      write(6,10200)
10200 FORMAT(3HEND/5HSOLVE)
      RETURN
      END
      SUBROUTINE PKHD(IT)
C***********************************************************************
C        PKHD HAS ONE FORMAL PARAMETER (IT).  THE SUBROUTINE CREATES
C        AND WRITES ON THE PROBLEM FILE A RANDOM MUNBER OF ARCS
C        FROM NODE IT TO RANDOMLY SELECTED NODES.  THE SUBROUTINE
C        DYNAMICALLY ADJUSTS VARIOUS PARAMETERS IN ORDER TO INSURE
C        THAT THE RESULTING NETWORK HAS THE RIGHT NUMBER OF ARCS.
C***********************************************************************
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
      COMMON/ARRAY1/IST,IPRED
      COMMON/ARRAY2/IHEAD
      COMMON/ARRAY3/ITAIL
      COMMON/ARRAY4/ISEED
      COMMON/ARRAY5/IFLAG
      COMMON/ARRAY6/ISUP
      COMMON/ARRAY7/LSINKS
      DIMENSION IPRED(1),IHEAD(1),ITAIL(1),IFLAG(1),ISUP(1),LSINKS(1)
      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS

      IF((NODLFT-1)*2.LE.DENS-NARCS-1)GO TO 5
      NODLFT=NODLFT-1
      RETURN
    5 IF((DENS-NARCS+NONSOR-KTL-1)/NODLFT-NONSOR+1) 12,10,10
   10 K=NONSOR
      GO TO 15
12    NUPBND=(DENS-NARCS-NODLFT)/NODLFT*2
14    K=IRAN(1,NUPBND)
      IF(NODLFT.EQ.1) K=DENS-NARCS
      IF((NODLFT-1)*(NONSOR-1).LT.DENS-NARCS-K)GO TO 14
15    NODLFT=NODLFT-1
      DO 100 J=1,K
      NN=IRAN(1,KTL)
      KTL=KTL-1
      DO 25 L=NFTSOR,NODES
      IF(IFLAG(L).EQ.1) GO TO 25
      NN=NN-1
      IF(NN.EQ.0) GO TO 35
25    CONTINUE
      RETURN
35    IFLAG(L)=1
      ICAP=ITSUP
      JCAP=IRAN(1,100)
      IF(JCAP.GT.IPCAP) GO TO 40
      ICAP=IRAN(MINCAP,MAXCAP)
40    ICOST=IRAN(MINCST,MAXCST)
c      write(6,10100) IT,L,ICOST,ICAP
                             call putarc(IT,L,ICOST,ICAP)
10100 FORMAT(6X,2I6,2X,2I10)
      NARCS=NARCS+1
100   CONTINUE
      RETURN
      END
      SUBROUTINE ASSIGN
C***********************************************************************
C        ASSIGN HANDLES THE GENERATION OF ASSIGNMENT PROBLEMS.  THE
C        SUBROUTINE CREATES THE SUPPLIES, GENERATES THE SKELETON,
C        AND CALLS PKHD TO GENERATE THE REMAINING ARCS.
C***********************************************************************
      COMMON/VAR/NODES,DENS,MINCST,MAXCST,ITSUP,NSORC,NTSORC,NSINK,
     1NTSINK,NONSOR,NUPBND,NFSINK,NARCS,NLTR,NTRANS,NTRAVL,
     2NTRREM,NFTR,ISSORC,ISSINK,NSINKZ,NSORT,NSKSR,NFTSOR,IPHIC,
     3IPCAP,MINCAP,MAXCAP,KTL,NODLFT,NPSORC,NPSINK,LTSINK,nacnt
      COMMON/ARRAY1/IST,IPRED
      COMMON/ARRAY2/IHEAD
      COMMON/ARRAY3/ITAIL
      COMMON/ARRAY4/ISEED
      COMMON/ARRAY5/IFLAG
      COMMON/ARRAY6/ISUP
      COMMON/ARRAY7/LSINKS
      DIMENSION IPRED(1),IHEAD(1),ITAIL(1),IFLAG(1),ISUP(1),LSINKS(1)
      integer from(35000),to(35000),c(35000),u(35000),b(8500)
      common /arrays/from/arraye/to/arrayu/u/arrayc/c/arrayb/b
      INTEGER DENS

      DO 30 I=1,NSORC
30    ISUP(I)=1
      CALL WHEAD
      DO 40 I=NFSINK,NODES
40    IPRED(I)=1
      DO 45 I=1,NSORC
45    IFLAG(I)=0
      DO 100 IT=1,NSORC
      DO 48 I=NFSINK,NODES
48    IFLAG(I)=0
      KTL=NSINK-1
      NN=IRAN(1,NSINK-IT+1)
      DO 50 L=1,NSORC
      IF(IFLAG(L).EQ.1) GO TO 50
      NN=NN-1
      IF(NN.EQ.0) GO TO 75
50    CONTINUE
   75 NARCS=NARCS+1
      LL=NSORC+L
      ICOST=IRAN(MINCST,MAXCST)
c      write(6,10100) IT,LL,ICOST,ISUP(1)
                             call putarc(IT,LL,ICOST,ISUP(1))
10100 FORMAT(6X,2I6,2X,2I10)
      IFLAG(L)=1
      IFLAG(LL)=1
      CALL PKHD(IT)
100   CONTINUE
      RETURN
      END
      SUBROUTINE SETRAN(ISEED)
C
C   PORTABLE RANDOM NUMBER GENERATOR
C
C   THIS GENERATOR CONSISTS OF TWO ROUTINES
C     1) SETRAN - INITIALIZES CONSTANTS AND SEED
C     2) IRAN - GENERATES A RANDOM INTEGER IN A SPECIFIED RANGE
C
C   ALL INTEGER VARIABLES IN SETRAN AND IRAN MUST HAVE AT
C   LEAST 31 BITS OF PRECISION EXCLUSIVE OF SIGN
C
C   THE GENERATOR IS THE CONGRUENTIAL GENERATOR
C     I = 7**5 * I  MOD(2**31 - 1)
C
C   INITIALIZE CONSTANTS AND SEED
C   ISEED IS ASSUMED IN THE RANGE 0 .LT. ISEED .LT. 2**31 - 1
      COMMON/RAN/MULT,MODUL,I15,I16,JRAN
      MULT=16807
      MODUL=2147483647
      I15=2**15
      I16=2**16
      JRAN=ISEED
      RETURN
      END
      FUNCTION IRAN(IA,IB)
C   GENERATE A RANDOM INTEGER IN THE RANGE IA TO IB
C   IF IA .GT. IB THEN RETURN IRAN = IB
      COMMON/RAN/MULT,MODUL,I15,I16,JRAN
      IXHI=JRAN/I16
      IXLO=JRAN-IXHI*I16
      IXALO=IXLO*MULT
      LEFTLO=IXALO/I16
      IXAHI=IXHI*MULT
      IFULHI=IXAHI+LEFTLO
      IRTLO=IXALO-LEFTLO*I16
      IOVER=IFULHI/I15
      IRTHI=IFULHI-IOVER*I15
      JRAN=((IRTLO-MODUL) + IRTHI*I16) + IOVER
      IF(JRAN) 100,110,110
100   JRAN=JRAN+MODUL
110   CONTINUE
      J=IB-IA+1
      IF(J.LE.0) GO TO 120
      IRAN=MOD(JRAN,J)+IA
      GO TO 130
120   IRAN=IB
130   CONTINUE
      RETURN
      END

C---------------------------------------------------------------------------
C  AN EFFICIENT PARTIAL ENUMERATIVE ALGORITHM FOR THE MAXIMUM CLIQUE PROBLEM
C
C
C  THE ALGORITHM  (INCLUDING THE FORTRAN CODE) IS DESCRIBED IN DETAILS IN:
C  R. CARRAGHAN AND P.M. PARDALOS, AN EXACT ALGORITHM FOR THE MAXIMUM CLIQUE
C  PROBLEM, OPERATIONS RESEARCH LETTERS 9 (1990), PP. 375-382
C
C
C  AUTHORS          - PANOS M. PARDALOS AND RANDY CARRAGHAN    
C
C  WARRANTY         - NO WARRANTY EXPRESSED OR IMPLIED IS APPLICABLE
C
C
C  ALL TIMING SUBROUTINES ARE USED FOR THE IBM 3090
C
C  INPUT PARAMETERS:
C  N (NUMBER OF VERTICES)
C  DENSITY (A NUMBER BETWEEN 0 AND 1)
C  INCUMBENT (A LOWER BOUND ON THE MAX CLIQUE = 1 ALWAYS WORKS)
C  SEED (SEED FOR GENERATING RANDOM GRAPHS)
C
C---------------------------------------------------------------------------
C
      PARAMETER (MAXN=2000, MAXM=2000)
      INTEGER*2  N,ROW,COL
      LOGICAL*1  MAT(MAXN,MAXN),TEMPLOG
      INTEGER    EDGES
      REAL       DENS
      REAL*8     SEED
      INTEGER*2  ACTNODE(MAXN),TEMP
      INTEGER*2  ADJ(MAXM,MAXN)
      INTEGER*2  NODE,MIN,MINNODE,EDGE(MAXN)
      INTEGER*2  START(MAXN),LAST(MAXN),D,DTEMP,MAXCLIQUE,BEST(MAXN)
C     REAL       T1,T2,SORTTIME,TRAVTIME
C     REAL       TOTTIME
 
C     MAXN       MAXIMUM NUMBER OF NODES IN GRAPH
C     MAXM       GREATER OR EQUAL TO THE ACTUAL SIZE OF MAXCLIQUE
C     N          NUMBER OF NODES IN GRAPH
C     MAT        ADJACENCY MATRIX
C     ACTNODE    ACTUAL NODES IN ORIGINAL MATRIX
C     ADJ        REPRESENTS NODES FOUND AT ALL DEPTHS
C     MAXCLIQUE  SIZE OF LARGEST CURRENTLY KNOW CLIQUE
C     BEST       NODES IN LARGEST CURRENTLY KNOW CLIQUE
C     D          CURRENT DEPTH OF TRAVERSAL
C     START      NODE CURRENTLY BEING EXPANDED AT DEPTH D
C     LAST       LAST NODE TO (POSSIBLY) BE EXPANDED AT DEPTH D
 
C     -- GENERATION OF RANDOM GRAPH
 
      WRITE(*,*) 'ENTER N, DENSITY, INCUMBENT, SEED'
      READ(*,*) N,DENS,MAXCLIQUE,SEED
      EDGES = 0
      DO 10 ROW = 1,N-1
        DO 15 COL = ROW+1,N
          IF (GGUBFS(SEED).LT.DENS) THEN
            EDGES = EDGES + 1
            MAT(ROW,COL) = .TRUE.
            MAT(COL,ROW) = .TRUE.
          ELSE
            MAT(ROW,COL) = .FALSE.
            MAT(COL,ROW) = .FALSE.
          END IF
15      CONTINUE
10    CONTINUE
      DO 20 ROW = 1,N
        MAT(ROW,ROW) = .FALSE.
20    CONTINUE
      WRITE(*,*) ' '
      WRITE(*,85) 'TOTAL EDGES     ',EDGES
 
C     -- MAINTAIN POINTERS TO ORIGINAL MATRIX
 
C     CALL SECOND(T1)
      DO 25 NODE = 1,N
        ACTNODE(NODE) = NODE
25    CONTINUE
 
C     -- ORDER NODES BY INCREASING EDGE DENSITY
 
      IF (DENS.GE..40) THEN
        DO 30 ROW = 1,N
          EDGE(ROW) = 0
          DO 35 COL = 1,N
            IF (MAT(ROW,COL)) EDGE(ROW) = EDGE(ROW)+1
35        CONTINUE
30      CONTINUE
        DO 40 NODE = 1,N-2
          MIN = N
          DO 45 ROW = NODE,N
            IF (EDGE(ROW).LT.MIN) THEN
              MIN = EDGE(ROW)
              MINNODE = ROW
            END IF
45        CONTINUE
          EDGE(MINNODE) = EDGE(NODE)
          IF (NODE.NE.MINNODE) THEN
            TEMP = ACTNODE(NODE)
            ACTNODE(NODE) = ACTNODE(MINNODE)
            ACTNODE(MINNODE) = TEMP
            DO 50 ROW = 1,N
              TEMPLOG = MAT(ROW,NODE)
              MAT(ROW,NODE) = MAT(ROW,MINNODE)
              MAT(ROW,MINNODE) = TEMPLOG
50          CONTINUE
            DO 55 COL = 1,N
              TEMPLOG = MAT(NODE,COL)
              MAT(NODE,COL) = MAT(MINNODE,COL)
              MAT(MINNODE,COL) = TEMPLOG
55          CONTINUE
          END IF
          DO 60 COL = NODE,N
            IF (MAT(NODE,COL)) EDGE(COL) = EDGE(COL) - 1
60        CONTINUE
40      CONTINUE
      END IF
C     CALL SECOND(T2)
      SORTTIME = T2 - T1
 
C     CALL SECOND(T1)
      D = 1
      START(1) = 0
      LAST(1) = N
C     MAXCLIQUE = 0
      DO 65 COL = 1,N
        ADJ(1,COL) = COL
65    CONTINUE
 
C     -- MAIN ALGORITHM
 
70    START(D) = START(D) + 1
      IF ((D+LAST(D)-START(D)).GT.MAXCLIQUE) THEN
        DTEMP = D
        D = D + 1
        START(D) = 0
        LAST(D) = 0
C       -- DETERMINE NODE FOR NEXT DEPTH
        DO 75 COL = (START(DTEMP)+1),LAST(DTEMP)
          IF (MAT(ADJ(DTEMP,START(DTEMP)),ADJ(DTEMP,COL))) THEN
            LAST(D) = LAST(D) + 1
            ADJ(D,LAST(D)) = ADJ(DTEMP,COL)
          END IF
75      CONTINUE
C       -- IF THE NEXT DEPTH DOESN'T CONTAIN ANY NODES, SEE IF A NEW
C       -- MAXCLIQUE HAS BEEN FOUND AND RETURN TO PREVIOUS DEPTH
        IF (LAST(D).EQ.0.) THEN
          D = D - 1
          IF (D.GT.MAXCLIQUE) THEN
            MAXCLIQUE = D
            DO 80 COL = 1,D
              BEST(COL) = ADJ(COL,START(COL))
80          CONTINUE
          END IF
        END IF
      ELSE
C       -- PRUNE, FURTHER EXPANSION WOULD NOT FIND A BETTER INCUMBENT
        D = D - 1
      END IF
C     -- CONTINUE TRAVERSAL UNTIL A DEPTH OF ZERO IS REACHED
      IF (D.GT.0.) GOTO 70
C     CALL SECOND(T2)
      TRAVTIME = T2 - T1
 
C     -- OUTPUT THE MAXIMUM CLIQUE FOUND IN GRAPH
 
      WRITE(*,85) 'MAXCLIQUE SIZE  ',MAXCLIQUE
      WRITE(*,*) ' '
      WRITE(*,*) (ACTNODE(BEST(I)), I = 1,MAXCLIQUE)
      WRITE(*,*) ' '
C     WRITE(*,90) 'ORDER MATRIX    ',SORTTIME
C     WRITE(*,90) 'TRAVERSE TREE   ',TRAVTIME
C     WRITE(*,*)  '                  --------'
C     TOTTIME = SORTTIME + TRAVTIME
C     WRITE(*,90) 'TOTAL TIME      ',TOTTIME
85    FORMAT(1X,A,I10)
90    FORMAT(1X,A,F10.4)
      STOP
      END
 
C     -- IMSL RANDOM NUMBER GENERATOR
 
      REAL FUNCTION GGUBFS (DSEED)
      DOUBLE PRECISION   DSEED
      DOUBLE PRECISION   D2P31M,D2P31
      DATA               D2P31M/2147483647.D0/
      DATA               D2P31 /2147483648.D0/
      DSEED = DMOD(16807.D0*DSEED,D2P31M)
      GGUBFS = DSEED / D2P31
      RETURN
      END
 
C     -- DETERMINE CPU TIME, ISSUE 'GLOBAL TXTLIB UTILITY' FROM CMS 
C     THIS TIMING SUBROUTINE WAS USED FOR AN IBM 3090 MACHINE
 
C     SUBROUTINE SECOND(ECPU)                                           
C     LOGICAL*1 DATTIM(23)                                              
C     REAL*4 ECPU,ETIME,ETCPU                                          
C     INTEGER LD                                                      
C     LD = 23                                                           
C     CALL DATETM(DATTIM,LD,ECPU,ETIME,ETCPU)                          
C     RETURN                                                          
C     END

C--------------------------------------------------------------------------
C     MAX CLIQUE ALGORITHM BASED ON QUADRATIC ZERO-ONE PROGRAMMING
C
C
C  THE ALGORITHM IS DESCRIBED IN DETAILS IN: P.M. PARDALOS AND G.P. RODGERS,
C  A BRANCH AND BOUND ALGORITHM FOR THE MAXIMUM CLIQUE PROBLEM, COMP. AND
C  OPER. RESEARCH, VOL. 19, NO. 5 (1992), PP. 363-375.
C
C
C  AUTHORS          - PANOS M. PARDALOS AND GREGORY P. RODGERS
C
C  WARRANTY         - NO WARRANTY EXPRESSED OR IMPLIED IS APPLICABLE
C
C
C  NOTE: THE ALGORITHM CAN RUN IN PARALLEL 
C        ALL TIMING SUBROUTINES ARE USED FOR THE IBM 3090
C
C  INPUT PARAMETERS:
C  THE NUMBER OF PROCESSORS TO USE (=1 IF NOT RUN IN PARALLEL)
C  N (NUMBER OF VERTICES)
C  DENSTY (A NUMBER BETWEEN 0 AND 1)
C  DSEED (SEED FOR GENERATING RANDOM GRAPHS)
C
C--------------------------------------------------------------------------
C
C@PROCESS DC(STORE)                                                      
      PARAMETER (MAXN=3000,MAXEDG=50000,NWK=500000)
      INTEGER HA,KA,HAT,KAT,N,MAXC,WK,NWK                               
      REAL*8 E1,E2,E3,EHR,EBB                                           
      REAL   T1,T2,T3,THR,TBB,T0,OVH,T00,OMGEN                          
      LOGICAL X                                                         
      COMMON /STORE/ HA(MAXEDG),KA(MAXN+1),HAT(MAXEDG*2),
     >KAT(MAXN+1),X(MAXN),WK(NWK)                                         
      WRITE(*,*) 'ENTER THE NUMBER OF PROCESSORS TO USE'                
      READ(*,*) NPROCS                                                  
C                                                                       
C     GENERATE A RANDOM GRAPH AND CALCULATE TRANSPOSED ADJACENCY MATRIX 
C                                                                       
      CALL SECOND(T00)                                                  
      CALL MGRAPH(N,HA,KA,MAXEDG)                                       
      CALL SECOND(T0)                                                   
      OMGEN = T0-T00                                                    
      CALL TRPOSE(N,HA,KA,HAT,KAT,WK)                                   
C                                                                       
C     HEURISTIC PHASE USING THE GREEDY METHOD                           
C                                                                       
      CALL SECOND(T1)                                                   
      OVH = T1-T0                                                       
      CALL CLOCKX(E1)                                                   
      CALL GREEDY(N,HAT,KAT,MAXC,X,WK,WK(N+1),WK((2*N)+1),              
     >            WK((3*N)+1) )                                         
C                                                                       
C     BRANCH AND BOUND PHASE                                            
C                                                                       
      IHSOL= MAXC                                                       
      CALL SECOND(T2)                                                   
      CALL CLOCKX(E2)                                                   
      IF (NPROCS.NE.0)                                                  
     >CALL BBND(N, HAT,KAT,X,MAXC,WK,NWK,NSUBP,NSUBPG,NPROCS,NCHG)     
C                                                                       
C     FINISH TIMING AND PRINT RESULTS                                   
C                                                                       
      CALL SECOND(T3)                                                   
      CALL CLOCKX(E3)                                                   
      THR = T2-T1                                                       
      TBB = T3-T2                                                       
      EHR = (E2-E1)*0.000001                                            
      EBB = (E3-E2)*0.000001                                            
      RDNSTY = REAL(2*(KA(N+1)-1 )) / REAL(N*(N-1))                     
      WRITE(*,50) 'MATRIX GENERATION CPUTM=',OMGEN                      
      WRITE(*,50) 'TRANSPOSE OVERHEAD     =',OVH                        
      WRITE(*,40) 'PROBLEM DIMENSION      =',N                          
      WRITE(*,40) 'NUMBER OF EDGES        =',KA(N+1)-1                  
      WRITE(*,50) 'REAL DENSITY           =',RDNSTY                     
      WRITE(*,40) 'HEURISTIC IZE  =',IHSOL                      
      WRITE(*,40) 'MAXIMUM IZE    =',MAXC                       
      WRITE(*,40) 'NUMBER OF MIN CHAGES   =',NCHG                       
      WRITE(*,40) 'NUMBER OF SUBPROBLEMS  =',NSUBP                      
      WRITE(*,40) 'MINIMIZER SUBPROBLEM   =',NSUBPG                     
      WRITE(*,50) 'HEURISTIC CPU TIME     =',THR                        
      WRITE(*,50) 'HEURISTIC ELAPSED TIME =',EHR                        
      WRITE(*,50) 'B & B CPU TIME         =',TBB                        
      WRITE(*,50) 'B & B ELAPSED TIME     =',EBB                        
      WRITE(*,*) 'THE VERTICES IN THE CLIQUE ARE'                       
      IPTR = 0                                                          
      DO 10 I=1,N                                                       
         IF (X(I)) THEN                                                 
            IPTR = IPTR+1                                               
            WK(IPTR) = I                                                
         ENDIF                                                          
10    CONTINUE                                                          
      WRITE(*,20) (WK(I),I=1,IPTR)                                      
20    FORMAT(25(10I6,/))                                                
40    FORMAT(1X,A,I12)                                                  
50    FORMAT(1X,A,F12.4)                                                
      END                                                               
C= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      SUBROUTINE MGRAPH(N,HA,KA,MAXEL)                                  
C                                                                       
C     MAKE A RANDOM GRAPH                                               
C                                                                       
      INTEGER    N,HA(*),KA(*)                                          
      DOUBLE PRECISION DSEED                                            
      REAL       DENSTY                                                 
      WRITE(*,*) ' ENTER N,DENSTY,DSEED'                                
      READ(*,*) N,DENSTY,DSEED                                          
C     N      = 200                                                      
C     DENSTY = 0.25                                                     
C     DSEED  = 8651167.D0                                               
      NEDGES = 0                                                        
      DO 20 I=1,N                                                       
         KA(I) = NEDGES + 1                                             
         DO 10 J=I+1,N                                                  
            IF (GGUBFS(DSEED).LT.DENSTY) THEN                           
               NEDGES     = NEDGES + 1                                  
               IF (NEDGES.GT.MAXEL) RETURN                              
               HA(NEDGES) = J                                           
            ENDIF                                                       
10       CONTINUE                                                       
20    CONTINUE                                                          
      KA(N+1) = NEDGES + 1                                              
      RETURN                                                            
C     END OF MGRAPH                                                     
      END                                                               
C= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      SUBROUTINE TRPOSE(N,HA,KA,HAT,KAT,IT)                             
C                                                                       
C     CREATE THE TRANSPOSE GRAPH                                        
C                                                                       
      INTEGER N,HA(*),KA(*),HAT(*),KAT(*),IT(*),NEDGES                  
      NEDGES = KA(N+1)-1                                                
      KAT(N+1) = (2*NEDGES) + 1                                         
C     INITIALIZE KAT WITH SIZE OF EACH ROW OF HA                        
      DO 5 I=1,N                                                        
5        KAT(I)=KA(I+1)-KA(I)                                           
C     COMPUTE SIZE OF ROWS OF HAT                                       
      DO 20 K=1,NEDGES                                                  
         KAT(HA(K))=KAT(HA(K))+1                                        
20    CONTINUE                                                          
C     COMPUTE STARTING POSITIONS OF ROWS OF HAT                         
      DO 10 I=N,1,-1                                                    
         KAT(I) = KAT(I+1) - KAT(I)                                     
10    CONTINUE                                                          
C     INITIALIZE FIRST UNFILLED POSITION IN EACH ROW                    
      DO 30 K=1,N                                                       
         IT(K)=KAT(K)                                                   
30    CONTINUE                                                          
C     FILL LOWER TRIANGULAR PART OF HAT, WHILE UPDATING IT()            
      DO 45 J=1,N                                                       
         DO 40 K=KA(J),KA(J+1)-1                                        
C     HA(K)=VERTEX TO FILL IN THE EDGE IN LOWER TIANG. PART OF HAT      
C     IT(HA(K))=FIRST FREE POSITION FOR VERTEX TO BE FILLED             
            HAT(IT(HA(K)))=J                                            
C     UPDATE FIRST FREE POSITION                                        
            IT(HA(K))=IT(HA(K))+1                                       
40       CONTINUE                                                       
45    CONTINUE                                                          
C     COPY UPPER TRIANGULAR PART FROM HA TO HAT                         
      DO 60 K=1,N                                                       
         DO 50 I=KA(K),KA(K+1)-1                                        
            HAT(IT(K))=HA(I)                                            
            IT(K)=IT(K)+1                                               
50       CONTINUE                                                       
60    CONTINUE                                                          
      RETURN                                                            
C     END OF TRPOSE                                                     
      END                                                               
C= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      SUBROUTINE GREEDY(N,HAT,KAT,NUM1S,X,DEGFRE,FREE,P,DEGFX1)         
      INTEGER    N,HAT(*),KAT(*),NUM1S,DEGFRE(N),P(N),DEGFX1(N)         
      LOGICAL    X(N),FREE(N),VALUE                                     
C                                                                       
      IMAX = 1                                                          
      DO 10 I=1,N                                                       
         P(I) = I                                                       
         DEGFRE(I) = KAT(I+1)-KAT(I)                                    
         IF (DEGFRE(I).GT.DEGFRE(IMAX)) IMAX= I                         
         DEGFX1(I) = 0                                                  
         FREE(I) = .TRUE.                                               
10    CONTINUE                                                          
C                                                                       
C     PUT THE HIGHEST CONNECTED NODE INTO THE GREEDY            
      NUM1S      = 0                                                    
      X(IMAX)    = .TRUE.                                               
      P(1)       = IMAX                                                 
      P(IMAX)    = 1                                                    
      FREE(IMAX) = .FALSE.                                              
C                                                                       
      LEV  = 1                                                          
20    CONTINUE                                                          
         LEVP1 = LEV+1                                                  
C    --- UPDATE THE VECTORS DEGFRE, DEGFX1, AND NUM1S                   
         LP = P(LEV)                                                    
C        LP WAS THE LAST VARIABLE THAT WAS FIXED                        
         IF (X(LP)) THEN                                                
            NUM1S = NUM1S+1                                             
            DO 70 K=KAT(LP),KAT(LP+1)-1                                 
               J = HAT(K)                                               
               IF (FREE(J)) THEN                                        
                  DEGFRE(J)  = DEGFRE(J)  - 1                           
                  DEGFX1(J)  = DEGFX1(J)  + 1                           
               ENDIF                                                    
70          CONTINUE                                                    
         ELSE                                                           
C           LAST VERTEX WAS THROWN OUT SO DONT BOTHER WITH DEGFX1       
            DO 90 K=KAT(LP),KAT(LP+1)-1                                 
               DEGFRE(HAT(K)) = DEGFRE(HAT(K)) - 1                      
90          CONTINUE                                                    
         ENDIF                                                          
         IF (LEV.EQ.N) GOTO 1000                                        
C                                                                       
C    --- DETERMINE IF ANY VARIABLE CAN BE FIXED                         
         DO 130 I=LEVP1,N                                               
            IP = P(I)                                                   
C                                                                       
C           TWO TESTS TO SEE IF NODE IP CAN BE FIXED                    
C                                                                       
C       -1- IS IT DISCONNECTED TO A NODE CURRENTLY FIXED TO ONE?        
            IF (DEGFX1(IP).LT.NUM1S) THEN                               
               VALUE = .FALSE.                                          
               IVAR = I                                                 
               GOTO 150                                                 
            ENDIF                                                       
C                                                                       
C       -2- AFTER THE 1ST TEST WE KNOW IP IS CONNECTED TO               
C           ALL NODES FIXED TO ONE.  SO NOW WE CAN TEST IF IT           
C           IS CONNECTED TO ALL REMAINING FREE NODES.  IF IT IS         
C           THEN FIX IP TO 1                                            
            IF (DEGFRE(IP).GE.N-LEVP) THEN                              
               VALUE = .TRUE.                                           
               IVAR = I                                                 
               GOTO 150                                                 
            ENDIF                                                       
C                                                                       
130      CONTINUE                                                       
C                                                                       
C    --- NONE COULD BE FORCED SO FIND VARIABLE WITH HIGHEST DEGREE      
         IVAR   = LEVP1                                                 
         DO 140 I=LEVP1+1,N                                             
            IF (DEGFRE(P(I)).GT.DEGFRE(P(IVAR))) IVAR=I                 
               IVAR = I                                                 
140      CONTINUE                                                       
C                                                                       
C    --- SET TO ONE AND STACK THE SUBPROBLEM WITH X(IP) = 0             
         VALUE = .TRUE.                                                 
C                                                                       
C    --- IVAR IS NEW FIXED VARIABLE, INCREASE LEV & SWAP IN P           
150      LEV      = LEVP1                                               
         IT       = P(IVAR)                                             
         P(IVAR)  = P(LEV)                                              
         P(LEV)   = IT                                                  
         X(IT)    = VALUE                                               
         FREE(IT) = .FALSE.                                             
         GOTO 20                                                        
1000  CONTINUE                                                          
      RETURN                                                            
C     END GREEDY                                                        
      END                                                               
C = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
      SUBROUTINE COPYL(N,LFROM,LTO)                                     
      LOGICAL LFROM(N),LTO(N)                                           
      INTEGER N                                                         
      DO 10 I=1,N                                                       
         LTO(I) = LFROM(I)                                              
10    CONTINUE                                                          
      RETURN                                                            
C     END OF COPYL                                                      
      END                                                               
C = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
      SUBROUTINE BBND(N, HAT,KAT,XMIN,MAXC,IWK,NWK,NSUBP,NSUBPG,NPROCS,
     >   NCHG)                                                          
C     IMPLICIT LOGICAL (A-Z)                                            
      INTEGER N,NWK,HAT(*),KAT(*),MAXC,IWK(NWK),NSUBP,NSUBPG,NPROCS     
      LOGICAL XMIN(N)                                                   
C                                                                       
C     LOCAL VARIABLES                                                   
      INTEGER CSUBP,CYCLES                                              
      INTEGER NBUSY,NFREE,BUSY(6),FREE(6),STRWK(6),SPLIT(6)             
      INTEGER LDX,LDF,LSTK,LP,LX,LFR,LXM,LTOP,LLEV,LMIN,LNSB,LNSG,LNWK, 
     >        LEND                                                      
      INTEGER NSPLIT,IPT,IPTZ,IPTY,IMIN,IMAX,MINSPL,WSIZE,Y,Z,I,MINSB   
      LOGICAL PREMPT,NEWMAX                                             
C                                                                       
C   --- INITIALIZE STATISTICS                                           
      NCHG   = 0                                                        
      NSUBP  = 0                                                        
      NSUBPG = 0                                                        
      CSUBP  = 0                                                        
      CYCLES = 0                                                        
C                                                                       
C   --- INITILIZE THE MININUM # OF SUBPROBLEMS TO SOLVE IN EACH CYCLE   
      MINSB = 800                                                       
C                                                                       
C   --- DIVIDE WORKSPACE AMONG NPROCS PROCESSORS                        
C                                                                       
      WSIZE = NWK/NPROCS                                                
      STRWK(1) = 0                                                      
      DO 10 I=2,NPROCS                                                  
         STRWK(I) = STRWK(I-1)+WSIZE                                    
10    CONTINUE                                                          
C                                                                       
C   --- SET UP STORAGE POINTERS                                         
      LDX =  1                                                          
      LDF =  LDX + (   N    )                                           
      LSTK=  LDF + (   N    )                                           
      LP  = LSTK + ( 3*(N+1))                                           
      LX  =   LP + (   N    )                                           
      LFR =   LX + (   N    )                                           
      LXM =  LFR + (   N    )                                           
      LTOP=  LXM + (   N    )                                           
      LLEV= LTOP + (   1    )                                           
      LMIN= LLEV + (   1    )                                           
      LNSB= LMIN + (   1    )                                           
      LNSG= LNSB + (   1    )                                           
      LNWK= LNSG + (   1    )                                           
      LEND= LNWK + (   1    )                                           
      IF (LEND.GE.WSIZE) THEN                                           
         WRITE(6,200) LEND*NPROCS,NWK                                   
         RETURN                                                         
      ENDIF                                                             
C                                                                       
C   --- INITIALIZE SUBPROBLEM 1                                         
      DO 20 I=1,N                                                       
         IWK(LP+I-1)= I                                                 
20    CONTINUE                                                          
      IWK(LTOP)=  1                                                     
      IWK(LSTK)= -1                                                     
      IWK(LLEV)=  0                                                     
      IWK(LNWK)=  0                                                     
      IWK(LMIN)= MAXC                                                   
C                                                                       
C   --- SET UP BUSY AND FREE LISTS                                      
      NBUSY     = 1                                                     
      BUSY(1)   = 1                                                     
      NFREE     = NPROCS-1                                              
      DO 30 I=1,NFREE                                                   
         FREE(I) = I+1                                                  
30    CONTINUE                                                          
C-----------------------------------------------------------------------
C                                                                       
C     SPLIT SUBPROBLEMS TILL ALL PROCS ARE MARKED BUSY                  
C                                                                       
C-----------------------------------------------------------------------
C     WHILE (NBUSY.LT.NPROCS.AND.NBUSY.GT.0)                            
1000  IF (NBUSY.LT.NPROCS.AND.NBUSY.GT.0) THEN                          
C                                                                       
C        FIND ALL THE SPLIT POINTS IN THE NBUSY SUBPROBLEMS             
         NSPLIT=0                                                       
         DO 40 I=1,NBUSY                                                
            IPT = STRWK(BUSY(I))                                        
C           IS THE TOP OF THE STACK GREATER THAN 1?                     
            IF (IWK(IPT+LTOP).GT.1) THEN                                
C              GET THE LEVEL FROM THE TOP ELEMENT OF THE STACK          
               SPLIT(I) = IWK(IPT + LSTK + 3)                           
               NSPLIT   = NSPLIT  + 1                                   
            ELSE                                                        
               SPLIT(I) = 0                                             
            ENDIF                                                       
40       CONTINUE                                                       
C                                                                       
         IF (NSPLIT.EQ.0) THEN                                          
C           IF THERE ARE NO PROBLEMS TO SPLIT THEN FORCE SPLITTING      
C           OF THE FIRST PROCESS IN THE BUSY LIST BY (RE)STARTING       
C           THE BRANCH AND BOUND ALGORITHM                              
50          IPT = STRWK(BUSY(1))                                        
            CALL BBSPL1(N,HAT,KAT,WSIZE,IWK(IPT+1),NCHG)                
            NSUBP = NSUBP + IWK(IPT+LNSB)                               
            CSUBP = CSUBP + IWK(IPT+LNSB)                               
C           DID BBSPL1 FIND A NEW MINIMUM ?                             
            IF (IWK(IPT+LMIN).GT.MAXC) THEN                             
               MAXC = IWK(IPT+LMIN)                                     
               CALL COPYL(N,IWK(IPT+LXM),XMIN)                          
               DO 60 Y=1,NPROCS                                         
                  IWK(STRWK(Y)+LMIN) = MAXC                             
60             CONTINUE                                                 
               NSUBPG = CSUBP + IWK(IPT+LNSG)                           
            ENDIF                                                       
C           DID BBSPL1 SOLVE THE PROBLEM ?                              
            IF (IWK(IPT+LLEV).EQ.-1) THEN                               
C              ATTEMPTED SPLIT SOLVED THE PROBLEM                       
C              TAKE Y OFF BUSY LIST AND ADD IT TO THE FREE LIST         
               NFREE = NFREE + 1                                        
               NBUSY = NBUSY - 1                                        
               FREE(NFREE) = BUSY(1)                                    
               DO 70  I=1,NBUSY                                         
                  BUSY(I) = BUSY(I+1)                                   
70             CONTINUE                                                 
C              GO BACK AND TRY TO SPLIT ANOTHER SUBPROBLEM              
               IF (NBUSY.GT.0) GOTO 50                                  
            ELSE                                                        
C              NO, THEN A NEW SPLIT POINT WAS FOUND                     
               SPLIT(1) = IWK(IPT + LSTK + 3)                           
               NSPLIT = 1                                               
            ENDIF                                                       
         ENDIF                                                          
C                                                                       
         IF (NBUSY.EQ.0) GOTO 3000                                      
C                                                                       
C        NSPLIT PROBLEMS ARE NOW SPLITABLE                              
C        FIND LOWEST SPLITPOINT (HIGHEST PT IN TREE) AND SPLIT          
         IMIN   = 0                                                     
         MINSPL = N+1                                                   
C        EXAMINE SPLITPOINTS OF ALL BUSY SUBPROBLEMS                    
         DO 80 I=1,NBUSY                                                
            IF (SPLIT(I).NE.0.AND.SPLIT(I).LT.MINSPL) THEN              
               IMIN = I                                                 
               MINSPL = SPLIT(IMIN)                                     
            ENDIF                                                       
80       CONTINUE                                                       
C                                                                       
C      --- NOW SPLIT THE PROCESS DENOTED BY BUSY(IMIN)                  
         Y = BUSY(IMIN)                                                 
         Z = FREE(NFREE)                                                
         IPTY = STRWK(Y)                                                
         IPTZ = STRWK(Z)                                                
C        TAKE Z OFF FREE LIST AND ADD IT TO THE BUSY LIST               
         NFREE = NFREE - 1                                              
         NBUSY = NBUSY + 1                                              
         BUSY(NBUSY) = Z                                                
C                                                                       
C      --- INITIALIZE SUBPROBLEM Z FROM SUBPROBLEM Y                    
C        PERMUTATION VECTOR P                                           
         DO 90 I=1,N                                                    
            IWK((IPTZ+LP-1)+I)= IWK((IPTY+LP-1)+I)                      
90       CONTINUE                                                       
C        INITIALIZE TOP OF STACK AND STACK AS EMPTY                     
         IWK(IPTZ+LTOP) =  1                                            
         IWK(IPTZ+LSTK) = -1                                            
         IWK(IPTZ+LNWK) =  0                                            
C        LEVEL OF EXECUTION                                             
         IWK(IPTZ+LLEV) =  SPLIT(IMIN)                                  
C        INCUMBENT                                                      
         IWK(IPTZ+LMIN)= MAXC                                           
C        ZERO-ONE VARIABLES X                                           
         CALL COPYL(N,IWK(IPTY+LX),IWK(IPTZ+LX))                        
C        CHANGE ONE X VARIABLE                                          
         CALL CHANGL(IWK(IPTZ+LX),IWK(IPTZ+LP),SPLIT(IMIN))             
C        -->  SUBROUTINE CHANGL(X,P,LEV)                                
C        -->  X(P(LEV)) = .NOT.X(P(LEV))                                
C        REMOVE SUBPROBLEM FROM Y'S STACK                               
         CALL PLLSTK(IWK(IPTY+LTOP),IWK(IPTY+LSTK))                     
         IWK(IPTY+LNWK) =  0                                            
C        -->  SUBROUTINE PLLSTK(TOPSTK,STACK)                           
C        -->  INTEGER TOPSTK,STACK(3,*)                                 
      GOTO 1000                                                         
      ENDIF                                                             
C     ENDWHILE(NBUSY.LT.NPROCS.AND.NBUSY.GT.0)                          
C                                                                       
C-----------------------------------------------------------------------
C                                                                       
C     SOLVE SUBPROBLEMS IN PARALLEL                                     
C                                                                       
C-----------------------------------------------------------------------
C     WHILE (NBUSY.EQ.NPROCS)                                           
2000  IF (NBUSY.EQ.NPROCS) THEN                                         
C        EXECUTE NPROCS IN PARALEL   THIS IS CALLED ONE CYCLE           
C        EACH PROC WILL SEARCH ITS SUBPROBLEM FOR MAXVT VERTICES        
         CYCLES = CYCLES + 1                                            
         PREMPT = .FALSE.                                               
         DO 100 Y=1,NPROCS-1                                            
            IPT = STRWK(Y)+1                                            
C           SOLVE SUBPROBLEM Y                                          
            CALL BBP(N,HAT,KAT,MINSB,WSIZE,IWK(IPT),PREMPT,NCHG)        
CCCC        CALL DSPTCH('BBP',N,HAT,KAT,MINSB,WSIZE,IWK(IPT),PREMPT)    
100      CONTINUE                                                       
         IPT = STRWK(NPROCS)+1                                          
         CALL BBP(N,HAT,KAT,MINSB,WSIZE,IWK(IPT),PREMPT,NCHG)           
C                                                                       
C        SYNCHRONIZE SUBPROBLEMS (WAIT FOR ALL TO FINISH)               
CCCC     IF (NPROCS.GT.1) CALL SYNCRO                                   
C-----------------------------------------------------------------------
C                                                                       
C        ANALYSIS AND SYNCHRONIZATION PHASE                             
C                                                                       
C-----------------------------------------------------------------------
         NBUSY  = 0                                                     
         NFREE  = 0                                                     
         NEWMAX = .FALSE.                                               
         IMAX   = 0                                                     
         DO 110 Y=1,NPROCS                                              
            IPT = STRWK(Y)                                              
C           IWK(IPT+LNSB)IS THE # OF SUBPROBLEMS SOLVED FOR THIS PROBLEM
            NSUBP = NSUBP + IWK(IPT+LNSB)                               
C           FIND WHICH PROBLEM DID THE MOST TO CALCULATE CRITICAL PATH  
            IF (IWK(IPT+LNSB).GT.IMAX) IMAX=IWK(IPT+LNSB)               
            IF (IWK(IPT+LMIN).GT.MAXC) THEN                             
               NSUBPG = CSUBP + IWK(IPT+LNSG)                           
               NEWMAX = .TRUE.                                          
               MAXC   = IWK(IPT+LMIN)                                   
               CALL COPYL(N,IWK(IPT+LXM),XMIN)                          
            ENDIF                                                       
            IF (IWK(IPT+LLEV).NE.-1) THEN                               
               NBUSY = NBUSY + 1                                        
               BUSY(NBUSY) = Y                                          
            ELSE                                                        
               NFREE = NFREE + 1                                        
               FREE(NFREE) = Y                                          
            ENDIF                                                       
110      CONTINUE                                                       
C        KEEP TRACK OF CRITICAL PATH COUNT OF SUBPROBLEMS               
         CSUBP = CSUBP + IMAX                                           
C                                                                       
C        UPDATE NEW BOUND IF ONE WAS FOUND                              
         IF (NEWMAX) THEN                                               
            DO 120 Y=1,NPROCS                                           
               IWK(STRWK(Y)+LMIN) = MAXC                                
120         CONTINUE                                                    
         ENDIF                                                          
      GOTO 2000                                                         
      ENDIF                                                             
C     ENDWHILE(NBUSY.EQ.NPROCS)                                         
C                                                                       
C     REPEAT UNTIL ALL SUBPROBLEMS HAVE BEEN SOLVED (NBUSY.EQ.0)        
      IF (NBUSY.NE.0) GOTO 1000                                         
C--------------------------------------------------------------------   
C                                                                       
C     END OF CYETURN TO Q01                                     
C                                                                       
C--------------------------------------------------------------------   
3000  CONTINUE                                                          
      WRITE(*,*) 'PROBLEM SOLVED IN ',CYCLES,' CYCLES'                  
      WRITE(*,*) 'CRITICAL PATH SUBPROBLEM COUNT = ',CSUBP              
200   FORMAT(' NOT ENOUGH WORKSPACE:',I8,' NEEDED',I8,' SPECIFIED')     
      RETURN                                                            
C                                                                       
C     END OF                                                    
      END                                                               
C= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      SUBROUTINE CHANGL(X,P,LEV)                                        
C                                                                       
C     CHANGE THE ZERO-ONE VALUE IN X(P(LEV))                            
C                                                                       
      INTEGER P(*),LEV                                                  
      LOGICAL X(*)                                                      
      X(P(LEV)) = .NOT.X(P(LEV))                                        
      RETURN                                                            
C                                                                       
C     END OF CHANGL                                                     
      END                                                               
C= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      SUBROUTINE PLLSTK(TOPSTK,STACK)                                   
C                                                                       
C     PULL THE TOP MOST ELEMENT OFF OF THE STACK                        
C                                                                       
      INTEGER TOPSTK,STACK(3,*)                                         
      TOPSTK = TOPSTK-1                                                 
C     -1 IS AT TOP OF STACK.  DO NOT TOUCH IT                           
      DO 10 I=2,TOPSTK                                                  
         STACK(1,I) = STACK(1,I+1)                                      
         STACK(2,I) = STACK(2,I+1)                                      
C        CAUSE BOUNDS TO BE RECALCULATED (SAVE SYNCHRONIZATION TIME)    
         STACK(3,I) = -1                                                
10    CONTINUE                                                          
      RETURN                                                            
C                                                                       
C     END OF PLLSTK                                                     
      END                                                               
C= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      SUBROUTINE BBP(N,HAT,KAT,MINSB,NWK,IWK,PREMPT,NCHG)               
      INTEGER N,HAT(*),KAT(*),MINSB,NWK,IWK(NWK)                        
      LOGICAL PREMPT                                                    
C                                                                       
C     LOCAL VARIABLES                                                   
      INTEGER MAXWK                                                     
C   --- SET UP STORAGE POINTERS                                         
      LDX =  1                                                          
      LDF =  LDX + (   N    )                                           
      LSTK=  LDF + (   N    )                                           
      LP  = LSTK + ( 3*(N+1))                                           
      LX  =   LP + (   N    )                                           
      LFR =   LX + (   N    )                                           
      LXM =  LFR + (   N    )                                           
      LTOP=  LXM + (   N    )                                           
      LLEV= LTOP + (   1    )                                           
      LMIN= LLEV + (   1    )                                           
      LNSB= LMIN + (   1    )                                           
      LNSG= LNSB + (   1    )                                           
      LNWK= LNSG + (   1    )                                           
      LEND= LNWK + (   1    )                                           
      MAXWK = NWK-LEND                                                  
      CALL BB(N,HAT,KAT,MINSB,MAXWK,                                    
     >    IWK(LDX),IWK(LDF),IWK(LSTK),IWK(LP),IWK(LX),                  
     >    IWK(LFR),IWK(LXM),                                            
     >    IWK(LTOP),IWK(LLEV),IWK(LMIN),IWK(LNSB),IWK(LNSG),IWK(LNWK),  
     >    IWK(LEND),PREMPT,NCHG)                                        
      RETURN                                                            
C                                                                       
C     END OF BBP                                                        
C = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
      END                                                               
CPROCESS VECTOR(REPORT) DIRECTIVE('*VDIR:')                             
      SUBROUTINE BB(N,HAT,KAT,MAXS,MAXWK,                               
     >              DEGFX1,DEGFRE,STACK,P,X,FREE,XMIN,                  
     >              TOPSTK,LEV,MAXC,NSUBP,NSUBPG,ENDWK,                 
     >              IWK,PREMPT,NCHG)                                    
C                                                                       
C  PARAMETERS                                                           
      INTEGER N,MAXS,MAXWK,TOPSTK,LEV,MAXC,NSUBP,NSUBPG,ENDWK           
      INTEGER HAT(*),KAT(*),DEGFX1(N),DEGFRE(N),STACK(3,N),P(N),        
     >        IWK(MAXWK)                                                
      LOGICAL X(N),XMIN(N),FREE(N),PREMPT                               
C                                                                       
C  LOCAL VARIABLES                                                      
      INTEGER G,LEVP1,IP,LP,I,J,IT,DGNEED,NUM1S,NMLEVP                  
      INTEGER NFREE,NEWEWK,ITEMP,IPTR,IVAR                              
      LOGICAL USELST,VALUE                                              
C                                                                       
C*VDIR:  PREFER SCALAR ON                                               
      NSUBP  = 0                                                        
      NSUBPG = 0                                                        
      USELST = .FALSE.                                                  
C     CALCULATE THE UPPER BOUND ON MAXC, G                              
      G = N                                                             
      DO 10 I=1,LEV                                                     
         IP = P(I)                                                      
         FREE(IP) = .FALSE.                                             
         IF(.NOT.X(IP)) G = G-1                                         
10    CONTINUE                                                          
      DO 20 I=LEV+1,N                                                   
         FREE(P(I)) = .TRUE.                                            
20    CONTINUE                                                          
                                                                        
30    IF (LEV.EQ.-1.OR.(NSUBP.GE.MAXS.AND.PREMPT)) GOTO 1000            
C                                                                       
         LEVP1  = LEV    + 1                                            
C                                                                       
         IF (G.LE.MAXC.OR.LEV.EQ.N) THEN                                
C                                                                       
C           TERMINAL NODE FOUND                                         
C                                                                       
C         --- CHECK TO SEE IF IT WAS A LEAF                             
            IF (G.GT.MAXC) THEN                                         
               MAXC = G                                                 
               DO 40 J=1,N                                              
                  XMIN(J) = X(J)                                        
40             CONTINUE                                                 
               NSUBPG = NSUBP+1                                         
               NCHG = NCHG+1                                            
            ENDIF                                                       
C                                                                       
C         --- GET NEW SUBPROBLEM FROM THE STACK                         
            LEV    = STACK(1,TOPSTK)                                    
            G      = STACK(2,TOPSTK)                                    
            ITEMP  = STACK(3,TOPSTK)                                    
            TOPSTK = TOPSTK - 1                                         
            IF (LEV.NE.-1) THEN                                         
               X(P(LEV)) = (.NOT.X(P(LEV)))                             
               DO 50 I=LEV+1,N                                          
                  FREE(P(I)) = .TRUE.                                   
50             CONTINUE                                                 
C         ---  GET DEGREE COUNTS FROM STORAGE IF THERE WAS ENOUGH ROOM  
               IF (ITEMP.NE.-1) THEN                                    
                  ENDWK = ITEMP                                         
                  ITEMP = ENDWK + (N-LEV)                               
                  IPTR = 0                                              
                  DO 55 I=1,N                                           
                     IF (FREE(I)) THEN                                  
                        IPTR = IPTR+1                                   
C                       THE FREE LIST IN P IS NOW IN ORDER              
                        P(LEV+IPTR) = I                                 
                        DEGFRE(I) = IWK(ENDWK+IPTR)                     
                        DEGFX1(I) = IWK(ITEMP+IPTR)                     
                     ENDIF                                              
55                CONTINUE                                              
                  USELST = .TRUE.                                       
               ELSE                                                     
C                 THERE WASN'T ENOUGH ROOM, COUNTS MUST BE RECALCULATED 
                  USELST = .FALSE.                                      
               ENDIF                                                    
            ENDIF                                                       
            NSUBP = NSUBP + 1                                           
C                                                                       
         ELSE                                                           
C                                                                       
C           PROCEED DEPTH FIRST                                         
C                                                                       
C         --- CALCULATE THE DEGREE OF FREE NODES TO FREE NODES          
            IF (USELST) THEN                                            
               LP = P(LEV)                                              
C              LP WAS THE LAST VARIABLE THAT WAS FIXED                  
               IF (X(LP)) THEN                                          
C*VDIR: PREFER VECTOR                                                   
C*VDIR: IGNORE RECRDEPS(DEGFRE,DEGFX1)                                  
                  DO 70 K=KAT(LP),KAT(LP+1)-1                           
                     DEGFRE(HAT(K))  = DEGFRE(HAT(K))  - 1              
                     DEGFX1(HAT(K))  = DEGFX1(HAT(K))  + 1              
70                CONTINUE                                              
               ELSE                                                     
C                 LAST VERTEX WAS THROWN OUT SO DONT BOTHER WITH DEGFX1 
C*VDIR: PREFER VECTOR                                                   
C*VDIR: IGNORE RECRDEPS(DEGFRE)                                         
                  DO 90 K=KAT(LP),KAT(LP+1)-1                           
                     DEGFRE(HAT(K)) = DEGFRE(HAT(K)) - 1                
90                CONTINUE                                              
               ENDIF                                                    
            ELSE                                                        
C              CALCULATE FREE NODE CONNECTIVITY FROM SCRATCH            
               DO 120 I = LEVP1,N                                       
                  IP = P(I)                                             
                  DEGFRE(IP) = 0                                        
                  DEGFX1(IP) = 0                                        
                  DO 110 K=KAT(IP),KAT(IP+1)-1                          
                     J = HAT(K)                                         
                     IF (FREE(J)) THEN                                  
                        DEGFRE(IP) = DEGFRE(IP) + 1                     
                     ELSE                                               
                        IF (X(J)) DEGFX1(IP) = DEGFX1(IP) + 1           
                     ENDIF                                              
110               CONTINUE                                              
120            CONTINUE                                                 
            ENDIF                                                       
C                                                                       
C         --- DETERMINE IF ANY VARIABLE CAN BE FIXED                    
            NUM1S = LEV + G - N                                         
            DGNEED = MAXC - NUM1S -1                                    
            NMLEVP = N - LEVP1                                          
            DO 130 I=LEVP1,N                                            
               IP = P(I)                                                
C                                                                       
C              THREE TESTS TO SEE IF NODE IP CAN BE FIXED               
C                                                                       
C            -1- IS IT DISCONNECTED TO A NODE CURRENTLY FIXED TO ONE?   
               IF (DEGFX1(IP).LT.NUM1S) THEN                            
                  VALUE = .FALSE.                                       
                  IVAR = I                                              
                  G = G - 1                                             
                  GOTO 150                                              
               ENDIF                                                    
C                                                                       
C            -2- AFTER THE 1ST TEST WE KNOW IP IS CONNECTED TO          
C                ALL NODES FIXED TO ONE.  SO NOW WE CAN TEST IF IT      
C                IS CONNECTED TO ALL REMAINING FREE NODES.  IF IT IS    
C                THEN FIX IP TO 1                                       
               IF (DEGFRE(IP).GE.NMLEVP) THEN                           
                  VALUE = .TRUE.                                        
                  IVAR = I                                              
                  GOTO 150                                              
               ENDIF                                                    
C                                                                       
C            -3- IS ITS TOTAL DEGREE + 1 SMALLER THAN A KNOWN   
C              EACH FREE NODE NEEDS AT LEAST DEGREE DGNEED TO MAKE      
C              A F SIZE MAXC. IF NOT WE CAN THROW NODE AWAY.    
               IF (DEGFRE(IP).LE.DGNEED) THEN                           
C                 FIX TO 0                                              
                  VALUE = .FALSE.                                       
                  G     = G - 1                                         
                  IVAR  = I                                             
                  GOTO 150                                              
               ENDIF                                                    
C                                                                       
130         CONTINUE                                                    
C                                                                       
C           NOTE: AT THIS POINT WE KNOW THAT ALL FREE NODES ARE         
C                 CONNECTED TO ALL NODES FIXED TO ONE AND THAT THEY     
C                 ARE ALSO DISCONNECTED TO SOME FREE NODES.  SO         
C                 WE MAY CHOOSE VARIABLE TO BRANCH ON BASED ON HOW      
C                 MUCH THEY ARE CONNECTED OR DISCONNECTED TO OTHER      
C                 FREE NODES.                                           
C                                                                       
C         --- NONE COULD BE FIXED SO FIND VARIABLE I TO BRANCH ON.      
CCC           RULE1: CHOOSE NODE WITH HIGHEST FREE CONNECTIVITY         
C             RULE2: CHOOSE NODE WITH LOWEST FREE CONNECTIVITY          
C             RULE 2 IS FASTER IN VERIFYING OPTIMALITY AND IS USED HERE 
C             RULE 1 IS THE GREEDY METHOD.                              
            IVAR   = LEVP1                                              
            DO 140 I=LEVP1+1,N                                          
               IF (DEGFRE(P(I)).LT.DEGFRE(P(IVAR))) IVAR= I             
140         CONTINUE                                                    
C                                                                       
C         --- SET TO ONE AND STACK THE SUBPROBLEM WITH X(IP) = 0        
            VALUE = .TRUE.                                              
            IF (G-1.GT.MAXC) THEN                                       
C              ONLY STACK SUBPROBLEMS THAT ARE NOT SUBOPTIMAL           
               TOPSTK = TOPSTK + 1                                      
               STACK(1,TOPSTK) = LEVP1                                  
               STACK(2,TOPSTK) = G-1                                    
               NFREE = N-LEVP1                                          
               NEWEWK = ENDWK + (NFREE+NFREE)                           
               IF (NEWEWK.LE.MAXWK) THEN                                
                  STACK(3,TOPSTK) = ENDWK                               
                  FREE(P(IVAR)) = .FALSE.                               
                  ITEMP = ENDWK + NFREE                                 
                  IPTR = 0                                              
                  DO 145 I=1,N                                          
C                    NOTE: THE FOLLOWING REQUIRES THAT THE FREE LIST IN 
C                          THE PERMUTATION P BE IN ORDER                
                     IF (FREE(I)) THEN                                  
                        IPTR = IPTR+1                                   
                        IWK(ENDWK+IPTR) = DEGFRE(I)                     
                        IWK(ITEMP+IPTR) = DEGFX1(I)                     
                     ENDIF                                              
145               CONTINUE                                              
                  ENDWK = NEWEWK                                        
               ELSE                                                     
                  STACK(3,TOPSTK) = -1                                  
               ENDIF                                                    
            ENDIF                                                       
C                                                                       
C         --- IVAR IS NEW FIXED VARIABLE, INCREASE LEV & SWAP IN P      
150         LEV      = LEVP1                                            
            IT       = P(IVAR)                                          
            P(IVAR)  = P(LEV)                                           
            P(LEV)   = IT                                               
            X(IT)    = VALUE                                            
            FREE(IT) = .FALSE.                                          
            USELST   = .TRUE.                                           
C                                                                       
         ENDIF                                                          
         GOTO 30                                                        
C                                                                       
1000  PREMPT = .TRUE.                                                   
      RETURN                                                            
C                                                                       
C     END OF BB                                                         
      END                                                               
C = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
      REAL FUNCTION GGUBFS (DSEED)                                      
      DOUBLE PRECISION   DSEED                                          
      DOUBLE PRECISION   D2P31M,D2P31                                   
C     D2P31M=(2**31) - 1                                                
C     D2P31 =(2**31)(OR AN ADJUSTED VALUE)                              
      DATA               D2P31M/2147483647.D0/                          
      DATA               D2P31 /2147483648.D0/                          
      DSEED = DMOD(16807.D0*DSEED,D2P31M)                               
      GGUBFS = DSEED / D2P31                                            
      RETURN                                                            
      END                                                               
C = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = 
      SUBROUTINE SECOND(ECPU)                                           
C                                                                       
C  THIS PROCEDURE USES AN IBM UTILITIY THAT GIVES MANY TIMEING VALUES.  
C  WE ARE ONLY INTERESTED IN THE DOUBLE PRECESION CPU TIME.             
C  SEE EXPLANATION OF OTHER VALUES IN IBM UTILITY MANUAL.               
C  THE FOLLOWING CMS COMMAND MUST BE EXECUTED ONCE BEFORE RUNNING FV??? 
C  TO GET ACCESS TO THE IBM UTILITY DATETM.                             
C                                                                       
C    GLOBAL TXTLIB UTILITY                                              
C                                                                       
C  IT IS SUGGESTED THAT THIS COMMAND BE PUT IN YOUR PROFILE EXEC .      
C                                                                       
      LOGICAL*1 DATTIM(23)                                              
      REAL*4 ECPU,ETIME,ETCPU                                           
      INTEGER LD                                                        
      LD = 23                                                           
      CALL DATETM(DATTIM,LD,ECPU,ETIME,ETCPU)                           
C     ECPU = 0.0                                                        
      RETURN                                                            
      END                                                               
C= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      SUBROUTINE BBSPL1(N,HAT,KAT,NWK,IWK,NCHG)                         
      INTEGER N,HAT(*),KAT(*),NWK,IWK(NWK)                              
C   --- SET UP STORAGE POINTERS                                         
      LDX =  1                                                          
      LDF =  LDX + (   N    )                                           
      LSTK=  LDF + (   N    )                                           
      LP  = LSTK + ( 3*(N+1))                                           
      LX  =   LP + (   N    )                                           
      LFR =   LX + (   N    )                                           
      LXM =  LFR + (   N    )                                           
      LTOP=  LXM + (   N    )                                           
      LLEV= LTOP + (   1    )                                           
      LMIN= LLEV + (   1    )                                           
      LNSB= LMIN + (   1    )                                           
      LNSG= LNSB + (   1    )                                           
      LNWK= LNSG + (   1    )                                           
      LEND= LNWK + (   1    )                                           
      MAXWK = NWK-LEND                                                  
C     BBSPL2 WILL STOP AFTER THE FIRST SUBPROBLEM IS STACKED            
      CALL BBSPL2(N,HAT,KAT,MAXWK,                                      
     >    IWK(LDX),IWK(LDF),IWK(LSTK),IWK(LP),IWK(LX),                  
     >    IWK(LFR),IWK(LXM),                                            
     >    IWK(LTOP),IWK(LLEV),IWK(LMIN),IWK(LNSB),IWK(LNSG),IWK(LNWK),  
     >    IWK(LEND),NCHG)                                               
      RETURN                                                            
C                                                                       
C     END OF BBSPL1                                                     
C= = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = = =
      END                                                               
CPROCESS VECTOR(REPORT) DIRECTIVE('*VDIR:')                             
      SUBROUTINE BBSPL2(N,HAT,KAT,MAXWK,                                
     >              DEGFX1,DEGFRE,STACK,P,X,FREE,XMIN,                  
     >              TOPSTK,LEV,MAXC,NSUBP,NSUBPG,ENDWK,IWK,NCHG)        
C                                                                       
C  PARAMETERS                                                           
      INTEGER N,MAXWK,TOPSTK,LEV,MAXC,NSUBP,NSUBPG,ENDWK                
      INTEGER HAT(*),KAT(*),DEGFX1(N),DEGFRE(N),STACK(3,N),P(N),        
     >        IWK(MAXWK)                                                
      LOGICAL X(N),XMIN(N),FREE(N)                                      
C                                                                       
C  LOCAL VARIABLES                                                      
      INTEGER G,LEVP1,IP,LP,I,J,IT,DGNEED,NUM1S,NMLEVP                  
      INTEGER NFREE,NEWEWK,ITEMP,IPTR,IVAR                              
      LOGICAL USELST,VALUE                                              
C*VDIR: PREFER SCALAR ON                                                
C                                                                       
      NSUBP  = 0                                                        
      NSUBPG = 0                                                        
      USELST = .FALSE.                                                  
C     CALCULATE THE UPPER BOUND ON MAXC, G                              
      G = N                                                             
      DO 10 I=1,LEV                                                     
         IP = P(I)                                                      
         FREE(IP) = .FALSE.                                             
         IF(.NOT.X(IP)) G = G-1                                         
10    CONTINUE                                                          
      DO 20 I=LEV+1,N                                                   
         FREE(P(I)) = .TRUE.                                            
20    CONTINUE                                                          
                                                                        
30    IF (LEV.EQ.-1.OR.TOPSTK.GT.1) GOTO 1000                           
C                                                                       
         LEVP1  = LEV    + 1                                            
C                                                                       
         IF (G.LE.MAXC.OR.LEV.EQ.N) THEN                                
C                                                                       
C           TERMINAL NODE FOUND                                         
C                                                                       
C         --- CHECK TO SEE IF IT WAS A LEAF                             
            IF (G.GT.MAXC) THEN                                         
               MAXC = G                                                 
               DO 40 J=1,N                                              
                  XMIN(J) = X(J)                                        
40             CONTINUE                                                 
               NSUBPG = NSUBP+1                                         
               NCHG = NCHG + 1                                          
            ENDIF                                                       
C                                                                       
C         --- GET NEW SUBPROBLEM FROM THE STACK                         
            LEV    = STACK(1,TOPSTK)                                    
            G      = STACK(2,TOPSTK)                                    
            ITEMP  = STACK(3,TOPSTK)                                    
            TOPSTK = TOPSTK - 1                                         
            IF (LEV.NE.-1) THEN                                         
               X(P(LEV)) = (.NOT.X(P(LEV)))                             
               DO 50 I=LEV+1,N                                          
                  FREE(P(I)) = .TRUE.                                   
50             CONTINUE                                                 
C         ---  GET DEGREE COUNTS FROM STORAGE IF THERE WAS ENOUGH ROOM  
               IF (ITEMP.NE.-1) THEN                                    
                  ENDWK = ITEMP                                         
                  ITEMP = ENDWK + (N-LEV)                               
                  IPTR = 0                                              
                  DO 55 I=1,N                                           
                     IF (FREE(I)) THEN                                  
                        IPTR = IPTR+1                                   
C                       THE FREE LIST IN P IS NOW IN ORDER              
                        P(LEV+IPTR) = I                                 
                        DEGFRE(I) = IWK(ENDWK+IPTR)                     
                        DEGFX1(I) = IWK(ITEMP+IPTR)                     
                     ENDIF                                              
55                CONTINUE                                              
                  USELST = .TRUE.                                       
               ELSE                                                     
C                 THERE WASN'T ENOUGH ROOM, COUNTS MUST BE RECALCULATED 
                  USELST = .FALSE.                                      
               ENDIF                                                    
            ENDIF                                                       
            NSUBP = NSUBP + 1                                           
C                                                                       
         ELSE                                                           
C                                                                       
C           PROCEED DEPTH FIRST                                         
C                                                                       
C         --- CALCULATE THE DEGREE OF FREE NODES TO FREE NODES          
            IF (USELST) THEN                                            
               LP = P(LEV)                                              
C              LP WAS THE LAST VARIABLE THAT WAS FIXED                  
               IF (X(LP)) THEN                                          
C*VDIR: PREFER VECTOR                                                   
C*VDIR: IGNORE RECRDEPS(DEGFRE,DEGFX1)                                  
                  DO 70 K=KAT(LP),KAT(LP+1)-1                           
                     DEGFRE(HAT(K))  = DEGFRE(HAT(K))  - 1              
                     DEGFX1(HAT(K))  = DEGFX1(HAT(K))  + 1              
70                CONTINUE                                              
               ELSE                                                     
C                 LAST VERTEX WAS THROWN OUT SO DONT BOTHER WITH DEGFX1 
C*VDIR: PREFER VECTOR                                                   
C*VDIR: IGNORE RECRDEPS(DEGFRE)                                         
                  DO 90 K=KAT(LP),KAT(LP+1)-1                           
                     DEGFRE(HAT(K)) = DEGFRE(HAT(K)) - 1                
90                CONTINUE                                              
               ENDIF                                                    
            ELSE                                                        
C              CALCULATE FREE NODE CONNECTIVITY FROM SCRATCH            
               DO 120 I = LEVP1,N                                       
                  IP = P(I)                                             
                  DEGFRE(IP) = 0                                        
                  DEGFX1(IP) = 0                                        
                  DO 110 K=KAT(IP),KAT(IP+1)-1                          
                     J = HAT(K)                                         
                     IF (FREE(J)) THEN                                  
                        DEGFRE(IP) = DEGFRE(IP) + 1                     
                     ELSE                                               
                        IF (X(J)) DEGFX1(IP) = DEGFX1(IP) + 1           
                     ENDIF                                              
110               CONTINUE                                              
120            CONTINUE                                                 
            ENDIF                                                       
C                                                                       
C         --- DETERMINE IF ANY VARIABLE CAN BE FIXED                    
            NUM1S = LEV + G - N                                         
            DGNEED = MAXC - NUM1S -1                                    
            NMLEVP = N - LEVP1                                          
            DO 130 I=LEVP1,N                                            
               IP = P(I)                                                
C                                                                       
C              THREE TESTS TO SEE IF NODE IP CAN BE FIXED               
C                                                                       
C            -1- IS IT DISCONNECTED TO A NODE CURRENTLY FIXED TO ONE?   
               IF (DEGFX1(IP).LT.NUM1S) THEN                            
                  VALUE = .FALSE.                                       
                  IVAR = I                                              
                  G = G - 1                                             
                  GOTO 150                                              
               ENDIF                                                    
C                                                                       
C            -2- AFTER THE 1ST TEST WE KNOW IP IS CONNECTED TO          
C                ALL NODES FIXED TO ONE.  SO NOW WE CAN TEST IF IT      
C                IS CONNECTED TO ALL REMAINING FREE NODES.  IF IT IS    
C                THEN FIX IP TO 1                                       
               IF (DEGFRE(IP).GE.NMLEVP) THEN                           
                  VALUE = .TRUE.                                        
                  IVAR = I                                              
                  GOTO 150                                              
               ENDIF                                                    
C                                                                       
C            -3- IS ITS TOTAL DEGREE + 1 SMALLER THAN A KNOWN   
C              EACH FREE NODE NEEDS AT LEAST DEGREE DGNEED TO MAKE      
C              A F SIZE MAXC. IF NOT WE CAN THROW NODE AWAY.    
               IF (DEGFRE(IP).LE.DGNEED) THEN                           
C                 FIX TO 0                                              
                  VALUE = .FALSE.                                       
                  G     = G - 1                                         
                  IVAR  = I                                             
                  GOTO 150                                              
               ENDIF                                                    
C                                                                       
130         CONTINUE                                                    
C                                                                       
C           NOTE: AT THIS POINT WE KNOW THAT ALL FREE NODES ARE         
C                 CONNECTED TO ALL NODES FIXED TO ONE AND THAT THEY     
C                 ARE ALSO DISCONNECTED TO SOME FREE NODES.  SO         
C                 WE MAY CHOOSE VARIABLE TO BRANCH ON BASED ON HOW      
C                 MUCH THEY ARE CONNECTED OR DISCONNECTED TO OTHER      
C                 FREE NODES.                                           
C                                                                       
C         --- NONE COULD BE FIXED SO FIND VARIABLE I TO BRANCH ON.      
CCC           RULE1: CHOOSE NODE WITH HIGHEST FREE CONNECTIVITY         
C             RULE2: CHOOSE NODE WITH LOWEST FREE CONNECTIVITY          
C             RULE 2 IS FASTER IN VERIFYING OPTIMALITY AND IS USED HERE 
C             RULE 1 IS THE GREEDY METHOD.                              
            IVAR   = LEVP1                                              
            DO 140 I=LEVP1+1,N                                          
               IF (DEGFRE(P(I)).LT.DEGFRE(P(IVAR))) IVAR=I              
140         CONTINUE                                                    
C                                                                       
C         --- SET TO ONE AND STACK THE SUBPROBLEM WITH X(IP) = 0        
            VALUE = .TRUE.                                              
            IF (G-1.GT.MAXC) THEN                                       
C              ONLY STACK SUBPROBLEMS THAT ARE NOT SUBOPTIMAL           
               TOPSTK = TOPSTK + 1                                      
               STACK(1,TOPSTK) = LEVP1                                  
               STACK(2,TOPSTK) = G-1                                    
               NFREE = N-LEVP1                                          
               NEWEWK = ENDWK + (NFREE+NFREE)                           
               IF (NEWEWK.LE.MAXWK) THEN                                
                  STACK(3,TOPSTK) = ENDWK                               
                  FREE(P(IVAR)) = .FALSE.                               
                  ITEMP = ENDWK + NFREE                                 
                  IPTR = 0                                              
                  DO 145 I=1,N                                          
C                    NOTE: THE FOLLOWING REQUIRES THAT THE FREE LIST IN 
C                          THE PERMUTATION P BE IN ORDER                
                     IF (FREE(I)) THEN                                  
                        IPTR = IPTR+1                                   
                        IWK(ENDWK+IPTR) = DEGFRE(I)                     
                        IWK(ITEMP+IPTR) = DEGFX1(I)                     
                     ENDIF                                              
145               CONTINUE                                              
                  ENDWK = NEWEWK                                        
               ELSE                                                     
                  STACK(3,TOPSTK) = -1                                  
               ENDIF                                                    
            ENDIF                                                       
C                                                                       
C         --- IVAR IS NEW FIXED VARIABLE, INCREASE LEV & SWAP IN P      
150         LEV      = LEVP1                                            
            IT       = P(IVAR)                                          
            P(IVAR)  = P(LEV)                                           
            P(LEV)   = IT                                               
            X(IT)    = VALUE                                            
            FREE(IT) = .FALSE.                                          
            USELST   = .TRUE.                                           
C                                                                       
         ENDIF                                                          
         GOTO 30                                                        
C                                                                       
1000  RETURN                                                            
C                                                                       
C     END OF BBSPL2                                                     
      END                                                               

      subroutine datetm(a,b,c,d,e)
      logical*1 a
      integer b
      real*8 c,d,e
      a=.false.
      b=0
      c=0
      d=0
      e=0
      return
      end

      subroutine clockx(a)
      real*8 a
      a=0
      return
      end

      program ggraph
c     ---------------------------------------------------------------
c     generator: max-flow min-cost directed grid graph
c
c     Author: Mauricio G.C. Resende
c             AT&T Bell Laboratories
c             mgcr@research.att.com
c
c     Date: 23 Sep 91
c           01 Feb 92 - modified to generate COST in [1,MAXCOST]
c                                            CAP in [1,MAXCAP]
c 
c     standard input: h, w, MAXCAP, MAXCOST, SEED
c
c     graph has h * w + 2 nodes: source s, sink t and a grid of
c     h by w nodes.
c
c     arcs go from s to h nodes of first grid column
c             from h nodes of last grid column to t
c             from (i,j) to (i+1,j) and (j+1,i) except
c             for last row that go from (i,h) to (i+1,h) and last
c             column that go from (w,j) to t
c
c     arc capacities for grid arcs uniformly distributed [0,MAXCAP]
c                    for s - (1,j) = INFINITY
c                    for (w,j) - t = INFINITY
c
c     arc costs for grid arcs uniformly distributed [0,MAXCOST]
c               for s - (1,j) = 0
c               for (w,j) - t = 0
c     
c     Supply at node s = MAXFLO(s-t)
c     Demand at node t = MAXFLO(s-t)
c     Supply and demands for all other nodes = 0
c
c     Output: DIMACS min format
c
c     Uses subroutines: dnfwd and dnsub to compute max-flow.
c                       Reference: D. Goldbarb, M.D. Grigoriadis,
c                       "A computational comparison of the dinic 
c                       and network simplex methods for maximum flow",
c                       Annals of Operations Research 7, 1988.
c                       
c                       rand - portable pseudo-random number generator.
c                       Reference: L. Schrage, "A More Portable FORTRAN
c                       Random Number Generator", ACM Transactions on
c                       Mathematical Software, June, 1979.
c     
c     ---------------------------------------------------------------

      integer maxh,maxw,maxarc
      parameter (maxh=1000,maxw=1000)
      parameter (maxarc=524273)
      integer caps(maxh),costs(maxh),capt(maxh),costt(maxh)
      integer h,w,maxf,maxc,n1,n2,cap,unif,i,j
      integer nnodes,narcs,snode,tnode,seed,seed0
      integer cost(524273)
      integer v10(maxarc),v20(maxarc),cap0(maxarc),cost0(maxarc)
C
C************START DNSUB STANDARD USER XFACE DECLARATION BLOCK*********
C
C      USER MUST INCLUDE THIS BLOCK INHIS/HER	CALLING	PROGRAM.
C
C   THESE DECLARATIONS ACCOUNT FOR THE ENTIRE ARRAY STORAGE USED BY
C   THE      DNSUB SUBROUTINES, INCLUDING WHAT IS NECESSARY TO STORETHE
C   INPUT DATA.      IT AMOUNTS TO 6*NODES +5*ARCS WORDS, BUT IT MAY BE
C   STATED MORE      PRECISELY AS FOLLOWS:
C
C   1) FOR SOLVING PROBLEMS WITH UP TO 32,765 NODES AND      2,147,483,647
C   ARCS, AND WITH FLOW      VALUES OF UP TO2,147,483,647, IT SUFFICES
C   TO DECLARE ARRAYS AS SHOWN UNDER 'STD ARRANGEMENT' IN THE
C   TABLE BELOW.  THIS ARRANGEMENT IS THE ONE USED IN THE RELEASE
C   VERSION OF THE DNSUB SUBROUTINES.
C
C   2) IN ORDER      TO HANDLE PROBLEMS WITHMORE THAN 32,765 NODES,	ALL
C   INTEGER*2 DECLARATIONS BELOW MUST BE CHANGED TO INTEGER*4 AND
C   THE      DNSUB SUBROUTINES AND USER CALLING PROGRAMS MUST BE COMPILED
C   AND      LINKED.(SEE ALTERNATE 1 BELOW.)
C
C   3) FOR SOLVING ONLY      PROBLEMS WITH AT MOST 32,765 NODES, 32,767
C   ARCS, AND WITH FLOWS NOT EXCEEDING 32,767, ALL INTEGER*4
C   DECLARATIONS BELOW MAY BE CHANGED TO INTEGER*2, AND      THE DNSUB
C   SUBROUTINES       AND USER CALLING PROGRAMS MUSTBE COMPILED AND
C   LINKED. (SEE ALTERNATE 2 BELOW.)  IT IS ALSO NECESSARY TO
C   ACTIVATE THE STATEMENT DNIBIG=32767      in subroutine dnsub, and to
C   include 'implicit INTEGER*2 (i-n)' statements in each program
C   unit.  THIS      ARRANGEMENT, WHICH USESTHE LEAST AMOUNT OF MEMORY
C   AND      IS THE FASTEST when executed on16-BIT PROCESSORS, IS ONLY
C   USEFUL FOR A SET OF      VERY SPECIAL APPLICATIONS.  ITSgeneral
C   use      is not recommended.  OTHER ALTERNATES ARE ALSO POSSIBLE.
C
C  -----------------------------------------------------------------
C
C        STD ARRANGEMENT    ALTERNATE 1      ALTERNATE	2
C      				   (not	recommended)
C        ---------------  ---------------  ----------------
C  ARRAY   LENGTH TYPE EQV'D TYPE  TYPE EQV'D TYPE  TYPE EQV'D TYPE
C  ------  -----    ----  -------  ---- ----- ----  ---- ----- -----
C  DNFAPT    N      4               4                2
C  DNFADJ    A      2               4                2
C  DNCAP     A      4               4                2
C  DNBAPT    N      4               4                2
C  DNBADJ    A      2 DNFROM  2     4 DNFROM  4      2 DNFROM   2
C  DNFLOW    A      4 DNTO    2     4 DNTO    4      2 DNTO     2
C  DNBTOF    A      4 DNGCAP  4     4 DNGCAP  4      2 DNGCAP   2
C  DNPTRF    N      4               4                2
C  DNPTRB    N      4               4                2
C  DNLIST    N      2               4                2
C  DNFLAB    N      4 DNDIST  2     4 DNDIST  4      2 DNDIST   2
C  -----------------------------------------------------------------
C
C  TOTAL BYTES:     22*N + 16*A     24*N + 20*A       12*N + 10*A
C  (N=NODES, A=ARCS)
C  -----------------------------------------------------------------
C
C DIMENSION THESE TO AT LEAST MAX NUMBER OF NODES + 2:
        INTEGER   DNLIST(65538),DNDIST(65538)
        INTEGER   DNFAPT(65538),DNPTRF(65538),DNBAPT(65538),
     *              DNFLAB(65538),DNPTRB(65538)
C DIMENSION THESE TO AT LEAST MAX NUMBER OF ARCS + 1:
      INTEGER DNFADJ(524273),DNFROM(524273),DNTO(524273),DNBADJ(524273)
      INTEGER DNCAP(524273),DNGCAP(524273),DNFLOW(524273),DNBTOF(524273)
C
        COMMON /DN01/DNFAPT/DN02/DNFADJ/DN03/DNCAP/DN04/DNFROM
        COMMON /DN05/DNFLOW/DN06/DNGCAP/DN08/DNPTRF/DN09/DNLIST
        COMMON /DN10/DNBAPT/DN11/DNFLAB/DN12/DNPTRB
C
        INTEGER  DNNODE,NODP12,DNSRCE,DNSINK,I2,II2,K2,J2,IHEAD2,
     *  ITAIL2,QHEAD2,QTAIL2,KP2,KSAT2,DNNOP2,LAYMAX,K2DST,K2DP1,MAXD2
        INTEGER  DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,DNIBIG
        COMMON /DN00/DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,
     *               DNELTM,DNIBIG,DNNODE,DNSRCE,DNSINK,DNNOP2
        EQUIVALENCE (DNFLOW(1),DNTO(1)),(DNFLAB(1),DNDIST(1)),
     *              (DNFROM(1),DNBADJ(1)),(DNGCAP(1),DNBTOF(1))
C
C************END DNSUB STANDARD USER XFACE DECLARATION BLOCK***********
 
      read (5,*) h,w,maxf,maxc,seed
      seed0=seed
      nnodes=h*w+2
      narcs=2*(h-1)*w+w+h
      snode=h*w+1
      tnode=h*w+2
c     for dinic interface
c     ------------------------------------------------------
      nodes = nnodes
      isou=snode
      isnk=tnode
c     ------------------------------------------------------

      numarc=0
      do 1010 i=1,h-1
           numarc=numarc+1
           dnfrom(numarc)=(i-1)*w+1
           dnto(numarc)=dnfrom(numarc)+1
           dngcap(numarc)=unif(maxf,seed)
           cost(numarc)=unif(maxc,seed)
           caps(i)=dngcap(numarc)
           numarc=numarc+1
           dnfrom(numarc)=(i-1)*w+1
           dnto(numarc)=dnfrom(numarc)+w
           dngcap(numarc)=unif(maxf,seed)
           cost(numarc)=unif(maxc,seed)
           caps(i)=caps(i)+dngcap(numarc)
           costs(i)=unif(maxc,seed)
1010  continue
      numarc=numarc+1
      dnfrom(numarc)=(h-1)*w+1
      dnto(numarc)=dnfrom(numarc)+1
      dngcap(numarc)=unif(maxf,seed)
      cost(numarc)=unif(maxc,seed)
      caps(h)=dngcap(numarc)
      costs(h)=unif(maxc,seed)
      do 1020 i=1,h-1
           do 1030 j=2,w-2
                numarc=numarc+1
                dnfrom(numarc)=(i-1)*w+j
                dnto(numarc)=dnfrom(numarc)+1
                dngcap(numarc)=unif(maxf,seed)
                cost(numarc)=unif(maxc,seed)
                numarc=numarc+1
                dnfrom(numarc)=(i-1)*w+j
                dnto(numarc)=dnfrom(numarc)+w
                dngcap(numarc)=unif(maxf,seed)
                cost(numarc)=unif(maxc,seed)
1030       continue
1020  continue
      do 1040 j=2,w-2
           numarc=numarc+1
           dnfrom(numarc)=(h-1)*w+j
           dnto(numarc)=dnfrom(numarc)+1
           dngcap(numarc)=unif(maxf,seed)
           cost(numarc)=unif(maxc,seed)
1040  continue
        
           
      do 1050 i=1,h-1
           numarc=numarc+1
           dnfrom(numarc)=(i-1)*w+w-1
           dnto(numarc)=dnfrom(numarc)+1
           dngcap(numarc)=unif(maxf,seed)
           cost(numarc)=unif(maxc,seed)
           capt(i)=dngcap(numarc)
           numarc=numarc+1
           dnfrom(numarc)=(i-1)*w+w-1
           dnto(numarc)=dnfrom(numarc)+w
           dngcap(numarc)=unif(maxf,seed)
           cost(numarc)=unif(maxc,seed)
           costt(i)=unif(maxc,seed)
1050  continue
      numarc=numarc+1
      dnfrom(numarc)=(h-1)*w+w-1
      dnto(numarc)=dnfrom(numarc)+1
      dngcap(numarc)=unif(maxf,seed)
      cost(numarc)=unif(maxc,seed)
      capt(h)=dngcap(numarc)
      costt(h)=unif(maxc,seed)


      do 1060 i=1,h-1
           numarc=numarc+1
           dnfrom(numarc)=(i-1)*w+w
           dnto(numarc)=dnfrom(numarc)+w
           dngcap(numarc)=unif(maxf,seed)
           cost(numarc)=unif(maxc,seed)
           capt(i+1)=capt(i+1)+dngcap(numarc)
1060  continue

      do 1070 i=1,h
           numarc=numarc+1
           dnfrom(numarc)=h*w+1
           dnto(numarc)=(i-1)*w+1
           dngcap(numarc)=caps(i)
           cost(numarc)=costs(i)
1070  continue

      do 1080 i=1,h
           numarc=numarc+1
           dnfrom(numarc)=i*w
           dnto(numarc)=h*w+2
           dngcap(numarc)=capt(i)
           cost(numarc)=costt(i)
1080  continue

      do 90101 i=1,numarc
         v10(i)=dnfrom(i)
         v20(i)=dnto(i)
         cap0(i)=dngcap(i)
         cost0(i)=cost(i)
90101  continue
      call dnfwd(nodes,narcs,iretn)
      call dnsub(nodes,narcs,isou,isnk,maxflo,numaug,nphase,
     +           nncut,nacut,etime0,iretn)
      write(6,100) h,w
100   format("c    max-flow min-cost on a",i3," by ",i3," grid")
      write(6,105) maxf,maxc,seed0
105   format("c    cap: [0,",i8,"]   cost: [0,",i8,"]   seed:", i10)
      write(6,101) nodes,narcs
101   format("p min ",2i15)
      write(6,103) isou,maxflo
103   format("n ",2i15)
      write(6,103) isnk,-maxflo
      do 9010 i=1,numarc
         write(6,102) v10(i),v20(i),cap0(i),cost0(i)
102      format("a ",2i10," 0 ",2i10)
9010  continue
      
      stop
      end

      integer function unif(max,seed)
      integer max,seed
      real rand
      unif=1+rand(seed)*(max-1)
      return
      end

       real function rand(ix)
c      =================================================================
c      Portable pseudo-random number generator.
c      Reference: l. schrage, "A More Portable FORTRAN
c      Random Number Generator", ACM Transactions on
c      Mathematical Software, June, 1979.
c      =================================================================

       integer*4 a,p,ix,b15,b16,xhi,xalo,leftlo,fhi,k
       data a/16807/,b15/32768/,b16/65536/,p/2147483647/

       xhi=ix/b16
       xalo=(ix-xhi*b16)*a
       leftlo=xalo/b16
       fhi=xhi*a+leftlo
       k=fhi/b15
       ix=(((xalo-leftlo*b16)-p)+(fhi-k*b15)*b16)+k
       if (ix.lt.0) ix=ix+p

       rand=float(ix)*4.656612875e-10

       return
       end

      SUBROUTINE DNSUB(NODES,NARCS,ISOURC,ISINK,MAXFLO,
     *         NUMAUG,NUMSTG,NNCUT,NACUT,ELTIM,IRETN)
C
C************START DNSUB STANDARD USER XFACE DECLARATION BLOCK*********
C
C      USER MUST INCLUDE THIS BLOCK INHIS/HER	CALLING	PROGRAM.
C
C   THESE DECLARATIONS ACCOUNT FOR THE ENTIRE ARRAY STORAGE USED BY
C   THE      DNSUB SUBROUTINES, INCLUDING WHAT IS NECESSARY TO STORETHE
C   INPUT DATA.      IT AMOUNTS TO 6*NODES +5*ARCS WORDS, BUT IT MAY BE
C   STATED MORE      PRECISELY AS FOLLOWS:
C
C   1) FOR SOLVING PROBLEMS WITH UP TO 32,765 NODES AND      2,147,483,647
C   ARCS, AND WITH FLOW      VALUES OF UP TO2,147,483,647, IT SUFFICES
C   TO DECLARE ARRAYS AS SHOWN UNDER 'STD ARRANGEMENT' IN THE
C   TABLE BELOW.  THIS ARRANGEMENT IS THE ONE USED IN THE RELEASE
C   VERSION OF THE DNSUB SUBROUTINES.
C
C   2) IN ORDER      TO HANDLE PROBLEMS WITHMORE THAN 32,765 NODES,	ALL
C   INTEGER*2 DECLARATIONS BELOW MUST BE CHANGED TO INTEGER*4 AND
C   THE      DNSUB SUBROUTINES AND USER CALLING PROGRAMS MUST BE COMPILED
C   AND      LINKED.(SEE ALTERNATE 1 BELOW.)
C
C   3) FOR SOLVING ONLY      PROBLEMS WITH AT MOST 32,765 NODES, 32,767
C   ARCS, AND WITH FLOWS NOT EXCEEDING 32,767, ALL INTEGER*4
C   DECLARATIONS BELOW MAY BE CHANGED TO INTEGER*2, AND      THE DNSUB
C   SUBROUTINES       AND USER CALLING PROGRAMS MUSTBE COMPILED AND
C   LINKED. (SEE ALTERNATE 2 BELOW.)  IT IS ALSO NECESSARY TO
C   ACTIVATE THE STATEMENT DNIBIG=32767      in subroutine dnsub, and to
C   include 'implicit INTEGER*2 (i-n)' statements in each program
C   unit.  THIS      ARRANGEMENT, WHICH USESTHE LEAST AMOUNT OF MEMORY
C   AND      IS THE FASTEST when executed on16-BIT PROCESSORS, IS ONLY
C   USEFUL FOR A SET OF      VERY SPECIAL APPLICATIONS.  ITSgeneral
C   use      is not recommended.  OTHER ALTERNATES ARE ALSO POSSIBLE.
C
C  -----------------------------------------------------------------
C
C        STD ARRANGEMENT    ALTERNATE 1      ALTERNATE	2
C      				   (not	recommended)
C        ---------------  ---------------  ----------------
C  ARRAY   LENGTH TYPE EQV'D TYPE  TYPE EQV'D TYPE  TYPE EQV'D TYPE
C  ------  -----    ----  -------  ---- ----- ----  ---- ----- -----
C  DNFAPT    N      4               4                2
C  DNFADJ    A      2               4                2
C  DNCAP     A      4               4                2
C  DNBAPT    N      4               4                2
C  DNBADJ    A      2 DNFROM  2     4 DNFROM  4      2 DNFROM   2
C  DNFLOW    A      4 DNTO    2     4 DNTO    4      2 DNTO     2
C  DNBTOF    A      4 DNGCAP  4     4 DNGCAP  4      2 DNGCAP   2
C  DNPTRF    N      4               4                2
C  DNPTRB    N      4               4                2
C  DNLIST    N      2               4                2
C  DNFLAB    N      4 DNDIST  2     4 DNDIST  4      2 DNDIST   2
C  -----------------------------------------------------------------
C
C  TOTAL BYTES:     22*N + 16*A     24*N + 20*A       12*N + 10*A
C  (N=NODES, A=ARCS)
C  -----------------------------------------------------------------
C
C DIMENSION THESE TO AT LEAST MAX NUMBER OF NODES + 2:
        INTEGER   DNLIST(65538),DNDIST(65538)
        INTEGER   DNFAPT(65538),DNPTRF(65538),DNBAPT(65538),
     *              DNFLAB(65538),DNPTRB(65538)
C DIMENSION THESE TO AT LEAST MAX NUMBER OF ARCS + 1:
      INTEGER DNFADJ(524273),DNFROM(524273),DNTO(524273),DNBADJ(524273)
      INTEGER DNCAP(524273),DNGCAP(524273),DNFLOW(524273),DNBTOF(524273)
C
        COMMON /DN01/DNFAPT/DN02/DNFADJ/DN03/DNCAP/DN04/DNFROM
        COMMON /DN05/DNFLOW/DN06/DNGCAP/DN08/DNPTRF/DN09/DNLIST
        COMMON /DN10/DNBAPT/DN11/DNFLAB/DN12/DNPTRB
C
        INTEGER  DNNODE,NODP12,DNSRCE,DNSINK,I2,II2,K2,J2,IHEAD2,
     *  ITAIL2,QHEAD2,QTAIL2,KP2,KSAT2,DNNOP2,LAYMAX,K2DST,K2DP1,MAXD2
        INTEGER  DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,DNIBIG
        COMMON /DN00/DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,
     *               DNELTM,DNIBIG,DNNODE,DNSRCE,DNSINK,DNNOP2
        EQUIVALENCE (DNFLOW(1),DNTO(1)),(DNFLAB(1),DNDIST(1)),
     *              (DNFROM(1),DNBADJ(1)),(DNGCAP(1),DNBTOF(1))
C
C************END DNSUB STANDARD USER XFACE DECLARATION BLOCK***********
C***********************************************************************
C
C CALLING CONDITIONS:
C       USER CALLABLE WITH INPUT DATA AS FOLLOWS.
C INPUT:
C   SCALARS (IN CALLING SEQUENCE; ALL INTEGER*4):
C       NODES:  NUMBER OF NODES (INCLUDING SOURCE AND SINK)
C       NARCS:  NUMBER OF ARCS
C       ISOURC: NODE NUMBER FOR SOURCE
C       ISINK:  NODE NUMBER FOR SINK
C
C   ARRAYS (IN COMMON):
C       DNFAPT: (NODES+1)-LONG INTEGER*4 POINTER ARRAY FOR FORWARD ADJA-
C               CENCY LISTS (I.E. THE FORWARD ADJACENCY LIST OF A NODE I
C               IS THE SET OF ARCS
C                      {(I,DNFADJ(J)) :J=DNFAPT(I),...,DNFAPT(I+1)-1 }
C               NOTE: MUST HAVE DNFAPT(NODES+1) = NARCS+1.
C
C       DNFADJ: NARCS-LONG INTEGER*2 ARRAY GIVING THE LIST OF NODES IN
C               THE FORWARD ADJACENCY LIST DNFADJ(J) FOR EACH NODE J,
C               AS DESCRIBED ABOVE.
C
C       DNCAP:  NARCS-LONG INTEGER*4 ARRAY GIVING THE ARC CAPACITIES, IN
C               THE ORDER PRESCRIBED BY DNFAPT(.) AND DNFADJ(.). ALL ARC
C               CAPACITIES MUST BE GIVEN AS POSITIVE INTEGERS.
C
C   NOTE:       FOR TRANSFORMING UNORDERED ARC LISTS TO THE ABOVE INPUT
C               DATA STRUCTURE,USE SUBROUTINE DNFWD BEFORE CALLING DNSUB
C
C OUTPUT:
C
C   SCALARS (IN CALLING SEQUENCE):
C       MAXFLO: VALUE OF MAXIMUM FLOW (INTEGER*4).
C       NUMAUG: NUMBER OF FLOW AUGMENTATIONS (INTEGER*4).
C       NUMSTG: NUMBER OF STAGES (LAYERED NETWORKS CREATED; INTEGER*4).
C       NNCUT:  NUMBER OF NODES ON source SIDE OF FINAL CUT (INTEGER*4)
C       NACUT:  NUMBER OF SATURATED ARCS IN THE FINAL CUT (INTEGER*4)
C       ELTIM:  EXECUTION TIME, IN SECONDS (SEE NOTE 3 BELOW) (REAL*4).
C       IRETN:  NONZERO IF THERE ARE ERRORS IN INPUT DATA.
C
C   ARRAYS (IN COMMON:):
C       DNFAPT: THE ORIGINAL DNFAPT(.) WITH SOME OF ITS ELEMENTS
C               NEGATED TO MARK THE NODES THAT ARE ON THE SINK SIDE OF
C               THE MINIMUM CUT, I.E. DNFAPT(I)<0 IMPLIES THAT NODE I IS
C               ON THE SINK SIDE OF CUT, ELSE, IT IS ON THE source SIDE.
C
C       DNFADJ: THE ORIGINAL DNFADJ(.) WITH SOME OF ITS ELEMENTS NEGATED
C               TO MARK THOSE SATURATED ARCS THAT ARE IN THE MIN CUT
C               FOUND BY THE ALGORITHM, I.E.  DNFADJ(I)<0 IMPLIES THAT
C               THE I-TH ARC IN FORWARD ADJACENY ORDER IS IN THE CUT;
C               THE FOLLOWING CODE SEGMENT PRINTS THESE ARCS:
C
C                               DO 2 K=1,NODES
C                                  IBEG=IABS(DNFAPT(K))
C                                  IEND=IABS(DNFAPT(K+1))-1
C                                  DO 1 I=IBEG,IEND
C                                    IF(DNFADJ(I).LT.0)PRINT THE ARC
C                       1          CONTINUE
C                       2       CONTINUE
C
C               (SEE NOTE 1 BELOW).
C
C       DNCAP:  THE ORIGINAL CAPACITIES, UNALTERED.
C
C       DNFLOW: NARCS-LONG INTEGER*4 ARRAY WHICH GIVES FLOWS ON ARCS, IN
C               FORWARD ADJACENCY ORDER.
C
C       DNBAPT: (NODES+1)-LONG INTEGER*4 POINTER ARRAY FOR BACKWARD
C               ADJACENCY LISTS (I.E. THE FORWARD ADJACENCY LIST OF
C               NODE I IS THE SET OF ARCS
C                   {(DNBADJ(J),J): J=DNBAPT(I),...,DNBAPT(I+1)-1 }.
C               NOTE: WE MUST HAVE DNBAPT(NODES+1) = NARCS+1.
C
C       DNBADJ: NARCS-LONG INTEGER*2 ARRAY GIVING THE BACKWARD ADJACENCY
C               LIST OF EACH NODE J, ONE AFTER THE OTHER, AS DESCRIBED
C               ABOVE (ALSO SEE NOTE 2 BELOW).
C
C       DNBTOF: NARCS-LONG INTEGER*4 ARRAY GIVING THE BACKWARD ADJACENCY
C               TO FORWARD ADJACENCY MAPPING, I.E. THE J-TH ARC
C               IN THE BACKWARD ADJACENCY ORDER IS THE DNBTOF(J)-TH
C               ARC IN THE FORWARD ADJACENCY ORDER.
C
C***********************************************************************
C
C INTERNAL SCRATCH ARRAYS (IN COMMON):
C
C       DNLIST: (NODES+1)-LONG INTEGER*2 ARRAY USED AS FOLLOWS:
C               1) AS THE QUEUE IN BFS SEARCH FOR CONSTRUCTING THE
C                  LAYERED GRAPH (SUBR. DNBFS).
C               2) AS THE "PARENT" ARRAY IN DFS SEARCH OF LAYERED
C                  GRAPH (SUBR: DNDFS, DNPUSH).
C               3) AS SCRATCH IN CONSTRUCTING FWD ADJACENCIES
C                  (SUBR DNFWD), AND BWD ADJACENCIES (SUBR. DNSUB).
C
C       DNFLAB: NODES-LONG INTEGER*4 ARRAY USED IN DFS SEARCH OF
C               LAYERED GRAPH TO STORE THE FLOW LABEL FOR EACH NODE
C               (SEE ARRAY DNDIST() ).
C
C       DNDIST: NODES-LONG INTEGER*2 ARRAY USED IN CONSTRUCTING THE
C               LAYERED GRAPH BY BFS, STORING THE DISTANCE OF EACH
C               NODE FROM THE SOURCE; DNDIST(ISOURC)=0 (EQUIVALENCED
C               TO THE INTEGER*4 ARRAY DNFLAB() ).
C
C       DNPTRF: NODES-LONG INTEGER*4 STATUS AND POINTER ARRAY, I.E.
C               DNPTRF(K)=0 IF THERE ARE NO OPEN ARCS LEAVING NODE K
C                               IN THE REPRESENTATION OF THE LAYERED
C                               NETWORK.
C                        >0 THE ARC INDEX, IN 'FA' ORDER, THAT
C                               CORRESPONDS TO THE LAST ARC IN THE
C                               FWD ADJACENCY OF K WHICH IS SCANNED
C                               BACKWARD.
C
C       DNPTRB: NODES-LONG INTEGER*4 STATUS AND POINTER ARRAY, I.E.
C               DNPTRB(K)=0 IF THERE ARE NO OPEN ARCS ENTERING NODE K
C                               IN THE REPRESENTATION OF THE LAYERED
C                               NETWORK.
C                        >0 THE ARC INDEX (IN 'BA' ORDER) OF THE FIRST
C                               ARC IN THE BWD ADJACENCY OF K TO BE
C                               SCANNED IN LIFO ORDER.
C
C***********************************************************************
C
C NOTES:1) DNFADJ(J) IS INTERNALLY NEGATED TO MARK THE J-TH ARC (IN
C          FORWARD ADJACENCY ORDER) AS 'CLOSED'. BEFORE RETURNING
C          TO THE CALLING PGM, THESE MARKINGS ARE DISCARDED, AND SOME
C          ELEMENTS OF DNFADJ(.) ARE NEGATED TO REFLECT THE OUTPUT
C          SPECIFICATION DESCRIBED ABOVE.
C
C       2) DNBADJ(J) IS INTERNALLY NEGATED TO MARK THE J-TH ARC
C          (IN BACKWARD ADJACENCY ORDER) AS 'CLOSED'.
C
C       3) THE USER MUST PROVIDE A TIMING SUBROUTINE THAT RETURNS
C          THE CURRENT TIME IN VARIABLE ' T ', IN SECONDS.  SUCH
C          A SUBROUTINE IS INSTALLATION-DEPENDENT AND IS NOT GIVEN HERE.
C          IF THIS CANNOT BE DONE, PROVIDE THE FOLLOWING SUBROUTINE AND
C          FORGET THE EXECUTION TIMING INFORMATION:
C
C               SUBROUTINE GETIME(T)
C               REAL T
C               T=0.0
C               RETURN
C               END
C
C***********************************************************************
C
C       SUBROUTINES CALLED:     DNBFS, DNDFS, DNCUT, GETIME,DNCLEA
C
C***********************************************************************
C
C   NAMES COLLECTIVELY RESERVED BY ALL DNSUB SUBROUTINES:
C
C   DN00, DN01, DN02, DN03, DN04, DN05, DN06, DN08, DN09, DN10, DN11,
C   DN12, DNARC, DNAUG, DNBADJ, DNBAPT, DNBFS, DNBTOF, DNCAP, DNCLEA,
C   DNCUT, DNDFS, DNDIST, DNFADJ, DNPUSH, DNFAPT, DNFLAB, DNFLOW,
C   DNFROM, DNFVA, DNFWD, DNGCAP, DNIBIG, DNLAUG, DNLFVA, DNLIST,
C   DNNODE, DNNOP2, DNOUT, DNPTRB, DNPTRF, DNSINK, DNSRCE, DNSTGE,
C   DNSUB, DNELTM, DNTO.
C
C**********************************************************************
C INITIALIZATION:
C
C       CALL GETIME(TIMBEG)
        TIMBEG=etime(it)
        IRETN=0
        DNIBIG=2147483647
C       DNIBIG=32767
        DNARC=NARCS
        DNNODE=NODES
        DNNOP2=DNNODE+2
        DNSRCE=ISOURC
        DNSINK=ISINK
        DO 200 I4=1,DNARC
200     DNFLOW(I4)=0
C***********************************************************************
C
C USING THE FORWARD ADJACENCY ARRAYS DNFAPT(.) AND DNFADJ(.) (IN
C COMMON), CREATE THE BACKWARD ADJACENCY ARRAYS DNBAPT(.), DNBADJ(.)
C AND THE BACKWARD TO FORWARD ADJACENCY MAPPING DNBTOF(.).  DNLIST(.) IS
C USED HERE AS A SCRATCH ARRAY.
C
        NODP12=DNNODE+1
        DO 210 I2=1,NODP12
                DNLIST(I2)=0
210             DNBAPT(I2)=0
C TEMPORARILY STORE IN DNBAPT(.) NUMBER OF ARCS INTO EACH NODE:
        DO 230 I2=1,DNNODE
                IBEG4=DNFAPT(I2)
                IEND4=DNFAPT(I2+1)-1
                DO 220 I4=IBEG4,IEND4
                  JJDN=DNFADJ(I4)
220             DNBAPT(JJDN)=DNBAPT(JJDN)+1
230     CONTINUE
C CONSTRUCT DNBAPT(.):
        IHPI4=DNBAPT(1)
        DNBAPT(1)=1
        DO 240 I2=1,DNNODE
                IHPSV4=IHPI4+DNBAPT(I2)
                IHPI4=DNBAPT(I2+1)
240     DNBAPT(I2+1)=IHPSV4
C CONSTRUCT DNBADJ(.) AND DNBTOF(.):
        DO 260 I2=1,DNNODE
                IBEG4=DNFAPT(I2)
                IEND4=DNFAPT(I2+1)-1
                DO 250 I4=IBEG4,IEND4
                        IHEAD2=DNFADJ(I4)
                        IHPUT4=DNBAPT(IHEAD2)+DNLIST(IHEAD2)
                        IF(IHPUT4.LE.0)GOTO1900
                        DNBADJ(IHPUT4)=I2
                        DNBTOF(IHPUT4)=I4
250             DNLIST(IHEAD2)=DNLIST(IHEAD2)+1
260     CONTINUE
C
C***********************************************************************
C
        DNFVA=0
        DNAUG=0
        DNSTGE=1
C
C STAGE LOOP:
300     CONTINUE
C   FORM NEW LAYERED NETWORK W.R.T. CURRENT FEASIBLE FLOW.
                CALL DNBFS(LAYMAX)
                IF(LAYMAX.GT.0)GOTO1500
C   COMPUTE A MAXIMAL FLOW IN THIS LAYERED NET:
                CALL DNDFS
C   UPDATE FLOW VALUE:
                DNFVA=DNFVA+DNLFVA
                DNAUG=DNAUG+DNLAUG
                DNSTGE=DNSTGE+1
C   ERASE MARKINGS THAT DEFINE LAYERED NETWORK:
                CALL DNCLEA
        GOTO300
C***********************************************************************
C
C CURRENT FLOW IS MAXIMUM:
1500    MAXFLO=DNFVA
        NUMAUG=DNAUG
        NUMSTG=DNSTGE
        CALL DNCLEA
C MARK EXECUTION TIME:
C       CALL GETIME(TIMEND)
        TIMEND=etime(it)
        DNELTM=TIMEND-TIMBEG
        ELTIM=DNELTM
C
C MARK THE MIN CUT-SET IN DNFAPT(.) AND DNFADJ(.):
        CALL DNCUT(NNCUT,NACUT)
C
        RETURN
C
1900    IRETN=1
        RETURN
        END
        SUBROUTINE DNBFS(LAYMAX)
C
C
C DIMENSION THESE TO AT LEAST MAX NUMBER OF NODES + 2:
        INTEGER   DNLIST(65538),DNDIST(65538)
        INTEGER   DNFAPT(65538),DNPTRF(65538),DNBAPT(65538),
     *              DNFLAB(65538),DNPTRB(65538)
C DIMENSION THESE TO AT LEAST MAX NUMBER OF ARCS + 1:
      INTEGER DNFADJ(524273),DNFROM(524273),DNTO(524273),DNBADJ(524273)
      INTEGER DNCAP(524273),DNGCAP(524273),DNFLOW(524273),DNBTOF(524273)
C
        COMMON /DN01/DNFAPT/DN02/DNFADJ/DN03/DNCAP/DN04/DNFROM
        COMMON /DN05/DNFLOW/DN06/DNGCAP/DN08/DNPTRF/DN09/DNLIST
        COMMON /DN10/DNBAPT/DN11/DNFLAB/DN12/DNPTRB
C
        INTEGER  DNNODE,NODP12,DNSRCE,DNSINK,I2,II2,K2,J2,IHEAD2,
     *  ITAIL2,QHEAD2,QTAIL2,KP2,KSAT2,DNNOP2,LAYMAX,K2DST,K2DP1,MAXD2
        INTEGER  DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,DNIBIG
        COMMON /DN00/DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,
     *               DNELTM,DNIBIG,DNNODE,DNSRCE,DNSINK,DNNOP2
        EQUIVALENCE (DNFLOW(1),DNTO(1)),(DNFLAB(1),DNDIST(1)),
     *              (DNFROM(1),DNBADJ(1)),(DNGCAP(1),DNBTOF(1))
C
C*******************************************************************
C
C CALLING CONDITIONS:
C       INTERNAL CALL FROM DNSUB ONLY.
C INPUT ARRAYS:
C       DNFAPT, DNBAPT, DNFADJ, DNBADJ, DNBTOF, DNCAP, DNFLOW
C SCRATCH ARRAYS:
C       DNLIST
C OUTPUT:
C   IN CALLING SEQUENCE (INTEGER*2):
C       LAYMAX: 0 (LAYERED NET COMPLETE WITH SINK IN LAST LAYER.)
C               1 (LAST LAYER IS EMPTY; CURRENT FLOW IN ORIGINAL
C                  NETWORK IS MAXIMUM.)
C   IN COMMON (ARRAYS):
C       DNPTRF, DNPTRB, DNDIST
C***********************************************************************
C
C   THIS SUBROUTINE CONSTRUCTS THE LAYERED NETWORK OF THE RESIDUAL
C   NETWORK W.R.T. THE CURRENT FLOW.  THE RESIDUAL NETWORK IS
C   INFERRED, AND THE LAYERED NETWORK IS ONLY RECORDED BY TEMPORARY
C   MARKERS ON THE ORIGINAL GRAPH. THE SUBROUTINE IMPLEMENTS A
C   BREADTH-FIRST SEARCH ON THE RESIDUAL NETWORK, I.E.  NODES ARE
C   PROCESSED AS IN A QUEUE.  SUCH A SEARCH PARTITIONS THE NODES INTO
C   A SET OF 'LAYERS', ACCORDING TO THEIR CARDNALITY DISTANCE FROM
C   THE source. THE DNDIST(.) ARRAY IS USED TO RECORD THESE DISTANCES,
C   AND THUS DEFINES THE LAYERS (NOTE: DNDIST(ISOURC)=0).
C
C   IN SELECTING ARCS OF THE RESIDUAL NETWORK THAT ARE DIRECTED FROM
C   ONE LAYER TO THE NEXT, WE SHALL MARK THE ARCS IN THE ORIGINAL
C   NETWORK AS 'OPEN' OR 'CLOSED'.  A 'CLOSED' ARC (V,W) IN THE
C   LAYERED NETWORK IS EITHER AN ARC I=(V,W) THAT IS SATURATED IN THE
C   ORIGINAL NETWORK, OR AN ARC I=(W,V) OF THE ORIGINAL NETWORK WITH
C   ZERO FLOW. IN THE FORMER CASE, THE ABSENCE OF THIS ARC FROM THE
C   LAYERED NETWORK IS MARKED BY NEGATING DNFADJ(I), AND IN THE LATTER
C   CASE, BY NEGATING DNBADJ(I).  AN 'OPEN' ARC I=(V,W) FOR THE LAYERED
C   NETWORK EITHER HAS POSITIVE RESIDUAL CAPACITY, OR ARC (W,V) HAS
C   POSITIVE FLOW, IN THE ORIGINAL NETWORK. IF A NODE V HAS NO OPEN
C   ARCS IN THE LAYERED NETWORK THAT ARE IN THE FORWARD ADJACENCY LIST
C   OF V IN THE ORIGINAL NETWORK, THEN WE SET DNPTRF(V)=0; AND IF IT HAS
C   NO OPEN ARCS THAT ARE IN THE BACKWARD ADJACENCY LIST OF V IN THE
C   ORIGINAL NETWORK, WE SET DNPTRB(V)=0.
C
C   IN THIS BFS SEARCH WE ONLY USE OPEN ARCS THAT LEAD US TO NEW
C   NODES, OR TO NODES THAT HAVE ALREADY BEEN PLACED IN THE NEXT
C   LAYER. INITIALLY, THE QUEUE CONTAINS ONLY THE source.  AS THE
C   VERTICES ARE POPPED FROM THE QUEUE AND SCANNED, NEW NODES ARE
C   INJECTED INTO THE QUEUE. EVENTUALLY, EITHER THE SINK IS REACHED,
C   OR SOME VERTICES ARE NOT REACHABLE WITH OPEN ARCS FROM THE
C   CURRENT LAYER. IN THE FORMER CASE THE LAYERED NETWORK FOR THE
C   CURRENT STAGE IS COMPLETE, AND THUS A FLOW AUGMENTATION IS
C   POSSIBLE.  IN THE LATTER CASE, THE CURRENT FLOW ON THE ORIGINAL
C   NETWORK IS MAXIMUM, AND THE RUN TERMINATES.
C
C   THE QUEUE IS MAINTAINED IN THE LIST DNLIST(.) WITH TWO POINTERS,
C   AS SHOWN:
C                   -------------------------------------------
C    ARRAY              |    NODES TO BE SCANNED    |
C    DNLIST(.):  ...    |                           |
C                   -------------------------------------------
C                      ^                           ^
C                      |                           |
C                    QHEAD2                     QTAIL2
C*******************************************************************
C
C INITIALIZE:
                DO 10 I2=1,DNNODE
                        DNPTRF(I2)=0
                        DNPTRB(I2)=0
10              DNDIST(I2)=DNNOP2
                DNDIST(DNSRCE)=0
C PUT source INTO QUEUE:
                QHEAD2=0
                QTAIL2=1
                DNLIST(1)=DNSRCE
                MAXD2=DNNODE-1
C
C SCAN EACH NODE IN QUEUE:
C
C---------------
C
100     IF(QHEAD2.EQ.QTAIL2)GOTO2000
                QHEAD2=QHEAD2+1
C POP NODE IN FRONT OF QUEUE:
                K2=DNLIST(QHEAD2)
                K2DST=DNDIST(K2)
        IF(K2DST.GE.MAXD2)GOTO100
                K2DP1=K2DST+1
C
C  SCAN NODE K2, I.E. SEARCH OVER FWD ADJACENCY OF K2 AND FOR ARCS
C  (K2,J2) SUCH THAT J2 IS UNSCANNED AND J2 IS NOT IN THE QUEUE AND
C  ARC (K2,J2) HAS POSITIVE RESIDUAL CAPACITY IN ORIGINAL NETWORK.
C  'J2 UNSCANNED' IS CHECKED BY THE CONDITION: 'DNDIST(J2)>=DNDIST(K2)'.
C  'J2 NOT IN QUEUE' IS CHECKED BY THE CONDITION
C  'DNDIST(J2)=DNDIST(K2)+1 FOR      A SCANNED J2'.
C
                IBEG4=DNFAPT(K2)
                IEND4=DNFAPT(K2+1)-1
                IF(IBEG4.GT.IEND4)GOTO1000
                DO 400 I4=IBEG4,IEND4
                        J2=DNFADJ(I4)
                        IF(DNDIST(J2).LE.K2DST)GOTO300
                        IF(DNCAP(I4).LE.DNFLOW(I4))GOTO300
C (IMPLICITLY) MARK ARC (K2,J2) AS OPEN IN LAYERED NETWORK; ALSO,
C SAVE ITS INDEX IN DNPTRF(.):
                        DNPTRF(K2)=I4
                        IF(J2.NE.DNSINK)GOTO200
C J2=SINK:
                        MAXD2=K2DP1
                        DNDIST(J2)=MAXD2
                        GOTO400
C APPEND NODE J2 TO THE QUEUE, IF NOT ALREADY THERE:
200                     IF(DNDIST(J2).EQ.K2DP1)GOTO400
                        DNDIST(J2)=K2DP1
                        QTAIL2=QTAIL2+1
                        DNLIST(QTAIL2)=J2
                        GOTO400
C (EXPLICITLY) MARK ARC (K2,J2) AS CLOSED IN LAYERED NETWORK:
300                     DNFADJ(I4)=-DNFADJ(I4)
400             CONTINUE
C
C---------------
C
C IF SINK WAS REACHED, DON'T NEED TO SCAN BACKWARD ARCS      INTO ITS LAYER:
1000      IF(DNDIST(DNSINK).NE.DNNOP2)GOTO100
C
C ELSE,      CONTINUE SCAN OVER FORWARD ARCSOUT OF K2 IN THE RESIDUAL
C NETWORK (WHICH ARE BACKWARD ARCS OF THE ORIGINAL NETWORK WITH
C POSITIVE FLOW). THIS CODE SEGMENT IS ANALOGOUS TO THE      ONE ABOVE:
C
      IBEG4=DNBAPT(K2)
      IEND4=DNBAPT(K2+1)-1
      IF(IBEG4.GT.IEND4)GOTO100
      DO 1400 I4=IBEG4,IEND4
        J2=DNBADJ(I4)
        IF(DNDIST(J2).LE.K2DST)GOTO1300
        JJDN=DNBTOF(I4)
        IF(DNFLOW(JJDN).LE.0)GOTO1300
        DNPTRB(K2)=I4
        IF(DNDIST(J2).EQ.K2DP1)GOTO1400
        DNDIST(J2)=K2DP1
        QTAIL2=QTAIL2+1
        DNLIST(QTAIL2)=J2
        GOTO1400
 1300       DNBADJ(I4)=-DNBADJ(I4)
 1400      CONTINUE
      GOTO100
C
C---------------
C
2000      LAYER2=LAYER2+1
      LAYP12=LAYER2+1
C HERE,      ALL NODES IN QUEUE HAVEBEEN PROCESSED.
C IF THE SINK WAS REACHED, THE LAYERED NETWORK IS COMPLETE:
      LAYMAX=0
      IF(DNDIST(DNSINK).NE.DNNOP2)RETURN
C ELSE,      THE CURRENT FLOW IS MAXIMUM:
      LAYMAX=1
      RETURN
C
      END
      SUBROUTINE DNDFS
C
C
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF NODES + 2:
      INTEGER  DNLIST(65538),DNDIST(65538)
      INTEGER  DNFAPT(65538),DNPTRF(65538),DNBAPT(65538),
     *          DNFLAB(65538),DNPTRB(65538)
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF ARCS + 1:
      INTEGER DNFADJ(524273),DNFROM(524273),DNTO(524273),DNBADJ(524273)
      INTEGER DNCAP(524273),DNGCAP(524273),DNFLOW(524273),DNBTOF(524273)
C
      COMMON /DN01/DNFAPT/DN02/DNFADJ/DN03/DNCAP/DN04/DNFROM
      COMMON /DN05/DNFLOW/DN06/DNGCAP/DN08/DNPTRF/DN09/DNLIST
      COMMON /DN10/DNBAPT/DN11/DNFLAB/DN12/DNPTRB
C
      INTEGER DNNODE,NODP12,DNSRCE,DNSINK,I2,II2,K2,J2,IHEAD2,
     *      ITAIL2,QHEAD2,QTAIL2,KP2,KSAT2,DNNOP2,LAYMAX,K2DST,K2DP1,MAXD2
      INTEGER DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,DNIBIG
      COMMON /DN00/DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,
     *           DNELTM,DNIBIG,DNNODE,DNSRCE,DNSINK,DNNOP2
      EQUIVALENCE (DNFLOW(1),DNTO(1)),(DNFLAB(1),DNDIST(1)),
     *          (DNFROM(1),DNBADJ(1)),(DNGCAP(1),DNBTOF(1))
C
C***********************************************************************
C
C  THIS      SUBROUTINE FINDS A MAXIMAL FLOWIN THE LAYERED NETWORK.	IT
C  USES      A DEPTH-FIRST SEARCH STARTING FROM THE SOURCE AND RECORDS
C  THE DFS TREE      BY THE PREDECESSOR ARRAY DNLIST(.) AND FLOW LABEL
C  ARRAY DNFLAB(.). LAYERED NETWORK ARCS THAT ARE FORWARD IN THE
C  ORIGINAL NETWORK ARE      SEARCHED BEFOREBACKWARD ARCS.	THE
C  FORWARD AND BACKWARD      ADJACENCIES OF A NODE K2 ARE SCANNED INLIFO
C  ORDER, STARTING FROM      THE LAST ARC THAT WAS VISITED DURING A
C  PREVIOUS SCAN OF K2.      THUS, WITH THE AID OF THE TWO POINTER LISTS
C  DNPTRF(.) AND DNPTRB(.), THE      ADJACENCY LISTSOF THE ORIGINAL
C  NETWORK ARE SCANNED ONLY ONCE BY THIS SUBROUTINE. DNPTRF(K2)=0
C  IMPLIES THAT      NODE K2HAS NO OUTGOING	UNSCANNED ARCS;	DNPTRB(K2)=0
C  IMPLIES THAT      NODE K2HAS NO INCOMING	UNSCANNED ARCS;	A 'CLOSED'
C  NODE      IS DETECTED BY THE CONDITION DNPTRF(K2)=DNPTRB(K2)=0.
C
C***********************************************************************
C
C CALLING CONDITIONS:
C      INTERNAL CALL FROM DNSUB ONLY.
C INPUT      ARRAYS:
C      DNPTRB,DNPTR, DNBTOF, DNCAP, DNFLOW, DNBADJ, DNFADJ
C OUTPUT ARRAYS:
C      DNPTRF,DNPTRB,	DNLIST,	DNFLAB.
C***********************************************************************
C
C      SUBROUTINES CALLED:DNPUSH
C
C***********************************************************************
C
      K2=DNSRCE
      DNLFVA=0
      DNLAUG=0
      DNFLAB(K2)=DNIBIG
C
C-----------
C
C SCAN NODE K2:
C
100      IF(DNPTRF(K2).EQ.0)GOTO1000
C FIND AN OPEN ARC FROM      K2 TO SOME NODEJ2: SCAN THE
C FORWARD ADJACENCY LIST OF K2,      STARTING FROM  DNPTRF(K2) AND
C PROCEEDING BACKWARD ON DNFADJ() TOWARD DNFAPT(K2):
      I4=DNPTRF(K2)
      IPT4=DNFAPT(K2)
300      J2=DNFADJ(I4)
        IF(J2.GE.0)GOTO600
  400        I4=I4-1
      IF(I4.GE.IPT4)GOTO300
C NO OPEN ARCS OUT OF K2; MARK K2 AS CLOSED:
      DNPTRF(K2)=0
      GOTO1000
C AN OPEN ARC FOUND; MOVE POINTER DNPTRF() TO THIS ARC;
C EXTEND DFS TREE TO NODE J2:
  600      DNPTRF(K2)=I4
      DNFLAB(J2)=DNFLAB(K2)
      IF(DNCAP(I4)-DNFLOW(I4).LT.DNFLAB(J2))
     *        DNFLAB(J2)=DNCAP(I4)-DNFLOW(I4)
      DNLIST(J2)=K2
      K2=J2
C IF NODE K2 (FORMERLY J2) IS THE SINK,      AUGMENTFLOW; GET NEW K2:
      IF(K2.EQ.DNSINK)CALL DNPUSH(K2)
      GOTO100
C
C-----------
C
 1000      IF(DNPTRB(K2).EQ.0)GOTO2000
C SCAN BACKWARD      ARCS INTO K2 TOFIND AN	OPEN ARC:
      I4=DNPTRB(K2)
      IPT4=DNBAPT(K2)
 1300      J2=DNBADJ(I4)
       IF(J2.GE.0)GOTO1600
       I4=I4-1
       IF(I4.GE.IPT4)GOTO1300
C NO OPEN ARC INTO K2:
      DNPTRB(K2)=0
      GOTO2000
C AN OPEN ARC FOUND; EXTEND DFS      TREE TONODE J2:
 1600      DNPTRB(K2)=I4
      DNFLAB(J2)=DNFLAB(K2)
      JJDN=DNBTOF(I4)
      IFL4=DNFLOW(JJDN)
      IF(IFL4.LT.DNFLAB(J2))DNFLAB(J2)=IFL4
      DNLIST(J2)=-K2
      K2=J2
      GOTO100
C
C-----------
C
C K2 IS      'CLOSED' NODE; IF IT ISTHE source, THEN WE HAVE A MAXIMAL
C FLOW IN LAYERED NETWORK:
2000      IF(K2.EQ.DNSRCE)RETURN
C ELSE,      BACK UPONE NODE FROM K2 IN DFS	TREE:
      KP2=DNLIST(K2)
      K2=KP2
      IF(K2.LT.0)K2=-K2
      IF(KP2.GE.0)GOTO2200
      I4=DNPTRB(K2)
      DNBADJ(I4)=-DNBADJ(I4)
      GOTO100
2200      I4=DNPTRF(K2)
      DNFADJ(I4)=-DNFADJ(I4)
      GOTO100
C
C-----------
      END
      SUBROUTINE DNPUSH(K2)
C
C
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF NODES + 2:
      INTEGER  DNLIST(65538),DNDIST(65538)
      INTEGER  DNFAPT(65538),DNPTRF(65538),DNBAPT(65538),
     *          DNFLAB(65538),DNPTRB(65538)
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF ARCS + 1:
      INTEGER DNFADJ(524273),DNFROM(524273),DNTO(524273),DNBADJ(524273)
      INTEGER DNCAP(524273),DNGCAP(524273),DNFLOW(524273),DNBTOF(524273)
C
      COMMON /DN01/DNFAPT/DN02/DNFADJ/DN03/DNCAP/DN04/DNFROM
      COMMON /DN05/DNFLOW/DN06/DNGCAP/DN08/DNPTRF/DN09/DNLIST
      COMMON /DN10/DNBAPT/DN11/DNFLAB/DN12/DNPTRB
C
      INTEGER DNNODE,NODP12,DNSRCE,DNSINK,I2,II2,K2,J2,IHEAD2,
     *      ITAIL2,QHEAD2,QTAIL2,KP2,KSAT2,DNNOP2,LAYMAX,K2DST,K2DP1,MAXD2
      INTEGER DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,DNIBIG
      COMMON /DN00/DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,
     *           DNELTM,DNIBIG,DNNODE,DNSRCE,DNSINK,DNNOP2
      EQUIVALENCE (DNFLOW(1),DNTO(1)),(DNFLAB(1),DNDIST(1)),
     *          (DNFROM(1),DNBADJ(1)),(DNGCAP(1),DNBTOF(1))
C
C***********************************************************************
C
C AUGMENT FLOW ALONG FLOW AUGMENTING PATH DEFINED SUBROUTINE DNDFS, I.E.
C USING      THE PREDECESSORARRAY DNLIST(.), START FROM THE	SINK AND
C TRAVERSE TO THE SOURCE ARC FLOWS AND FLOW LABELS BY AN AMOUNT      EQUAL
C TO DNFLAB(DNSINK). MARK SATURATED FORWARD (FROM S TO T) ARCS,      AND
C BACKWARD ARCS      HAVING ZERO FLOW, AS CLOSED.
C
C***********************************************************************
C
C CALLING CONDITIONS:
C      INTERNAL CALL FROM DNDFS ONLY.
C INPUT      ARRAYS:
C      DNFLAB,DNLIST,DNPTRB,DNPTRF,DNBTOF,DNCAP,DNFLOW,DNBADJ,DNFADJ
C OUTPUT ARRAYS:
C      DNFLAB,DNFLOW,DNBADJ,DNFADJ
C***********************************************************************
C
      KSAT2=0
      J2=DNSINK
      INCRE4=DNFLAB(J2)
      DNLFVA=DNLFVA+INCRE4
      DNLAUG=DNLAUG+1
C
100      K2=J2
      J2=DNLIST(K2)
      DNFLAB(K2)=DNFLAB(K2)-INCRE4
      IF(J2.GT.0)GOTO200
C
C DECREASE FLOW      ON BACKWARD ARC(K2,J2):
      J2=-J2
      I4=DNPTRB(J2)
      II4=DNBTOF(I4)
      DNFLOW(II4)=DNFLOW(II4)-INCRE4
      IF(DNFLOW(II4).NE.0)GOTO100
C FLOW IS ZERO;      MARK ARC AS 'CLOSED' INLAYERED	NETWORK:
      DNBADJ(I4)=-DNBADJ(I4)
      KSAT2=J2
      GOTO100
C
C INCREASE FLOW      ON FORWARD ARC (J2,K2):
200      I4=DNPTRF(J2)
      DNFLOW(I4)=DNFLOW(I4)+INCRE4
      IF(DNCAP(I4).NE.DNFLOW(I4))GOTO300
C ARC IS NOW SATURATED;      MARK ISAS 'CLOSED' IN LAYERED NET
      DNFADJ(I4)=-DNFADJ(I4)
      KSAT2=J2
300      IF(J2.NE.DNSRCE)GOTO100
C
C RETURN TO RESUME SEARCH FROM K2 (NODE      CLOSESTTO source OF
C THE ARC CLOSED LAST)
      IF(KSAT2.EQ.0)STOP
      K2=KSAT2
      RETURN
      END
      SUBROUTINE DNFWD(NODES,NARCS,IRETN)
C
C
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF NODES + 2:
      INTEGER  DNLIST(65538),DNDIST(65538)
      INTEGER  DNFAPT(65538),DNPTRF(65538),DNBAPT(65538),
     *          DNFLAB(65538),DNPTRB(65538)
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF ARCS + 1:
      INTEGER DNFADJ(524273),DNFROM(524273),DNTO(524273),DNBADJ(524273)
      INTEGER DNCAP(524273),DNGCAP(524273),DNFLOW(524273),DNBTOF(524273)
C
      COMMON /DN01/DNFAPT/DN02/DNFADJ/DN03/DNCAP/DN04/DNFROM
      COMMON /DN05/DNFLOW/DN06/DNGCAP/DN08/DNPTRF/DN09/DNLIST
      COMMON /DN10/DNBAPT/DN11/DNFLAB/DN12/DNPTRB
C
      INTEGER DNNODE,NODP12,DNSRCE,DNSINK,I2,II2,K2,J2,IHEAD2,
     *      ITAIL2,QHEAD2,QTAIL2,KP2,KSAT2,DNNOP2,LAYMAX,K2DST,K2DP1,MAXD2
      INTEGER DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,DNIBIG
      COMMON /DN00/DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,
     *           DNELTM,DNIBIG,DNNODE,DNSRCE,DNSINK,DNNOP2
      EQUIVALENCE (DNFLOW(1),DNTO(1)),(DNFLAB(1),DNDIST(1)),
     *          (DNFROM(1),DNBADJ(1)),(DNGCAP(1),DNBTOF(1))
C
C***********************************************************************
C
C CALLING CONDITIONS:
C      USER CALLABLE; BEFORE CALLING DNSUB.
C INPUT:
C   IN CALLING SEQUENCE      (ALL INTEGER*4):
C      NODES=NUMBER OF NODES, INCLUDING source AND SINK
C      NARCS=NUMBER OF ARCS.
C
C   IN COMMON, PROVIDE THREE ARC LISTS WITH ARCS IN ANY      ORDER:
C      DNFROM=THE LIST OF TAILS. (INTEGER*2)
C      DNTO=THE LIST OF HEADS. (INTEGER*2)
C      DNGCAP=THE LIST OF CAPACITIES.	(INTEGER*4).
C
C SCRATCH ARRAY      (IN COMMON):
C      DNLIST
C OUTPUT:
C   IN CALLING SEQUENCE      (INTEGER*4):
C      IRETN=0 NO ERRORS;  =1	ERROR DETECTED,	CHECK INPUT.
C   IN COMMON, ARRAYS:
C      DNFAPT,DNFADJ,DNCAP (I.E. THE FWD ADJACENCY INPUT DATA STRUCTURE
C       THAT IS REQUIRED AS INPUT TO SUBROUTINE DNSUB).
C
C***********************************************************************
C
C  USING THE THREE ARC LISTS DNFROM(.),      DNTO(.), DNGCAP(.), THIS
C  SUBROUTINE CONSTRUCTS THE FORWARD ADJACENCY ARRAYS DNFAPT(.),
C  DNFADJ(.), AND DNCAP(.), AS THE INPUT REQUIRED BY SUBROUTINE      DNSUB.
C
C***********************************************************************
C
C INITIALIZE:
      IRETN=0
      NODP1=NODES+1
      DO 100 I2=1,NODP1
      DNFAPT(I2)=0
100      DNLIST(I2)=0
C TEMPORARILY STORE IN DNFAPT(.) NUMBER      OF ARCSOUT OF EACH NODE:
      DO 200 I4=1,NARCS
        JJDN=DNFROM(I4)
200      DNFAPT(JJDN)=DNFAPT(JJDN)+1
C CONSTRUCT DNFAPT(.):
      ITPI4=DNFAPT(1)
      DNFAPT(1)=1
      DO 300 I2=1,NODES
      ITPSV4=ITPI4+DNFAPT(I2)
      ITPI4=DNFAPT(I2+1)
300      DNFAPT(I2+1)=ITPSV4
C CONSTRUCT DNFADJ(.) AND DNCAP(.):
      DO 400 I4=1,NARCS
      ITAIL2=DNFROM(I4)
      ITPUT4=DNFAPT(ITAIL2)+DNLIST(ITAIL2)
      IF(ITPUT4.LE.0)GOTO500
      DNFADJ(ITPUT4)=DNTO(I4)
      DNLIST(ITAIL2)=DNLIST(ITAIL2)+1
      DNCAP(ITPUT4)=DNGCAP(I4)
400      CONTINUE
      RETURN
500      IRETN=1
      RETURN
      END
      SUBROUTINE DNCLEA
C
C
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF NODES + 2:
      INTEGER  DNLIST(65538),DNDIST(65538)
      INTEGER  DNFAPT(65538),DNPTRF(65538),DNBAPT(65538),
     *          DNFLAB(65538),DNPTRB(65538)
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF ARCS + 1:
      INTEGER DNFADJ(524273),DNFROM(524273),DNTO(524273),DNBADJ(524273)
      INTEGER DNCAP(524273),DNGCAP(524273),DNFLOW(524273),DNBTOF(524273)
C
      COMMON /DN01/DNFAPT/DN02/DNFADJ/DN03/DNCAP/DN04/DNFROM
      COMMON /DN05/DNFLOW/DN06/DNGCAP/DN08/DNPTRF/DN09/DNLIST
      COMMON /DN10/DNBAPT/DN11/DNFLAB/DN12/DNPTRB
C
      INTEGER DNNODE,NODP12,DNSRCE,DNSINK,I2,II2,K2,J2,IHEAD2,
     *      ITAIL2,QHEAD2,QTAIL2,KP2,KSAT2,DNNOP2,LAYMAX,K2DST,K2DP1,MAXD2
      INTEGER DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,DNIBIG
      COMMON /DN00/DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,
     *           DNELTM,DNIBIG,DNNODE,DNSRCE,DNSINK,DNNOP2
      EQUIVALENCE (DNFLOW(1),DNTO(1)),(DNFLAB(1),DNDIST(1)),
     *          (DNFROM(1),DNBADJ(1)),(DNGCAP(1),DNBTOF(1))
C
C*******************************************************************
C CALLING CONDITIONS:
C      INTERNAL CALL FROM DNSUB ONLY.
C INPUT      (IN COMMON):
C   SCALARS: DNARC
C   ARRAYS:  DNFADJ, DNBADJ
C OUTPUT:
C   ARRAYS (IN COMMON):      DNFADJ,DNBADJ
C********************************************************************
C
C CLEAR      MARKINGS IN ARRAYS DNFADJ() ANDDNBADJ().:
      DO 100 I4=1,DNARC
        IF(DNBADJ(I4).LT.0)DNBADJ(I4)=-DNBADJ(I4)
        IF(DNFADJ(I4).LT.0)DNFADJ(I4)=-DNFADJ(I4)
100      CONTINUE
      RETURN
      END
      SUBROUTINE DNCUT(NNCUT,NACUT)
C
C
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF NODES + 2:
      INTEGER  DNLIST(65538),DNDIST(65538)
      INTEGER  DNFAPT(65538),DNPTRF(65538),DNBAPT(65538),
     *          DNFLAB(65538),DNPTRB(65538)
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF ARCS + 1:
      INTEGER DNFADJ(524273),DNFROM(524273),DNTO(524273),DNBADJ(524273)
      INTEGER DNCAP(524273),DNGCAP(524273),DNFLOW(524273),DNBTOF(524273)
C
      COMMON /DN01/DNFAPT/DN02/DNFADJ/DN03/DNCAP/DN04/DNFROM
      COMMON /DN05/DNFLOW/DN06/DNGCAP/DN08/DNPTRF/DN09/DNLIST
      COMMON /DN10/DNBAPT/DN11/DNFLAB/DN12/DNPTRB
C
      INTEGER DNNODE,NODP12,DNSRCE,DNSINK,I2,II2,K2,J2,IHEAD2,
     *      ITAIL2,QHEAD2,QTAIL2,KP2,KSAT2,DNNOP2,LAYMAX,K2DST,K2DP1,MAXD2
      INTEGER DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,DNIBIG
      COMMON /DN00/DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,
     *           DNELTM,DNIBIG,DNNODE,DNSRCE,DNSINK,DNNOP2
      EQUIVALENCE (DNFLOW(1),DNTO(1)),(DNFLAB(1),DNDIST(1)),
     *          (DNFROM(1),DNBADJ(1)),(DNGCAP(1),DNBTOF(1))
C
C***********************************************************************
C CALLING CONDITIONS:
C      ONLY AFTER A SUCCESSFULRETURN FROM A CALL TO DNSUB.
C INPUT      ARRAYS:
C      DNFAPT,DNFADJ,	DNCAP,DNFLOW, DNDIST
C OUTPUT ARRAYS:
C      DNFAPT,DNFADJ
C PASSED IN CALLING SEQUENCE:
C      NNCUT:NUMBER OF NODES	ON source SIDE OF FINAL	CUT (INTEGER*4)
C      NACUT:NUMBER OF ARCS IN THE FINAL CUT	(INTEGER*4)
C***********************************************************************
C
C NEGATE DNFAPT(.) FOR NODES ON      SINK SIDE OF CUT:
      NNCUT=0
      DO 1700I2=1,DNNODE
      IF(DNDIST(I2).NE.DNNOP2)GOTO1650
      DNFAPT(I2)=-IABS(DNFAPT(I2))
      GOTO1700
1650      NNCUT=NNCUT+1
1700      CONTINUE
C NEGATE DNFADJ(.) FOR THOSE SATURATED ARCS IN MIN CUT:
      NACUT=0
      DO 1900I2=1,DNNODE
      IF(DNFAPT(I2).LT.0)GOTO1900
C NODE I2 IS ON      source SIDE:
      IBEG4=IABS(DNFAPT(I2))
      IEND4=IABS(DNFAPT(I2+1))-1
      DO 1800 I4=IBEG4,IEND4
        JJDN=DNFADJ(I4)
        IF(DNFAPT(JJDN).GT.0)GOTO1800
C NODE DNFADJ(I4) ON SINK SIDE:
        IF(DNFLOW(I4).NE.DNCAP(I4))GOTO1800
        II2=DNFADJ(I4)
        DNFADJ(I4)=-IABS(II2)
        NACUT=NACUT+1
 1800      CONTINUE
 1900      CONTINUE
      RETURN
      END
      SUBROUTINE DNOUT(IUNREP)
C
        CHARACTER*1  T  , JJS,  JJT , ISIDE, JSIDE 
        CHARACTER*3  BL3, BSAT, TAG1
        CHARACTER*4  BL4, BCUT, TAG2
C
C
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF NODES + 2:
      INTEGER  DNLIST(65538),DNDIST(65538)
      INTEGER  DNFAPT(65538),DNPTRF(65538),DNBAPT(65538),
     *          DNFLAB(65538),DNPTRB(65538)
C DIMENSION THESE TO AT      LEAST MAX NUMBER OF ARCS + 1:
      INTEGER DNFADJ(524273),DNFROM(524273),DNTO(524273),DNBADJ(524273)
      INTEGER DNCAP(524273),DNGCAP(524273),DNFLOW(524273),DNBTOF(524273)
C
      COMMON /DN01/DNFAPT/DN02/DNFADJ/DN03/DNCAP/DN04/DNFROM
      COMMON /DN05/DNFLOW/DN06/DNGCAP/DN08/DNPTRF/DN09/DNLIST
      COMMON /DN10/DNBAPT/DN11/DNFLAB/DN12/DNPTRB
C
      INTEGER DNNODE,NODP12,DNSRCE,DNSINK,I2,II2,K2,J2,IHEAD2,
     *      ITAIL2,QHEAD2,QTAIL2,KP2,KSAT2,DNNOP2,LAYMAX,K2DST,K2DP1,MAXD2
      INTEGER DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,DNIBIG
      COMMON /DN00/DNARC,DNFVA,DNAUG,DNLFVA,DNLAUG,DNSTGE,
     *           DNELTM,DNIBIG,DNNODE,DNSRCE,DNSINK,DNNOP2
      EQUIVALENCE (DNFLOW(1),DNTO(1)),(DNFLAB(1),DNDIST(1)),
     *          (DNFROM(1),DNBADJ(1)),(DNGCAP(1),DNBTOF(1))
        DATA BL3/3H   /,  BL4/4H    /,  BSAT/3HSAT/,  BCUT/4H-CUT/,
     1       JJT/1HT/
      DATA JJS/1HS/
C
C***********************************************************************
C
C PREPARES OUTPUT REPORT. MAY ONLY BE CALLED AFTER A CALL TO DNSUB.
C
C***********************************************************************
C
C CALLING CONDITIONS:
C      USER CALLABLE; ONLY AFTER CALLING DNSUB.
C INPUT      ARRAYS:
C      DNFAPT,DNFADJ,	DNCAP, DNFLOW
C SCRATCH ARRAYS:
C      DNLIST
C OUTPUT ARRAYS:  NONE
C***********************************************************************
C
C PRINT      SUMMARYSECTION:
      WRITE(IUNREP,1000)
     *            DNNODE,DNARC,DNSRCE,DNSINK,DNFVA,DNELTM,DNAUG,DNSTGE
C PRINT      CUT-SETNODES:
      K2=0
      DO 200 I2=1,DNNODE
      IF(DNFAPT(I2).LT.0)GOTO200
      K2=K2+1
      DNLIST(K2)=I2
200      CONTINUE
c     WRITE(IUNREP,1003)K2
c     WRITE(IUNREP,1004)(DNLIST(I2),I2=1,K2)
c     WRITE(IUNREP,1001)
C PRINT      ARC LIST:
      NTOTC4=0
      NSAINC=0
      NSA=0
      NPOSFL=0
      DO 400 I2=1,DNNODE
         IBEG4=IABS(DNFAPT(I2))
         IEND4=IABS(DNFAPT(I2+1))-1
         DO 300 I4=IBEG4,IEND4
      MFLO4=DNFLOW(I4)
      IF(MFLO4.EQ.0)GOTO300
      NPOSFL=NPOSFL+1
      TAG1=BL3
      IF(MFLO4.NE.DNCAP(I4))GOTO270
        TAG1=BSAT
        NSA=NSA+1
 270      TAG2=BL4
C      IF(DNFADJ(I4).LT.0)TAG2=BCUT
      IF(DNFADJ(I4).GE.0)GOTO280
        NTOTC4=NTOTC4+MFLO4
        NSAINC=NSAINC+1
  280      ISIDE=JJS
      JSIDE=ISIDE
      IF(DNFAPT(I2).LT.0)ISIDE=JJT
      IFAPLU=DNFADJ(I4)
      IFAPLU=IABS(IFAPLU)
      IF(DNFAPT(IFAPLU).LT.0)JSIDE=JJT
      IF(ISIDE.NE.JSIDE)TAG2=BCUT
C
c     WRITE(IUNREP,1002)I2,ISIDE,IFAPLU,JSIDE,
c    *        MFLO4,DNCAP(I4),TAG1,TAG2
  300         CONTINUE
  400      CONTINUE
C PRINT      MAXFLO VALUE AND COMPUTED MINCUT
c     WRITE(IUNREP,1006)NPOSFL,NSA,NSAINC
c     IF(DNFVA.NE.NTOTC4)WRITE(IUNREP,1007)DNFVA,NTOTC4
c     WRITE(IUNREP,1008)
      RETURN
C
C FORMATS:
1000      FORMAT(/13H DINIC MAXFLO,
     */13H PROBLEM HAS ,I6,7H NODES,,I6,24H ARCS, SOURCE/SINK PAIR,,2I6
     */16H MAX FLOW VALUE=,I16,21H, PC/AT ELAPSED TIME ,F8.2,6H SECS.,
     */21H TOTAL AUGMENTATIONS=,I6,4H IN ,I6,7H STAGES)
1001      FORMAT(/25H ARCS WITH POSITIVE FLOW , 
     *//23H       TAIL        HEAD,
     *      40H           FLOW       CAPACITY    STATUS/)
1002      FORMAT(I10,1X,A1,I10,1X,A1,2I15,4X,A3,A4)
1003      FORMAT(/10H THERE ARE,I8,29H NODES IN SOURCE SIDE OF CUT,,
     *      10H THEY ARE /)
1004      FORMAT(10I6)
1006      FORMAT(/7H NOTES ,
     */10X,13H 1) THERE ARE,I6,26H ARCS WITH POSITIVE FLOW, ,I5,3H OF
     */10X,22H      THEM SATURATED (,I5,26H OF WHICH ARE IN MINCUT). ,
     */10X,52H 2)   S  /  T   REFER TO SOURCE / SINK SIDES OF CUT.)
 1007      FORMAT(
     * 10X,41H 3) MAX FLOW VALUE FROM SOURCE TO SINK IS,I14,1H,
     */10X,41H      BUT, CUT CAPACITY WAS COMPUTED AS  ,I14)
1008      FORMAT(/15H END OF REPORT.)
      END

:	This is a shell archive.
:	Remove everything above this line and
:	run the following text with /bin/sh to create:
:	waissi/ac-max.p
:	waissi/ac-max.pas
:	waissi/bi-max.p
:	waissi/bi-max.pas
:	waissi/index
:	waissi/ra-max.p
:	waissi/ra-max.pas
:	waissi/random.p
:	waissi/random.pas
:	waissi/readme
:	waissi/readme_next
:	waissi/tp55
:	waissi/tr1-max.p
:	waissi/tr1-max.pas
:	waissi/tr2-max.p
:	waissi/tr2-max.pas
: This archive created: Fri Sep 13 10:13:51 1991
cat << 'SHAR_EOF' > waissi/ac-max.p
{
 ACYCLIC NETWORK GENERATOR FOR MAX-FLOW 
                               (revised 11/25/90)
                               (revised 01/04/91)

 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revisions and corrections: INTEGER changed to LONGINT
 to allow the range [-2^31 ... 2^31-1]. A bug was 
 corrected in the calculation of num_arcs for special
 SPARSE networks, (line 312 shall read:

   for i:=2 to num_nodes do num_arcs:=num_arcs+2;

 This source program has been given to public domain
 through DIMACS. 

 This program generates ACYCLIC MAX-FLOW NETWORKS to 
 user specified files. Two types of acyclic networks
 can be generated: FULLY DENSE and special SPARSE 
 acyclic networks. The two key procedures are:

 PROCEDURE AcyclicNet1;   (fully dense networks)
 PROCEDURE AcyclicNet2;   (special sparse networks)

 Data file format corresponds to DIMACS data file
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for 
 transportability.

 Another version of this program, that uses windowing
 and has a user-friendly menu interface is available.
 The version uses Turbo Pascal 5.5 features (including
 CTR, DOS), and is compiled in Turbo Pascal Units TPU's.
 Runs on DOS 3.xx and latter versions. Five network
 generators and a new max-flow algorithm are included
 in the package, and can be invoked from the menu.

 This program is robust. A generated arc is written 
 to the disk file, and not stored in the memory. Disk
 full causes a run-time error.
}

Program AcyclicNetwork(input,netres,output);

  type string = packed array [1..20] of char;
  var
    cap:real;
    y,p,q,i,k,num,try,arcnumber:integer;
    node_i,node_j,num_arcs,num_nodes,capacity:integer;
    tail,head:integer;
    ch:char;
    done,special,sparse:boolean;
    OutFileName:string;
    netres:text;
    source:integer;
    sink:integer;

  {Two new Sun-compatible RNG procedures added by McGeoch 11/90}
  Procedure Randomize;
  var i: integer;
    Begin
    	{Pascal function seed(n) sets therng seed to n and returns the
	 previous value.  Integer function wallclock returns the number
	 of seconds elapsed since sometime in 1970. 
	 }
	 i:= seed(wallclock);
     End;
     
  Function irandom(top:integer): integer;
    {Returns an integer from 0..(top-1) }
    Begin
    	{My local Pascal function random(x) ignores its real argument
	 x.  It is not the seed.}
	 irandom := trunc(random(0.0)*top);
    End;

    Procedure WriteArc;
  Begin
    write(netres,'a');
    writeln(netres,tail:10,head:10,cap:10:0);
  End;

  Procedure AcyclicNet1;
    var ss1:real;
    Procedure NewArc1;
    Begin
      if special then
        Begin
          if (head=tail+1) then
            Begin
              ss1:=tail-num_nodes/2;
              cap:=1+sqr(ss1);
            End
          else cap:=1;
        End
      else cap:=random(capacity)+1;
      num:=try;
      try:=try+1;
      WriteArc;
    End;

  Begin                  { Procedure AcyclicNet1 }
    k:=1;   
    for p:=1 to (num_nodes-1) do
    Begin
      tail:=p;
      for q:=p+1 to num_nodes do
      Begin
        head:=q;
        NewArc1;
      End;
    End;
  End;

  Procedure AcyclicNet2;
    Procedure NewArc2;
    Begin
      if (head=tail+1) and (head<>num_nodes) then
        cap:=num_nodes
      else cap:=1;
      num:=try;
      try:=try+1;
      WriteArc;
    End;

  Begin                  { Procedure AcyclicNet2 }
    k:=1;   
    for p:=1 to (num_nodes-1) do
    Begin
      tail:=p;
      head:=p+1;
      NewArc2;
      if (head<>num_nodes) then
      Begin
        tail:=p;
        head:=num_nodes;
        NewArc2;
      End;
    End;
  End;

  Procedure Banner1;
  Begin
    writeln;
    writeln('     ACYCLIC MAX-FLOW NETWORK');
    writeln('           GENERATOR');
    writeln('    Copyright (C) Gary R. Waissi');
    writeln('              (1990)');
    writeln('   University of Michigan-Dearborn');
    writeln('     School of Management, 113FOB');
    writeln('        Dearborn, MI 48128');
    writeln;
    writeln('  The program generates an ACYCLIC');
    writeln('  MAX-FLOW network into a user file.');
    writeln('  An acyclic network is such that');
    writeln('  for each arc (i,j), where i is the');
    writeln('  arc tail node number, and j is the');
    writeln('  arc head node number i<j.');
    writeln;
    writeln('  The generated acyclic network will');
    writeln('  be either fully dense or sparse.');
    writeln;
  End;
  
  Procedure Banner2;
    Begin
      writeln;
      writeln('  This program can generate two');
      writeln('  types of acyclic networks: FULLY');
      writeln('  DENSE and special SPARSE ACYCLIC');
      writeln('  networks.');
      writeln; 
      writeln('  For the FULLY DENSE acyclic ');
      writeln('  networks the user has two options');
      writeln('  for arc flow capacities: random');
      writeln('  or special capacities. Special ');
      writeln('  arcs capacities are calculated ');
      writeln('  using the concept of Glover et al.');
      writeln('  published in "A Comprehensive  ');
      writeln('  Computer Evaluation and Enhancement');
      writeln('  of Maximum Flow Algorithms", Appl.');
      writeln('  of MS, Vol 3, 1983. This approach');
      writeln('  forces flow on each to capacity at');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  optimum. The networks were called');
      writeln('  in the study "hard networks", ');
      writeln('  because such networks were found');
      writeln('  to cause algorithms to their worst');
      writeln('  case performance.');
      writeln('  The special SPARSE acyclic networks');
      writeln('  are such that each node is connected');
      writeln('  by an arc to the next node and to');
      writeln('  the sink node, i.e. there exist two');
      writeln('  types of arcs: 1. (i,j) where j=i+1');
      writeln('  for all i and j\t with capacity n;');
      writeln('  and 2. (i,t) for all i\t with ');
      writeln('  capacity 1. These simple networks');
      writeln('  cause the Dinic Algorithm (Dinic,');
      writeln('  E.A., Algorithm for Solution of ');
      writeln('  a Problem of Maximum Flow in ');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  a Network with Power Estimation,');
      writeln('  Soviet Math. Dokl. Vol. 11, No. 5,');
      writeln('  pp. 1277-1280, 1970), to it''s worst');
      writeln('  case performance. These sparse ');
      writeln('  acyclic networks were presented in');
      writeln('  the dissertation of Gary R. Waissi,');
      writeln('  "Acyclic Network Generation and');
      writeln('  Maximal Flow Algorithms for Single');
      writeln('  Commodity Flow", University of');
      writeln('  Michigan, 1985.');
      write('  Press ENTER <ret> to continue');
      readln;
    End;
  
  Procedure Banner3;
    Begin
      writeln;
      writeln('  You can choose either random');
      writeln('  capacities for arcs, or special');
      writeln('  arc capacities. Special arc ');
      writeln('  capacities are calculated using');
      writeln('  the following (Glover et al):');
      writeln('  1. cap(i,j)=1 for each (i,j) with');
      writeln('     j>i+1');
      writeln('  2. cap(i,j)=1+(i-n/2)^2 for each');
      writeln('     (i,j) with j=i+1');
      writeln;
      writeln('  The program, however, will round');
      writeln('  all non-integer capacities to');
      writeln('  integer values to conform with');
      writeln('  DIMACS specifications.');
      writeln;
    End;

  Procedure Banner4;
    Begin
      if not sparse then
        writeln(netres,'c Fully Dense Acyclic Network')
      else writeln(netres,'c Sparse Acyclic Network');
      writeln(netres,'c for Max-Flow');
      if not special then
        writeln(netres,'c Arcs with random capacities')
      else writeln(netres,'c Arcs with special capacities');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
      writeln;
      writeln('  Please notice, that for simplicity');
      writeln('  the source node s is always numbered');
      writeln('  with 1, and the sink node t is');
      writeln('  assigned the largest node number,');
      writeln('  here t = ',sink,'.');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  AN ACYCLIC MAX-FLOW NETWORK will');
      writeln('  be generated to file ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The sink node is node   ',sink:8);
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
    End;

  Procedure Banner5;
    Begin
      writeln('  The network is completed. The data');
      writeln('  file is an ASCII file, with name:');
	  writeln('  ',OutFileName,',and can be');
      writeln('  accessed with your editor.');
    End;

  Procedure UserValues;
    Begin
      sparse:=true;
      special:=false;
      done:=false;
      try:=1;
      writeln;
      repeat
        write('  How many nodes are in the network: ');
        readln(num_nodes);
        if (num_nodes<=1) then
        writeln('  Try again. Need at least two nodes.');
      until (num_nodes>1);
      source:=1;
      sink:=num_nodes;
      Banner2;
      writeln('  Do you want a FULLY DENSE or');
      writeln('  a SPARSE acyclic network.');
      writeln('  Type F for FULLY DENSE and S for');
      write('  SPARSE (F/S): ');
      readln(ch);
      if (ch='f') or (ch='F') then
      Begin
        sparse:=false;
        num_arcs:=0;
        for i:=1 to (num_nodes-1) do num_arcs:=num_arcs+i;
        Banner3;
        writeln('  Do you want special arc flow');
        write('  capacities (Y/N): ');
        readln(ch);
        if (ch='y') or (ch='Y') then special:=true
        else
          begin
            writeln('  What is the upper bound for arc');
            write('  FLOW CAPACITY: ');
            readln(capacity);
          end;
        Banner4;
        AcyclicNet1;
      End
      else if (ch='s') or (ch='S') then
      Begin
        num_arcs:=-1;
        for i:=2 to num_nodes do num_arcs:=num_arcs+2;
        special:=true;
        Banner4;
        AcyclicNet2;
      End;
    End;

Begin
  randomize;  {Turbo Pascal random number generator initiator.  }
              {You may have to replace this by compiler         }
              {specific randomizer, or write a short procedure. }
  Banner1;
  writeln('  Try the network generation out by');
  writeln('  following the instructions.');
  write('  Do you want to continue (Y/N) ');
  readln(ch);
  if (ch='y') or (ch='Y') then
  Begin
    write('  Enter name of the output file: ');
    readln(OutFileName);
{ SUN     assign(netres,OutFileName+'.max'); }
    rewrite(netres,OutFileName);
    UserValues;
{ SUN     close(netres); }
    Banner5;
  End;
End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/ac-max.pas
{
 ACYCLIC NETWORK GENERATOR FOR MAX-FLOW 
                               (revised 11/25/90)
                               (revised 01/04/91)

 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revisions and corrections: INTEGER changed to LONGINT
 to allow the range [-2^31 ... 2^31-1]. A bug was 
 corrected in the calculation of num_arcs for special
 SPARSE networks, (line 312 shall read:

   for i:=2 to num_nodes do num_arcs:=num_arcs+2;

 This source program has been given to public domain
 through DIMACS. 

 This program generates ACYCLIC MAX-FLOW NETWORKS to 
 user specified files. Two types of acyclic networks
 can be generated: FULLY DENSE and special SPARSE 
 acyclic networks. The two key procedures are:

 PROCEDURE AcyclicNet1;   (fully dense networks)
 PROCEDURE AcyclicNet2;   (special sparse networks)

 Data file format corresponds to DIMACS data file
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for 
 transportability.

 Another version of this program, that uses windowing
 and has a user-friendly menu interface is available.
 The version uses Turbo Pascal 5.5 features (including
 CTR, DOS), and is compiled in Turbo Pascal Units TPU's.
 Runs on DOS 3.xx and latter versions. Five network
 generators and a new max-flow algorithm are included
 in the package, and can be invoked from the menu.

 This program is robust. A generated arc is written 
 to the disk file, and not stored in the memory. Disk
 full causes a run-time error.
}

Program AcyclicNetwork(input,netres);

  var
    cap:real;
    y,p,q,i,k,num,try,arcnumber:longint;
    node_i,node_j,num_arcs,num_nodes,capacity:longint;
    tail,head:longint;
    ch:char;
    done,special,sparse:boolean;
    OutFileName:string[20];
    netres:text;
    source:longint;
    sink:longint;

  Procedure WriteArc;
  Begin
    write(netres,'a');
    writeln(netres,tail:10,head:10,cap:10:0);
  End;

  Procedure AcyclicNet1;
    var ss1:real;
    Procedure NewArc1;
    Begin
      if special then
        Begin
          if (head=tail+1) then
            Begin
              ss1:=tail-num_nodes/2;
              cap:=1+sqr(ss1);
            End
          else cap:=1;
        End
      else cap:=random(capacity)+1;
      num:=try;
      try:=try+1;
      WriteArc;
    End;

  Begin                  { Procedure AcyclicNet1 }
    k:=1;   
    for p:=1 to (num_nodes-1) do
    Begin
      tail:=p;
      for q:=p+1 to num_nodes do
      Begin
        head:=q;
        NewArc1;
      End;
    End;
  End;

  Procedure AcyclicNet2;
    Procedure NewArc2;
    Begin
      if (head=tail+1) and (head<>num_nodes) then
        cap:=num_nodes
      else cap:=1;
      num:=try;
      try:=try+1;
      WriteArc;
    End;

  Begin                  { Procedure AcyclicNet2 }
    k:=1;   
    for p:=1 to (num_nodes-1) do
    Begin
      tail:=p;
      head:=p+1;
      NewArc2;
      if (head<>num_nodes) then
      Begin
        tail:=p;
        head:=num_nodes;
        NewArc2;
      End;
    End;
  End;

  Procedure Banner1;
  Begin
    writeln;
    writeln('     ACYCLIC MAX-FLOW NETWORK');
    writeln('           GENERATOR');
    writeln('    Copyright (C) Gary R. Waissi');
    writeln('              (1990)');
    writeln('   University of Michigan-Dearborn');
    writeln('     School of Management, 113FOB');
    writeln('        Dearborn, MI 48128');
    writeln;
    writeln('  The program generates an ACYCLIC');
    writeln('  MAX-FLOW network into a user file.');
    writeln('  An acyclic network is such that');
    writeln('  for each arc (i,j), where i is the');
    writeln('  arc tail node number, and j is the');
    writeln('  arc head node number i<j.');
    writeln;
    writeln('  The generated acyclic network will');
    writeln('  be either fully dense or sparse.');
    writeln;
  End;
  
  Procedure Banner2;
    Begin
      writeln;
      writeln('  This program can generate two');
      writeln('  types of acyclic networks: FULLY');
      writeln('  DENSE and special SPARSE ACYCLIC');
      writeln('  networks.');
      writeln; 
      writeln('  For the FULLY DENSE acyclic ');
      writeln('  networks the user has two options');
      writeln('  for arc flow capacities: random');
      writeln('  or special capacities. Special ');
      writeln('  arcs capacities are calculated ');
      writeln('  using the concept of Glover et al.');
      writeln('  published in "A Comprehensive  ');
      writeln('  Computer Evaluation and Enhancement');
      writeln('  of Maximum Flow Algorithms", Appl.');
      writeln('  of MS, Vol 3, 1983. This approach');
      writeln('  forces flow on each to capacity at');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  optimum. The networks were called');
      writeln('  in the study "hard networks", ');
      writeln('  because such networks were found');
      writeln('  to cause algorithms to their worst');
      writeln('  case performance.');
      writeln('  The special SPARSE acyclic networks');
      writeln('  are such that each node is connected');
      writeln('  by an arc to the next node and to');
      writeln('  the sink node, i.e. there exist two');
      writeln('  types of arcs: 1. (i,j) where j=i+1');
      writeln('  for all i and j\t with capacity n;');
      writeln('  and 2. (i,t) for all i\t with ');
      writeln('  capacity 1. These simple networks');
      writeln('  cause the Dinic Algorithm (Dinic,');
      writeln('  E.A., Algorithm for Solution of ');
      writeln('  a Problem of Maximum Flow in ');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  a Network with Power Estimation,');
      writeln('  Soviet Math. Dokl. Vol. 11, No. 5,');
      writeln('  pp. 1277-1280, 1970), to it''s worst');
      writeln('  case performance. These sparse ');
      writeln('  acyclic networks were presented in');
      writeln('  the dissertation of Gary R. Waissi,');
      writeln('  "Acyclic Network Generation and');
      writeln('  Maximal Flow Algorithms for Single');
      writeln('  Commodity Flow", University of');
      writeln('  Michigan, 1985.');
      write('  Press ENTER <ret> to continue');
      readln;
    End;
  
  Procedure Banner3;
    Begin
      writeln;
      writeln('  You can choose either random');
      writeln('  capacities for arcs, or special');
      writeln('  arc capacities. Special arc ');
      writeln('  capacities are calculated using');
      writeln('  the following (Glover et al):');
      writeln('  1. cap(i,j)=1 for each (i,j) with');
      writeln('     j>i+1');
      writeln('  2. cap(i,j)=1+(i-n/2)^2 for each');
      writeln('     (i,j) with j=i+1');
      writeln;
      writeln('  The program, however, will round');
      writeln('  all non-integer capacities to');
      writeln('  integer values to conform with');
      writeln('  DIMACS specifications.');
      writeln;
    End;

  Procedure Banner4;
    Begin
      if not sparse then
        writeln(netres,'c Fully Dense Acyclic Network')
      else writeln(netres,'c Sparse Acyclic Network');
      writeln(netres,'c for Max-Flow');
      if not special then
        writeln(netres,'c Arcs with random capacities')
      else writeln(netres,'c Arcs with special capacities');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
      writeln;
      writeln('  Please notice, that for simplicity');
      writeln('  the source node s is always numbered');
      writeln('  with 1, and the sink node t is');
      writeln('  assigned the largest node number,');
      writeln('  here t = ',sink,'.');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  AN ACYCLIC MAX-FLOW NETWORK will');
      writeln('  be generated to file ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The sink node is node   ',sink:8);
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
    End;

  Procedure Banner5;
    Begin
      writeln('  The network is completed. The data');
      writeln('  file is an ASCII file, and can be');
      writeln('  accessed with your editor. You may');
      writeln('  print the file using the DOS');
      writeln('  command PRINT ',OutFileName,'.max.');
    End;

  Procedure UserValues;
    Begin
      sparse:=true;
      special:=false;
      done:=false;
      try:=1;
      writeln;
      repeat
        write('  How many nodes are in the network: ');
        readln(num_nodes);
        if (num_nodes<=1) then
        writeln('  Try again. Need at least two nodes.');
      until (num_nodes>1);
      source:=1;
      sink:=num_nodes;
      Banner2;
      writeln('  Do you want a FULLY DENSE or');
      writeln('  a SPARSE acyclic network.');
      writeln('  Type F for FULLY DENSE and S for');
      write('  SPARSE (F/S): ');
      readln(ch);
      if (ch='f') or (ch='F') then
      Begin
        sparse:=false;
        num_arcs:=0;
        for i:=1 to (num_nodes-1) do num_arcs:=num_arcs+i;
        Banner3;
        writeln('  Do you want special arc flow');
        write('  capacities (Y/N): ');
        readln(ch);
        if (ch='y') or (ch='Y') then special:=true
        else
          begin
            writeln('  What is the upper bound for arc');
            write('  FLOW CAPACITY: ');
            readln(capacity);
          end;
        Banner4;
        AcyclicNet1;
      End
      else if (ch='s') or (ch='S') then
      Begin
        num_arcs:=-1;
        for i:=2 to num_nodes do num_arcs:=num_arcs+2;
        special:=true;
        Banner4;
        AcyclicNet2;
      End;
    End;

Begin
  randomize;  {Turbo Pascal random number generator initiator.  }
              {You may have to replace this by compiler         }
              {specific randomizer, or write a short procedure. }
  Banner1;
  writeln('  Try the network generation out by');
  writeln('  following the instructions.');
  write('  Do you want to continue (Y/N) ');
  readln(ch);
  if (ch='y') or (ch='Y') then
  Begin
    write('  Enter name of the output file: ');
    readln(OutFileName);
    assign(netres,OutFileName+'.max');
    rewrite(netres);
    UserValues;
    close(netres);
    Banner5;
  End;
End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/bi-max.p
{
 BIPARTITE MAX-FLOW NETWORK GENERATOR FOR MAX-FLOW
                                (revised 11/25/90)
                                (revised 01/04/91)

 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revisions: INTEGER is changed to LONGINT to allow
 range [-2^31 ... 2^31-1]. 

 This program generates BIPARTITE MAX-FLOW NETWORKS
 to user specified files. The key procedure is:

 PROCEDURE BipartiteNet;

 Data file format corresponds to DIMACS data file
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge: 
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for
 transportability.

 Another version, that uses windowing and a user
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR, DOS),
 and is compiled in Turbo Pascal Units TPU's. Runs on
 DOS 3.xx and latter versions. Five network generators
 and a new max-flow algorithm are included in the 
 package, and can be invoked from the menu.

 This program is robust. A generated arc is written 
 to the disk file, and not stored in the memory. Disk
 full causes a run-time error.
}

Program BipartiteNetwork(input,output);

  type string = packed array [1..20] of char;
  var 
      ii,jj,cap:integer;
      i,k,kk,z,num,col,imax,jmax,capacity:integer;
      num_nodes,num_arcs:integer;
      source,sink:integer;
      ch:char;
      found:boolean;
      unit_cap:boolean;
      OutFileName:string;
      netres:text;

  {Two new Sun-compatible RNG procedures added by McGeoch 11/90}
  Procedure Randomize;
  var i: integer;
    Begin
    	{Pascal function seed(n) sets therng seed to n and returns the
	 previous value.  Integer function wallclock returns the number
	 of seconds elapsed since sometime in 1970. 
	 }
	 i:= seed(wallclock);
     End;
     
  Function irandom(top:integer): integer;
    {Returns an integer from 0..(top-1) }
    Begin
    	{My local Pascal function random(x) ignores its real argument
	 x.  It is not the seed.}
	 irandom := trunc(random(0.0)*top);
    End;
  Procedure WriteArcs;
    Begin
      write(netres,'a');
      writeln(netres,ii:10,jj:10,cap:10);
    End;

  Procedure BipartiteNet;
    Procedure SourceArcs;
      Begin
        i:=2; z:=1;
        repeat
          ii:=1; jj:=i;
          cap:=irandom(capacity)+1;
          WriteArcs;
          z:=z+1; i:=i+1;
        until i=imax+2;
      End;

    Procedure BipartiteArcs;
      Begin
        i:=2;
        k:=imax+1;
        repeat
          repeat
            ii:=i;
            jj:=k+1;
            if unit_cap then cap:=1
            else cap:=irandom(capacity)+1;
            WriteArcs;
            z:=z+1;
            k:=k+1;
          until k=imax+jmax+1;
          i:=i+1;
          k:=imax+1;
        until i=imax+2;
      End;

    Procedure SinkArcs;
      Begin
        i:=imax+2;
        repeat
          ii:=i;
          jj:=imax+jmax+2;
          cap:=irandom(capacity)+1;
          WriteArcs;
          z:=z+1; i:=i+1;
        until i=imax+jmax+2;
      End;

    Begin                 { Procedure BipartiteNet; }
      kk:=1;
      SourceArcs;
      BipartiteArcs;
      SinkArcs;
    End;
  
  Procedure Banner1;
    Begin
      writeln;
      writeln('    BIPARTITE MAX-FLOW NETWORK');
      writeln('           GENERATOR');
      writeln('    Copyright (C) Gary R. Waissi');
      writeln('              (1990)');
      writeln('   University of Michigan-Dearborn');
      writeln('     School of Management, 113FOB');
      writeln('        Dearborn, MI 48128');
      writeln;
      writeln('  This program generates a BIPARTITE');
      writeln('  MAX-FLOW network into a user file.');
      writeln('  The bipartite network is appended');
      writeln('  with two nodes, a common source ');
      writeln('  "super source" and a common sink');
      writeln('  "super sink". The program is');
      writeln('  designed for max-flow applications.');
      writeln('  The generated data file corresponds');
      writeln('  to DIMACS (1990) specifications.');
      writeln;
    End;

  Procedure Banner2;
    Begin
      writeln;
      writeln('  A BIPARTITE MAX-FLOW NETWORK will');
      writeln('  be generated to file ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The sink node is node   ',source:8);
      writeln('  The sink node is numbered with the ');
      writeln('  largest node number. ');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln(netres,'c Bipartite Network for Max-Flow');
      if unit_cap then
        writeln(netres,'c with UNIT capacities on bipartite arcs')
      else
        writeln(netres,'c with RANDOM capacities');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
      writeln;
      writeln('  The network generation is in progress.');
      writeln('  Please wait.');
    End;

  Procedure Banner3;
    Begin
      writeln;
      writeln('  The network is completed. The data');
      writeln('  file is an ASCII file, with name:');
	  writeln('  ',OutFileName,',and can be');
      writeln('  accessed with your editor.');
    End;

  Procedure UserValues;
    Begin
      unit_cap:=false;
      repeat
        writeln('  Type the number of nodes on');
        write('  the source side: ');
        readln(imax);
        if (imax<1) then
        writeln('  Try again. Need at least one node.');
      until (imax>=1);
      repeat
        writeln('  Type the number of nodes on the');
        write('  sink side: ');
        readln(jmax);
        if (jmax<1) then
        writeln('  Try again. Need at least one node.');
      until (jmax>=1);
      writeln;
      writeln('  You have two choices for arc');
      writeln('  capacities: either unit capacities');
      writeln('  or random capacities.');
      writeln('  Do you want unit flow capacities');
      write('  on bipartite arcs (Y/N) ');
      readln(ch);
      if (ch='y') or (ch='Y') then unit_cap:=true;
      if unit_cap then
        Begin
          writeln('  Give an upper bound for the ');
          writeln('  random CAPACITY for arcs out');
          write('  of the source and into the sink: ');
          readln(capacity);
        End
      else
        Begin
          writeln('  Give an upper bound for the');
          write('  random CAPACITY: ');
          readln(capacity);
        End;
      num_nodes:=imax+jmax+2;
      num_arcs:=imax+jmax+imax*jmax;
      source:=1;
      sink:=num_nodes;
    End;

  Begin
    randomize;  {Turbo Pascal random number generator initiator.}
                {You may to replace this by compiler specific   }
                {randomizer, or write a short procedure.        }
    Banner1;
    writeln('  Try the network generation out by');
    writeln('  following the instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);
{ SUN       assign(netres,OutFileName+'.max'); }
      rewrite(netres,OutFileName);
      UserValues;
      Banner2;
      BipartiteNet;
{ SUN       close(netres); }
      Banner3;
    End;
  End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/bi-max.pas
{
 BIPARTITE MAX-FLOW NETWORK GENERATOR FOR MAX-FLOW
                                (revised 11/25/90)
                                (revised 01/04/91)

 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revisions: INTEGER is changed to LONGINT to allow
 range [-2^31 ... 2^31-1]. 

 This program generates BIPARTITE MAX-FLOW NETWORKS
 to user specified files. The key procedure is:

 PROCEDURE BipartiteNet;

 Data file format corresponds to DIMACS data file
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge: 
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for
 transportability.

 Another version, that uses windowing and a user
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR, DOS),
 and is compiled in Turbo Pascal Units TPU's. Runs on
 DOS 3.xx and latter versions. Five network generators
 and a new max-flow algorithm are included in the 
 package, and can be invoked from the menu.

 This program is robust. A generated arc is written 
 to the disk file, and not stored in the memory. Disk
 full causes a run-time error.
}

Program BipartiteNetwork(input,output);

  var 
      ii,jj,cap:longint;
      i,k,kk,z,num,col,imax,jmax,capacity:longint;
      num_nodes,num_arcs:longint;
      source,sink:longint;
      ch:char;
      found:boolean;
      unit_cap:boolean;
      OutFileName:string[20];
      netres:text;

  Procedure WriteArcs;
    Begin
      write(netres,'a');
      writeln(netres,ii:10,jj:10,cap:10);
    End;

  Procedure BipartiteNet;
    Procedure SourceArcs;
      Begin
        i:=2; z:=1;
        repeat
          ii:=1; jj:=i;
          cap:=random(capacity)+1;
          WriteArcs;
          z:=z+1; i:=i+1;
        until i=imax+2;
      End;

    Procedure BipartiteArcs;
      Begin
        i:=2;
        k:=imax+1;
        repeat
          repeat
            ii:=i;
            jj:=k+1;
            if unit_cap then cap:=1
            else cap:=random(capacity)+1;
            WriteArcs;
            z:=z+1;
            k:=k+1;
          until k=imax+jmax+1;
          i:=i+1;
          k:=imax+1;
        until i=imax+2;
      End;

    Procedure SinkArcs;
      Begin
        i:=imax+2;
        repeat
          ii:=i;
          jj:=imax+jmax+2;
          cap:=random(capacity)+1;
          WriteArcs;
          z:=z+1; i:=i+1;
        until i=imax+jmax+2;
      End;

    Begin                 { Procedure BipartiteNet; }
      kk:=1;
      SourceArcs;
      BipartiteArcs;
      SinkArcs;
    End;
  
  Procedure Banner1;
    Begin
      writeln;
      writeln('    BIPARTITE MAX-FLOW NETWORK');
      writeln('           GENERATOR');
      writeln('    Copyright (C) Gary R. Waissi');
      writeln('              (1990)');
      writeln('   University of Michigan-Dearborn');
      writeln('     School of Management, 113FOB');
      writeln('        Dearborn, MI 48128');
      writeln;
      writeln('  This program generates a BIPARTITE');
      writeln('  MAX-FLOW network into a user file.');
      writeln('  The bipartite network is appended');
      writeln('  with two nodes, a common source ');
      writeln('  "super source" and a common sink');
      writeln('  "super sink". The program is');
      writeln('  designed for max-flow applications.');
      writeln('  The generated data file corresponds');
      writeln('  to DIMACS (1990) specifications.');
      writeln;
    End;

  Procedure Banner2;
    Begin
      writeln;
      writeln('  A BIPARTITE MAX-FLOW NETWORK will');
      writeln('  be generated to file ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The sink node is node   ',source:8);
      writeln('  The sink node is numbered with the ');
      writeln('  largest node number. ');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln(netres,'c Bipartite Network for Max-Flow');
      if unit_cap then
        writeln(netres,'c with UNIT capacities on bipartite arcs')
      else
        writeln(netres,'c with RANDOM capacities');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
      writeln;
      writeln('  The network generation is in progress.');
      writeln('  Please wait.');
    End;

  Procedure Banner3;
    Begin
      writeln;
      writeln('  The network is completed. The data');
      writeln('  file is an ASCII file, and can be');
      writeln('  accessed with your editor. You may');
      writeln('  print the file using the DOS');
      writeln('  command PRINT ',OutFileName,'.max.');
    End;

  Procedure UserValues;
    Begin
      unit_cap:=false;
      repeat
        writeln('  Type the number of nodes on');
        write('  the source side: ');
        readln(imax);
        if (imax<1) then
        writeln('  Try again. Need at least one node.');
      until (imax>=1);
      repeat
        writeln('  Type the number of nodes on the');
        write('  sink side: ');
        readln(jmax);
        if (jmax<1) then
        writeln('  Try again. Need at least one node.');
      until (jmax>=1);
      writeln;
      writeln('  You have two choices for arc');
      writeln('  capacities: either unit capacities');
      writeln('  or random capacities.');
      writeln('  Do you want unit flow capacities');
      write('  on bipartite arcs (Y/N) ');
      readln(ch);
      if (ch='y') or (ch='Y') then unit_cap:=true;
      if unit_cap then
        Begin
          writeln('  Give an upper bound for the ');
          writeln('  random CAPACITY for arcs out');
          write('  of the source and into the sink: ');
          readln(capacity);
        End
      else
        Begin
          writeln('  Give an upper bound for the');
          write('  random CAPACITY: ');
          readln(capacity);
        End;
      num_nodes:=imax+jmax+2;
      num_arcs:=imax+jmax+imax*jmax;
      source:=1;
      sink:=num_nodes;
    End;

  Begin
    randomize;  {Turbo Pascal random number generator initiator.}
                {You may to replace this by compiler specific   }
                {randomizer, or write a short procedure.        }
    Banner1;
    writeln('  Try the network generation out by');
    writeln('  following the instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);
      assign(netres,OutFileName+'.max');
      rewrite(netres);
      UserValues;
      Banner2;
      BipartiteNet;
      close(netres);
      Banner3;
    End;
  End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/index
total 142
-rw-rw-r--  1 badics      12256 Feb 21  1991 ac-max.p
-rw-rw-r--  1 badics      11672 Feb 21  1991 ac-max.pas
-rw-rw-r--  1 badics       8523 Feb 21  1991 bi-max.p
-rw-rw-r--  1 badics       7946 Feb 21  1991 bi-max.pas
-r--rw-r--  1 badics          0 Sep 12 21:01 index
-rw-rw-r--  1 badics      11614 Feb 21  1991 ra-max.p
-rw-rw-r--  1 badics      11027 Feb 21  1991 ra-max.pas
-rw-rw-r--  1 mcgeoch     11098 Nov 30  1990 random.p
-rw-rw-r--  1 mcgeoch     10563 Nov 30  1990 random.pas
-rw-rw-r--  1 mcgeoch      1195 Jul  1 19:28 readme
-rw-rw-r--  1 badics      18202 Feb 21  1991 readme_next
drwxrwsr-x  2 badics        512 May 29 19:54 tp55
-rw-rw-r--  1 badics       8781 Feb 21  1991 tr1-max.p
-rw-rw-r--  1 badics       8204 Feb 21  1991 tr1-max.pas
-rw-rw-r--  1 badics       8568 Feb 21  1991 tr2-max.p
-rw-rw-r--  1 badics       7989 Feb 21  1991 tr2-max.pas
SHAR_EOF
cat << 'SHAR_EOF' > waissi/ra-max.p
{
 RANDOM NETWORK GENERATOR FOR MAX-FLOW  (revised 11/25/90)

 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revisions: INTEGER changed to LONGINT to allow the
 range of [-2^31 ... 2^31-1].

 This program generates RANDOM NETWORKS for MAX-FLOW
 applications to user specified files. Key procedure is:

 PROCEDURE RandomNet;

 Data file format corresponds to DIMACS data file
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for 
 transportability.

 Another version, that uses windowing and a user 
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR, DOS),
 and is compiled in Turbo Pascal Units TPU's. Runs on
 DOS 3.xx and latter versions. Five network generators
 and a new max-flow algorithm are included in the 
 package, and can be invoked from the menu.

 This program generates a BALANCED ARC TREE. This arc
 tree is temporarily maintained and manipulated in the 
 RAM. When the network is complete, i.e. the arc tree
 is filled with arcs (random pairs of numbers), the 
 network is written to a file. Two types of run-time
 errors may occur:

   101 Disk write error, if the disk becomes full
   203 Heap overflow error. With Turbo Pascal 5.5
       the stack, heap minimum and heap maximum sizes
       can be controlled using the M compiler option:
       [ M stacksize,heapmin,heapmax], with default
       being [ M 16384,0,655360]. See below an example
       use of this compiler option. 
       
       Each dynamic variable is stored in the heap by
       stacking them on the top of each other.

 In Turbo Pascal 5.5 the available memory can be tested
 using MemAvail and MaxAvail functions (omitted here for
 transportability). Please note, that relatively small
 networks, a few thousand nodes and arcs, will already
 cause a heap overflow on PC's with 512 to 640kB of RAM.
}

Program RandomNetwork(input,netres,output);
{$M 16384,0,512000}

  Type
  ArcTreeType  = ^ArcRecord;
  ArcRecord    =
    RECORD
      ArcNumber:integer;
      ii :integer;
      jj :integer;
      cap:integer;
      LeftArcTree,RightArcTree:ArcTreeType;
    End;
  type string = packed array [1..20] of char;

  Var
    Arc:ArcTreeType;
    ArcTreeRoot:ArcTreeType;
    i,num,arcnumber:integer;
    num_arcs,num_nodes,capacity:integer;
    z:integer;
    X,Y:integer;
    xx1,xx2,xx3,xx4:integer;
    source,sink:integer;
    ch:char;
    found:boolean;
    found11,found22:boolean;
    OutFileName:string;
    netres:text;

  {Two new Sun-compatible RNG procedures added by McGeoch 11/90}
  Procedure Randomize;
  var i: integer;
    Begin
    	{Pascal function seed(n) sets therng seed to n and returns the
	 previous value.  Integer function wallclock returns the number
	 of seconds elapsed since sometime in 1970. 
	 }
	 i:= seed(wallclock);
     End;
     
  Function irandom(top:integer): integer;
    {Returns an integer from 0..(top-1) }
    Begin
    	{My local Pascal function random(x) ignores its real argument
	 x.  It is not the seed.}
	 irandom := trunc(random(0.0)*top);
    End;

    Function ArcTree(nn:integer):ArcTreeType;
    Var NewArc:ArcTreeType;
        nll,nrr:integer;
  Begin
    IF nn=0 THEN ArcTree:=nil ELSE
    Begin
      nll:=nn DIV 2; nrr:=nn-nll-1;
      xx1:=xx1+1;
      xx2:=0;xx3:=0;xx4:=0;
      NEW(NewArc);
      WITH NewArc^ DO
      Begin
        ArcNumber:=xx1;
        ii:=xx2; jj:=xx3; Cap:=xx4;
        LeftArcTree :=ArcTree(nll);
        RightArcTree:=ArcTree(nrr);
      End;
      ArcTree:=NewArc;
    End;
  End;

  Procedure LocateArc(t2:ArcTreeType; h2:integer);
    VAR Found2:BOOLEAN;
    Begin
      Found2:=FALSE;
      WHILE (t2<>nil) AND NOT Found2 DO
      Begin
        IF t2^.ArcNumber=h2 THEN Found2:=TRUE
        ELSE IF h2=t2^.LeftArcTree^.ArcNumber
        THEN t2:=t2^.LeftArcTree
        ELSE IF h2=t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.RightArcTree
        ELSE IF h2<t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.LeftArcTree
        ELSE IF h2>t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.RightArcTree;
      End;
      IF Found2 THEN Arc:=t2;
    End;

  Procedure PrintArcTree(ArcTree1:ArcTreeType);
    Begin
      IF ArcTree1<>nil THEN
      WITH ArcTree1^ DO
      Begin
        PrintArcTree(LeftArcTree);
        write(netres,'a');
        writeln(netres,ii:10,jj:10,Cap:10);
        z:=z+1;
        PrintArcTree(RightArcTree);
      End;
    End;

Procedure Randomnet;
  var complete:boolean;
  Procedure Add_Arc1;
    Begin
      z:=1;
      repeat
      Begin
        LocateArc(ArcTreeRoot,Z);
        IF (Arc^.ii=0) and (Arc^.jj=0) THEN
          Begin
            Arc^.ii:=X; Arc^.jj:=Y;
            Arc^.cap:=irandom(capacity)+1;
            IF z=num_arcs THEN complete:=true;
            z:=num_arcs;
          End;
        z:=z+1;
      End;
      until z=num_arcs+1;
    End;

  Procedure Add_Arc2;
    Begin
      z:=1;
      repeat
      Begin
        LocateArc(ArcTreeRoot,Z);
        IF (Arc^.ii=0) and (Arc^.jj=0) THEN
          Begin
            Arc^.ii:=Y; Arc^.jj:=X;
            Arc^.cap:=irandom(capacity)+1;
            IF z=num_arcs THEN complete:=true;
            z:=num_arcs;
          End;
        z:=z+1;
      End;
      until z=num_arcs+1;
    End;

  Begin
    complete:=false;
    repeat
    Begin
      Begin
        repeat
          X:=irandom(num_nodes)+1;
          Y:=irandom(num_nodes)+1;
        until (Y<>X);
      End;
      IF X<>Y THEN
      Begin
        found11:=false;
        found22:=false;
        for z:=1 to num_arcs do
        Begin
          LocateArc(ArcTreeRoot,Z);
          IF ((X=Arc^.ii) and (Y=Arc^.jj))
            THEN found11:=true;
        End;
        IF not found11 THEN Add_Arc1
        else if found11 then
        Begin
          for z:=1 to num_arcs do
          Begin
            LocateArc(ArcTreeRoot,Z);
            IF ((Y=Arc^.ii) and (X=Arc^.jj))
              THEN found22:=true;
          End;
          IF not found22 THEN Add_Arc2;
        End;
      End;
    End;
    until complete;
  End;
  
  Procedure Banner1;
    Begin
      writeln;
      writeln('     RANDOM NETWORK GENERATOR');
      writeln('          FOR MAX-FLOW');
      writeln('    Copyright (C) Gary R. Waissi');
      writeln('              (1990)');
      writeln('   University of Michigan-Dearborn');
      writeln('     School of Management, 113FOB');
      writeln('        Dearborn, MI 48128');
      writeln;
      writeln('  This program generates a RANDOM');
      writeln('  network for MAX-FLOW into a user');
      writeln('  file. The network is generated by');
      writeln('  randomly pairing a given number');
      writeln('  of nodes using a given number of');
      writeln('  arcs.');
      writeln;
    End;

  Procedure Banner2;
    Begin
      writeln;
      writeln('  The maximum number of arcs in');
      writeln('  a fully dense network cannot ');
      writeln('  exceed n^2-n. Also, you need at');
      writeln('  least one arc. Duplicate arcs');
      writeln('  and self-loops will not ');
      writeln('  be allowed.    ');
    End;

  Procedure Banner3;
    Begin
      writeln;
      writeln('  A RANDOM NETWORK for MAX-FLOW will');
      writeln('  be generated to file ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The sink node is node   ',sink:8);
      writeln('  The sink node is numbered with the');
      writeln('  largest node number. ');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network generation may take');
      writeln('  some time. The entire network is');
      writeln('  temporarily stored in a tree in RAM.');
      writeln('  The storage of the tree requires');
      writeln('  storing of dynamic variables in ');
      writeln('  a heap. The heap sizes are limited,');
      writeln('  but can usually be controlled using');
      writeln('  various compiler options. ');
      writeln('  PLEASE WAIT !!');
      writeln;
    End;

  Procedure Banner4;
    Begin
      writeln;
      writeln('  The network is completed. The data');
      writeln('  file is an ASCII file, with name:');
	  writeln('  ',OutFileName,',and can be');
      writeln('  accessed with your editor.');
   End;

  Procedure UserValues;
    var total_arcs:integer;
    Begin
      xx1:=0;
      repeat
        write('  How many nodes are in the network: ');
        readln(num_nodes);
        if (num_nodes<=1) then
        writeln('  Try again. Need at least two nodes.');
      until (num_nodes>1);
      total_arcs:=num_nodes*num_nodes-num_nodes;
      write('  How many arcs are in the network: ');
      Begin
        repeat
          readln(num_arcs);
          if (num_arcs>total_arcs) OR (num_arcs<1) then
            Begin
              Banner2;
              writeln('  Try again with the number of');
              writeln('  arcs at least one, but not ');
              writeln('  more than ',total_arcs,'.');
              write('  How many arcs are in the network: ');
            End;
          until ((num_arcs<=total_arcs) AND (num_arcs>=1));
      End;      
      writeln('  What is the upper bound for arc flow');
      write('  CAPACITY: ');
      readln(capacity);
      source:=1;
      sink:=num_nodes;
      Banner3;
      writeln(netres,'c Random Network');
      writeln(netres,'c for Max-Flow');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
      ArcTreeRoot:=ArcTree(num_arcs);
    End;

  Begin
    randomize;  {Turbo Pascal random number generator initiator.}
                {You may to replace this by compiler specific   }
                {randomizer, or write a short procedure.        }
    Banner1;
    writeln('  Try the network generation out by');
    writeln('  following the instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);
{ SUN       assign(netres,OutFileName+'.max'); }
      rewrite(netres,OutFileName);
      UserValues;
      RandomNet;
      z:=1;
      PrintArcTree(ArcTreeRoot);
{ SUN       close(netres); }
      Banner4;
    End;
  End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/ra-max.pas
{
 RANDOM NETWORK GENERATOR FOR MAX-FLOW  (revised 11/25/90)

 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revisions: INTEGER changed to LONGINT to allow the
 range of [-2^31 ... 2^31-1].

 This program generates RANDOM NETWORKS for MAX-FLOW
 applications to user specified files. Key procedure is:

 PROCEDURE RandomNet;

 Data file format corresponds to DIMACS data file
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for 
 transportability.

 Another version, that uses windowing and a user 
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR, DOS),
 and is compiled in Turbo Pascal Units TPU's. Runs on
 DOS 3.xx and latter versions. Five network generators
 and a new max-flow algorithm are included in the 
 package, and can be invoked from the menu.

 This program generates a BALANCED ARC TREE. This arc
 tree is temporarily maintained and manipulated in the 
 RAM. When the network is complete, i.e. the arc tree
 is filled with arcs (random pairs of numbers), the 
 network is written to a file. Two types of run-time
 errors may occur:

   101 Disk write error, if the disk becomes full
   203 Heap overflow error. With Turbo Pascal 5.5
       the stack, heap minimum and heap maximum sizes
       can be controlled using the M compiler option:
       [ M stacksize,heapmin,heapmax], with default
       being [ M 16384,0,655360]. See below an example
       use of this compiler option. 
       
       Each dynamic variable is stored in the heap by
       stacking them on the top of each other.

 In Turbo Pascal 5.5 the available memory can be tested
 using MemAvail and MaxAvail functions (omitted here for
 transportability). Please note, that relatively small
 networks, a few thousand nodes and arcs, will already
 cause a heap overflow on PC's with 512 to 640kB of RAM.
}

Program RandomNetwork(input,netres);
{$M 16384,0,512000}

  Type
  ArcTreeType  = ^ArcRecord;
  ArcRecord    =
    RECORD
      ArcNumber:longint;
      ii :longint;
      jj :longint;
      cap:longint;
      LeftArcTree,RightArcTree:ArcTreeType;
    End;

  Var
    Arc:ArcTreeType;
    ArcTreeRoot:ArcTreeType;
    i,num,arcnumber:longint;
    num_arcs,num_nodes,capacity:longint;
    z:longint;
    X,Y:longint;
    xx1,xx2,xx3,xx4:longint;
    source,sink:longint;
    ch:char;
    found:boolean;
    found11,found22:boolean;
    OutFileName:string[20];
    netres:text;

  Function ArcTree(nn:longint):ArcTreeType;
    Var NewArc:ArcTreeType;
        nll,nrr:longint;
  Begin
    IF nn=0 THEN ArcTree:=nil ELSE
    Begin
      nll:=nn DIV 2; nrr:=nn-nll-1;
      xx1:=xx1+1;
      xx2:=0;xx3:=0;xx4:=0;
      NEW(NewArc);
      WITH NewArc^ DO
      Begin
        ArcNumber:=xx1;
        ii:=xx2; jj:=xx3; Cap:=xx4;
        LeftArcTree :=ArcTree(nll);
        RightArcTree:=ArcTree(nrr);
      End;
      ArcTree:=NewArc;
    End;
  End;

  Procedure LocateArc(t2:ArcTreeType; h2:longint);
    VAR Found2:BOOLEAN;
    Begin
      Found2:=FALSE;
      WHILE (t2<>nil) AND NOT Found2 DO
      Begin
        IF t2^.ArcNumber=h2 THEN Found2:=TRUE
        ELSE IF h2=t2^.LeftArcTree^.ArcNumber
        THEN t2:=t2^.LeftArcTree
        ELSE IF h2=t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.RightArcTree
        ELSE IF h2<t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.LeftArcTree
        ELSE IF h2>t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.RightArcTree;
      End;
      IF Found2 THEN Arc:=t2;
    End;

  Procedure PrintArcTree(ArcTree1:ArcTreeType);
    Begin
      IF ArcTree1<>nil THEN
      WITH ArcTree1^ DO
      Begin
        PrintArcTree(LeftArcTree);
        write(netres,'a');
        writeln(netres,ii:10,jj:10,Cap:10);
        z:=z+1;
        PrintArcTree(RightArcTree);
      End;
    End;

Procedure Randomnet;
  var complete:boolean;
  Procedure Add_Arc1;
    Begin
      z:=1;
      repeat
      Begin
        LocateArc(ArcTreeRoot,Z);
        IF (Arc^.ii=0) and (Arc^.jj=0) THEN
          Begin
            Arc^.ii:=X; Arc^.jj:=Y;
            Arc^.cap:=random(capacity)+1;
            IF z=num_arcs THEN complete:=true;
            z:=num_arcs;
          End;
        z:=z+1;
      End;
      until z=num_arcs+1;
    End;

  Procedure Add_Arc2;
    Begin
      z:=1;
      repeat
      Begin
        LocateArc(ArcTreeRoot,Z);
        IF (Arc^.ii=0) and (Arc^.jj=0) THEN
          Begin
            Arc^.ii:=Y; Arc^.jj:=X;
            Arc^.cap:=random(capacity)+1;
            IF z=num_arcs THEN complete:=true;
            z:=num_arcs;
          End;
        z:=z+1;
      End;
      until z=num_arcs+1;
    End;

  Begin
    complete:=false;
    repeat
    Begin
      Begin
        repeat
          X:=random(num_nodes)+1;
          Y:=random(num_nodes)+1;
        until (Y<>X);
      End;
      IF X<>Y THEN
      Begin
        found11:=false;
        found22:=false;
        for z:=1 to num_arcs do
        Begin
          LocateArc(ArcTreeRoot,Z);
          IF ((X=Arc^.ii) and (Y=Arc^.jj))
            THEN found11:=true;
        End;
        IF not found11 THEN Add_Arc1
        else if found11 then
        Begin
          for z:=1 to num_arcs do
          Begin
            LocateArc(ArcTreeRoot,Z);
            IF ((Y=Arc^.ii) and (X=Arc^.jj))
              THEN found22:=true;
          End;
          IF not found22 THEN Add_Arc2;
        End;
      End;
    End;
    until complete;
  End;
  
  Procedure Banner1;
    Begin
      writeln;
      writeln('     RANDOM NETWORK GENERATOR');
      writeln('          FOR MAX-FLOW');
      writeln('    Copyright (C) Gary R. Waissi');
      writeln('              (1990)');
      writeln('   University of Michigan-Dearborn');
      writeln('     School of Management, 113FOB');
      writeln('        Dearborn, MI 48128');
      writeln;
      writeln('  This program generates a RANDOM');
      writeln('  network for MAX-FLOW into a user');
      writeln('  file. The network is generated by');
      writeln('  randomly pairing a given number');
      writeln('  of nodes using a given number of');
      writeln('  arcs.');
      writeln;
    End;

  Procedure Banner2;
    Begin
      writeln;
      writeln('  The maximum number of arcs in');
      writeln('  a fully dense network cannot ');
      writeln('  exceed n^2-n. Also, you need at');
      writeln('  least one arc. Duplicate arcs');
      writeln('  and self-loops will not ');
      writeln('  be allowed.    ');
    End;

  Procedure Banner3;
    Begin
      writeln;
      writeln('  A RANDOM NETWORK for MAX-FLOW will');
      writeln('  be generated to file ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The sink node is node   ',sink:8);
      writeln('  The sink node is numbered with the');
      writeln('  largest node number. ');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network generation may take');
      writeln('  some time. The entire network is');
      writeln('  temporarily stored in a tree in RAM.');
      writeln('  The storage of the tree requires');
      writeln('  storing of dynamic variables in ');
      writeln('  a heap. The heap sizes are limited,');
      writeln('  but can usually be controlled using');
      writeln('  various compiler options. ');
      writeln('  PLEASE WAIT !!');
      writeln;
    End;

  Procedure Banner4;
    Begin
      writeln;
      writeln('  The network is completed. The data');
      writeln('  file is an ASCII file, and can be');
      writeln('  accessed with your editor. You may');
      writeln('  print the file using the DOS');
      writeln('  command PRINT ',OutFileName,'.max.');
    End;

  Procedure UserValues;
    var total_arcs:longint;
    Begin
      xx1:=0;
      repeat
        write('  How many nodes are in the network: ');
        readln(num_nodes);
        if (num_nodes<=1) then
        writeln('  Try again. Need at least two nodes.');
      until (num_nodes>1);
      total_arcs:=num_nodes*num_nodes-num_nodes;
      write('  How many arcs are in the network: ');
      Begin
        repeat
          readln(num_arcs);
          if (num_arcs>total_arcs) OR (num_arcs<1) then
            Begin
              Banner2;
              writeln('  Try again with the number of');
              writeln('  arcs at least one, but not ');
              writeln('  more than ',total_arcs,'.');
              write('  How many arcs are in the network: ');
            End;
          until ((num_arcs<=total_arcs) AND (num_arcs>=1));
      End;      
      writeln('  What is the upper bound for arc flow');
      write('  CAPACITY: ');
      readln(capacity);
      source:=1;
      sink:=num_nodes;
      Banner3;
      writeln(netres,'c Random Network');
      writeln(netres,'c for Max-Flow');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
      ArcTreeRoot:=ArcTree(num_arcs);
    End;

  Begin
    randomize;  {Turbo Pascal random number generator initiator.}
                {You may to replace this by compiler specific   }
                {randomizer, or write a short procedure.        }
    Banner1;
    writeln('  Try the network generation out by');
    writeln('  following the instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);
      assign(netres,OutFileName+'.max');
      rewrite(netres);
      UserValues;
      RandomNet;
      z:=1;
      PrintArcTree(ArcTreeRoot);
      close(netres);
      Banner4;
    End;
  End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/random.p
{ 
  MODIFIED TO COMPILE UNDER SUN UNIX PASCAL 11/90 C. McGeoch
  Modifications include:
    1) Change all integer types ot integer types
    2) Define a string type
    3) Change assign to rewrite
    4) Remove the close function
    5) Add function randomize;
    6) Add function irandom;
    7) Remove user instructions that no longer apply
  
  Catherine McGeoch
  DIMACS Center 
  Box 1179, Rutgers University
  Piscataway, NJ 08855-1179
 }

{
 RANDOM NETWORK GENERATOR FOR MAX-FLOW  (revised 11/25/90)
 
 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128
 
 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu
 
 Revisions: INTEGER changed to LONGINT to allow the
 range of [-2^31 ... 2^31-1].
 
 This program generates RANDOM NETWORKS to user
 specified files. This program was originally 
 designed for max-flow applications. Key procedure
 is:
 
 PROCEDURE RandomNet;
 
 Data file format corresponds to DIMACS data file
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu
 
 This program is written in standard Pascal for 
 transportability.
 
 Another version, that uses windowing and a user 
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR, DOS),
 and is compiled in Turbo Pascal Units TPU's. Runs on
 DOS 3.xx and latter versions. Five network generators
 and a new max-flow algorithm are included in the 
 package, and can be invoked from the menu.
 
 This program generates a BALANCED ARC TREE. This arc
 tree is temporarily maintained and manipulated in the 
 RAM. When the network is complete, i.e. the arc tree
 is filled with arcs (random pairs of numbers), the 
 network is written to a file. Two types of run-time
 errors may occur:
 
   101 Disk write error, if the disk becomes full
   203 Heap overflow error. With Turbo Pascal 5.5
       the stack, heap minimum and heap maximum sizes
       can be controlled using the M compiler option:
       [ M stacksize,heapmin,heapmax], with default
       being [ M 16384,0,655360]. See below an example
       use of this compiler option. 
 
       Each dynamic variable is stored in the heap by
       stacking them on the top of each other.
 
 In Turbo Pascal 5.5 the available memory can be tested
 using MemAvail and MaxAvail functions (omitted here for
 transportability). Please note, that relatively small
 networks, a few thousand nodes and arcs, will already
 cause a heap overflow on PC's with 512 to 640kB of RAM.
}
 
Program RandomNetwork(input,netres,output);
{$M 16384,0,512000}
  Type
  ArcTreeType  = ^ArcRecord;
  ArcRecord    =
    RECORD
      ArcNumber:integer;
      ii :integer;
      jj :integer;
      cap:integer;
      LeftArcTree,RightArcTree:ArcTreeType;
    End;
 string = packed array [1..20] of char;
    
  Var
    Arc:ArcTreeType;
    ArcTreeRoot:ArcTreeType;
    i,k,num,arcnumber:integer;
    num_arcs,num_nodes,capacity:integer;
    z:integer;
    X,Y:integer;
    xx1,xx2,xx3,xx4:integer;
    source,sink:integer;
    ch:char;
    found,example:boolean;
    found11,found22:boolean;
    OutFileName:string;
    netres:text;

   {Two new Sun-compatible RNG procedures added by McGeoch 11/90}
  Procedure Randomize;
  var i: integer;
    Begin
    	{Pascal function seed(n) sets therng seed to n and returns the
	 previous value.  Integer function wallclock returns the number
	 of seconds elapsed since sometime in 1970. 
	 }
	 i:= seed(wallclock);
     End;
     
  Function irandom(top:integer): integer;
    {Returns an integer from 0..(top-1) }
    Begin
    	{My local Pascal function random(x) ignores its real argument
	 x.  It is not the seed.}
	 irandom := trunc(random(0.0)*top);
    End;
 
  Function ArcTree(nn:integer):ArcTreeType;
    Var NewArc:ArcTreeType;
        nll,nrr:integer;
  Begin
    IF nn=0 THEN ArcTree:=nil ELSE
    Begin
      nll:=nn DIV 2; nrr:=nn-nll-1;
      xx1:=xx1+1;
      xx2:=0;xx3:=0;xx4:=0;
      NEW(NewArc);
      WITH NewArc^ DO
      Begin
        ArcNumber:=xx1;
        ii:=xx2; jj:=xx3; Cap:=xx4;
        LeftArcTree :=ArcTree(nll);
        RightArcTree:=ArcTree(nrr);
      End;
      ArcTree:=NewArc;
    End;
  End;
 
  Procedure LocateArc(t2:ArcTreeType; h2:integer);
    VAR Found2:BOOLEAN;
    Begin
      Found2:=FALSE;
      WHILE (t2<>nil) AND NOT Found2 DO
      Begin
        IF t2^.ArcNumber=h2 THEN Found2:=TRUE
        ELSE IF h2=t2^.LeftArcTree^.ArcNumber
        THEN t2:=t2^.LeftArcTree
        ELSE IF h2=t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.RightArcTree
        ELSE IF h2<t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.LeftArcTree
        ELSE IF h2>t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.RightArcTree;
      End;
      IF Found2 THEN Arc:=t2;
    End;
 
  Procedure PrintArcTree(ArcTree1:ArcTreeType);
    Begin
      IF ArcTree1<>nil THEN
      WITH ArcTree1^ DO
      Begin
        PrintArcTree(LeftArcTree);
        write(netres,'a');
        writeln(netres,ii:8,jj:8,Cap:8);
        if k<5 then Writeln(ii:5,jj:5,Cap:5);
        k:=k+1;
        z:=z+1;
        PrintArcTree(RightArcTree);
      End;
    End;
 
Procedure Randomnet;
  var complete:boolean;
      iter1,iter2:boolean;
  Procedure Add_Arc1;
    Begin
      z:=1;
      repeat
      Begin
        LocateArc(ArcTreeRoot,Z);
        IF (Arc^.ii=0) and (Arc^.jj=0) THEN
          Begin
            Arc^.ii:=X; Arc^.jj:=Y;
            Arc^.cap:=irandom(capacity)+1;
            IF z=num_arcs THEN complete:=true;
            z:=num_arcs;
          End;
        z:=z+1;
      End;
      until z=num_arcs+1;
    End;
 
  Procedure Add_Arc2;
    Begin
      z:=1;
      repeat
      Begin
        LocateArc(ArcTreeRoot,Z);
        IF (Arc^.ii=0) and (Arc^.jj=0) THEN
          Begin
            Arc^.ii:=Y; Arc^.jj:=X;
            Arc^.cap:=irandom(capacity)+1;
            IF z=num_arcs THEN complete:=true;
            z:=num_arcs;
          End;
        z:=z+1;
      End;
      until z=num_arcs+1;
    End;
 
  Begin
    iter1:=true;
    iter2:=true;
    complete:=false;
    repeat
    Begin
      Begin
        repeat
          if iter1 and iter2 then
          begin
            X:=irandom(num_nodes)+1; Y:=irandom(num_nodes)+1;
            iter2:=false;
          end
          else if iter1 and not iter2 then
          begin
            Y:=irandom(num_nodes)+1; X:=irandom(num_nodes)+1;
            iter1:=false;
            iter2:=true;
          end
          else if not iter1 and iter2 then
          begin
            X:=irandom(X)+1; Y:=irandom(Y)+1;
            iter2:=false;
          end
          else if not iter1 and not iter2 then
          begin
            Y:=irandom(X)+1; X:=irandom(Y)+1;
            iter1:=true;
            iter2:=true;
          end;
        until (Y<>X);
      End;
      IF X<>Y THEN
      Begin
        found11:=false;
        found22:=false;
        for z:=1 to num_arcs do
        Begin
          LocateArc(ArcTreeRoot,Z);
          IF ((X=Arc^.ii) and (Y=Arc^.jj)) THEN found11:=true;
        End;
        IF not found11 THEN Add_Arc1
        else if found11 then
        Begin
          for z:=1 to num_arcs do
          Begin
            LocateArc(ArcTreeRoot,Z);
            IF ((Y=Arc^.ii) and (X=Arc^.jj)) THEN found22:=true;
          End;
          IF not found22 THEN Add_Arc2;
        End;
      End;
    End;
    until complete;
  End;
 
  Procedure UserValues;
    var total_arcs:integer;
    Begin
      xx1:=0;
      writeln('  RANDOM NETWORK GENERATION');
      repeat
        write('  How many nodes are in the network: ');
        readln(num_nodes);
        if (num_nodes<=1) then
        writeln('  Try again. Need at least two nodes.');
      until (num_nodes>1);
      total_arcs:=num_nodes*num_nodes-num_nodes;
      write('  How many arcs are in the network: ');
      Begin
        repeat
          readln(num_arcs);
          if (num_arcs>total_arcs) OR (num_arcs<1) then
            Begin
              writeln('  The maximum number of arcs in a fully ');
              writeln('  dense network cannot exceed n^2-n.    ');
              writeln('  Also, you need at least one arc.');
              writeln('  Duplicate arcs and self-loops will not ');
              writeln('  be allowed.    ');
              writeln('  Try again with the number of arcs at');
              writeln('  least one, but not more than ',total_arcs,'.');
              write('  How many arcs are in the network: ');
            End;
          until ((num_arcs<=total_arcs) AND (num_arcs>=1));
      End; 
      write('  What is the upper bound for arc flow capacity: ');
      readln(capacity);
      source:=1;
      sink:=num_nodes;
      writeln(netres,'c Random Network');
      writeln(netres,'p max',num_nodes:6,num_arcs:8);
      writeln(netres,'n',source:10,'  s');
      writeln(netres,'n',sink:10,'  t');
      writeln;
      writeln('  A RANDOM NETWORK  will be generated to file ');
      writeln('  ',OutFileName,'.');
      writeln('  The number of nodes is ',num_nodes:8);
      writeln('  The number of arcs is  ',num_arcs:8);
      writeln('  The source node is node ',source,'. The sink node');
      writeln('  is numbered with the largest node number. Here the');
      writeln('  sink is node ',sink,'. '); 

{*SUN The network is given as  ');
      writeln('  a list of arcs using four numbers as follows:');
      writeln('  arc tail node - arc head node - arc cost/capacity.');
      writeln('  The first few data lines look like this:');
      writeln;
      writeln('   Number of');
      writeln('   Nodes     Arcs');
      writeln(num_nodes:5,num_arcs:10);
      writeln('   Source    Sink');
      writeln(source:5,sink:10);
      writeln('   From  To  Capacity');
}

      writeln('   PLEASE WAIT !!!!      ');
      ArcTreeRoot:=ArcTree(num_arcs);
    End;
 
  Begin
    randomize;  {Turbo Pascal random number generator initiator.}
                {You may to replace this by compiler specific   }
                {randomizer, or write a short procedure.        }
    example:=true;
    writeln('  This program generates a RANDOM network');
    writeln('  into a user file. The network is generated');
    writeln('  by randomly pairing a given number of nodes');
    writeln('  using a given number of arcs.');
    writeln;
    writeln('  Try the network generation out by following the');
    writeln('  instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);

{*SUN       assign(netres,OutFileName+'.max');
}
      rewrite(netres,OutFileName);
      UserValues;
      RandomNet;
      z:=1; k:=1;
      PrintArcTree(ArcTreeRoot);
{*SUN      close(netres);
}
      writeln;
      writeln('  The network is completed. The data file is');
      writeln('  an ASCII file, and can be accessed with your');
      writeln('  editor.');
    End;
  End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/random.pas
Received: from porthos.rutgers.edu by dimacs.rutgers.edu (5.59/SMI4.0/RU1.4/3.08) 
	id AA13664; Mon, 26 Nov 90 01:02:11 EST
Received: from umich.edu by porthos.rutgers.edu (5.59/SMI4.0/RU1.4/3.08) 
	id AA10289; Sun, 25 Nov 90 21:19:57 EST
Received: from um.cc.umich.edu by umich.edu (5.61/1123-1.0)
	id AA10892; Sun, 25 Nov 90 21:19:53 -0500
Date: Sun, 25 Nov 90 21:16:26 EST
From: Gary_Waissi@um.cc.umich.edu
To: netflow@dimacs.rutgers.edu
Message-Id: <7319988@um.cc.umich.edu>
Status: RO

{
 RANDOM NETWORK GENERATOR FOR MAX-FLOW  (revised 11/25/90)
 
 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128
 
 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu
 
 Revisions: INTEGER changed to LONGINT to allow the
 range of [-2^31 ... 2^31-1].
 
 This program generates RANDOM NETWORKS to user
 specified files. This program was originally 
 designed for max-flow applications. Key procedure
 is:
 
 PROCEDURE RandomNet;
 
 Data file format corresponds to DIMACS data file
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu
 
 This program is written in standard Pascal for 
 transportability.
 
 Another version, that uses windowing and a user 
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR, DOS),
 and is compiled in Turbo Pascal Units TPU's. Runs on
 DOS 3.xx and latter versions. Five network generators
 and a new max-flow algorithm are included in the 
 package, and can be invoked from the menu.
 
 This program generates a BALANCED ARC TREE. This arc
 tree is temporarily maintained and manipulated in the 
 RAM. When the network is complete, i.e. the arc tree
 is filled with arcs (random pairs of numbers), the 
 network is written to a file. Two types of run-time
 errors may occur:
 
   101 Disk write error, if the disk becomes full
   203 Heap overflow error. With Turbo Pascal 5.5
       the stack, heap minimum and heap maximum sizes
       can be controlled using the M compiler option:
       [ M stacksize,heapmin,heapmax], with default
       being [ M 16384,0,655360]. See below an example
       use of this compiler option. 
 
       Each dynamic variable is stored in the heap by
       stacking them on the top of each other.
 
 In Turbo Pascal 5.5 the available memory can be tested
 using MemAvail and MaxAvail functions (omitted here for
 transportability). Please note, that relatively small
 networks, a few thousand nodes and arcs, will already
 cause a heap overflow on PC's with 512 to 640kB of RAM.
}
 
Program RandomNetwork(input,netres);
{$M 16384,0,512000}
 
  Type
  ArcTreeType  = ^ArcRecord;
  ArcRecord    =
    RECORD
      ArcNumber:longint;
      ii :longint;
      jj :longint;
      cap:longint;
      LeftArcTree,RightArcTree:ArcTreeType;
    End;
 
  Var
    Arc:ArcTreeType;
    ArcTreeRoot:ArcTreeType;
    i,k,num,arcnumber:longint;
    num_arcs,num_nodes,capacity:longint;
    z:longint;
    X,Y:longint;
    xx1,xx2,xx3,xx4:longint;
    source,sink:longint;
    ch:char;
    found,example:boolean;
    found11,found22:boolean;
    OutFileName:string[20];
    netres:text;
 
  Function ArcTree(nn:longint):ArcTreeType;
    Var NewArc:ArcTreeType;
        nll,nrr:longint;
  Begin
    IF nn=0 THEN ArcTree:=nil ELSE
    Begin
      nll:=nn DIV 2; nrr:=nn-nll-1;
      xx1:=xx1+1;
      xx2:=0;xx3:=0;xx4:=0;
      NEW(NewArc);
      WITH NewArc^ DO
      Begin
        ArcNumber:=xx1;
        ii:=xx2; jj:=xx3; Cap:=xx4;
        LeftArcTree :=ArcTree(nll);
        RightArcTree:=ArcTree(nrr);
      End;
      ArcTree:=NewArc;
    End;
  End;
 
  Procedure LocateArc(t2:ArcTreeType; h2:longint);
    VAR Found2:BOOLEAN;
    Begin
      Found2:=FALSE;
      WHILE (t2<>nil) AND NOT Found2 DO
      Begin
        IF t2^.ArcNumber=h2 THEN Found2:=TRUE
        ELSE IF h2=t2^.LeftArcTree^.ArcNumber
        THEN t2:=t2^.LeftArcTree
        ELSE IF h2=t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.RightArcTree
        ELSE IF h2<t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.LeftArcTree
        ELSE IF h2>t2^.RightArcTree^.ArcNumber
        THEN t2:=t2^.RightArcTree;
      End;
      IF Found2 THEN Arc:=t2;
    End;
 
  Procedure PrintArcTree(ArcTree1:ArcTreeType);
    Begin
      IF ArcTree1<>nil THEN
      WITH ArcTree1^ DO
      Begin
        PrintArcTree(LeftArcTree);
        write(netres,'a');
        writeln(netres,ii:8,jj:8,Cap:8);
        if k<5 then Writeln(ii:5,jj:5,Cap:5);
        k:=k+1;
        z:=z+1;
        PrintArcTree(RightArcTree);
      End;
    End;
 
Procedure Randomnet;
  var complete:boolean;
      iter1,iter2:boolean;
  Procedure Add_Arc1;
    Begin
      z:=1;
      repeat
      Begin
        LocateArc(ArcTreeRoot,Z);
        IF (Arc^.ii=0) and (Arc^.jj=0) THEN
          Begin
            Arc^.ii:=X; Arc^.jj:=Y;
            Arc^.cap:=random(capacity)+1;
            IF z=num_arcs THEN complete:=true;
            z:=num_arcs;
          End;
        z:=z+1;
      End;
      until z=num_arcs+1;
    End;
 
  Procedure Add_Arc2;
    Begin
      z:=1;
      repeat
      Begin
        LocateArc(ArcTreeRoot,Z);
        IF (Arc^.ii=0) and (Arc^.jj=0) THEN
          Begin
            Arc^.ii:=Y; Arc^.jj:=X;
            Arc^.cap:=random(capacity)+1;
            IF z=num_arcs THEN complete:=true;
            z:=num_arcs;
          End;
        z:=z+1;
      End;
      until z=num_arcs+1;
    End;
 
  Begin
    iter1:=true;
    iter2:=true;
    complete:=false;
    repeat
    Begin
      Begin
        repeat
          if iter1 and iter2 then
          begin
            X:=random(num_nodes)+1; Y:=random(num_nodes)+1;
            iter2:=false;
          end
          else if iter1 and not iter2 then
          begin
            Y:=random(num_nodes)+1; X:=random(num_nodes)+1;
            iter1:=false;
            iter2:=true;
          end
          else if not iter1 and iter2 then
          begin
            X:=random(X)+1; Y:=random(Y)+1;
            iter2:=false;
          end
          else if not iter1 and not iter2 then
          begin
            Y:=random(X)+1; X:=random(Y)+1;
            iter1:=true;
            iter2:=true;
          end;
        until (Y<>X);
      End;
      IF X<>Y THEN
      Begin
        found11:=false;
        found22:=false;
        for z:=1 to num_arcs do
        Begin
          LocateArc(ArcTreeRoot,Z);
          IF ((X=Arc^.ii) and (Y=Arc^.jj)) THEN found11:=true;
        End;
        IF not found11 THEN Add_Arc1
        else if found11 then
        Begin
          for z:=1 to num_arcs do
          Begin
            LocateArc(ArcTreeRoot,Z);
            IF ((Y=Arc^.ii) and (X=Arc^.jj)) THEN found22:=true;
          End;
          IF not found22 THEN Add_Arc2;
        End;
      End;
    End;
    until complete;
  End;
 
  Procedure UserValues;
    var total_arcs:longint;
    Begin
      xx1:=0;
      writeln('  RANDOM NETWORK GENERATION');
      repeat
        write('  How many nodes are in the network: ');
        readln(num_nodes);
        if (num_nodes<=1) then
        writeln('  Try again. Need at least two nodes.');
      until (num_nodes>1);
      total_arcs:=num_nodes*num_nodes-num_nodes;
      write('  How many arcs are in the network: ');
      Begin
        repeat
          readln(num_arcs);
          if (num_arcs>total_arcs) OR (num_arcs<1) then
            Begin
              writeln('  The maximum number of arcs in a fully ');
              writeln('  dense network cannot exceed n^2-n.    ');
              writeln('  Also, you need at least one arc.');
              writeln('  Duplicate arcs and self-loops will not ');
              writeln('  be allowed.    ');
              writeln('  Try again with the number of arcs at');
              writeln('  least one, but not more than ',total_arcs,'.');
              write('  How many arcs are in the network: ');
            End;
          until ((num_arcs<=total_arcs) AND (num_arcs>=1));
      End; 
      write('  What is the upper bound for arc flow capacity: ');
      readln(capacity);
      source:=1;
      sink:=num_nodes;
      writeln(netres,'c Random Network');
      writeln(netres,'p max',num_nodes:6,num_arcs:8);
      writeln(netres,'n',source:10,'  s');
      writeln(netres,'n',sink:10,'  t');
      writeln;
      writeln('  A RANDOM NETWORK  will be generated to file ');
      writeln('  ',OutFileName,'.');
      writeln('  The number of nodes is ',num_nodes:8);
      writeln('  The number of arcs is  ',num_arcs:8);
      writeln('  The source node is node ',source,'. The sink node');
      writeln('  is numbered with the largest node number. Here the');
      writeln('  sink is node ',sink,'. The network is given as  ');
      writeln('  a list of arcs using four numbers as follows:');
      writeln('  arc tail node - arc head node - arc cost/capacity.');
      writeln('  The first few data lines look like this:');
      writeln;
      writeln('   Number of');
      writeln('   Nodes     Arcs');
      writeln(num_nodes:5,num_arcs:10);
      writeln('   Source    Sink');
      writeln(source:5,sink:10);
      writeln('   From  To  Capacity');
      writeln('   PLEASE WAIT !!!!      ');
      ArcTreeRoot:=ArcTree(num_arcs);
    End;
 
  Begin
    randomize;  {Turbo Pascal random number generator initiator.}
                {You may to replace this by compiler specific   }
                {randomizer, or write a short procedure.        }
    example:=true;
    writeln('  This program generates a RANDOM network');
    writeln('  into a user file. The network is generated');
    writeln('  by randomly pairing a given number of nodes');
    writeln('  using a given number of arcs.');
    writeln;
    writeln('  Try the network generation out by following the');
    writeln('  instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);
      assign(netres,OutFileName+'.max');
      rewrite(netres);
      UserValues;
      RandomNet;
      z:=1; k:=1;
      PrintArcTree(ArcTreeRoot);
      close(netres);
      writeln;
      writeln('  The network is completed. The data file is');
      writeln('  an ASCII file, and can be accessed with your');
      writeln('  editor. You may print the file using the DOS');
      writeln('  command PRINT ',OutFileName,'.max.');
    End;
  End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/readme
-----------------------------------------------------------
NETWORK PROBLEM GENERATORS

          readme_next describes five network generators which generate
          networks for maximum-flow problems in the DIMACS standard format:
		
           ac-max.p(as)    Acyclic network generator
           bi-max.p(as)    Bipartite network generator
           tr1-max.p(as)   Transit grid network generator, one-way
           tr2-max.p(as)   Transit grid network generator, two-way
           ra-max.p(as)    Random network generator

         (C) Gary R. Waissi, University of Michigan-Dearborn
         School of Management, Room 113FOB, Dearborn, MI 48128
         Tel: (313) 593-5012
         E-mail: gary_waissi@um.cc.umich.edu

-----------------------------------------------------------
DIMACS NOTE: 
     1) All file names in the directory are  in lower-case.
     2) Files with the suffix .pas will compile under Standard Pascal
     3) Files with the suffix .p   have been modified to compile
              under Sun Pascal.  You must use the -L option
              when compiling:  for example  pc -L random.p
     4) Files in the tp55 directory will compile under Turbo-Pascal 5.5	


SHAR_EOF
cat << 'SHAR_EOF' > waissi/readme_next
Gary R. Waissi, University of Michigan-Dearborn
School of Management, Room 113FOB, Dearborn, MI 48128
Tel: (313) 593-5012
E-mail: gary_waissi@um.cc.umich.edu
-----------------------------------------------------------
Table of Contents:
1. NETWORK PROBLEM GENERATORS FOR MAX-FLOW;
   Standard Pascal Versions
2. DESCRIPTION OF NETWORK GENERATORS
3. EXAMPLE OUTPUT DATA FILES
-----------------------------------------------------------
Programs:  
Copyright (C) Gary R. Waissi (1990,1991)

Algorithms:
Copyright (C) Gary R. Waissi (1988,1989,1990,1991)

(updated November, 1990, December 1990, January 1991)
-----------------------------------------------------------
1. NETWORK PROBLEM GENERATORS FOR MAX-FLOW;
   Standard Pascal Versions
-----------------------------------------------------------

The Max-Flow Problem
--------------------
In a maximum flow problem the total flow from a specified
source node to a specified sink is maximized, while 
satisfying flow feasibility and flow conservation 
constraints, as follows:
        
    MAX  SUM f(i,j) over all arcs (i,j) in A

    where f(i,j) = flow on arc (i,j)
          A      = set of arcs in the network

The Network Generators
----------------------
The programs generate max-flow networks in five network
categories; acyclic, bipartite, one-way transit grid, 
two-way transit grid, and random.

Standard Pascal Source Files
----------------------------
  ac-max.pas    Acyclic network generator
  bi-max.pas    Bipartite network generator
  tr1-max.pas   Transit grid network generator, one-way
  tr2-max.pas   Transit grid network generator, two-way
  ra-max.pas    Random network generator

These source programs have been given to public domain
through The Center for Discrete Mathematics and Theoretical
Computer Science (DIMACS), Rutgers University. The programs
are designed for maximum flow applications. All programs
are written in standard Pascal for portability.

Data file formats correspond to DIMACS data file
specifications described in "The First DIMACS International
Algorithm Implementation Challenge: Problem Definitions and
Specifications". Please contact via e-mail:
netflow@dimacs.rutgers.edu

Data File Format
----------------
All the MAX-FLOW networks are given as lists of lines using
the same format. There are four types of lines: comment 
lines c, problem line p, node lines n, arc lines a, as 
follows:

      c This is a comment line. The "p" line gives the 
      c problem type, here MAX (maximization), number of
      c nodes, and number of arcs. There are exactly two
      c "n" lines. The first "n" line lists the source node
      c number, and a lower case letter s designating the
      c source. The second "n" line lists the sink node
      c number, and a lower case c letter t designating
      c the sink. All user input must be in integers.
      c The "a" lines list the arcs, one line per arc with
      c three numbers: Arc tail node, arc head node, arc
      c flow capacity.
      c For example like this:
      p max NODES ARCS
      n NODE WHICH
      a FROM TO CAP
      c where
      c      max   = specifies the max-flow data file
      c      NODES = number of nodes
      c      ARCS  = number of arcs
      c      NODE  = source of sink node number
      c      WHICH = s for a source node, t for a sink node
      c      FROM  = arc tail node number
      c      TO    = arc head node number
      c      CAP   = arc flow capacity

For simplicity the only supply node s is always numbered
with 1, and the only demand node t is assigned the largest
node number. In all cases, where the user is asked for 
a flow capacity bound, the program will generate random
arc flow capacities. All arc flow lower bounds are set 
equal to zero.

The data files are ASCII files, and can be accessed with
a common editor. 


2. DESCRIPTION OF NETWORK GENERATORS

Acyclic Network Generator for Max-Flow
--------------------------------------
Source Files:
ac-max.pas   Standard Pascal Version
Copyright (C) Gary R. Waissi (1990,1991)

The program generates an ACYCLIC MAX-FLOW network into
a user file. An acyclic network is such that for each
arc (i,j), where i is the arc tail node number, and j is 
the arc head node number, i<j.

The program can generate three types of acyclic networks:

    - Fully dense networks with random capacities
    - Fully dense networks with special capacities
    - Special sparse networks with special capacities.

The two key procedures are:

 PROCEDURE AcyclicNet1;
 PROCEDURE AcyclicNet2;

For the FULLY DENSE acyclic networks the user has two
options for arc flow capacities: random or special
capacities. Special arcs capacities are calculated using
the concept of Glover et al. (published in "A Comprehensive
Computer Evaluation and Enhancement of Maximum Flow
Algorithms", Appl. of MS, Vol 3, 1983) as follows:

     1. For all arcs, say (i,j), where j=i+1 the capacity
        CAP(i,j) of the arc (i,j) is

            CAP(i,j) = 1 + (i - n/2)^2
            where n is the number of nodes

     2. For all arcs, say (i,j), where j>i+1 the capacity

            CAP(i,j) = 1.

The networks were called "hard networks" in the study,
because such networks were found to cause max-flow 
algorithms to their worst case performance.

If random capacities are selected for fully dense networks,
then the program wil generate random arc flow capacities
from a range of values between zero and a user specified
value. All non-integer values are truncated to integer 
values to conform with DIMACS specifications.

The special SPARSE acyclic networks are such that each node
is connected by an arc to the next node and to the sink 
node, i.e. there exist two types of arcs: 

     1. (i,j) where j=i+1 for all i and j\t with capacity n

     2. (i,t) for all i\t with capacity 1.

These simple networks cause the Dinic Layered Network
Algorithm (Dinic, E.A., Algorithm for Solution of a Problem
of Maximum Flow in a Network with Power Estimation, Soviet
Math. Dokl. Vol. 11, No. 5, pp. 1277-1280, 1970), to it's
worst case performance. That is, an acyclic network of n
nodes requires always the generation of (n-1) Dinic 
networks for maximum value flow, regardless of the maximal
flow algorithm applied to the Dinic networks. Many max-flow
algorithms use the Dinic Algorithm to generate auxiliary 
acyclic networks from an original network, and find the 
maximal flow in such an acyclic network. These sparse 
acyclic networks were presented in the dissertation of
Gary R. Waissi, "Acyclic Network Generation and Maximal
Flow Algorithms for Single Commodity Flow", University 
of Michigan, 1985.

This program is robust. A generated arc is written to the
disk file, and not stored in the memory. Disk full causes
a run-time error (101).


Bipartite Network Generator for Max-Flow
----------------------------------------
Source File:
bi-max.pas   Standard Pascal Version
Copyright (C) Gary R. Waissi (1990,1991)

The program generates a BIPARTITE MAX-FLOW NETWORK to 
a user specified file. The set of nodes N can be 
partitioned into two sets N1 and N2, such that all arcs
are directed from N1 to N2.

The program generates two types of networks:

    - Bipartite networks with unit capacities on bipartite
      arcs, and random capacities on arcs from the
      SUPER SOURCE and into the SUPER SINK.

    - Bipartite networks with random capacities.

The key procedure is:

PROCEDURE BipartiteNet;

The user selects the number of nodes on the source side
and sink side of the network respectively. The bipartite
network is appended with two nodes, a common source
SUPER SOURCE, and a common sink SUPER SINK. The SUPER
SOURCE is connected by arcs to all nodes in the SOURCE SET,
N1. The nodes in the SINK SET, N2, are connected by arcs
to the SUPER SINK. The SUPER SOURCE is always numbered with
number one, and the SUPER SINK is numbered with the largest
node number.

The user has two options for the arc capacities: either
random capacities or unit capacities. In the case of random
capacities all arcs capacities are random integers between
zero and a user selected upper bound. In the case of unit
capacities all arc capacities connecting the nodes in the
SOURCE SET, N1, to the nodes in the SINK SET, N2, are unit
capacities, i.e the bipartite arcs. However, the arc 
capacities of arcs from the SUPER SOURCE to N1, as well
as, the arc capacities of arcs from N2 to the SUPER SINK,
are random.

This program is robust. A generated arc is written to the
disk file, and not stored in the memory. Disk full causes
a run-time error (101).


Transit Grid Network Generator for Max-Flow/One-Way System
----------------------------------------------------------
Source File:
tr1-max.pas   Standard Pascal Version

Copyright (C) Gary R. Waissi (1990,1991)

This program generates a ONE-WAY TRANSIT GRID NETWORK for
the MAX-FLOW problem into a user specified file with at
most one arc between any pair of nodes.

The program generates one type of networks:
    
   - One-Way Transit-Grid networks with a SUPER SOURCE
     and a SUPER SINK, random arc flow capacities.

The key procedure is:

PROCEDURE TransitOneNet;

The network resembles a one-way city street network. The
direction of each arc, except those connected to the common
source and common sink respectively, is randomly assigned.
The arc flow capacities are randomly assigned from a range
between zero and a user selected value. All arc capacities
are random integers.

Two nodes a SUPER SOURCE and a SUPER SINK are added to the
network automatically. The SUPER SOURCE is connected by 
arcs to nodes on one side of the grid. The nodes on the 
opposite side of the grid are connected to the SUPER SINK. 

The user is suggested to select a number of nodes in the
network, that creates a complete square grid. The program
works, however, for any n>=4.

For example:

      4 nodes in a 2 x 2 network  (smallest)
      9 nodes in a 3 x 3 network
     16 nodes in a 4 x 4 network
     25 nodes in a 5 x 5 network
          ...
   1600 nodes in a 40 x 40 network
          ...
  10000 nodes in a 100 x 100 network.
          ...

This program is robust. A generated arc is written to the
disk file, and not stored in the memory. Disk full causes
a run-time error (101).

Transit Grid Network Generator for Max-Flow/Two-Way System
----------------------------------------------------------
Source File:
tr2-max.pas   Standard Pascal Version

Copyright (C) Gary R. Waissi  (1990,1991)

This program generates a TWO-WAY TRANSIT GRID NETWORK for
the MAX-FLOW problem into a user specified file with two
arcs between any pair of nodes forming the grid.

The program generates one type of networks:
    
   - Two-Way Transit-Grid networks with a SUPER SOURCE
     and a SUPER SINK, random arc flow capacities.

The key procedure is:

PROCEDURE TransitTwoNet;

The network resembles a two-way city street network. There
are two arcs, one in each direction, between the nodes 
forming the grid. The arc flow capacities are randomly 
assigned from a range between zero and a user selected 
value. 

Two nodes a SUPER SOURCE and a SUPER SINK are added to
the network automatically. The SUPER SOURCE is connected
by two arcs, one in each direction, to nodes on one side of
the grid. The nodes on the opposite side of the grid are
connected by two arcs, one in each direction, to the SUPER
SINK. 

The user is suggested to select a number of nodes in the
network, that creates a complete square grid. The program
works, however, for any n>=4.

For example:

      4 nodes in a 2 x 2 network  (smallest)
      9 nodes in a 3 x 3 network
     16 nodes in a 4 x 4 network
     25 nodes in a 5 x 5 network
          ...
   1600 nodes in a 40 x 40 network
          ...
  10000 nodes in a 100 x 100 network.
          ...

This program is robust. A generated arc is written to the
disk file, and not stored in the memory. Disk full causes
a run-time error (101).


RANDOM NETWORK GENERATOR FOR MAX-FLOW
Source File: 
ra-max.pas   Standard Pascal Version
Copyright (C) Gary R. Waissi (1990,1991)

This program generates a RANDOM MAX-FLOW network into
a user file. The network is generated by randomly pairing
a given number of nodes using a given number of arcs.

The program generates one type of networks:

    - Random networks with random arc flow capacities.

The key procedure is:

PROCEDURE RandomNet;

The maximum number of arcs in a fully dense network cannot
exceed n^2-n. Duplicate arcs and self-loops are not allowed.

This program generates initially a BALANCED ARC TREE to 
store network arcs. This arc tree is temporarily maintained
and manipulated in the RAM. The size of the tree is 
determined by the number of arcs in the random network
selected by the user. The program then generates a pair
of random numbers, say (i,j). This pair of numbers 
represents an arc (i,j) with node i as the arc origin and
node j as the arc destination. The balanced tree is then 
searched to determine, if this arc (i,j) is already 
included in the tree (network). If the pair of numbers
is found, another pair is generated and the search is 
repeated. The process is repeated until the tree (network)
is complete, i.e. the required number of arcs is generated.
The resulting network may be a connected or disconnected
network.

When the network is completed, i.e. the arc tree is filled
with arcs (random pairs of numbers), the network is written
to a file.

Two types of run-time errors may occur:

   101 Disk write error, if the disk becomes full.
   203 Heap overflow error. Each dynamic variable 
       is stored in the heap by stacking them on the
       top of each other.
       
3. EXAMPLE OUTPUT DATA FILES

EXAMPLE: A Fully Dense Acyclic Network
with Random Arc Capacities

c Fully Dense Acyclic Network
c for Max-Flow
c Arcs with random capacities
p max         5        10
n             1  s
n             5  t
a         1         2         7
a         1         3         3
a         1         4         6
a         1         5         5
a         2         3         5
a         2         4         8
a         2         5         2
a         3         4         7
a         3         5         4
a         4         5         2


EXAMPLE: A Fully Dense Acyclic Network
with Special Arc Capacities; (Glover et al
"Hard Network", but with rounded capacities)

c Fully Dense Acyclic Network
c for Max-Flow
c Arcs with special capacities
p max         5        10
n             1  s
n             5  t
a         1         2         3
a         1         3         1
a         1         4         1
a         1         5         1
a         2         3         1
a         2         4         1
a         2         5         1
a         3         4         1
a         3         5         1
a         4         5         3


EXAMPLE: A Sparse Acyclic Network with Special
Arc Capacities; (Dinic Worst Case Network)

c Sparse Acyclic Network
c for Max-Flow
c Arcs with special capacities
p max         5         7
n             1  s
n             5  t
a         1         2         5
a         1         5         1
a         2         3         5
a         2         5         1
a         3         4         5
a         3         5         1
a         4         5         1


EXAMPLE: A Bipartite Network with Unit Capacities

c Bipartite Network for Max-Flow
c with UNIT capacities on bipartite arcs
p max         8        15
n             1  s
n             8  t
a         1         2        11
a         1         3        25
a         1         4         7
a         2         5         1
a         2         6         1
a         2         7         1
a         3         5         1
a         3         6         1
a         3         7         1
a         4         5         1
a         4         6         1
a         4         7         1
a         5         8        10
a         6         8        15
a         7         8        30


EXAMPLE: A Bipartite Network with Random Capacities

c Bipartite Network for Max-Flow
c with RANDOM capacities
p max         8        15
n             1  s
n             8  t
a         1         2        11
a         1         3        30
a         1         4        22
a         2         5         7
a         2         6         8
a         2         7         4
a         3         5         2
a         3         6        10
a         3         7         2
a         4         5        23
a         4         6        27
a         4         7        27
a         5         8        23
a         6         8        18
a         7         8        19


EXAMPLE: One-Way Transit Grid Network
         Random Arc Capacities

c One-Way Transit Grid Network
c for Max-Flow
p max         6         8
n             1  s
n             6  t
a         1         2         8
a         1         3         5
a         2         3         1
a         2         4         8
a         3         5         9
a         5         4         6
a         4         6        10
a         5         6         5


EXAMPLE: Two-Way Transit Grid Network
         Random Arc Capacities

c Two-Way Transit Grid Network
c for Max-Flow
p max         6        16
n             1  s
n             6  t
a         1         2        10
a         2         1         3
a         1         3         7
a         3         1         1
a         2         3        10
a         3         2         9
a         2         4         7
a         4         2         6
a         3         5         5
a         5         3         3
a         4         5         9
a         5         4         2
a         4         6         5
a         6         4         6
a         5         6         6
a         6         5        10


EXAMPLE: Random Network
         Random Arc Capacities

c Random Network
c for Max-Flow
p max         5        10
n             1  s
n             5  t
a         5         3        30
a         4         2        23
a         3         5        16
a         1         3         7
a         2         4         6
a         4         3         6
a         2         1        25
a         1         4        30
a         4         1        23
a         2         5        18
SHAR_EOF
cat << 'SHAR_EOF' > waissi/tp55
acmaxi.pasbimaxi.pasramaxi.pasSHAR_EOF
cat << 'SHAR_EOF' > waissi/tr1-max.p
{
 TRANSIT GRID NETWORK GENERATOR FOR MAX-FLOW/
 ONE-WAY SYSTEM              (revised 11/25/90)
                             (revised 01/05/91)

 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revisions: INTEGER changed to LONGINT to allow the
 range [-2^31 ... 2^31-1].

 This program generates ONE-WAY TRANSIT GRID NETWORKS
 for MAX-FLOW problems to user specified files with 
 at most one arc between any pair of nodes. The 
 direction of a generated arc is randomly assigned.
 The key procedure is:

 PROCEDURE TransitOneNet;

 Data file format corresponds to DIMACS data file 
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for
 transportability.

 Another version, that uses windowing and a user 
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR, DOS),
 and is compiled in Turbo Pascal Units TPU's. Runs on
 DOS 3.xx and latter versions. Five network generators
 and a new max-flow algorithm are included in the 
 package, and can be invoked from the menu.

 This program is robust. A generated arc is written to
 the disk file, and not stored in the memory. Disk full
 causes a run-time error.
}
Program TransitGridNetworkOne(input,output);

  type string = packed array [1..20] of char;

    var ii,jj,kk,cap:integer;
      i,z,k,num,col,imax,zmax,colmax,capacity:integer;
      num_nodes,num_arcs:integer;
      source,sink:integer;
      ch:char;
      found:boolean;
      OutFileName:string;
      netres:text;

    {Two new Sun-compatible RNG procedures added by McGeoch 11/90}
  Procedure Randomize;
  var i: integer;
    Begin
    	{Pascal function seed(n) sets therng seed to n and returns the
	 previous value.  Integer function wallclock returns the number
	 of seconds elapsed since sometime in 1970. 
	 }
	 i:= seed(wallclock);
     End;
     
  Function irandom(top:integer): integer;
    {Returns an integer from 0..(top-1) }
    Begin
    	{My local Pascal function random(x) ignores its real argument
	 x.  It is not the seed.}
	 irandom := trunc(random(0.0)*top);
    End;
  
  Procedure WriteArc;
    Begin
      write(netres,'a');
      writeln(netres,ii:10,jj:10,cap:10);
    End;
  
  Procedure GetArc(var head:integer);
    Begin
      ii:=i; jj:=head;
      cap:=irandom(capacity)+1;
    End;

  Procedure TransitOneNet;
    Procedure ChangeDir;
      var a,test:integer;
      Begin
        test:=irandom(capacity);
        if (test<0.50*capacity) then
          Begin a:=ii; ii:=jj; jj:=a;
          End;
      End;

    Procedure Gen1;
      Begin
        for z:=1 to colmax do
        Begin
          i:=1;
          kk:=z+1;
          GetArc(kk); WriteArc;
        End;
      End;

    Procedure Gen2;
      Begin
        i:=imax-colmax+2;
        for z:=(zmax+colmax+1) to (zmax+2*colmax) do
        Begin
          kk:=imax+2; GetArc(kk); WriteArc;
          i:=i+1;
        End;
      End;

    Procedure GenArcs;
      Procedure DoArc;
        Begin
          GetArc(kk); ChangeDir; WriteArc;
        End;

      Begin
        col:=1; num:=colmax; i:=2; z:=colmax+1;
        repeat
          repeat
            if (i<num+1) then
              Begin kk:=i+1; DoArc; z:=z+1;
              End;
            kk:=i+colmax;
            DoArc;
            z:=z+1; i:=i+1;
          until (i=num+2);
          num:=num+colmax;
          col:=col+1;
        until (col=colmax);
        repeat kk:=i+1; DoArc; i:=i+1; z:=z+1;
        until (i=imax+1);
      End;

    Begin         { Procedure TransitOneNet; }
      Gen1; GenArcs; Gen2
    End;
 
  Procedure Banner1;
    Begin
      writeln;
      writeln('    ONE-WAY TRANSIT GRID NETWORK');
      writeln('            GENERATOR');
      writeln('    Copyright (C) Gary R. Waissi');
      writeln('              (1990)');
      writeln('   University of Michigan-Dearborn');
      writeln('     School of Management, 113FOB');
      writeln('        Dearborn, MI 48128');
      writeln;
      writeln('  This program generates a ONE-WAY');
      writeln('  TRANSIT GRID network for MAX-FLOW');
      writeln('  into a user file. The network');
      writeln('  resembles a one-way city street');
      writeln('  network. The direction of each ');
      writeln('  one-way street, except those');
      writeln('  connected to the common source');
      writeln('  and common sink respectively, is');
      writeln('  randomly assigned.');
      writeln;
    End;

  Procedure Banner2;
    Begin
      writeln;
      writeln('  For the number of nodes in the');
      writeln('  network select a number that ');
      writeln('  creates a complete square grid.');
      writeln('  For example:');
      writeln('      4 nodes in a 2 x 2 network,');
      writeln('      9 nodes in a 3 x 3 network,');
      writeln('     16 nodes in a 4 x 4 network,');
      writeln('     25 nodes in a 5 x 5 network,');
      writeln('   ...');
      writeln('   1600 nodes in a 40 x 40 network.');
      writeln('  The program adds automatically');
      writeln('  two nodes, a supersource and ');
      writeln('  a supersink, to the network.');
    End;

  Procedure Banner3;
    Begin
      writeln;
      writeln('  A ONE-WAY TRANSIT GRID NETWORK');
      writeln('  for MAX-FLOW will be generated');
      writeln('  to file ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The source node is node ',sink:8);
      writeln('  The sink node is numbered with the');
      writeln('  largest node number.');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
    End;

  Procedure Banner4;
    Begin
      writeln;
      writeln('  The network is completed. The');
      writeln('  file is an ASCII file, with name:');
	  writeln('  ',OutFileName,',and can be');
      writeln('  accessed with your editor.');
    End;

  Procedure UserValues;
    Begin
      repeat
        writeln('  How many nodes are in the network ?');
        write('  (4, 9, 16, 25,..., 400, 625,...): ');
        readln(imax);
        if (imax<4) then
        Begin
          writeln('  Try again. Need at least four');
          writeln('  nodes in the smallest grid ');
          writeln('  network.');
        End;
      until (imax>=4);
      colmax:=round(sqrt(imax));
      zmax:=2*(imax-colmax);
      writeln('  What is the upper bound for arc flow');
      write('  CAPACITY: ');
      readln(capacity);
      num_nodes:=imax+2;
      num_arcs:=zmax+2*colmax;
      source:=1;
      sink:=num_nodes;
      Banner3;
      writeln(netres,'c One-Way Transit Grid Network');
      writeln(netres,'c for Max-Flow');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
    End;

  Begin
    randomize; {Turbo Pascal random number generator initiator.}
               {You may to replace this by compiler specific   }
               {randomizer, or write a short procedure.        }
    Banner1;
    writeln('  Try the network generation out by');
    writeln('  following the instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);
{ SUN       assign(netres,OutFileName+'.max'); }
      rewrite(netres,OutFileName);
      Banner2;
      UserValues;
      TransitOneNet;
{ SUN       close(netres); }
      Banner4;
    End;
  End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/tr1-max.pas
{
 TRANSIT GRID NETWORK GENERATOR FOR MAX-FLOW/
 ONE-WAY SYSTEM              (revised 11/25/90)
                             (revised 01/05/91)

 Copyright (C) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revisions: INTEGER changed to LONGINT to allow the
 range [-2^31 ... 2^31-1].

 This program generates ONE-WAY TRANSIT GRID NETWORKS
 for MAX-FLOW problems to user specified files with 
 at most one arc between any pair of nodes. The 
 direction of a generated arc is randomly assigned.
 The key procedure is:

 PROCEDURE TransitOneNet;

 Data file format corresponds to DIMACS data file 
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for
 transportability.

 Another version, that uses windowing and a user 
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR, DOS),
 and is compiled in Turbo Pascal Units TPU's. Runs on
 DOS 3.xx and latter versions. Five network generators
 and a new max-flow algorithm are included in the 
 package, and can be invoked from the menu.

 This program is robust. A generated arc is written to
 the disk file, and not stored in the memory. Disk full
 causes a run-time error.
}
Program TransitGridNetworkOne(input,output);

  var ii,jj,kk,cap:longint;
      i,z,k,num,col,imax,zmax,colmax,capacity:longint;
      num_nodes,num_arcs:longint;
      source,sink:longint;
      ch:char;
      found:boolean;
      OutFileName:string[20];
      netres:text;
  
  Procedure WriteArc;
    Begin
      write(netres,'a');
      writeln(netres,ii:10,jj:10,cap:10);
    End;
  
  Procedure GetArc(var head:longint);
    Begin
      ii:=i; jj:=head;
      cap:=random(capacity)+1;
    End;

  Procedure TransitOneNet;
    Procedure ChangeDir;
      var a,test:longint;
      Begin
        test:=random(capacity);
        if (test<0.50*capacity) then
          Begin a:=ii; ii:=jj; jj:=a;
          End;
      End;

    Procedure Gen1;
      Begin
        for z:=1 to colmax do
        Begin
          i:=1;
          kk:=z+1;
          GetArc(kk); WriteArc;
        End;
      End;

    Procedure Gen2;
      Begin
        i:=imax-colmax+2;
        for z:=(zmax+colmax+1) to (zmax+2*colmax) do
        Begin
          kk:=imax+2; GetArc(kk); WriteArc;
          i:=i+1;
        End;
      End;

    Procedure GenArcs;
      Procedure DoArc;
        Begin
          GetArc(kk); ChangeDir; WriteArc;
        End;

      Begin
        col:=1; num:=colmax; i:=2; z:=colmax+1;
        repeat
          repeat
            if (i<num+1) then
              Begin kk:=i+1; DoArc; z:=z+1;
              End;
            kk:=i+colmax;
            DoArc;
            z:=z+1; i:=i+1;
          until (i=num+2);
          num:=num+colmax;
          col:=col+1;
        until (col=colmax);
        repeat kk:=i+1; DoArc; i:=i+1; z:=z+1;
        until (i=imax+1);
      End;

    Begin         { Procedure TransitOneNet; }
      Gen1; GenArcs; Gen2
    End;
 
  Procedure Banner1;
    Begin
      writeln;
      writeln('    ONE-WAY TRANSIT GRID NETWORK');
      writeln('            GENERATOR');
      writeln('    Copyright (C) Gary R. Waissi');
      writeln('              (1990)');
      writeln('   University of Michigan-Dearborn');
      writeln('     School of Management, 113FOB');
      writeln('        Dearborn, MI 48128');
      writeln;
      writeln('  This program generates a ONE-WAY');
      writeln('  TRANSIT GRID network for MAX-FLOW');
      writeln('  into a user file. The network');
      writeln('  resembles a one-way city street');
      writeln('  network. The direction of each ');
      writeln('  one-way street, except those');
      writeln('  connected to the common source');
      writeln('  and common sink respectively, is');
      writeln('  randomly assigned.');
      writeln;
    End;

  Procedure Banner2;
    Begin
      writeln;
      writeln('  For the number of nodes in the');
      writeln('  network select a number that ');
      writeln('  creates a complete square grid.');
      writeln('  For example:');
      writeln('      4 nodes in a 2 x 2 network,');
      writeln('      9 nodes in a 3 x 3 network,');
      writeln('     16 nodes in a 4 x 4 network,');
      writeln('     25 nodes in a 5 x 5 network,');
      writeln('   ...');
      writeln('   1600 nodes in a 40 x 40 network.');
      writeln('  The program adds automatically');
      writeln('  two nodes, a supersource and ');
      writeln('  a supersink, to the network.');
    End;

  Procedure Banner3;
    Begin
      writeln;
      writeln('  A ONE-WAY TRANSIT GRID NETWORK');
      writeln('  for MAX-FLOW will be generated');
      writeln('  to file ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The source node is node ',sink:8);
      writeln('  The sink node is numbered with the');
      writeln('  largest node number.');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
    End;

  Procedure Banner4;
    Begin
      writeln;
      writeln('  The network is completed. The');
      writeln('  data file is an ASCII file, and');
      writeln('  can be accessed with your editor.');
      writeln('  You may print the file using the');
      writeln('  DOS command PRINT ',OutFileName,'.max.');
    End;

  Procedure UserValues;
    Begin
      repeat
        writeln('  How many nodes are in the network ?');
        write('  (4, 9, 16, 25,..., 400, 625,...): ');
        readln(imax);
        if (imax<4) then
        Begin
          writeln('  Try again. Need at least four');
          writeln('  nodes in the smallest grid ');
          writeln('  network.');
        End;
      until (imax>=4);
      colmax:=round(sqrt(imax));
      zmax:=2*(imax-colmax);
      writeln('  What is the upper bound for arc flow');
      write('  CAPACITY: ');
      readln(capacity);
      num_nodes:=imax+2;
      num_arcs:=zmax+2*colmax;
      source:=1;
      sink:=num_nodes;
      Banner3;
      writeln(netres,'c One-Way Transit Grid Network');
      writeln(netres,'c for Max-Flow');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
    End;

  Begin
    randomize; {Turbo Pascal random number generator initiator.}
               {You may to replace this by compiler specific   }
               {randomizer, or write a short procedure.        }
    Banner1;
    writeln('  Try the network generation out by');
    writeln('  following the instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);
      assign(netres,OutFileName+'.max');
      rewrite(netres);
      Banner2;
      UserValues;
      TransitOneNet;
      close(netres);
      Banner4;
    End;
  End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/tr2-max.p
{
 TRANSIT GRID NETWORK GENERATOR FOR MAX-FLOW/
 TWO-WAY SYSTEM             (revised 11/25/90)
                            (revised 01/05/91)

 Copyright (C) (1990) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revision: INTEGER changed to LONGINT to allow input
 value range of [-2^31 ... 2^31-1].

 This program generates TWO-WAY TRANSIT GRID NETWORKS
 for MAX-FLOW to user specified files with exactly
 two arcs between any pair of nodes that form the grid.
 Key procedure is:

 PROCEDURE TransitTwoNet;

 Data file format corresponds to DIMACS data file 
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for
 transportability.

 Another version, that uses windowing and a user
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR,
 DOS), and is compiled in Turbo Pascal Units TPU's.
 Runs on DOS 3.xx and latter versions. Five network
 generators and a new max-flow algorithm are 
 included in the package, and can be invoked from 
 the menu.

 This program is robust. A generated arc is written
 to the disk file, and not stored in the memory.
 Disk full causes a run-time error.
}

Program TransitGridNetworkTwo(input,output);

   type string = packed array [1..20] of char;
  var ii,jj,kk,zz,cap:integer;
      i,z,k,num,col,imax,zmax,colmax,capacity:integer;
      num_nodes,num_arcs:integer;
      source,sink:integer;
      ch:char;
      found:boolean;
      OutFileName:string;
      netres:text;
 
  {Two new Sun-compatible RNG procedures added by McGeoch 11/90}
  Procedure Randomize;
  var i: integer;
    Begin
    	{Pascal function seed(n) sets therng seed to n and returns the
	 previous value.  Integer function wallclock returns the number
	 of seconds elapsed since sometime in 1970. 
	 }
	 i:= seed(wallclock);
     End;
     
  Function irandom(top:integer): integer;
    {Returns an integer from 0..(top-1) }
    Begin
    	{My local Pascal function random(x) ignores its real argument
	 x.  It is not the seed.}
	 irandom := trunc(random(0.0)*top);
    End;

    Procedure WriteArc;
    Begin
      write(netres,'a');
      writeln(netres,ii:10,jj:10,cap:10);
      zz:=zz+1;
    End;

  Procedure GetArc1(var head:integer);
    Begin
      ii:=i; jj:=head;
      cap:=irandom(capacity)+1;
    End;

  Procedure GetArc2(var head:integer);
    Begin
      ii:=head; jj:=i;
      cap:=irandom(capacity)+1;
    End;

  Procedure TransitTwoNet;
    Procedure Gen1;
      Begin
        for z:=1 to colmax do
        Begin
          i:=1; kk:=z+1;
          GetArc1(kk);
          WriteArc;
          GetArc2(kk);
          WriteArc;
        End;
      End;

    Procedure Gen2;
      Begin
        i:=imax-colmax+2;
        for z:=(zmax+colmax+1) to (zmax+2*colmax) do
        Begin
          kk:=imax+2;
          GetArc1(kk); WriteArc;
          GetArc2(kk); WriteArc;
          i:=i+1;
        End;
      End;

    Procedure GenArcs;
      Procedure DoArc;
        Begin
          GetArc1(kk); WriteArc;
          GetArc2(kk); WriteArc;
        End;

      Begin
        col:=1; num:=colmax; i:=2; z:=colmax+1;
        repeat
          repeat
            if (i<num+1) then
              Begin kk:=i+1; DoArc; z:=z+1;
              End;
            kk:=i+colmax;
            DoArc;
            z:=z+1; i:=i+1;
          until (i=num+2);
          num:=num+colmax;
          col:=col+1;
        until (col=colmax);
        repeat kk:=i+1; DoArc; i:=i+1; z:=z+1;
        until (i=imax+1);
      End;

    Begin         { Procedure TransitTwoNet; }
      zz:=1; Gen1; GenArcs; Gen2
    End;
  
  Procedure Banner1;
    Begin
      writeln;
      writeln('    TWO-WAY TRANSIT GRID NETWORK');
      writeln('       GENERATOR FOR MAX-FLOW');
      writeln('    Copyright (C) Gary R. Waissi');
      writeln('              (1990)');
      writeln('   University of Michigan-Dearborn');
      writeln('     School of Management, 113FOB');
      writeln('        Dearborn, MI 48128');
      writeln;
      writeln('  This program generates a TWO-WAY');
      writeln('  TRANSIT GRID network for MAX-FLOW');
      writeln('  into a user file. The network ');
      writeln('  resembles a two-way city street');
      writeln('  network.');
      writeln;
    End;

  Procedure Banner2;
    Begin
      writeln;
      writeln('  For the number of nodes select ');
      writeln('  a number that creates a complete');
      writeln('  square grid. For example:');
      writeln('       4 nodes in a 2 x 2 network,');
      writeln('       9 nodes in a 3 x 3 network,');
      writeln('      16 nodes in a 4 x 4 network,');
      writeln('      25 nodes in a 5 x 5 network,');
      writeln('    ...');
      writeln('    1600 nodes in a 40 x 40 network.');
      writeln('  The program adds automatically ');
      writeln('  two nodes, a supersource and ');
      writeln('  a supersink, to the network.');
      writeln;
    End;

  Procedure Banner3;
    Begin
      writeln;
      writeln('  A TWO-WAY TRANSIT GRID NETWORK for');
      writeln('  MAX-FLOW will be generated to file');
      writeln('    ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The sink node is node   ',sink:8);
      writeln('  The sink node is numbered with the');
      writeln('  largest node number.');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
    End;

  Procedure Banner4;
    Begin
      writeln;
      writeln('  The network is completed. The data');
      writeln('  file is an ASCII file, with name:');
	  writeln('  ',OutFileName,',and can be');
      writeln('  accessed with your editor.');
    End;

  Procedure UserValues;
    Begin
      repeat
        writeln('  How many nodes are in the network: ');
        write('  (4, 9, 16, 25, ..., 400, 625,...):');
        readln(imax);
        if (imax<4) then
        Begin
          writeln('  Try again. Need at least four');
          writeln('  nodes in the smallest grid network.');
        End;
      until (imax>=4);
      colmax:=round(sqrt(imax));
      zmax:=2*(imax-colmax);
      writeln('  What is the upper bound for arc flow');
      write('  CAPACITY: ');
      readln(capacity);
      num_nodes:=imax+2;
      num_arcs:=2*(zmax+2*colmax);
      source:=1;
      sink:=num_nodes;
      Banner3;
      writeln(netres,'c Two-Way Transit Grid Network');
      writeln(netres,'c for Max-Flow');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
    End;

  Begin
    randomize;  {Turbo Pascal random number generator initiator.}
                {You may to replace this by compiler specific   }
                {randomizer, or write a short procedure.        }
    Banner1;
    writeln('  Try the network generation out by');
    writeln('  following the instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);
{ SUN       assign(netres,OutFileName+'.max'); }
      rewrite(netres,OutFileName);
      Banner2;
      UserValues;
      TransitTwoNet;
{ SUN       close(netres); }
      Banner4;
    End;
  End.
SHAR_EOF
cat << 'SHAR_EOF' > waissi/tr2-max.pas
{
 TRANSIT GRID NETWORK GENERATOR FOR MAX-FLOW/
 TWO-WAY SYSTEM             (revised 11/25/90)
                            (revised 01/05/91)

 Copyright (C) (1990) Gary R. Waissi
 University of Michigan-Dearborn
 School of Management, 113FOB
 Dearborn, MI 48128

 Tel: (313) 593-5012
 E-mail: gary_waissi@um.cc.mich.edu

 Revision: INTEGER changed to LONGINT to allow input
 value range of [-2^31 ... 2^31-1].

 This program generates TWO-WAY TRANSIT GRID NETWORKS
 for MAX-FLOW to user specified files with exactly
 two arcs between any pair of nodes that form the grid.
 Key procedure is:

 PROCEDURE TransitTwoNet;

 Data file format corresponds to DIMACS data file 
 specifications described in "The First DIMACS 
 International Algorithm Implementation Challenge:
 Problem Definitions and Specifications". Please 
 contact via e-mail: netflow@dimacs.rutgers.edu

 This program is written in standard Pascal for
 transportability.

 Another version, that uses windowing and a user
 friendly menu interface is available. The version
 uses Turbo Pascal 5.5 features (including CTR,
 DOS), and is compiled in Turbo Pascal Units TPU's.
 Runs on DOS 3.xx and latter versions. Five network
 generators and a new max-flow algorithm are 
 included in the package, and can be invoked from 
 the menu.

 This program is robust. A generated arc is written
 to the disk file, and not stored in the memory.
 Disk full causes a run-time error.
}

Program TransitGridNetworkTwo(input,output);

  var ii,jj,kk,zz,cap:longint;
      i,z,k,num,col,imax,zmax,colmax,capacity:longint;
      num_nodes,num_arcs:longint;
      source,sink:longint;
      ch:char;
      found:boolean;
      OutFileName:string[20];
      netres:text;
  
  Procedure WriteArc;
    Begin
      write(netres,'a');
      writeln(netres,ii:10,jj:10,cap:10);
      zz:=zz+1;
    End;

  Procedure GetArc1(var head:longint);
    Begin
      ii:=i; jj:=head;
      cap:=random(capacity)+1;
    End;

  Procedure GetArc2(var head:longint);
    Begin
      ii:=head; jj:=i;
      cap:=random(capacity)+1;
    End;

  Procedure TransitTwoNet;
    Procedure Gen1;
      Begin
        for z:=1 to colmax do
        Begin
          i:=1; kk:=z+1;
          GetArc1(kk);
          WriteArc;
          GetArc2(kk);
          WriteArc;
        End;
      End;

    Procedure Gen2;
      Begin
        i:=imax-colmax+2;
        for z:=(zmax+colmax+1) to (zmax+2*colmax) do
        Begin
          kk:=imax+2;
          GetArc1(kk); WriteArc;
          GetArc2(kk); WriteArc;
          i:=i+1;
        End;
      End;

    Procedure GenArcs;
      Procedure DoArc;
        Begin
          GetArc1(kk); WriteArc;
          GetArc2(kk); WriteArc;
        End;

      Begin
        col:=1; num:=colmax; i:=2; z:=colmax+1;
        repeat
          repeat
            if (i<num+1) then
              Begin kk:=i+1; DoArc; z:=z+1;
              End;
            kk:=i+colmax;
            DoArc;
            z:=z+1; i:=i+1;
          until (i=num+2);
          num:=num+colmax;
          col:=col+1;
        until (col=colmax);
        repeat kk:=i+1; DoArc; i:=i+1; z:=z+1;
        until (i=imax+1);
      End;

    Begin         { Procedure TransitTwoNet; }
      zz:=1; Gen1; GenArcs; Gen2
    End;
  
  Procedure Banner1;
    Begin
      writeln;
      writeln('    TWO-WAY TRANSIT GRID NETWORK');
      writeln('       GENERATOR FOR MAX-FLOW');
      writeln('    Copyright (C) Gary R. Waissi');
      writeln('              (1990)');
      writeln('   University of Michigan-Dearborn');
      writeln('     School of Management, 113FOB');
      writeln('        Dearborn, MI 48128');
      writeln;
      writeln('  This program generates a TWO-WAY');
      writeln('  TRANSIT GRID network for MAX-FLOW');
      writeln('  into a user file. The network ');
      writeln('  resembles a two-way city street');
      writeln('  network.');
      writeln;
    End;

  Procedure Banner2;
    Begin
      writeln;
      writeln('  For the number of nodes select ');
      writeln('  a number that creates a complete');
      writeln('  square grid. For example:');
      writeln('       4 nodes in a 2 x 2 network,');
      writeln('       9 nodes in a 3 x 3 network,');
      writeln('      16 nodes in a 4 x 4 network,');
      writeln('      25 nodes in a 5 x 5 network,');
      writeln('    ...');
      writeln('    1600 nodes in a 40 x 40 network.');
      writeln('  The program adds automatically ');
      writeln('  two nodes, a supersource and ');
      writeln('  a supersink, to the network.');
      writeln;
    End;

  Procedure Banner3;
    Begin
      writeln;
      writeln('  A TWO-WAY TRANSIT GRID NETWORK for');
      writeln('  MAX-FLOW will be generated to file');
      writeln('    ',OutFileName,'.max.');
      writeln('  The number of nodes is  ',num_nodes:8);
      writeln('  The number of arcs is   ',num_arcs:8);
      writeln('  The source node is node ',source:8);
      writeln('  The sink node is node   ',sink:8);
      writeln('  The sink node is numbered with the');
      writeln('  largest node number.');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
      writeln('  The network is given as a list of');
      writeln('  lines: comment lines, problem line,');
      writeln('  node lines, arc lines as follows:');
      writeln('  c this is comment line');
      writeln('  c The "p" line gives the problem');
      writeln('  c TYPE, number of nodes, and ');
      writeln('  c number of arcs. Two "n" lines');
      writeln('  c list the source node, and the');
      writeln('  c sink node, one line per node,');
      writeln('  c including a node designator (s,t).');
      writeln('  c The "a" lines list the arcs, one');
      writeln('  c line per arc with three numbers:');
      writeln('  c   Source Destination Capacity');
      writeln('  c For example like this:');
      writeln('  p MAX NODES ARCS');
      writeln('  n NODE WHICH');
      writeln('  a FROM TO CAPACITY');
      write('  Press ENTER <ret> to continue');
      readln;
      writeln;
    End;

  Procedure Banner4;
    Begin
      writeln;
      writeln('  The network is completed. The data');
      writeln('  file is an ASCII file, and can be');
      writeln('  accessed with your editor. You may');
      writeln('  print the file using the DOS');
      writeln('  command PRINT ',OutFileName,'.max.');
    End;

  Procedure UserValues;
    Begin
      repeat
        writeln('  How many nodes are in the network: ');
        write('  (4, 9, 16, 25, ..., 400, 625,...):');
        readln(imax);
        if (imax<4) then
        Begin
          writeln('  Try again. Need at least four');
          writeln('  nodes in the smallest grid network.');
        End;
      until (imax>=4);
      colmax:=round(sqrt(imax));
      zmax:=2*(imax-colmax);
      writeln('  What is the upper bound for arc flow');
      write('  CAPACITY: ');
      readln(capacity);
      num_nodes:=imax+2;
      num_arcs:=2*(zmax+2*colmax);
      source:=1;
      sink:=num_nodes;
      Banner3;
      writeln(netres,'c Two-Way Transit Grid Network');
      writeln(netres,'c for Max-Flow');
      writeln(netres,'p max',num_nodes:10,num_arcs:10);
      writeln(netres,'n',source:14,'  s');
      writeln(netres,'n',sink:14,'  t');
    End;

  Begin
    randomize;  {Turbo Pascal random number generator initiator.}
                {You may to replace this by compiler specific   }
                {randomizer, or write a short procedure.        }
    Banner1;
    writeln('  Try the network generation out by');
    writeln('  following the instructions.');
    write('  Do you want to continue (Y/N) ');
    readln(ch);
    if (ch='y') or (ch='Y') then
    Begin
      write('  Enter name of the output file: ');
      readln(OutFileName);
      assign(netres,OutFileName+'.max');
      rewrite(netres);
      Banner2;
      UserValues;
      TransitTwoNet;
      close(netres);
      Banner4;
    End;
  End.
SHAR_EOF
:	End of shell archive
exit 0

:	This is a shell archive.
:	Remove everything above this line and
:	run the following text with /bin/sh to create:
:	gen_maxflow_typedef.h
:	genio.c
:	genio.h
:	genmain.c
:	genrmf.c
:	index
:	makefile
:	math_to_gcc.h
:	readme
:	readme.shar
: This archive created: Sun Oct 13 17:26:13 1991
echo shar: extracting gen_maxflow_typedef.h
sed 's/^XX//' << 'SHAR_EOF' > gen_maxflow_typedef.h
XX/* gen_maxflow_typedef.h == Type definitions for a directed graph 
XX                            for generators */
XX/*
XX   Implemented by 
XX   Tamas Badics, 1991, 
XX   Rutgers University, RUTCOR
XX   P.O.Box 5062
XX   New Brunswick, NJ, 08903
XX 
XX   e-mail: badics@rutcor.rutgers.edu
XX*/
XX
XX#ifndef _GEN_MAXFLOW_TYPE_H
XX#define _GEN_MAXFLOW_TYPE_H
XX
XX#include <stdio.h>
XX
XX/*==================================================================*/
XXtypedef struct VERTEX{
XX	
XX	struct EDGE ** edgelist;  /* Pointer to the list of pointers to 
XX								 the adjacent edges. 
XX								 (No matter that to or from edges) */
XX
XX	struct EDGE ** current;   /* Pointer to the current edge */
XX
XX	int degree;        /* Number of adjacent edges (both direction) */
XX	int index;
XX}vertex;
XX
XX/*==================================================================*/
XXtypedef struct EDGE{
XX	int from;
XX	int to;
XX	int cap;        /* Capacity */
XX}edge;
XX
XX/*==================================================================*/
XXtypedef struct NETWORK{
XX
XX	struct NETWORK	* next, * prev;
XX
XX	int vertnum;
XX	int edgenum;
XX
XX	vertex	* verts; /* Vertex array[1..vertnum] */
XX	edge    * edges; /* Edge array[1..edgenum] */
XX
XX	int source; /* Pointer to the source */
XX	int sink;   /* Pointer to the sink */
XX}network;
XX
XX#endif 
XX
SHAR_EOF
if test 1250 -ne "`wc -c gen_maxflow_typedef.h`"
then
echo shar: error transmitting gen_maxflow_typedef.h '(should have been 1250 characters)'
fi
echo shar: extracting genio.c
sed 's/^XX//' << 'SHAR_EOF' > genio.c
XX/* I/O routines for DIMACS standard format generator */
XX/*
XX   Implemented by 
XX   Tamas Badics, 1991, 
XX   Rutgers University, RUTCOR
XX   P.O.Box 5062
XX   New Brunswick, NJ, 08903
XX 
XX   e-mail: badics@rutcor.rutgers.edu
XX*/
XX
XX#include <stdio.h>
XX#include "gen_maxflow_typedef.h"
XX#include "genio.h"
XX
XX/*===============================================================*/
XXvoid gen_free_net(network * n)
XX{
XX	free(n->edges);
XX	free(n);
XX}
XX
XX/*================================================================*/
XXvoid print_max_format (FILE * out, network * n
XX					   , char * comm[], int dim)
XX                           /* prints a network heading with 
XX							  dim lines of comments
XX							  (no \n needs at the ends )*/
XX	 
XX{
XX	int i, vnum, e_num;
XX	edge * e;
XX
XX	vnum = n->vertnum;
XX	e_num = n->edgenum;
XX	
XX	for( i = 0; i < dim; i++)
XX	  fprintf( out, "c %s\n", comm[i]);
XX	
XX	fprintf( out, "p max %7d %10d\n", vnum, e_num);
XX	fprintf( out, "n %7d s\n", n->source);
XX	fprintf( out, "n %7d t\n", n->sink);
XX
XX	for (i = 1; i <= e_num; i++){
XX		e = &n->edges[i];
XX		fprintf(out, "a %7d %7d %10d\n"
XX			   , e->from, e->to, (int)e->cap); 
XX	}
XX}
XX
SHAR_EOF
if test 1107 -ne "`wc -c genio.c`"
then
echo shar: error transmitting genio.c '(should have been 1107 characters)'
fi
echo shar: extracting genio.h
sed 's/^XX//' << 'SHAR_EOF' > genio.h
XX#ifndef _GENIO
XX#define _GENIO
XX
XXvoid gen_free_net(network * n);
XX
XXvoid print_max_format (FILE * outfile, network * n
XX					   , char * comm[], int dim);
XX                           /* prints a network heading with 
XX							  dim lines of comments
XX							  (no \n needs at the ends )*/
XX	 
XXnetwork * gen_rmf(int a, int b, int c1, int c2);  
XX                              /* generates a network with 
XX								 a*a*b nodes and 6a*a*b-4ab-2a*a edges
XX								 random_frame network:
XX								 Derigs & Meier
XX								 Methods & Models of OR (1989) 
XX								 33:383-403 */
XX#endif
SHAR_EOF
if test 565 -ne "`wc -c genio.h`"
then
echo shar: error transmitting genio.h '(should have been 565 characters)'
fi
echo shar: extracting genmain.c
sed 's/^XX//' << 'SHAR_EOF' > genmain.c
XX/* genrmf maxflow input generator */
XX
XX#include <stdio.h>
XX#include "gen_maxflow_typedef.h"
XX#include "genio.h"
XX
XX
XXvoid print_usage(void);
XX
XXvoid main(int argc, char * argv[])
XX{
XX	network * n;
XX	int i, feas, quiet;
XX	FILE * output;
XX	int a, b, c1, c2;
XX	char comm[10][80];
XX	char * com1[10];
XX	int seed;
XX
XX	output = stdout;
XX	a = -1;
XX	b = -1;
XX	c1 = -1;
XX	c2 = -1;
XX	seed = -1;
XX	
XX	for (i = 1; i < argc; i++){
XX		switch (look_up(argv[i])){
XX		  case 0: 
XX			output = fopen(argv[++i],"w");
XX			if (output == NULL) {
XX				fprintf(stderr
XX                    ,"genrmf: Output file %s can't be opened\n",argv[i]);
XX				exit(-1);
XX			}	
XX			break;
XX		  case 1: 
XX			a = atoi(argv[++i]);
XX			break;
XX		  case 2: 
XX			b = atoi(argv[++i]);
XX			break;
XX		  case 3: 
XX			c1 = atoi(argv[++i]);
XX			break;
XX		  case 4: 
XX			c2 = atoi(argv[++i]);
XX			break;
XX		  case 5: 
XX			seed = atoi(argv[++i]);
XX			break;
XX		  default:
XX			break;
XX		} 
XX	}
XX
XX	if (a == -1 || b == -1 || c1 == -1 || c2 == -1)
XX	  print_usage();
XX	
XX	if (seed = -1)
XX	  seed = (int) time(0);
XX	
XX	srand48(seed);
XX	
XX	n = gen_rmf(a, b, c1, c2);
XX
XX	sprintf(comm[0], "This file was generated by genrmf.");
XX	sprintf(comm[1], "The parameters are: a: %d b: %d c1: %d c2: %d"
XX			, a, b, c1, c2);
XX
XX	com1[0] = comm[0];
XX	com1[1] = comm[1];
XX	
XX	print_max_format(output, n, com1, 2);
XX
XX	gen_free_net(n);
XX
XX	if (output != stdout)
XX	  fclose(output);
XX}
XX/*=================================================================*/
XX#define OPS_NUM 6
XX
XXint look_up(char * s)
XX{
XX	char * ops[OPS_NUM] 
XX	  = { "-out", "-a", "-b", "-c1", "-c2", "-seed"};
XX	int i;
XX	
XX	for (i = 0; i < OPS_NUM; i++){
XX		if (strcmp(ops[i], s) == 0)
XX		  return i;
XX	} 
XX	return -1;
XX} 
XX
XXvoid print_usage(void)
XX{
XX	printf("Usage: genrmf [-out out_file]\n");
XX	printf("              -a frame_size -b depth\n");
XX	printf("              -c1 cap_range1 -c2 cap_range2\n");
XX	exit(0);
XX}
XX
SHAR_EOF
if test 1819 -ne "`wc -c genmain.c`"
then
echo shar: error transmitting genmain.c '(should have been 1819 characters)'
fi
echo shar: extracting genrmf.c
sed 's/^XX//' << 'SHAR_EOF' > genrmf.c
XX/* maxflow generator in DIMACS format */
XX/*
XX   Implemented by 
XX   Tamas Badics, 1991, 
XX   Rutgers University, RUTCOR
XX   P.O.Box 5062
XX   New Brunswick, NJ, 08903
XX 
XX   e-mail: badics@rutcor.rutgers.edu
XX*/
XX/*
XXGENRMF -- Maxflow generator in DIMACS format.
XX
XXFiles: genio.c genrmf.c genmain.c  genio.h 
XX	   gen_maxflow_typedef.h  math_to_gcc.h
XX	   makefile
XX
XXCompilation: Simply type make.
XX
XXUsage: genrmf [-out out_file]
XX              -a frame_size -b depth
XX              -c1 cap_range1 -c2 cap_range2
XX
XX		Here without the -out option the generator will
XX		write to stdout.
XX
XX		The generated network is as follows:
XX			It has b pieces of frames of size (a x a).
XX			(So alltogether the number of vertices is a*a*b)
XX			
XX			In each frame all the vertices are connected with 
XX			their neighbours. (forth and back)
XX			In addition the vertices of a frame are connected
XX			one to one with the vertices of next frame using 
XX			a random permutation of those vertices.
XX
XX			The source is the lower left vertex of the first frame,
XX			the sink is the upper right vertex of the b'th frame. 
XX                         t
XX				+-------+
XX				|	   .|
XX				|	  .	|
XX             /  |    /  |
XX			+-------+/ -+ b
XX			|    |  |/.
XX		  a |   -v- |/
XX            |    |  |/
XX		    +-------+ 1
XX           s    a
XX
XX			The capacities are randomly chosen integers
XX			from the range of (c1, c2) in the case of interconnecting
XX			edges, and c2 * a * a for the in-frame edges.
XX 
XXThis generator was used by U. Derigs & W. Meier (1989)
XXin the article "Implementing Goldberg's Max-Flow-Algorithm
XX				A Computational Investigation"
XXZOR - Methods & Models of OR (1989) 33:383-403
XX
XX*/
XX
XX#include <stdio.h>
XX#include "gen_maxflow_typedef.h"
XX#include "genio.h"
XX#include "math_to_gcc.h"
XX
XXvoid make_edge(int from, int to, int c1, int c2);
XXvoid permute(void);
XXvoid connect(int offset, int cv, int x1, int y1);
XX
XXnetwork * N;
XXint * Parr;
XXint A, AA, C2AA, Ec;
XX
XX/*==================================================================*/
XXnetwork * gen_rmf(int a, int b, int c1, int c2)  
XX                              /* generates a network with 
XX								 a*a*b nodes and 6a*a*b-4ab-2a*a edges
XX								 random_frame network:
XX								 Derigs & Meier
XX								 Methods & Models of OR (1989) 
XX								 33:383-403 */
XX{
XX	int x, y, z, offset, cv;
XX	vertex * v;
XX	edge * e;
XX	
XX	A = a;
XX	AA = a*a;
XX	C2AA = c2*AA;
XX	Ec = 0;
XX	
XX	N = (network *)malloc(sizeof(network));
XX	N->vertnum = AA * b;
XX	N->edgenum = 5*AA*b-4*A*b-AA; 
XX	N->edges =(edge *)calloc(N->edgenum + 1, sizeof(edge));
XX	N->source = 1;
XX	N->sink   = N->vertnum;
XX
XX	Parr = (int *)calloc(AA + 1, sizeof(int));
XX	
XX	for (x = 1; x <= AA; x++)
XX	  Parr[x] = x;
XX	
XX	for( z = 1; z <= b; z++){
XX		offset = AA * (z-1);
XX		if (z != b)
XX		  permute();
XX	
XX		for( x = 1; x <= A; x++){ 
XX			for( y = 1; y <= A; y++){
XX				cv = offset + (x - 1) * A + y;
XX				if (z != b)
XX				  make_edge(cv, offset + AA + Parr[cv - offset]  
XX							,c1, c2);   /* the intermediate edges */
XX				
XX				if (y < A)
XX				  connect(offset, cv, x, y + 1);
XX				if (y > 1)
XX				  connect(offset, cv, x, y - 1);
XX				if (x < A)
XX				  connect(offset, cv, x + 1, y);
XX				if (x > 1)
XX				  connect(offset, cv, x - 1, y);
XX			}
XX		}
XX	}
XX	return N;
XX}
XX/*==================================================================*/
XXvoid make_edge(int from, int to, int c1, int c2)
XX{
XX	Ec++;
XX	N->edges[Ec].from = from;
XX	N->edges[Ec].to = to;
XX	N->edges[Ec].cap = RANDOM(c1, c2);
XX}
XX
XX/*==================================================================*/
XXvoid permute(void)
XX{
XX	int i, j, tmp;
XX	
XX	for (i = 1; i < AA; i++){
XX		j = RANDOM(i, AA);
XX		tmp = Parr[i];
XX		Parr[i] = Parr[j];
XX		Parr[j] = tmp;
XX	} 
XX}
XX
XX/*==================================================================*/
XXvoid connect(int offset, int cv, int x1, int y1)
XX{
XX	int cv1;
XX	cv1 = offset + (x1 - 1) * A + y1;
XX	Ec++;
XX	N->edges[Ec].from = cv;
XX	N->edges[Ec].to = cv1;
XX	N->edges[Ec].cap = C2AA;
XX}
XX
XX
SHAR_EOF
if test 3843 -ne "`wc -c genrmf.c`"
then
echo shar: error transmitting genrmf.c '(should have been 3843 characters)'
fi
echo shar: extracting index
sed 's/^XX//' << 'SHAR_EOF' > index
XXtotal 31
XX-rw-rw-r--  1 badics       1250 May 29 19:55 gen_maxflow_typedef.h
XX-rw-rw-r--  1 badics       1107 May 29 19:55 genio.c
XX-rw-rw-r--  1 badics        565 May 29 19:55 genio.h
XX-rw-rw-r--  1 badics       1676 May 29 19:55 genmain.c
XX-rw-rw-r--  1 badics       3843 May 29 19:55 genrmf.c
XX-rw-rw-r--  1 mcgeoch     13153 Sep 13 10:25 genrmf.sh
XX-r--rw-r--  1 badics          0 Oct 13 13:01 index
XX-rw-rw-r--  1 badics        189 May 29 19:55 makefile
XX-rw-rw-r--  1 badics        318 May 29 19:55 math_to_gcc.h
XX-rw-rw-r--  1 mcgeoch      1371 Jul  1 19:13 readme
XX-rw-rw-r--  1 mcgeoch      1418 Jul  1 19:04 readme.BAK
XX-rw-rw-r--  1 mcgeoch       198 Sep 13 10:29 readme.shar
SHAR_EOF
if test 675 -ne "`wc -c index`"
then
echo shar: error transmitting index '(should have been 675 characters)'
fi
echo shar: extracting makefile
sed 's/^XX//' << 'SHAR_EOF' > makefile
XX
XXCFILES1= genio.c genrmf.c genmain.c
XX
XXOBJS= $(CFILES1:%.c=%.o)
XX
XXCC= gcc
XX
XXOUTFILE = genrmf
XX
XXCFLAGS=-O 
XX
XXLIBS = -lm 
XX
XXmain: ${OBJS} 
XX	${CC} ${OBJS} ${CFLAGS} ${LDFLAGS} -o ${OUTFILE} ${LIBS}
SHAR_EOF
if test 189 -ne "`wc -c makefile`"
then
echo shar: error transmitting makefile '(should have been 189 characters)'
fi
echo shar: extracting math_to_gcc.h
sed 's/^XX//' << 'SHAR_EOF' > math_to_gcc.h
XX/* Macros for converting from Turboc math.h to gcc math.h */
XX
XX#ifndef MATH_TO
XX#define MATH_TO
XX
XX#include <math.h>
XX
XXdouble drand48(void);
XXvoid srand48(long int);
XX
XX#define random(A) (int)(drand48()*(double)(A))
XX#define RANDOM(A, B) (int)(random(B-A + 1) + (A))
XX
XX#define sgn(A)  ((A) > 0) ? 1 : ((A)== 0) ? 0 : -1
XX
XX#endif
SHAR_EOF
if test 318 -ne "`wc -c math_to_gcc.h`"
then
echo shar: error transmitting math_to_gcc.h '(should have been 318 characters)'
fi
echo shar: extracting readme
sed 's/^XX//' << 'SHAR_EOF' > readme
XXGENRMF -- Maxflow generator in DIMACS format.
XX
XXThis generator produces the RMFGEN networks developed by 
XX Goldfarb and Grigoriadis (see ``A computational comparison of the Dinic
XX  and Network Simplex methods for maximum flow,'' Annals of Operations 
XX  Research 13 (1988), pp 83--123. 
XX
XXContributed by Tamas Badics. 
XX
XXFiles: genio.c genrmf.c genmain.c  genio.h 
XX	   gen_maxflow_typedef.h  math_to_gcc.h
XX	   makefile
XX
XXCompilation: Get all the files. Type make.
XX
XXUsage: genrmf [-out out_file]
XX              -a frame_size -b depth
XX              -c1 cap_range1 -c2 cap_range2
XX
XX	       Here without the -out option the generator will
XX		write to stdout.
XX
XX		The generated network is as follows:
XX			It has b pieces of frames of size (a x a).
XX			(So alltogether the number of vertices is a*a*b)
XX			
XX			In each frame all the vertices are connected with 
XX			their neighbours. (forth and back)
XX			In addition the vertices of a frame are connected
XX			one to one with the vertices of next frame using 
XX			a random permutation of those vertices.
XX
XX			The source is the lower left vertex of the first frame,
XX			the sink is the upper right vertex of the b'th frame. 
XX               
XX			The capacities are randomly chosen integers
XX			from the range of (c1, c2) in the case of 
XX                        interconnecting edges, and c2 * a * a for 
XX                        the in-frame edges.
XX
XX
XX
SHAR_EOF
if test 1371 -ne "`wc -c readme`"
then
echo shar: error transmitting readme '(should have been 1371 characters)'
fi
echo shar: extracting readme.shar
sed 's/^XX//' << 'SHAR_EOF' > readme.shar
XX
XXThe file genrmf.sh is a shar file containing all the files
XXin this directory.  You can get the file, then type
XX
XXmkdir genrfm
XX/bin/sh genrmf.sh
XX
XXTo create a subdirectory containing all the files. 
XX
SHAR_EOF
if test 198 -ne "`wc -c readme.shar`"
then
echo shar: error transmitting readme.shar '(should have been 198 characters)'
fi
:	End of shell archive
exit 0

# To unbundle, sh this file
echo min_to_flo 1>&2
sed 's/.//' >min_to_flo <<'//GO.SYSIN DD min_to_flo'
-
-
-case $# in
-0|1)	echo "Usage: min_to_flo input.min NETFLO.INP"; exit 1
-esac
-
-
-awk -f trans.a <$1 > tmp.0000
-grep a tmp.0000 > tmp.a
-grep b tmp.0000 > tmp.b
-grep c tmp.0000 > tmp.c
-grep d tmp.0000 > tmp.d
-grep e tmp.0000 > tmp.e
-grep f tmp.0000 > tmp.f
-cat tmp.[abcdef] | awk -f format.a >$2
-\rm tmp.0000 tmp.[abcdef]
//GO.SYSIN DD min_to_flo
echo trans.a 1>&2
sed 's/.//' >trans.a <<'//GO.SYSIN DD trans.a'
-#This awk program is the first part of a system to translate
-#files in the DIMACS .min format to ones readable by Helgassen 
-#and Kennington's NETFLO program.  
-#It does no error checking. 
-
-$1 == "c" { #ignore comment lines 
-	}
-
-$1 == "p"  {prob = $2;  nodes = $3; arcs = $4;
-	    print "a", nodes  
-	}
-
-$1 == "n"  {name = $2; demand = $3;
-	    print "b", name, demand 
-	}
-
-$1 == "a"  {from = $2; to =$3; low=$4; cap=$5; cost=$6; 
-	    acount++;
-
-	    if (cap == -1) cap = 0;
-            else if (cap == 0) cap = -1;
-
-            print "e", acount, from, to, cost, cap, low;  
-	
-		incident[to]++;
-	}	
-
-END     { for (i = 1; i <= nodes; i++) {
-		if (1== (i % 8) ) printf("d ");    #start new line 
-		printf("%10d",incident[i]);
-		if (0== (i % 8) ) printf("\n");    #terminate line
-	   } 
-          #finish last line 
-          while (0 != (i % 8)) {printf("%10d", 0); i++;}
-	  printf("\n");
-	  
- 	  # add zero lines
-	  print "c\n"; 
-          print "f\n" ; 
-	}
-	 
-	   
//GO.SYSIN DD trans.a
echo format.a 1>&2
sed 's/.//' >format.a <<'//GO.SYSIN DD format.a'
-$1 == "a" {printf("%10d\n", $2);}
-
-$1 == "b" {printf("%10d%10d\n", $2, $3); }
-
-$1 == "c" {printf("%-80s\n","00000000000000000000");}
-
-$1 == "d" {printf("%10d%10d%10d%10d%10d%10d%10d%10d\n", $2,$3,$4,$5,$6,$7,$8,$9);
-}
-
-$1 == "e" {printf("%10d%10d%10d%10d%10d\n",$2,$3,$4,$5,$6)}
-
-$1 == "f" {for (i=1; i<=5;i++) printf("%10s","0000000000");
-           printf("%30s\n", " ");
-    	}
-
-          
-
//GO.SYSIN DD format.a
